<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:schold="http://www.ascc.net/xml/schematron"
                xmlns:iso="http://purl.oclc.org/dsdl/schematron"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xmlns:oval="http://oval.mitre.org/XMLSchema/oval-common-5"
                xmlns:oval-def="http://oval.mitre.org/XMLSchema/oval-definitions-5"
                xmlns:ind-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#independent"
                xmlns:aix-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#aix"
                xmlns:apache-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#apache"
                xmlns:catos-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#catos"
                xmlns:esx-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#esx"
                xmlns:freebsd-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#freebsd"
                xmlns:hpux-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#hpux"
                xmlns:ios-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#ios"
                xmlns:linux-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#linux"
                xmlns:macos-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#macos"
                xmlns:pixos-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#pixos"
                xmlns:sp-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#sharepoint"
                xmlns:sol-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#solaris"
                xmlns:unix-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#unix"
                xmlns:win-def="http://oval.mitre.org/XMLSchema/oval-definitions-5#windows"
                version="1.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
<xsl:param name="archiveDirParameter"/>
   <xsl:param name="archiveNameParameter"/>
   <xsl:param name="fileNameParameter" />
   <!--PHASES-->


<!--PROLOG-->


<!--XSD TYPES-->


<!--KEYS AND FUCNTIONS-->


<!--DEFAULT RULES-->


<!--MODE: SCHEMATRON-FULL-PATH-->
<!--This mode can be used to generate an ugly though full XPath for locators-->
<xsl:template match="*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">
            <xsl:value-of select="name()"/>
            <xsl:variable name="p" select="1+    count(preceding-sibling::*[name()=name(current())])"/>
            <xsl:if test="$p&gt;1 or following-sibling::*[name()=name(current())]">[<xsl:value-of select="$p"/>]</xsl:if>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>']</xsl:text>
            <xsl:variable name="p"
                          select="1+   count(preceding-sibling::*[local-name()=local-name(current())])"/>
            <xsl:if test="$p&gt;1 or following-sibling::*[local-name()=local-name(current())]">[<xsl:value-of select="$p"/>]</xsl:if>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <xsl:template match="@*" mode="schematron-get-full-path">
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>@*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>' and namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <!--MODE: SCHEMATRON-FULL-PATH-2-->
<!--This mode can be used to generate prefixed XPath for humans-->
<xsl:template match="node() | @*" mode="schematron-get-full-path-2">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="preceding-sibling::*[name(.)=name(current())]">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-3-->
<!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
<xsl:template match="node() | @*" mode="schematron-get-full-path-3">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="parent::*">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>

   <!--MODE: GENERATE-ID-FROM-PATH -->
<xsl:template match="/" mode="generate-id-from-path"/>
   <xsl:template match="text()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
   </xsl:template>
   <xsl:template match="comment()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
   </xsl:template>
   <xsl:template match="processing-instruction()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.@', name())"/>
   </xsl:template>
   <xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:text>.</xsl:text>
      <xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
   </xsl:template>

   <!--MODE: GENERATE-ID-2 -->
<xsl:template match="/" mode="generate-id-2">U</xsl:template>
   <xsl:template match="*" mode="generate-id-2" priority="2">
      <xsl:text>U</xsl:text>
      <xsl:number level="multiple" count="*"/>
   </xsl:template>
   <xsl:template match="node()" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>n</xsl:text>
      <xsl:number count="node()"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="string-length(local-name(.))"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="translate(name(),':','.')"/>
   </xsl:template>
   <!--Strip characters--><xsl:template match="text()" priority="-1"/>

   <!--SCHEMA METADATA-->
<xsl:template match="/">
      <xsl:apply-templates select="/" mode="M19"/>
      <xsl:apply-templates select="/" mode="M20"/>
      <xsl:apply-templates select="/" mode="M21"/>
      <xsl:apply-templates select="/" mode="M22"/>
      <xsl:apply-templates select="/" mode="M23"/>
      <xsl:apply-templates select="/" mode="M24"/>
      <xsl:apply-templates select="/" mode="M25"/>
      <xsl:apply-templates select="/" mode="M26"/>
      <xsl:apply-templates select="/" mode="M27"/>
      <xsl:apply-templates select="/" mode="M28"/>
      <xsl:apply-templates select="/" mode="M29"/>
      <xsl:apply-templates select="/" mode="M30"/>
      <xsl:apply-templates select="/" mode="M31"/>
      <xsl:apply-templates select="/" mode="M32"/>
      <xsl:apply-templates select="/" mode="M33"/>
      <xsl:apply-templates select="/" mode="M34"/>
      <xsl:apply-templates select="/" mode="M35"/>
      <xsl:apply-templates select="/" mode="M36"/>
      <xsl:apply-templates select="/" mode="M37"/>
      <xsl:apply-templates select="/" mode="M38"/>
      <xsl:apply-templates select="/" mode="M39"/>
      <xsl:apply-templates select="/" mode="M40"/>
      <xsl:apply-templates select="/" mode="M41"/>
      <xsl:apply-templates select="/" mode="M42"/>
      <xsl:apply-templates select="/" mode="M43"/>
      <xsl:apply-templates select="/" mode="M44"/>
      <xsl:apply-templates select="/" mode="M45"/>
      <xsl:apply-templates select="/" mode="M46"/>
      <xsl:apply-templates select="/" mode="M47"/>
      <xsl:apply-templates select="/" mode="M48"/>
      <xsl:apply-templates select="/" mode="M49"/>
      <xsl:apply-templates select="/" mode="M50"/>
      <xsl:apply-templates select="/" mode="M51"/>
      <xsl:apply-templates select="/" mode="M52"/>
      <xsl:apply-templates select="/" mode="M53"/>
      <xsl:apply-templates select="/" mode="M54"/>
      <xsl:apply-templates select="/" mode="M55"/>
      <xsl:apply-templates select="/" mode="M56"/>
      <xsl:apply-templates select="/" mode="M57"/>
      <xsl:apply-templates select="/" mode="M58"/>
      <xsl:apply-templates select="/" mode="M59"/>
      <xsl:apply-templates select="/" mode="M60"/>
      <xsl:apply-templates select="/" mode="M61"/>
      <xsl:apply-templates select="/" mode="M62"/>
      <xsl:apply-templates select="/" mode="M63"/>
      <xsl:apply-templates select="/" mode="M64"/>
      <xsl:apply-templates select="/" mode="M65"/>
      <xsl:apply-templates select="/" mode="M66"/>
      <xsl:apply-templates select="/" mode="M67"/>
      <xsl:apply-templates select="/" mode="M68"/>
      <xsl:apply-templates select="/" mode="M69"/>
      <xsl:apply-templates select="/" mode="M70"/>
      <xsl:apply-templates select="/" mode="M71"/>
      <xsl:apply-templates select="/" mode="M72"/>
      <xsl:apply-templates select="/" mode="M73"/>
      <xsl:apply-templates select="/" mode="M74"/>
      <xsl:apply-templates select="/" mode="M75"/>
      <xsl:apply-templates select="/" mode="M76"/>
      <xsl:apply-templates select="/" mode="M77"/>
      <xsl:apply-templates select="/" mode="M78"/>
      <xsl:apply-templates select="/" mode="M79"/>
      <xsl:apply-templates select="/" mode="M80"/>
      <xsl:apply-templates select="/" mode="M81"/>
      <xsl:apply-templates select="/" mode="M82"/>
      <xsl:apply-templates select="/" mode="M83"/>
      <xsl:apply-templates select="/" mode="M84"/>
      <xsl:apply-templates select="/" mode="M85"/>
      <xsl:apply-templates select="/" mode="M86"/>
      <xsl:apply-templates select="/" mode="M87"/>
      <xsl:apply-templates select="/" mode="M88"/>
      <xsl:apply-templates select="/" mode="M89"/>
      <xsl:apply-templates select="/" mode="M90"/>
      <xsl:apply-templates select="/" mode="M91"/>
      <xsl:apply-templates select="/" mode="M92"/>
      <xsl:apply-templates select="/" mode="M93"/>
      <xsl:apply-templates select="/" mode="M94"/>
      <xsl:apply-templates select="/" mode="M95"/>
      <xsl:apply-templates select="/" mode="M96"/>
      <xsl:apply-templates select="/" mode="M97"/>
      <xsl:apply-templates select="/" mode="M98"/>
      <xsl:apply-templates select="/" mode="M99"/>
      <xsl:apply-templates select="/" mode="M100"/>
      <xsl:apply-templates select="/" mode="M101"/>
      <xsl:apply-templates select="/" mode="M102"/>
      <xsl:apply-templates select="/" mode="M103"/>
      <xsl:apply-templates select="/" mode="M104"/>
      <xsl:apply-templates select="/" mode="M105"/>
      <xsl:apply-templates select="/" mode="M106"/>
      <xsl:apply-templates select="/" mode="M107"/>
      <xsl:apply-templates select="/" mode="M108"/>
      <xsl:apply-templates select="/" mode="M109"/>
      <xsl:apply-templates select="/" mode="M110"/>
      <xsl:apply-templates select="/" mode="M111"/>
      <xsl:apply-templates select="/" mode="M112"/>
      <xsl:apply-templates select="/" mode="M113"/>
      <xsl:apply-templates select="/" mode="M114"/>
      <xsl:apply-templates select="/" mode="M115"/>
      <xsl:apply-templates select="/" mode="M116"/>
      <xsl:apply-templates select="/" mode="M117"/>
      <xsl:apply-templates select="/" mode="M118"/>
      <xsl:apply-templates select="/" mode="M119"/>
      <xsl:apply-templates select="/" mode="M120"/>
      <xsl:apply-templates select="/" mode="M121"/>
      <xsl:apply-templates select="/" mode="M122"/>
      <xsl:apply-templates select="/" mode="M123"/>
      <xsl:apply-templates select="/" mode="M124"/>
      <xsl:apply-templates select="/" mode="M125"/>
      <xsl:apply-templates select="/" mode="M126"/>
      <xsl:apply-templates select="/" mode="M127"/>
      <xsl:apply-templates select="/" mode="M128"/>
      <xsl:apply-templates select="/" mode="M129"/>
      <xsl:apply-templates select="/" mode="M130"/>
      <xsl:apply-templates select="/" mode="M131"/>
      <xsl:apply-templates select="/" mode="M132"/>
      <xsl:apply-templates select="/" mode="M133"/>
      <xsl:apply-templates select="/" mode="M134"/>
      <xsl:apply-templates select="/" mode="M135"/>
      <xsl:apply-templates select="/" mode="M136"/>
      <xsl:apply-templates select="/" mode="M137"/>
      <xsl:apply-templates select="/" mode="M138"/>
      <xsl:apply-templates select="/" mode="M139"/>
      <xsl:apply-templates select="/" mode="M140"/>
      <xsl:apply-templates select="/" mode="M141"/>
      <xsl:apply-templates select="/" mode="M142"/>
      <xsl:apply-templates select="/" mode="M143"/>
      <xsl:apply-templates select="/" mode="M144"/>
      <xsl:apply-templates select="/" mode="M145"/>
      <xsl:apply-templates select="/" mode="M146"/>
      <xsl:apply-templates select="/" mode="M147"/>
      <xsl:apply-templates select="/" mode="M148"/>
      <xsl:apply-templates select="/" mode="M149"/>
      <xsl:apply-templates select="/" mode="M150"/>
      <xsl:apply-templates select="/" mode="M151"/>
      <xsl:apply-templates select="/" mode="M152"/>
      <xsl:apply-templates select="/" mode="M153"/>
      <xsl:apply-templates select="/" mode="M154"/>
      <xsl:apply-templates select="/" mode="M155"/>
      <xsl:apply-templates select="/" mode="M156"/>
      <xsl:apply-templates select="/" mode="M157"/>
      <xsl:apply-templates select="/" mode="M158"/>
      <xsl:apply-templates select="/" mode="M159"/>
      <xsl:apply-templates select="/" mode="M160"/>
      <xsl:apply-templates select="/" mode="M161"/>
      <xsl:apply-templates select="/" mode="M162"/>
      <xsl:apply-templates select="/" mode="M163"/>
      <xsl:apply-templates select="/" mode="M164"/>
      <xsl:apply-templates select="/" mode="M165"/>
      <xsl:apply-templates select="/" mode="M166"/>
      <xsl:apply-templates select="/" mode="M167"/>
      <xsl:apply-templates select="/" mode="M168"/>
      <xsl:apply-templates select="/" mode="M169"/>
      <xsl:apply-templates select="/" mode="M170"/>
      <xsl:apply-templates select="/" mode="M171"/>
      <xsl:apply-templates select="/" mode="M172"/>
      <xsl:apply-templates select="/" mode="M173"/>
      <xsl:apply-templates select="/" mode="M174"/>
      <xsl:apply-templates select="/" mode="M175"/>
      <xsl:apply-templates select="/" mode="M176"/>
      <xsl:apply-templates select="/" mode="M177"/>
      <xsl:apply-templates select="/" mode="M178"/>
      <xsl:apply-templates select="/" mode="M179"/>
      <xsl:apply-templates select="/" mode="M180"/>
      <xsl:apply-templates select="/" mode="M181"/>
      <xsl:apply-templates select="/" mode="M182"/>
      <xsl:apply-templates select="/" mode="M183"/>
      <xsl:apply-templates select="/" mode="M184"/>
      <xsl:apply-templates select="/" mode="M185"/>
      <xsl:apply-templates select="/" mode="M186"/>
      <xsl:apply-templates select="/" mode="M187"/>
      <xsl:apply-templates select="/" mode="M188"/>
      <xsl:apply-templates select="/" mode="M189"/>
      <xsl:apply-templates select="/" mode="M190"/>
      <xsl:apply-templates select="/" mode="M191"/>
      <xsl:apply-templates select="/" mode="M192"/>
      <xsl:apply-templates select="/" mode="M193"/>
      <xsl:apply-templates select="/" mode="M194"/>
      <xsl:apply-templates select="/" mode="M195"/>
      <xsl:apply-templates select="/" mode="M196"/>
      <xsl:apply-templates select="/" mode="M197"/>
      <xsl:apply-templates select="/" mode="M198"/>
      <xsl:apply-templates select="/" mode="M199"/>
      <xsl:apply-templates select="/" mode="M200"/>
      <xsl:apply-templates select="/" mode="M201"/>
      <xsl:apply-templates select="/" mode="M202"/>
      <xsl:apply-templates select="/" mode="M203"/>
      <xsl:apply-templates select="/" mode="M204"/>
      <xsl:apply-templates select="/" mode="M205"/>
      <xsl:apply-templates select="/" mode="M206"/>
      <xsl:apply-templates select="/" mode="M207"/>
      <xsl:apply-templates select="/" mode="M208"/>
      <xsl:apply-templates select="/" mode="M209"/>
      <xsl:apply-templates select="/" mode="M210"/>
      <xsl:apply-templates select="/" mode="M211"/>
      <xsl:apply-templates select="/" mode="M212"/>
      <xsl:apply-templates select="/" mode="M213"/>
      <xsl:apply-templates select="/" mode="M214"/>
      <xsl:apply-templates select="/" mode="M215"/>
      <xsl:apply-templates select="/" mode="M216"/>
      <xsl:apply-templates select="/" mode="M217"/>
      <xsl:apply-templates select="/" mode="M218"/>
      <xsl:apply-templates select="/" mode="M219"/>
      <xsl:apply-templates select="/" mode="M220"/>
      <xsl:apply-templates select="/" mode="M221"/>
      <xsl:apply-templates select="/" mode="M222"/>
      <xsl:apply-templates select="/" mode="M223"/>
      <xsl:apply-templates select="/" mode="M224"/>
      <xsl:apply-templates select="/" mode="M225"/>
      <xsl:apply-templates select="/" mode="M226"/>
      <xsl:apply-templates select="/" mode="M227"/>
      <xsl:apply-templates select="/" mode="M228"/>
      <xsl:apply-templates select="/" mode="M229"/>
      <xsl:apply-templates select="/" mode="M230"/>
      <xsl:apply-templates select="/" mode="M231"/>
      <xsl:apply-templates select="/" mode="M232"/>
      <xsl:apply-templates select="/" mode="M233"/>
      <xsl:apply-templates select="/" mode="M234"/>
      <xsl:apply-templates select="/" mode="M235"/>
      <xsl:apply-templates select="/" mode="M236"/>
      <xsl:apply-templates select="/" mode="M237"/>
      <xsl:apply-templates select="/" mode="M238"/>
      <xsl:apply-templates select="/" mode="M239"/>
      <xsl:apply-templates select="/" mode="M240"/>
      <xsl:apply-templates select="/" mode="M241"/>
      <xsl:apply-templates select="/" mode="M242"/>
      <xsl:apply-templates select="/" mode="M243"/>
      <xsl:apply-templates select="/" mode="M244"/>
      <xsl:apply-templates select="/" mode="M245"/>
      <xsl:apply-templates select="/" mode="M246"/>
      <xsl:apply-templates select="/" mode="M247"/>
      <xsl:apply-templates select="/" mode="M248"/>
      <xsl:apply-templates select="/" mode="M249"/>
      <xsl:apply-templates select="/" mode="M250"/>
      <xsl:apply-templates select="/" mode="M251"/>
      <xsl:apply-templates select="/" mode="M252"/>
      <xsl:apply-templates select="/" mode="M253"/>
      <xsl:apply-templates select="/" mode="M254"/>
      <xsl:apply-templates select="/" mode="M255"/>
      <xsl:apply-templates select="/" mode="M256"/>
      <xsl:apply-templates select="/" mode="M257"/>
      <xsl:apply-templates select="/" mode="M258"/>
      <xsl:apply-templates select="/" mode="M259"/>
      <xsl:apply-templates select="/" mode="M260"/>
      <xsl:apply-templates select="/" mode="M261"/>
      <xsl:apply-templates select="/" mode="M262"/>
      <xsl:apply-templates select="/" mode="M263"/>
      <xsl:apply-templates select="/" mode="M264"/>
      <xsl:apply-templates select="/" mode="M265"/>
      <xsl:apply-templates select="/" mode="M266"/>
      <xsl:apply-templates select="/" mode="M267"/>
      <xsl:apply-templates select="/" mode="M268"/>
      <xsl:apply-templates select="/" mode="M269"/>
      <xsl:apply-templates select="/" mode="M270"/>
      <xsl:apply-templates select="/" mode="M271"/>
      <xsl:apply-templates select="/" mode="M272"/>
      <xsl:apply-templates select="/" mode="M273"/>
      <xsl:apply-templates select="/" mode="M274"/>
      <xsl:apply-templates select="/" mode="M275"/>
      <xsl:apply-templates select="/" mode="M276"/>
      <xsl:apply-templates select="/" mode="M277"/>
      <xsl:apply-templates select="/" mode="M278"/>
      <xsl:apply-templates select="/" mode="M279"/>
      <xsl:apply-templates select="/" mode="M280"/>
      <xsl:apply-templates select="/" mode="M281"/>
      <xsl:apply-templates select="/" mode="M282"/>
      <xsl:apply-templates select="/" mode="M283"/>
      <xsl:apply-templates select="/" mode="M284"/>
      <xsl:apply-templates select="/" mode="M285"/>
      <xsl:apply-templates select="/" mode="M286"/>
      <xsl:apply-templates select="/" mode="M287"/>
      <xsl:apply-templates select="/" mode="M288"/>
      <xsl:apply-templates select="/" mode="M289"/>
      <xsl:apply-templates select="/" mode="M290"/>
      <xsl:apply-templates select="/" mode="M291"/>
      <xsl:apply-templates select="/" mode="M292"/>
      <xsl:apply-templates select="/" mode="M293"/>
      <xsl:apply-templates select="/" mode="M294"/>
      <xsl:apply-templates select="/" mode="M295"/>
      <xsl:apply-templates select="/" mode="M296"/>
      <xsl:apply-templates select="/" mode="M297"/>
      <xsl:apply-templates select="/" mode="M298"/>
      <xsl:apply-templates select="/" mode="M299"/>
      <xsl:apply-templates select="/" mode="M300"/>
      <xsl:apply-templates select="/" mode="M301"/>
      <xsl:apply-templates select="/" mode="M302"/>
      <xsl:apply-templates select="/" mode="M303"/>
      <xsl:apply-templates select="/" mode="M304"/>
      <xsl:apply-templates select="/" mode="M305"/>
      <xsl:apply-templates select="/" mode="M306"/>
      <xsl:apply-templates select="/" mode="M307"/>
      <xsl:apply-templates select="/" mode="M308"/>
      <xsl:apply-templates select="/" mode="M309"/>
      <xsl:apply-templates select="/" mode="M310"/>
      <xsl:apply-templates select="/" mode="M311"/>
      <xsl:apply-templates select="/" mode="M312"/>
      <xsl:apply-templates select="/" mode="M313"/>
      <xsl:apply-templates select="/" mode="M314"/>
      <xsl:apply-templates select="/" mode="M315"/>
      <xsl:apply-templates select="/" mode="M316"/>
      <xsl:apply-templates select="/" mode="M317"/>
      <xsl:apply-templates select="/" mode="M318"/>
      <xsl:apply-templates select="/" mode="M319"/>
      <xsl:apply-templates select="/" mode="M320"/>
      <xsl:apply-templates select="/" mode="M321"/>
      <xsl:apply-templates select="/" mode="M322"/>
      <xsl:apply-templates select="/" mode="M323"/>
      <xsl:apply-templates select="/" mode="M324"/>
      <xsl:apply-templates select="/" mode="M325"/>
      <xsl:apply-templates select="/" mode="M326"/>
      <xsl:apply-templates select="/" mode="M327"/>
      <xsl:apply-templates select="/" mode="M328"/>
      <xsl:apply-templates select="/" mode="M329"/>
      <xsl:apply-templates select="/" mode="M330"/>
      <xsl:apply-templates select="/" mode="M331"/>
      <xsl:apply-templates select="/" mode="M332"/>
      <xsl:apply-templates select="/" mode="M333"/>
      <xsl:apply-templates select="/" mode="M334"/>
      <xsl:apply-templates select="/" mode="M335"/>
      <xsl:apply-templates select="/" mode="M336"/>
      <xsl:apply-templates select="/" mode="M337"/>
      <xsl:apply-templates select="/" mode="M338"/>
      <xsl:apply-templates select="/" mode="M339"/>
      <xsl:apply-templates select="/" mode="M340"/>
      <xsl:apply-templates select="/" mode="M341"/>
      <xsl:apply-templates select="/" mode="M342"/>
      <xsl:apply-templates select="/" mode="M343"/>
      <xsl:apply-templates select="/" mode="M344"/>
      <xsl:apply-templates select="/" mode="M345"/>
      <xsl:apply-templates select="/" mode="M346"/>
      <xsl:apply-templates select="/" mode="M347"/>
      <xsl:apply-templates select="/" mode="M348"/>
      <xsl:apply-templates select="/" mode="M349"/>
      <xsl:apply-templates select="/" mode="M350"/>
      <xsl:apply-templates select="/" mode="M351"/>
      <xsl:apply-templates select="/" mode="M352"/>
      <xsl:apply-templates select="/" mode="M353"/>
      <xsl:apply-templates select="/" mode="M354"/>
      <xsl:apply-templates select="/" mode="M355"/>
      <xsl:apply-templates select="/" mode="M356"/>
      <xsl:apply-templates select="/" mode="M357"/>
      <xsl:apply-templates select="/" mode="M358"/>
      <xsl:apply-templates select="/" mode="M359"/>
      <xsl:apply-templates select="/" mode="M360"/>
      <xsl:apply-templates select="/" mode="M361"/>
      <xsl:apply-templates select="/" mode="M362"/>
      <xsl:apply-templates select="/" mode="M363"/>
      <xsl:apply-templates select="/" mode="M364"/>
      <xsl:apply-templates select="/" mode="M365"/>
      <xsl:apply-templates select="/" mode="M366"/>
      <xsl:apply-templates select="/" mode="M367"/>
      <xsl:apply-templates select="/" mode="M368"/>
      <xsl:apply-templates select="/" mode="M369"/>
      <xsl:apply-templates select="/" mode="M370"/>
      <xsl:apply-templates select="/" mode="M371"/>
      <xsl:apply-templates select="/" mode="M372"/>
      <xsl:apply-templates select="/" mode="M373"/>
      <xsl:apply-templates select="/" mode="M374"/>
      <xsl:apply-templates select="/" mode="M375"/>
      <xsl:apply-templates select="/" mode="M376"/>
      <xsl:apply-templates select="/" mode="M377"/>
      <xsl:apply-templates select="/" mode="M378"/>
      <xsl:apply-templates select="/" mode="M379"/>
      <xsl:apply-templates select="/" mode="M380"/>
      <xsl:apply-templates select="/" mode="M381"/>
      <xsl:apply-templates select="/" mode="M382"/>
      <xsl:apply-templates select="/" mode="M383"/>
      <xsl:apply-templates select="/" mode="M384"/>
      <xsl:apply-templates select="/" mode="M385"/>
      <xsl:apply-templates select="/" mode="M386"/>
      <xsl:apply-templates select="/" mode="M387"/>
      <xsl:apply-templates select="/" mode="M388"/>
      <xsl:apply-templates select="/" mode="M389"/>
      <xsl:apply-templates select="/" mode="M390"/>
      <xsl:apply-templates select="/" mode="M391"/>
      <xsl:apply-templates select="/" mode="M392"/>
      <xsl:apply-templates select="/" mode="M393"/>
      <xsl:apply-templates select="/" mode="M394"/>
      <xsl:apply-templates select="/" mode="M395"/>
      <xsl:apply-templates select="/" mode="M396"/>
      <xsl:apply-templates select="/" mode="M397"/>
      <xsl:apply-templates select="/" mode="M398"/>
      <xsl:apply-templates select="/" mode="M399"/>
      <xsl:apply-templates select="/" mode="M400"/>
      <xsl:apply-templates select="/" mode="M401"/>
      <xsl:apply-templates select="/" mode="M402"/>
      <xsl:apply-templates select="/" mode="M403"/>
      <xsl:apply-templates select="/" mode="M404"/>
      <xsl:apply-templates select="/" mode="M405"/>
      <xsl:apply-templates select="/" mode="M406"/>
      <xsl:apply-templates select="/" mode="M407"/>
      <xsl:apply-templates select="/" mode="M408"/>
      <xsl:apply-templates select="/" mode="M409"/>
      <xsl:apply-templates select="/" mode="M410"/>
      <xsl:apply-templates select="/" mode="M411"/>
      <xsl:apply-templates select="/" mode="M412"/>
      <xsl:apply-templates select="/" mode="M413"/>
      <xsl:apply-templates select="/" mode="M414"/>
      <xsl:apply-templates select="/" mode="M415"/>
      <xsl:apply-templates select="/" mode="M416"/>
      <xsl:apply-templates select="/" mode="M417"/>
      <xsl:apply-templates select="/" mode="M418"/>
      <xsl:apply-templates select="/" mode="M419"/>
      <xsl:apply-templates select="/" mode="M420"/>
      <xsl:apply-templates select="/" mode="M421"/>
      <xsl:apply-templates select="/" mode="M422"/>
      <xsl:apply-templates select="/" mode="M423"/>
      <xsl:apply-templates select="/" mode="M424"/>
      <xsl:apply-templates select="/" mode="M425"/>
      <xsl:apply-templates select="/" mode="M426"/>
      <xsl:apply-templates select="/" mode="M427"/>
      <xsl:apply-templates select="/" mode="M428"/>
      <xsl:apply-templates select="/" mode="M429"/>
      <xsl:apply-templates select="/" mode="M430"/>
      <xsl:apply-templates select="/" mode="M431"/>
      <xsl:apply-templates select="/" mode="M432"/>
      <xsl:apply-templates select="/" mode="M433"/>
      <xsl:apply-templates select="/" mode="M434"/>
      <xsl:apply-templates select="/" mode="M435"/>
      <xsl:apply-templates select="/" mode="M436"/>
      <xsl:apply-templates select="/" mode="M437"/>
      <xsl:apply-templates select="/" mode="M438"/>
      <xsl:apply-templates select="/" mode="M439"/>
      <xsl:apply-templates select="/" mode="M440"/>
      <xsl:apply-templates select="/" mode="M441"/>
      <xsl:apply-templates select="/" mode="M442"/>
      <xsl:apply-templates select="/" mode="M443"/>
      <xsl:apply-templates select="/" mode="M444"/>
      <xsl:apply-templates select="/" mode="M445"/>
      <xsl:apply-templates select="/" mode="M446"/>
      <xsl:apply-templates select="/" mode="M447"/>
      <xsl:apply-templates select="/" mode="M448"/>
      <xsl:apply-templates select="/" mode="M449"/>
      <xsl:apply-templates select="/" mode="M450"/>
      <xsl:apply-templates select="/" mode="M451"/>
      <xsl:apply-templates select="/" mode="M452"/>
      <xsl:apply-templates select="/" mode="M453"/>
      <xsl:apply-templates select="/" mode="M454"/>
      <xsl:apply-templates select="/" mode="M455"/>
      <xsl:apply-templates select="/" mode="M456"/>
      <xsl:apply-templates select="/" mode="M457"/>
      <xsl:apply-templates select="/" mode="M458"/>
      <xsl:apply-templates select="/" mode="M459"/>
      <xsl:apply-templates select="/" mode="M460"/>
      <xsl:apply-templates select="/" mode="M461"/>
      <xsl:apply-templates select="/" mode="M462"/>
      <xsl:apply-templates select="/" mode="M463"/>
      <xsl:apply-templates select="/" mode="M464"/>
      <xsl:apply-templates select="/" mode="M465"/>
      <xsl:apply-templates select="/" mode="M466"/>
      <xsl:apply-templates select="/" mode="M467"/>
      <xsl:apply-templates select="/" mode="M468"/>
      <xsl:apply-templates select="/" mode="M469"/>
      <xsl:apply-templates select="/" mode="M470"/>
      <xsl:apply-templates select="/" mode="M471"/>
      <xsl:apply-templates select="/" mode="M472"/>
      <xsl:apply-templates select="/" mode="M473"/>
      <xsl:apply-templates select="/" mode="M474"/>
      <xsl:apply-templates select="/" mode="M475"/>
      <xsl:apply-templates select="/" mode="M476"/>
      <xsl:apply-templates select="/" mode="M477"/>
      <xsl:apply-templates select="/" mode="M478"/>
      <xsl:apply-templates select="/" mode="M479"/>
      <xsl:apply-templates select="/" mode="M480"/>
      <xsl:apply-templates select="/" mode="M481"/>
      <xsl:apply-templates select="/" mode="M482"/>
      <xsl:apply-templates select="/" mode="M483"/>
      <xsl:apply-templates select="/" mode="M484"/>
      <xsl:apply-templates select="/" mode="M485"/>
      <xsl:apply-templates select="/" mode="M486"/>
      <xsl:apply-templates select="/" mode="M487"/>
      <xsl:apply-templates select="/" mode="M488"/>
      <xsl:apply-templates select="/" mode="M489"/>
      <xsl:apply-templates select="/" mode="M490"/>
      <xsl:apply-templates select="/" mode="M491"/>
      <xsl:apply-templates select="/" mode="M492"/>
      <xsl:apply-templates select="/" mode="M493"/>
      <xsl:apply-templates select="/" mode="M494"/>
      <xsl:apply-templates select="/" mode="M495"/>
      <xsl:apply-templates select="/" mode="M496"/>
      <xsl:apply-templates select="/" mode="M497"/>
      <xsl:apply-templates select="/" mode="M498"/>
      <xsl:apply-templates select="/" mode="M499"/>
      <xsl:apply-templates select="/" mode="M500"/>
      <xsl:apply-templates select="/" mode="M501"/>
      <xsl:apply-templates select="/" mode="M502"/>
      <xsl:apply-templates select="/" mode="M503"/>
      <xsl:apply-templates select="/" mode="M504"/>
      <xsl:apply-templates select="/" mode="M505"/>
      <xsl:apply-templates select="/" mode="M506"/>
      <xsl:apply-templates select="/" mode="M507"/>
      <xsl:apply-templates select="/" mode="M508"/>
      <xsl:apply-templates select="/" mode="M509"/>
      <xsl:apply-templates select="/" mode="M510"/>
      <xsl:apply-templates select="/" mode="M511"/>
      <xsl:apply-templates select="/" mode="M512"/>
      <xsl:apply-templates select="/" mode="M513"/>
      <xsl:apply-templates select="/" mode="M514"/>
      <xsl:apply-templates select="/" mode="M515"/>
      <xsl:apply-templates select="/" mode="M516"/>
      <xsl:apply-templates select="/" mode="M517"/>
      <xsl:apply-templates select="/" mode="M518"/>
      <xsl:apply-templates select="/" mode="M519"/>
      <xsl:apply-templates select="/" mode="M520"/>
      <xsl:apply-templates select="/" mode="M521"/>
      <xsl:apply-templates select="/" mode="M522"/>
      <xsl:apply-templates select="/" mode="M523"/>
      <xsl:apply-templates select="/" mode="M524"/>
      <xsl:apply-templates select="/" mode="M525"/>
      <xsl:apply-templates select="/" mode="M526"/>
      <xsl:apply-templates select="/" mode="M527"/>
      <xsl:apply-templates select="/" mode="M528"/>
      <xsl:apply-templates select="/" mode="M529"/>
      <xsl:apply-templates select="/" mode="M530"/>
      <xsl:apply-templates select="/" mode="M531"/>
      <xsl:apply-templates select="/" mode="M532"/>
      <xsl:apply-templates select="/" mode="M533"/>
      <xsl:apply-templates select="/" mode="M534"/>
      <xsl:apply-templates select="/" mode="M535"/>
      <xsl:apply-templates select="/" mode="M536"/>
      <xsl:apply-templates select="/" mode="M537"/>
      <xsl:apply-templates select="/" mode="M538"/>
      <xsl:apply-templates select="/" mode="M539"/>
      <xsl:apply-templates select="/" mode="M540"/>
      <xsl:apply-templates select="/" mode="M541"/>
      <xsl:apply-templates select="/" mode="M542"/>
      <xsl:apply-templates select="/" mode="M543"/>
      <xsl:apply-templates select="/" mode="M544"/>
      <xsl:apply-templates select="/" mode="M545"/>
      <xsl:apply-templates select="/" mode="M546"/>
      <xsl:apply-templates select="/" mode="M547"/>
      <xsl:apply-templates select="/" mode="M548"/>
      <xsl:apply-templates select="/" mode="M549"/>
      <xsl:apply-templates select="/" mode="M550"/>
      <xsl:apply-templates select="/" mode="M551"/>
      <xsl:apply-templates select="/" mode="M552"/>
      <xsl:apply-templates select="/" mode="M553"/>
      <xsl:apply-templates select="/" mode="M554"/>
      <xsl:apply-templates select="/" mode="M555"/>
      <xsl:apply-templates select="/" mode="M556"/>
      <xsl:apply-templates select="/" mode="M557"/>
      <xsl:apply-templates select="/" mode="M558"/>
      <xsl:apply-templates select="/" mode="M559"/>
      <xsl:apply-templates select="/" mode="M560"/>
      <xsl:apply-templates select="/" mode="M561"/>
      <xsl:apply-templates select="/" mode="M562"/>
      <xsl:apply-templates select="/" mode="M563"/>
      <xsl:apply-templates select="/" mode="M564"/>
      <xsl:apply-templates select="/" mode="M565"/>
      <xsl:apply-templates select="/" mode="M566"/>
      <xsl:apply-templates select="/" mode="M567"/>
      <xsl:apply-templates select="/" mode="M568"/>
      <xsl:apply-templates select="/" mode="M569"/>
      <xsl:apply-templates select="/" mode="M570"/>
      <xsl:apply-templates select="/" mode="M571"/>
      <xsl:apply-templates select="/" mode="M572"/>
      <xsl:apply-templates select="/" mode="M573"/>
      <xsl:apply-templates select="/" mode="M574"/>
      <xsl:apply-templates select="/" mode="M575"/>
      <xsl:apply-templates select="/" mode="M576"/>
      <xsl:apply-templates select="/" mode="M577"/>
      <xsl:apply-templates select="/" mode="M578"/>
      <xsl:apply-templates select="/" mode="M579"/>
      <xsl:apply-templates select="/" mode="M580"/>
      <xsl:apply-templates select="/" mode="M581"/>
      <xsl:apply-templates select="/" mode="M582"/>
      <xsl:apply-templates select="/" mode="M583"/>
      <xsl:apply-templates select="/" mode="M584"/>
      <xsl:apply-templates select="/" mode="M585"/>
      <xsl:apply-templates select="/" mode="M586"/>
      <xsl:apply-templates select="/" mode="M587"/>
      <xsl:apply-templates select="/" mode="M588"/>
      <xsl:apply-templates select="/" mode="M589"/>
      <xsl:apply-templates select="/" mode="M590"/>
      <xsl:apply-templates select="/" mode="M591"/>
      <xsl:apply-templates select="/" mode="M592"/>
      <xsl:apply-templates select="/" mode="M593"/>
      <xsl:apply-templates select="/" mode="M594"/>
      <xsl:apply-templates select="/" mode="M595"/>
      <xsl:apply-templates select="/" mode="M596"/>
      <xsl:apply-templates select="/" mode="M597"/>
      <xsl:apply-templates select="/" mode="M598"/>
      <xsl:apply-templates select="/" mode="M599"/>
      <xsl:apply-templates select="/" mode="M600"/>
      <xsl:apply-templates select="/" mode="M601"/>
      <xsl:apply-templates select="/" mode="M602"/>
      <xsl:apply-templates select="/" mode="M603"/>
      <xsl:apply-templates select="/" mode="M604"/>
      <xsl:apply-templates select="/" mode="M605"/>
      <xsl:apply-templates select="/" mode="M606"/>
      <xsl:apply-templates select="/" mode="M607"/>
      <xsl:apply-templates select="/" mode="M608"/>
      <xsl:apply-templates select="/" mode="M609"/>
      <xsl:apply-templates select="/" mode="M610"/>
      <xsl:apply-templates select="/" mode="M611"/>
      <xsl:apply-templates select="/" mode="M612"/>
      <xsl:apply-templates select="/" mode="M613"/>
      <xsl:apply-templates select="/" mode="M614"/>
      <xsl:apply-templates select="/" mode="M615"/>
      <xsl:apply-templates select="/" mode="M616"/>
      <xsl:apply-templates select="/" mode="M617"/>
      <xsl:apply-templates select="/" mode="M618"/>
      <xsl:apply-templates select="/" mode="M619"/>
      <xsl:apply-templates select="/" mode="M620"/>
      <xsl:apply-templates select="/" mode="M621"/>
      <xsl:apply-templates select="/" mode="M622"/>
      <xsl:apply-templates select="/" mode="M623"/>
      <xsl:apply-templates select="/" mode="M624"/>
      <xsl:apply-templates select="/" mode="M625"/>
      <xsl:apply-templates select="/" mode="M626"/>
      <xsl:apply-templates select="/" mode="M627"/>
      <xsl:apply-templates select="/" mode="M628"/>
      <xsl:apply-templates select="/" mode="M629"/>
      <xsl:apply-templates select="/" mode="M630"/>
      <xsl:apply-templates select="/" mode="M631"/>
      <xsl:apply-templates select="/" mode="M632"/>
      <xsl:apply-templates select="/" mode="M633"/>
      <xsl:apply-templates select="/" mode="M634"/>
      <xsl:apply-templates select="/" mode="M635"/>
      <xsl:apply-templates select="/" mode="M636"/>
      <xsl:apply-templates select="/" mode="M637"/>
      <xsl:apply-templates select="/" mode="M638"/>
      <xsl:apply-templates select="/" mode="M639"/>
      <xsl:apply-templates select="/" mode="M640"/>
      <xsl:apply-templates select="/" mode="M641"/>
      <xsl:apply-templates select="/" mode="M642"/>
      <xsl:apply-templates select="/" mode="M643"/>
      <xsl:apply-templates select="/" mode="M644"/>
      <xsl:apply-templates select="/" mode="M645"/>
      <xsl:apply-templates select="/" mode="M646"/>
      <xsl:apply-templates select="/" mode="M647"/>
      <xsl:apply-templates select="/" mode="M648"/>
      <xsl:apply-templates select="/" mode="M649"/>
      <xsl:apply-templates select="/" mode="M650"/>
      <xsl:apply-templates select="/" mode="M651"/>
      <xsl:apply-templates select="/" mode="M652"/>
      <xsl:apply-templates select="/" mode="M653"/>
      <xsl:apply-templates select="/" mode="M654"/>
      <xsl:apply-templates select="/" mode="M655"/>
      <xsl:apply-templates select="/" mode="M656"/>
      <xsl:apply-templates select="/" mode="M657"/>
      <xsl:apply-templates select="/" mode="M658"/>
      <xsl:apply-templates select="/" mode="M659"/>
      <xsl:apply-templates select="/" mode="M660"/>
      <xsl:apply-templates select="/" mode="M661"/>
      <xsl:apply-templates select="/" mode="M662"/>
      <xsl:apply-templates select="/" mode="M663"/>
      <xsl:apply-templates select="/" mode="M664"/>
      <xsl:apply-templates select="/" mode="M665"/>
      <xsl:apply-templates select="/" mode="M666"/>
      <xsl:apply-templates select="/" mode="M667"/>
      <xsl:apply-templates select="/" mode="M668"/>
      <xsl:apply-templates select="/" mode="M669"/>
      <xsl:apply-templates select="/" mode="M670"/>
      <xsl:apply-templates select="/" mode="M671"/>
      <xsl:apply-templates select="/" mode="M672"/>
      <xsl:apply-templates select="/" mode="M673"/>
      <xsl:apply-templates select="/" mode="M674"/>
      <xsl:apply-templates select="/" mode="M675"/>
      <xsl:apply-templates select="/" mode="M676"/>
      <xsl:apply-templates select="/" mode="M677"/>
      <xsl:apply-templates select="/" mode="M678"/>
      <xsl:apply-templates select="/" mode="M679"/>
      <xsl:apply-templates select="/" mode="M680"/>
      <xsl:apply-templates select="/" mode="M681"/>
      <xsl:apply-templates select="/" mode="M682"/>
      <xsl:apply-templates select="/" mode="M683"/>
      <xsl:apply-templates select="/" mode="M684"/>
      <xsl:apply-templates select="/" mode="M685"/>
      <xsl:apply-templates select="/" mode="M686"/>
      <xsl:apply-templates select="/" mode="M687"/>
      <xsl:apply-templates select="/" mode="M688"/>
      <xsl:apply-templates select="/" mode="M689"/>
      <xsl:apply-templates select="/" mode="M690"/>
      <xsl:apply-templates select="/" mode="M691"/>
      <xsl:apply-templates select="/" mode="M692"/>
      <xsl:apply-templates select="/" mode="M693"/>
      <xsl:apply-templates select="/" mode="M694"/>
      <xsl:apply-templates select="/" mode="M695"/>
      <xsl:apply-templates select="/" mode="M696"/>
      <xsl:apply-templates select="/" mode="M697"/>
      <xsl:apply-templates select="/" mode="M698"/>
      <xsl:apply-templates select="/" mode="M699"/>
      <xsl:apply-templates select="/" mode="M700"/>
      <xsl:apply-templates select="/" mode="M701"/>
      <xsl:apply-templates select="/" mode="M702"/>
      <xsl:apply-templates select="/" mode="M703"/>
      <xsl:apply-templates select="/" mode="M704"/>
      <xsl:apply-templates select="/" mode="M705"/>
      <xsl:apply-templates select="/" mode="M706"/>
      <xsl:apply-templates select="/" mode="M707"/>
      <xsl:apply-templates select="/" mode="M708"/>
      <xsl:apply-templates select="/" mode="M709"/>
      <xsl:apply-templates select="/" mode="M710"/>
      <xsl:apply-templates select="/" mode="M711"/>
      <xsl:apply-templates select="/" mode="M712"/>
      <xsl:apply-templates select="/" mode="M713"/>
      <xsl:apply-templates select="/" mode="M714"/>
      <xsl:apply-templates select="/" mode="M715"/>
      <xsl:apply-templates select="/" mode="M716"/>
      <xsl:apply-templates select="/" mode="M717"/>
      <xsl:apply-templates select="/" mode="M718"/>
      <xsl:apply-templates select="/" mode="M719"/>
      <xsl:apply-templates select="/" mode="M720"/>
      <xsl:apply-templates select="/" mode="M721"/>
      <xsl:apply-templates select="/" mode="M722"/>
      <xsl:apply-templates select="/" mode="M723"/>
      <xsl:apply-templates select="/" mode="M724"/>
      <xsl:apply-templates select="/" mode="M725"/>
      <xsl:apply-templates select="/" mode="M726"/>
      <xsl:apply-templates select="/" mode="M727"/>
      <xsl:apply-templates select="/" mode="M728"/>
      <xsl:apply-templates select="/" mode="M729"/>
      <xsl:apply-templates select="/" mode="M730"/>
      <xsl:apply-templates select="/" mode="M731"/>
      <xsl:apply-templates select="/" mode="M732"/>
      <xsl:apply-templates select="/" mode="M733"/>
      <xsl:apply-templates select="/" mode="M734"/>
      <xsl:apply-templates select="/" mode="M735"/>
      <xsl:apply-templates select="/" mode="M736"/>
      <xsl:apply-templates select="/" mode="M737"/>
      <xsl:apply-templates select="/" mode="M738"/>
      <xsl:apply-templates select="/" mode="M739"/>
      <xsl:apply-templates select="/" mode="M740"/>
      <xsl:apply-templates select="/" mode="M741"/>
      <xsl:apply-templates select="/" mode="M742"/>
      <xsl:apply-templates select="/" mode="M743"/>
      <xsl:apply-templates select="/" mode="M744"/>
      <xsl:apply-templates select="/" mode="M745"/>
      <xsl:apply-templates select="/" mode="M746"/>
      <xsl:apply-templates select="/" mode="M747"/>
      <xsl:apply-templates select="/" mode="M748"/>
      <xsl:apply-templates select="/" mode="M749"/>
      <xsl:apply-templates select="/" mode="M750"/>
      <xsl:apply-templates select="/" mode="M751"/>
      <xsl:apply-templates select="/" mode="M752"/>
      <xsl:apply-templates select="/" mode="M753"/>
      <xsl:apply-templates select="/" mode="M754"/>
      <xsl:apply-templates select="/" mode="M755"/>
      <xsl:apply-templates select="/" mode="M756"/>
      <xsl:apply-templates select="/" mode="M757"/>
      <xsl:apply-templates select="/" mode="M758"/>
      <xsl:apply-templates select="/" mode="M759"/>
      <xsl:apply-templates select="/" mode="M760"/>
      <xsl:apply-templates select="/" mode="M761"/>
      <xsl:apply-templates select="/" mode="M762"/>
      <xsl:apply-templates select="/" mode="M763"/>
      <xsl:apply-templates select="/" mode="M764"/>
      <xsl:apply-templates select="/" mode="M765"/>
      <xsl:apply-templates select="/" mode="M766"/>
      <xsl:apply-templates select="/" mode="M767"/>
      <xsl:apply-templates select="/" mode="M768"/>
      <xsl:apply-templates select="/" mode="M769"/>
      <xsl:apply-templates select="/" mode="M770"/>
      <xsl:apply-templates select="/" mode="M771"/>
      <xsl:apply-templates select="/" mode="M772"/>
      <xsl:apply-templates select="/" mode="M773"/>
      <xsl:apply-templates select="/" mode="M774"/>
      <xsl:apply-templates select="/" mode="M775"/>
      <xsl:apply-templates select="/" mode="M776"/>
      <xsl:apply-templates select="/" mode="M777"/>
      <xsl:apply-templates select="/" mode="M778"/>
      <xsl:apply-templates select="/" mode="M779"/>
      <xsl:apply-templates select="/" mode="M780"/>
      <xsl:apply-templates select="/" mode="M781"/>
      <xsl:apply-templates select="/" mode="M782"/>
      <xsl:apply-templates select="/" mode="M783"/>
      <xsl:apply-templates select="/" mode="M784"/>
      <xsl:apply-templates select="/" mode="M785"/>
      <xsl:apply-templates select="/" mode="M786"/>
      <xsl:apply-templates select="/" mode="M787"/>
      <xsl:apply-templates select="/" mode="M788"/>
      <xsl:apply-templates select="/" mode="M789"/>
      <xsl:apply-templates select="/" mode="M790"/>
      <xsl:apply-templates select="/" mode="M791"/>
      <xsl:apply-templates select="/" mode="M792"/>
      <xsl:apply-templates select="/" mode="M793"/>
      <xsl:apply-templates select="/" mode="M794"/>
      <xsl:apply-templates select="/" mode="M795"/>
      <xsl:apply-templates select="/" mode="M796"/>
      <xsl:apply-templates select="/" mode="M797"/>
      <xsl:apply-templates select="/" mode="M798"/>
      <xsl:apply-templates select="/" mode="M799"/>
      <xsl:apply-templates select="/" mode="M800"/>
      <xsl:apply-templates select="/" mode="M801"/>
      <xsl:apply-templates select="/" mode="M802"/>
      <xsl:apply-templates select="/" mode="M803"/>
      <xsl:apply-templates select="/" mode="M804"/>
      <xsl:apply-templates select="/" mode="M805"/>
      <xsl:apply-templates select="/" mode="M806"/>
      <xsl:apply-templates select="/" mode="M807"/>
      <xsl:apply-templates select="/" mode="M808"/>
      <xsl:apply-templates select="/" mode="M809"/>
      <xsl:apply-templates select="/" mode="M810"/>
      <xsl:apply-templates select="/" mode="M811"/>
      <xsl:apply-templates select="/" mode="M812"/>
      <xsl:apply-templates select="/" mode="M813"/>
      <xsl:apply-templates select="/" mode="M814"/>
      <xsl:apply-templates select="/" mode="M815"/>
      <xsl:apply-templates select="/" mode="M816"/>
      <xsl:apply-templates select="/" mode="M817"/>
      <xsl:apply-templates select="/" mode="M818"/>
      <xsl:apply-templates select="/" mode="M819"/>
      <xsl:apply-templates select="/" mode="M820"/>
      <xsl:apply-templates select="/" mode="M821"/>
      <xsl:apply-templates select="/" mode="M822"/>
      <xsl:apply-templates select="/" mode="M823"/>
      <xsl:apply-templates select="/" mode="M824"/>
      <xsl:apply-templates select="/" mode="M825"/>
      <xsl:apply-templates select="/" mode="M826"/>
      <xsl:apply-templates select="/" mode="M827"/>
      <xsl:apply-templates select="/" mode="M828"/>
      <xsl:apply-templates select="/" mode="M829"/>
      <xsl:apply-templates select="/" mode="M830"/>
      <xsl:apply-templates select="/" mode="M831"/>
      <xsl:apply-templates select="/" mode="M832"/>
      <xsl:apply-templates select="/" mode="M833"/>
      <xsl:apply-templates select="/" mode="M834"/>
      <xsl:apply-templates select="/" mode="M835"/>
      <xsl:apply-templates select="/" mode="M836"/>
      <xsl:apply-templates select="/" mode="M837"/>
      <xsl:apply-templates select="/" mode="M838"/>
      <xsl:apply-templates select="/" mode="M839"/>
      <xsl:apply-templates select="/" mode="M840"/>
      <xsl:apply-templates select="/" mode="M841"/>
      <xsl:apply-templates select="/" mode="M842"/>
      <xsl:apply-templates select="/" mode="M843"/>
      <xsl:apply-templates select="/" mode="M844"/>
      <xsl:apply-templates select="/" mode="M845"/>
      <xsl:apply-templates select="/" mode="M846"/>
      <xsl:apply-templates select="/" mode="M847"/>
      <xsl:apply-templates select="/" mode="M848"/>
      <xsl:apply-templates select="/" mode="M849"/>
      <xsl:apply-templates select="/" mode="M850"/>
      <xsl:apply-templates select="/" mode="M851"/>
      <xsl:apply-templates select="/" mode="M852"/>
      <xsl:apply-templates select="/" mode="M853"/>
      <xsl:apply-templates select="/" mode="M854"/>
      <xsl:apply-templates select="/" mode="M855"/>
      <xsl:apply-templates select="/" mode="M856"/>
      <xsl:apply-templates select="/" mode="M857"/>
      <xsl:apply-templates select="/" mode="M858"/>
      <xsl:apply-templates select="/" mode="M859"/>
      <xsl:apply-templates select="/" mode="M860"/>
      <xsl:apply-templates select="/" mode="M861"/>
      <xsl:apply-templates select="/" mode="M862"/>
      <xsl:apply-templates select="/" mode="M863"/>
      <xsl:apply-templates select="/" mode="M864"/>
      <xsl:apply-templates select="/" mode="M865"/>
      <xsl:apply-templates select="/" mode="M866"/>
      <xsl:apply-templates select="/" mode="M867"/>
      <xsl:apply-templates select="/" mode="M868"/>
      <xsl:apply-templates select="/" mode="M869"/>
      <xsl:apply-templates select="/" mode="M870"/>
      <xsl:apply-templates select="/" mode="M871"/>
      <xsl:apply-templates select="/" mode="M872"/>
      <xsl:apply-templates select="/" mode="M873"/>
      <xsl:apply-templates select="/" mode="M874"/>
      <xsl:apply-templates select="/" mode="M875"/>
      <xsl:apply-templates select="/" mode="M876"/>
      <xsl:apply-templates select="/" mode="M877"/>
      <xsl:apply-templates select="/" mode="M878"/>
      <xsl:apply-templates select="/" mode="M879"/>
      <xsl:apply-templates select="/" mode="M880"/>
      <xsl:apply-templates select="/" mode="M881"/>
      <xsl:apply-templates select="/" mode="M882"/>
      <xsl:apply-templates select="/" mode="M883"/>
      <xsl:apply-templates select="/" mode="M884"/>
      <xsl:apply-templates select="/" mode="M885"/>
      <xsl:apply-templates select="/" mode="M886"/>
      <xsl:apply-templates select="/" mode="M887"/>
      <xsl:apply-templates select="/" mode="M888"/>
      <xsl:apply-templates select="/" mode="M889"/>
      <xsl:apply-templates select="/" mode="M890"/>
      <xsl:apply-templates select="/" mode="M891"/>
      <xsl:apply-templates select="/" mode="M892"/>
      <xsl:apply-templates select="/" mode="M893"/>
      <xsl:apply-templates select="/" mode="M894"/>
      <xsl:apply-templates select="/" mode="M895"/>
      <xsl:apply-templates select="/" mode="M896"/>
      <xsl:apply-templates select="/" mode="M897"/>
      <xsl:apply-templates select="/" mode="M898"/>
      <xsl:apply-templates select="/" mode="M899"/>
      <xsl:apply-templates select="/" mode="M900"/>
      <xsl:apply-templates select="/" mode="M901"/>
      <xsl:apply-templates select="/" mode="M902"/>
      <xsl:apply-templates select="/" mode="M903"/>
      <xsl:apply-templates select="/" mode="M904"/>
      <xsl:apply-templates select="/" mode="M905"/>
      <xsl:apply-templates select="/" mode="M906"/>
      <xsl:apply-templates select="/" mode="M907"/>
      <xsl:apply-templates select="/" mode="M908"/>
      <xsl:apply-templates select="/" mode="M909"/>
      <xsl:apply-templates select="/" mode="M910"/>
      <xsl:apply-templates select="/" mode="M911"/>
      <xsl:apply-templates select="/" mode="M912"/>
      <xsl:apply-templates select="/" mode="M913"/>
      <xsl:apply-templates select="/" mode="M914"/>
      <xsl:apply-templates select="/" mode="M915"/>
      <xsl:apply-templates select="/" mode="M916"/>
      <xsl:apply-templates select="/" mode="M917"/>
      <xsl:apply-templates select="/" mode="M918"/>
      <xsl:apply-templates select="/" mode="M919"/>
      <xsl:apply-templates select="/" mode="M920"/>
      <xsl:apply-templates select="/" mode="M921"/>
      <xsl:apply-templates select="/" mode="M922"/>
      <xsl:apply-templates select="/" mode="M923"/>
      <xsl:apply-templates select="/" mode="M924"/>
      <xsl:apply-templates select="/" mode="M925"/>
      <xsl:apply-templates select="/" mode="M926"/>
      <xsl:apply-templates select="/" mode="M927"/>
      <xsl:apply-templates select="/" mode="M928"/>
      <xsl:apply-templates select="/" mode="M929"/>
      <xsl:apply-templates select="/" mode="M930"/>
      <xsl:apply-templates select="/" mode="M931"/>
      <xsl:apply-templates select="/" mode="M932"/>
      <xsl:apply-templates select="/" mode="M933"/>
      <xsl:apply-templates select="/" mode="M934"/>
      <xsl:apply-templates select="/" mode="M935"/>
      <xsl:apply-templates select="/" mode="M936"/>
      <xsl:apply-templates select="/" mode="M937"/>
      <xsl:apply-templates select="/" mode="M938"/>
      <xsl:apply-templates select="/" mode="M939"/>
      <xsl:apply-templates select="/" mode="M940"/>
      <xsl:apply-templates select="/" mode="M941"/>
      <xsl:apply-templates select="/" mode="M942"/>
      <xsl:apply-templates select="/" mode="M943"/>
      <xsl:apply-templates select="/" mode="M944"/>
      <xsl:apply-templates select="/" mode="M945"/>
      <xsl:apply-templates select="/" mode="M946"/>
      <xsl:apply-templates select="/" mode="M947"/>
      <xsl:apply-templates select="/" mode="M948"/>
      <xsl:apply-templates select="/" mode="M949"/>
      <xsl:apply-templates select="/" mode="M950"/>
      <xsl:apply-templates select="/" mode="M951"/>
      <xsl:apply-templates select="/" mode="M952"/>
      <xsl:apply-templates select="/" mode="M953"/>
      <xsl:apply-templates select="/" mode="M954"/>
      <xsl:apply-templates select="/" mode="M955"/>
      <xsl:apply-templates select="/" mode="M956"/>
      <xsl:apply-templates select="/" mode="M957"/>
      <xsl:apply-templates select="/" mode="M958"/>
      <xsl:apply-templates select="/" mode="M959"/>
      <xsl:apply-templates select="/" mode="M960"/>
      <xsl:apply-templates select="/" mode="M961"/>
      <xsl:apply-templates select="/" mode="M962"/>
      <xsl:apply-templates select="/" mode="M963"/>
      <xsl:apply-templates select="/" mode="M964"/>
      <xsl:apply-templates select="/" mode="M965"/>
      <xsl:apply-templates select="/" mode="M966"/>
      <xsl:apply-templates select="/" mode="M967"/>
      <xsl:apply-templates select="/" mode="M968"/>
      <xsl:apply-templates select="/" mode="M969"/>
      <xsl:apply-templates select="/" mode="M970"/>
      <xsl:apply-templates select="/" mode="M971"/>
      <xsl:apply-templates select="/" mode="M972"/>
      <xsl:apply-templates select="/" mode="M973"/>
      <xsl:apply-templates select="/" mode="M974"/>
      <xsl:apply-templates select="/" mode="M975"/>
      <xsl:apply-templates select="/" mode="M976"/>
      <xsl:apply-templates select="/" mode="M977"/>
      <xsl:apply-templates select="/" mode="M978"/>
      <xsl:apply-templates select="/" mode="M979"/>
      <xsl:apply-templates select="/" mode="M980"/>
      <xsl:apply-templates select="/" mode="M981"/>
      <xsl:apply-templates select="/" mode="M982"/>
      <xsl:apply-templates select="/" mode="M983"/>
      <xsl:apply-templates select="/" mode="M984"/>
      <xsl:apply-templates select="/" mode="M985"/>
      <xsl:apply-templates select="/" mode="M986"/>
      <xsl:apply-templates select="/" mode="M987"/>
      <xsl:apply-templates select="/" mode="M988"/>
      <xsl:apply-templates select="/" mode="M989"/>
      <xsl:apply-templates select="/" mode="M990"/>
      <xsl:apply-templates select="/" mode="M991"/>
      <xsl:apply-templates select="/" mode="M992"/>
      <xsl:apply-templates select="/" mode="M993"/>
      <xsl:apply-templates select="/" mode="M994"/>
      <xsl:apply-templates select="/" mode="M995"/>
      <xsl:apply-templates select="/" mode="M996"/>
      <xsl:apply-templates select="/" mode="M997"/>
      <xsl:apply-templates select="/" mode="M998"/>
      <xsl:apply-templates select="/" mode="M999"/>
      <xsl:apply-templates select="/" mode="M1000"/>
      <xsl:apply-templates select="/" mode="M1001"/>
      <xsl:apply-templates select="/" mode="M1002"/>
      <xsl:apply-templates select="/" mode="M1003"/>
      <xsl:apply-templates select="/" mode="M1004"/>
      <xsl:apply-templates select="/" mode="M1005"/>
      <xsl:apply-templates select="/" mode="M1006"/>
      <xsl:apply-templates select="/" mode="M1007"/>
      <xsl:apply-templates select="/" mode="M1008"/>
      <xsl:apply-templates select="/" mode="M1009"/>
      <xsl:apply-templates select="/" mode="M1010"/>
      <xsl:apply-templates select="/" mode="M1011"/>
      <xsl:apply-templates select="/" mode="M1012"/>
      <xsl:apply-templates select="/" mode="M1013"/>
      <xsl:apply-templates select="/" mode="M1014"/>
      <xsl:apply-templates select="/" mode="M1015"/>
      <xsl:apply-templates select="/" mode="M1016"/>
      <xsl:apply-templates select="/" mode="M1017"/>
      <xsl:apply-templates select="/" mode="M1018"/>
      <xsl:apply-templates select="/" mode="M1019"/>
      <xsl:apply-templates select="/" mode="M1020"/>
      <xsl:apply-templates select="/" mode="M1021"/>
      <xsl:apply-templates select="/" mode="M1022"/>
      <xsl:apply-templates select="/" mode="M1023"/>
      <xsl:apply-templates select="/" mode="M1024"/>
      <xsl:apply-templates select="/" mode="M1025"/>
      <xsl:apply-templates select="/" mode="M1026"/>
      <xsl:apply-templates select="/" mode="M1027"/>
      <xsl:apply-templates select="/" mode="M1028"/>
      <xsl:apply-templates select="/" mode="M1029"/>
      <xsl:apply-templates select="/" mode="M1030"/>
      <xsl:apply-templates select="/" mode="M1031"/>
      <xsl:apply-templates select="/" mode="M1032"/>
      <xsl:apply-templates select="/" mode="M1033"/>
      <xsl:apply-templates select="/" mode="M1034"/>
      <xsl:apply-templates select="/" mode="M1035"/>
      <xsl:apply-templates select="/" mode="M1036"/>
      <xsl:apply-templates select="/" mode="M1037"/>
      <xsl:apply-templates select="/" mode="M1038"/>
      <xsl:apply-templates select="/" mode="M1039"/>
      <xsl:apply-templates select="/" mode="M1040"/>
      <xsl:apply-templates select="/" mode="M1041"/>
      <xsl:apply-templates select="/" mode="M1042"/>
      <xsl:apply-templates select="/" mode="M1043"/>
      <xsl:apply-templates select="/" mode="M1044"/>
      <xsl:apply-templates select="/" mode="M1045"/>
      <xsl:apply-templates select="/" mode="M1046"/>
      <xsl:apply-templates select="/" mode="M1047"/>
      <xsl:apply-templates select="/" mode="M1048"/>
      <xsl:apply-templates select="/" mode="M1049"/>
      <xsl:apply-templates select="/" mode="M1050"/>
      <xsl:apply-templates select="/" mode="M1051"/>
      <xsl:apply-templates select="/" mode="M1052"/>
      <xsl:apply-templates select="/" mode="M1053"/>
      <xsl:apply-templates select="/" mode="M1054"/>
      <xsl:apply-templates select="/" mode="M1055"/>
      <xsl:apply-templates select="/" mode="M1056"/>
      <xsl:apply-templates select="/" mode="M1057"/>
      <xsl:apply-templates select="/" mode="M1058"/>
      <xsl:apply-templates select="/" mode="M1059"/>
      <xsl:apply-templates select="/" mode="M1060"/>
      <xsl:apply-templates select="/" mode="M1061"/>
      <xsl:apply-templates select="/" mode="M1062"/>
      <xsl:apply-templates select="/" mode="M1063"/>
      <xsl:apply-templates select="/" mode="M1064"/>
      <xsl:apply-templates select="/" mode="M1065"/>
      <xsl:apply-templates select="/" mode="M1066"/>
      <xsl:apply-templates select="/" mode="M1067"/>
      <xsl:apply-templates select="/" mode="M1068"/>
      <xsl:apply-templates select="/" mode="M1069"/>
      <xsl:apply-templates select="/" mode="M1070"/>
      <xsl:apply-templates select="/" mode="M1071"/>
      <xsl:apply-templates select="/" mode="M1072"/>
      <xsl:apply-templates select="/" mode="M1073"/>
      <xsl:apply-templates select="/" mode="M1074"/>
      <xsl:apply-templates select="/" mode="M1075"/>
      <xsl:apply-templates select="/" mode="M1076"/>
      <xsl:apply-templates select="/" mode="M1077"/>
      <xsl:apply-templates select="/" mode="M1078"/>
      <xsl:apply-templates select="/" mode="M1079"/>
      <xsl:apply-templates select="/" mode="M1080"/>
      <xsl:apply-templates select="/" mode="M1081"/>
      <xsl:apply-templates select="/" mode="M1082"/>
      <xsl:apply-templates select="/" mode="M1083"/>
      <xsl:apply-templates select="/" mode="M1084"/>
      <xsl:apply-templates select="/" mode="M1085"/>
      <xsl:apply-templates select="/" mode="M1086"/>
      <xsl:apply-templates select="/" mode="M1087"/>
      <xsl:apply-templates select="/" mode="M1088"/>
      <xsl:apply-templates select="/" mode="M1089"/>
      <xsl:apply-templates select="/" mode="M1090"/>
      <xsl:apply-templates select="/" mode="M1091"/>
      <xsl:apply-templates select="/" mode="M1092"/>
      <xsl:apply-templates select="/" mode="M1093"/>
      <xsl:apply-templates select="/" mode="M1094"/>
      <xsl:apply-templates select="/" mode="M1095"/>
      <xsl:apply-templates select="/" mode="M1096"/>
      <xsl:apply-templates select="/" mode="M1097"/>
      <xsl:apply-templates select="/" mode="M1098"/>
      <xsl:apply-templates select="/" mode="M1099"/>
      <xsl:apply-templates select="/" mode="M1100"/>
      <xsl:apply-templates select="/" mode="M1101"/>
      <xsl:apply-templates select="/" mode="M1102"/>
      <xsl:apply-templates select="/" mode="M1103"/>
      <xsl:apply-templates select="/" mode="M1104"/>
      <xsl:apply-templates select="/" mode="M1105"/>
      <xsl:apply-templates select="/" mode="M1106"/>
      <xsl:apply-templates select="/" mode="M1107"/>
      <xsl:apply-templates select="/" mode="M1108"/>
      <xsl:apply-templates select="/" mode="M1109"/>
      <xsl:apply-templates select="/" mode="M1110"/>
      <xsl:apply-templates select="/" mode="M1111"/>
      <xsl:apply-templates select="/" mode="M1112"/>
      <xsl:apply-templates select="/" mode="M1113"/>
      <xsl:apply-templates select="/" mode="M1114"/>
      <xsl:apply-templates select="/" mode="M1115"/>
      <xsl:apply-templates select="/" mode="M1116"/>
      <xsl:apply-templates select="/" mode="M1117"/>
      <xsl:apply-templates select="/" mode="M1118"/>
      <xsl:apply-templates select="/" mode="M1119"/>
      <xsl:apply-templates select="/" mode="M1120"/>
      <xsl:apply-templates select="/" mode="M1121"/>
      <xsl:apply-templates select="/" mode="M1122"/>
      <xsl:apply-templates select="/" mode="M1123"/>
      <xsl:apply-templates select="/" mode="M1124"/>
      <xsl:apply-templates select="/" mode="M1125"/>
      <xsl:apply-templates select="/" mode="M1126"/>
      <xsl:apply-templates select="/" mode="M1127"/>
      <xsl:apply-templates select="/" mode="M1128"/>
      <xsl:apply-templates select="/" mode="M1129"/>
      <xsl:apply-templates select="/" mode="M1130"/>
      <xsl:apply-templates select="/" mode="M1131"/>
      <xsl:apply-templates select="/" mode="M1132"/>
      <xsl:apply-templates select="/" mode="M1133"/>
      <xsl:apply-templates select="/" mode="M1134"/>
      <xsl:apply-templates select="/" mode="M1135"/>
      <xsl:apply-templates select="/" mode="M1136"/>
      <xsl:apply-templates select="/" mode="M1137"/>
      <xsl:apply-templates select="/" mode="M1138"/>
      <xsl:apply-templates select="/" mode="M1139"/>
      <xsl:apply-templates select="/" mode="M1140"/>
      <xsl:apply-templates select="/" mode="M1141"/>
      <xsl:apply-templates select="/" mode="M1142"/>
      <xsl:apply-templates select="/" mode="M1143"/>
      <xsl:apply-templates select="/" mode="M1144"/>
      <xsl:apply-templates select="/" mode="M1145"/>
      <xsl:apply-templates select="/" mode="M1146"/>
      <xsl:apply-templates select="/" mode="M1147"/>
      <xsl:apply-templates select="/" mode="M1148"/>
      <xsl:apply-templates select="/" mode="M1149"/>
      <xsl:apply-templates select="/" mode="M1150"/>
      <xsl:apply-templates select="/" mode="M1151"/>
      <xsl:apply-templates select="/" mode="M1152"/>
      <xsl:apply-templates select="/" mode="M1153"/>
      <xsl:apply-templates select="/" mode="M1154"/>
      <xsl:apply-templates select="/" mode="M1155"/>
      <xsl:apply-templates select="/" mode="M1156"/>
      <xsl:apply-templates select="/" mode="M1157"/>
      <xsl:apply-templates select="/" mode="M1158"/>
      <xsl:apply-templates select="/" mode="M1159"/>
      <xsl:apply-templates select="/" mode="M1160"/>
      <xsl:apply-templates select="/" mode="M1161"/>
      <xsl:apply-templates select="/" mode="M1162"/>
      <xsl:apply-templates select="/" mode="M1163"/>
      <xsl:apply-templates select="/" mode="M1164"/>
      <xsl:apply-templates select="/" mode="M1165"/>
      <xsl:apply-templates select="/" mode="M1166"/>
      <xsl:apply-templates select="/" mode="M1167"/>
      <xsl:apply-templates select="/" mode="M1168"/>
      <xsl:apply-templates select="/" mode="M1169"/>
      <xsl:apply-templates select="/" mode="M1170"/>
      <xsl:apply-templates select="/" mode="M1171"/>
      <xsl:apply-templates select="/" mode="M1172"/>
      <xsl:apply-templates select="/" mode="M1173"/>
      <xsl:apply-templates select="/" mode="M1174"/>
      <xsl:apply-templates select="/" mode="M1175"/>
      <xsl:apply-templates select="/" mode="M1176"/>
      <xsl:apply-templates select="/" mode="M1177"/>
      <xsl:apply-templates select="/" mode="M1178"/>
      <xsl:apply-templates select="/" mode="M1179"/>
      <xsl:apply-templates select="/" mode="M1180"/>
      <xsl:apply-templates select="/" mode="M1181"/>
      <xsl:apply-templates select="/" mode="M1182"/>
      <xsl:apply-templates select="/" mode="M1183"/>
      <xsl:apply-templates select="/" mode="M1184"/>
      <xsl:apply-templates select="/" mode="M1185"/>
      <xsl:apply-templates select="/" mode="M1186"/>
      <xsl:apply-templates select="/" mode="M1187"/>
      <xsl:apply-templates select="/" mode="M1188"/>
      <xsl:apply-templates select="/" mode="M1189"/>
      <xsl:apply-templates select="/" mode="M1190"/>
      <xsl:apply-templates select="/" mode="M1191"/>
      <xsl:apply-templates select="/" mode="M1192"/>
      <xsl:apply-templates select="/" mode="M1193"/>
      <xsl:apply-templates select="/" mode="M1194"/>
      <xsl:apply-templates select="/" mode="M1195"/>
      <xsl:apply-templates select="/" mode="M1196"/>
      <xsl:apply-templates select="/" mode="M1197"/>
      <xsl:apply-templates select="/" mode="M1198"/>
      <xsl:apply-templates select="/" mode="M1199"/>
      <xsl:apply-templates select="/" mode="M1200"/>
      <xsl:apply-templates select="/" mode="M1201"/>
      <xsl:apply-templates select="/" mode="M1202"/>
      <xsl:apply-templates select="/" mode="M1203"/>
      <xsl:apply-templates select="/" mode="M1204"/>
      <xsl:apply-templates select="/" mode="M1205"/>
      <xsl:apply-templates select="/" mode="M1206"/>
      <xsl:apply-templates select="/" mode="M1207"/>
      <xsl:apply-templates select="/" mode="M1208"/>
      <xsl:apply-templates select="/" mode="M1209"/>
      <xsl:apply-templates select="/" mode="M1210"/>
      <xsl:apply-templates select="/" mode="M1211"/>
      <xsl:apply-templates select="/" mode="M1212"/>
      <xsl:apply-templates select="/" mode="M1213"/>
      <xsl:apply-templates select="/" mode="M1214"/>
      <xsl:apply-templates select="/" mode="M1215"/>
      <xsl:apply-templates select="/" mode="M1216"/>
      <xsl:apply-templates select="/" mode="M1217"/>
      <xsl:apply-templates select="/" mode="M1218"/>
      <xsl:apply-templates select="/" mode="M1219"/>
      <xsl:apply-templates select="/" mode="M1220"/>
      <xsl:apply-templates select="/" mode="M1221"/>
      <xsl:apply-templates select="/" mode="M1222"/>
      <xsl:apply-templates select="/" mode="M1223"/>
      <xsl:apply-templates select="/" mode="M1224"/>
      <xsl:apply-templates select="/" mode="M1225"/>
      <xsl:apply-templates select="/" mode="M1226"/>
      <xsl:apply-templates select="/" mode="M1227"/>
      <xsl:apply-templates select="/" mode="M1228"/>
      <xsl:apply-templates select="/" mode="M1229"/>
      <xsl:apply-templates select="/" mode="M1230"/>
      <xsl:apply-templates select="/" mode="M1231"/>
      <xsl:apply-templates select="/" mode="M1232"/>
      <xsl:apply-templates select="/" mode="M1233"/>
      <xsl:apply-templates select="/" mode="M1234"/>
      <xsl:apply-templates select="/" mode="M1235"/>
      <xsl:apply-templates select="/" mode="M1236"/>
      <xsl:apply-templates select="/" mode="M1237"/>
      <xsl:apply-templates select="/" mode="M1238"/>
      <xsl:apply-templates select="/" mode="M1239"/>
      <xsl:apply-templates select="/" mode="M1240"/>
      <xsl:apply-templates select="/" mode="M1241"/>
      <xsl:apply-templates select="/" mode="M1242"/>
      <xsl:apply-templates select="/" mode="M1243"/>
      <xsl:apply-templates select="/" mode="M1244"/>
      <xsl:apply-templates select="/" mode="M1245"/>
      <xsl:apply-templates select="/" mode="M1246"/>
      <xsl:apply-templates select="/" mode="M1247"/>
      <xsl:apply-templates select="/" mode="M1248"/>
      <xsl:apply-templates select="/" mode="M1249"/>
      <xsl:apply-templates select="/" mode="M1250"/>
      <xsl:apply-templates select="/" mode="M1251"/>
      <xsl:apply-templates select="/" mode="M1252"/>
      <xsl:apply-templates select="/" mode="M1253"/>
      <xsl:apply-templates select="/" mode="M1254"/>
      <xsl:apply-templates select="/" mode="M1255"/>
      <xsl:apply-templates select="/" mode="M1256"/>
   </xsl:template>

   <!--SCHEMATRON PATTERNS-->


<!--PATTERN none_exist_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:tests/child::*" priority="1000"
                 mode="M19">

		<!--REPORT -->
<xsl:if test="@check='none exist'"> DEPRECATED ATTRIBUTE VALUE IN: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ATTRIBUTE VALUE: <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M19"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M19"/>
   <xsl:template match="@*|node()" priority="-2" mode="M19">
      <xsl:apply-templates select="@*|*" mode="M19"/>
   </xsl:template>

   <!--PATTERN empty_def_doc-->


	<!--RULE -->
<xsl:template match="oval-def:oval_definitions" priority="1000" mode="M20">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="oval-def:definitions or oval-def:tests or oval-def:objects or oval-def:states or oval-def:variables"/>
         <xsl:otherwise>A valid OVAL Definition document must contain at least one definitions, tests, objects, states, or variables element. The optional definitions, tests, objects, states, and variables sections define the specific characteristics that should be evaluated on a system to determine the truth values of the OVAL Definition Document. To be valid though, at least one definitions, tests, objects, states, or variables element must be present.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M20"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M20"/>
   <xsl:template match="@*|node()" priority="-2" mode="M20">
      <xsl:apply-templates select="@*|*" mode="M20"/>
   </xsl:template>

   <!--PATTERN required_criteria-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:definitions/oval-def:definition[@deprecated='false' or not(@deprecated)]"
                 priority="1000"
                 mode="M21">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="oval-def:criteria"/>
         <xsl:otherwise>A valid OVAL Definition document must contain a criteria unless the definition is a deprecated definition.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M21"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M21"/>
   <xsl:template match="@*|node()" priority="-2" mode="M21">
      <xsl:apply-templates select="@*|*" mode="M21"/>
   </xsl:template>

   <!--PATTERN test_type-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:tests/*[@check_existence='none_exist']"
                 priority="1000"
                 mode="M22">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(*[name()='state'])"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="@id"/>
            <xsl:text/> - No state should be referenced when check_existence has a value of 'none_exist'.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M22"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M22"/>
   <xsl:template match="@*|node()" priority="-2" mode="M22">
      <xsl:apply-templates select="@*|*" mode="M22"/>
   </xsl:template>

   <!--PATTERN setobjref-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/*/oval-def:set/oval-def:object_reference"
                 priority="1002"
                 mode="M23">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="name(./../..) = name(/oval-def:oval_definitions/oval-def:objects/*[@id=current()])"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../../@id"/>
            <xsl:text/> - Each object referenced by the set must be of the same type as parent object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M23"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/*/oval-def:set/oval-def:set/oval-def:object_reference"
                 priority="1001"
                 mode="M23">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="name(./../../..) = name(/oval-def:oval_definitions/oval-def:objects/*[@id=current()])"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../../../@id"/>
            <xsl:text/> - Each object referenced by the set must be of the same type as parent object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M23"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/*/oval-def:set/oval-def:set/oval-def:set/oval-def:object_reference"
                 priority="1000"
                 mode="M23">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="name(./../../../..) = name(/oval-def:oval_definitions/oval-def:objects/*[@id=current()])"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../../../../@id"/>
            <xsl:text/> - Each object referenced by the set must be of the same type as parent object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M23"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M23"/>
   <xsl:template match="@*|node()" priority="-2" mode="M23">
      <xsl:apply-templates select="@*|*" mode="M23"/>
   </xsl:template>

   <!--PATTERN value-->


	<!--RULE -->
<xsl:template match="oval-def:constant_variable/oval-def:value" priority="1000" mode="M24">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test=".!=''"/>
         <xsl:otherwise>The value element of the constant_variable <xsl:text/>
            <xsl:value-of select="../../@id"/>
            <xsl:text/> can not be empty.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M24"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M24"/>
   <xsl:template match="@*|node()" priority="-2" mode="M24">
      <xsl:apply-templates select="@*|*" mode="M24"/>
   </xsl:template>

   <!--PATTERN literal_component-->


	<!--RULE -->
<xsl:template match="oval-def:literal_component" priority="1000" mode="M25">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test=".!=''"/>
         <xsl:otherwise>The literal_component of variable <xsl:text/>
            <xsl:value-of select="../../@id"/>
            <xsl:text/> can not be empty.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M25"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M25"/>
   <xsl:template match="@*|node()" priority="-2" mode="M25">
      <xsl:apply-templates select="@*|*" mode="M25"/>
   </xsl:template>

   <!--PATTERN item_field-->


	<!--RULE -->
<xsl:template match="oval-def:object_component" priority="1000" mode="M26">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@item_field!=''"/>
         <xsl:otherwise>The item_field attribute of an object_component of variable <xsl:text/>
            <xsl:value-of select="../../@id"/>
            <xsl:text/> can not be empty.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M26"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M26"/>
   <xsl:template match="@*|node()" priority="-2" mode="M26">
      <xsl:apply-templates select="@*|*" mode="M26"/>
   </xsl:template>

   <!--PATTERN arithmeticfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:arithmetic/oval-def:literal_component" priority="1001"
                 mode="M27">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='float' or @datatype='int'"/>
         <xsl:otherwise>A literal_component used by an arithmetic function must have a datatype of float or int.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M27"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:arithmetic/oval-def:variable_component" priority="1000"
                 mode="M27">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype='float' or //oval-def:variables/*[@id=$var_ref]/@datatype='int'"/>
         <xsl:otherwise>The variable referenced by the arithmetic function must have a datatype of float or int.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M27"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M27"/>
   <xsl:template match="@*|node()" priority="-2" mode="M27">
      <xsl:apply-templates select="@*|*" mode="M27"/>
   </xsl:template>

   <!--PATTERN beginfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:begin/oval-def:literal_component" priority="1001" mode="M28">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the begin function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M28"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:begin/oval-def:variable_component" priority="1000" mode="M28">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the begin function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M28"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M28"/>
   <xsl:template match="@*|node()" priority="-2" mode="M28">
      <xsl:apply-templates select="@*|*" mode="M28"/>
   </xsl:template>

   <!--PATTERN concatfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:concat/oval-def:literal_component" priority="1001" mode="M29">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the concat function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M29"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:concat/oval-def:variable_component" priority="1000" mode="M29">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the concat function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M29"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M29"/>
   <xsl:template match="@*|node()" priority="-2" mode="M29">
      <xsl:apply-templates select="@*|*" mode="M29"/>
   </xsl:template>

   <!--PATTERN endfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:end/oval-def:literal_component" priority="1001" mode="M30">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the end function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M30"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:end/oval-def:variable_component" priority="1000" mode="M30">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the end function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M30"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M30"/>
   <xsl:template match="@*|node()" priority="-2" mode="M30">
      <xsl:apply-templates select="@*|*" mode="M30"/>
   </xsl:template>

   <!--PATTERN escaperegexfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:escape_regex/oval-def:literal_component" priority="1001"
                 mode="M31">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the escape_regex function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M31"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:escape_regex/oval-def:variable_component" priority="1000"
                 mode="M31">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the escape_regex function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M31"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M31"/>
   <xsl:template match="@*|node()" priority="-2" mode="M31">
      <xsl:apply-templates select="@*|*" mode="M31"/>
   </xsl:template>

   <!--PATTERN splitfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:split/oval-def:literal_component" priority="1001" mode="M32">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the split function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M32"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:split/oval-def:variable_component" priority="1000" mode="M32">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the split function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M32"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M32"/>
   <xsl:template match="@*|node()" priority="-2" mode="M32">
      <xsl:apply-templates select="@*|*" mode="M32"/>
   </xsl:template>

   <!--PATTERN substringfunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:substring/oval-def:literal_component" priority="1001"
                 mode="M33">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the substring function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M33"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:substring/oval-def:variable_component" priority="1000"
                 mode="M33">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the substring function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M33"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M33"/>
   <xsl:template match="@*|node()" priority="-2" mode="M33">
      <xsl:apply-templates select="@*|*" mode="M33"/>
   </xsl:template>

   <!--PATTERN timedifferencefunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:time_difference/oval-def:literal_component" priority="1001"
                 mode="M34">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string' or @datatype='int'"/>
         <xsl:otherwise>A literal_component used by the time_difference function must have a datatype of string or int.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M34"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:time_difference/oval-def:variable_component" priority="1000"
                 mode="M34">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype='string' or //oval-def:variables/*[@id=$var_ref]/@datatype='int'"/>
         <xsl:otherwise>The variable referenced by the time_difference function must have a datatype of string or int.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M34"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M34"/>
   <xsl:template match="@*|node()" priority="-2" mode="M34">
      <xsl:apply-templates select="@*|*" mode="M34"/>
   </xsl:template>

   <!--PATTERN regexcapturefunctionrules-->


	<!--RULE -->
<xsl:template match="oval-def:regex_capture/oval-def:literal_component" priority="1001"
                 mode="M35">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>A literal_component used by the regex_capture function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M35"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:regex_capture/oval-def:variable_component" priority="1000"
                 mode="M35">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="//oval-def:variables/*[@id=$var_ref]/@datatype = 'string'"/>
         <xsl:otherwise>The variable referenced by the regex_capture function must have a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M35"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M35"/>
   <xsl:template match="@*|node()" priority="-2" mode="M35">
      <xsl:apply-templates select="@*|*" mode="M35"/>
   </xsl:template>

   <!--PATTERN definition_entity_rules-->


	<!--RULE -->
<xsl:template match="oval-def:objects/*/*[@var_ref]|oval-def:states/*/*[@var_ref]"
                 priority="1010"
                 mode="M36">
      <xsl:variable name="var_ref" select="@var_ref"/>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test=".=''"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - a var_ref has been supplied for the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity so no value should be provided<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="( (not(@datatype)) and ('string' = //oval-def:variables/*[@id=$var_ref]/@datatype) ) or (@datatype = //oval-def:variables/*[@id=$var_ref]/@datatype)"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="$var_ref"/>
            <xsl:text/> - inconsistent datatype between the variable and an associated var_ref<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[not(@datatype)]|oval-def:states/*/*[not(@datatype)]"
                 priority="1009"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='case insensitive equals' or @operation='case insensitive not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given the lack of a declared datatype (hence a default datatype of string).<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='binary']|oval-def:states/*/*[@datatype='binary']"
                 priority="1008"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of binary.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='boolean']|oval-def:states/*/*[@datatype='boolean']"
                 priority="1007"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of boolean.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='evr_string']|oval-def:states/*/*[@datatype='evr_string']"
                 priority="1006"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or  @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of evr_string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='fileset_revision']|oval-def:states/*/*[@datatype='fileset_revision']"
                 priority="1005"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or  @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of fileset_revision.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='float']|oval-def:states/*/*[@datatype='float']"
                 priority="1004"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of float.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='ios_version']|oval-def:states/*/*[@datatype='ios_version']"
                 priority="1003"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of ios_version.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='int']|oval-def:states/*/*[@datatype='int']"
                 priority="1002"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or @operation='bitwise and' or @operation='bitwise or'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of int.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='string']|oval-def:states/*/*[@datatype='string']"
                 priority="1001"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='case insensitive equals' or @operation='case insensitive not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of string.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@datatype='version']|oval-def:states/*/*[@datatype='version']"
                 priority="1000"
                 mode="M36">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The use of '<xsl:text/>
            <xsl:value-of select="@operation"/>
            <xsl:text/>' for the operation attribute of the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity is not valid given a datatype of version.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M36"/>
   <xsl:template match="@*|node()" priority="-2" mode="M36">
      <xsl:apply-templates select="@*|*" mode="M36"/>
   </xsl:template>

   <!--PATTERN entityobjectbaserules-->


	<!--RULE -->
<xsl:template match="oval-def:objects/*/*[@var_ref]" priority="1001" mode="M37">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@var_check"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - a var_ref has been supplied for the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity so a var_check should also be provided<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M37"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:objects/*/*[@var_check]" priority="1000" mode="M37">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@var_ref"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - a var_check has been supplied for the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity so a var_ref should also be provided<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M37"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M37"/>
   <xsl:template match="@*|node()" priority="-2" mode="M37">
      <xsl:apply-templates select="@*|*" mode="M37"/>
   </xsl:template>

   <!--PATTERN entitystatebaserules-->


	<!--RULE -->
<xsl:template match="oval-def:states/*/*[@var_ref]" priority="1001" mode="M38">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@var_check"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - a var_ref has been supplied for the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity so a var_check should also be provided<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M38"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="oval-def:states/*/*[@var_check]" priority="1000" mode="M38">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@var_ref"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - a var_check has been supplied for the <xsl:text/>
            <xsl:value-of select="name()"/>
            <xsl:text/> entity so a var_ref should also be provided<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M38"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M38"/>
   <xsl:template match="@*|node()" priority="-2" mode="M38">
      <xsl:apply-templates select="@*|*" mode="M38"/>
   </xsl:template>

   <!--PATTERN famtst-->


	<!--RULE -->
<xsl:template match="ind-def:family_test/ind-def:object" priority="1001" mode="M39">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:family_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a family_test must reference a family_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M39"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:family_test/ind-def:state" priority="1000" mode="M39">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:family_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a family_test must reference a family_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M39"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M39"/>
   <xsl:template match="@*|node()" priority="-2" mode="M39">
      <xsl:apply-templates select="@*|*" mode="M39"/>
   </xsl:template>

   <!--PATTERN famstefamily-->


	<!--RULE -->
<xsl:template match="ind-def:family_state/ind-def:family" priority="1000" mode="M40">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the family entity of a family_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M40"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M40"/>
   <xsl:template match="@*|node()" priority="-2" mode="M40">
      <xsl:apply-templates select="@*|*" mode="M40"/>
   </xsl:template>

   <!--PATTERN md5tst_dep-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_test" priority="1000" mode="M41">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M41"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M41"/>
   <xsl:template match="@*|node()" priority="-2" mode="M41">
      <xsl:apply-templates select="@*|*" mode="M41"/>
   </xsl:template>

   <!--PATTERN md5tst-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_test/ind-def:object" priority="1001" mode="M42">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:filemd5_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a filemd5_test must reference a filemd5_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M42"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:filemd5_test/ind-def:state" priority="1000" mode="M42">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:filemd5_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a filemd5_test must reference a filemd5_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M42"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M42"/>
   <xsl:template match="@*|node()" priority="-2" mode="M42">
      <xsl:apply-templates select="@*|*" mode="M42"/>
   </xsl:template>

   <!--PATTERN md5obj_dep-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_object" priority="1000" mode="M43">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M43"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M43"/>
   <xsl:template match="@*|node()" priority="-2" mode="M43">
      <xsl:apply-templates select="@*|*" mode="M43"/>
   </xsl:template>

   <!--PATTERN md5objpath-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_object/ind-def:path" priority="1000" mode="M44">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a filemd5_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M44"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M44"/>
   <xsl:template match="@*|node()" priority="-2" mode="M44">
      <xsl:apply-templates select="@*|*" mode="M44"/>
   </xsl:template>

   <!--PATTERN md5objfilename-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_object/ind-def:filename" priority="1000" mode="M45">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a filemd5_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M45"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M45"/>
   <xsl:template match="@*|node()" priority="-2" mode="M45">
      <xsl:apply-templates select="@*|*" mode="M45"/>
   </xsl:template>

   <!--PATTERN md5ste_dep-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_state" priority="1000" mode="M46">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M46"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M46"/>
   <xsl:template match="@*|node()" priority="-2" mode="M46">
      <xsl:apply-templates select="@*|*" mode="M46"/>
   </xsl:template>

   <!--PATTERN md5stepath-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_state/ind-def:path" priority="1000" mode="M47">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a filemd5_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M47"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M47"/>
   <xsl:template match="@*|node()" priority="-2" mode="M47">
      <xsl:apply-templates select="@*|*" mode="M47"/>
   </xsl:template>

   <!--PATTERN md5stefilename-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_state/ind-def:filename" priority="1000" mode="M48">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a filemd5_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M48"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M48"/>
   <xsl:template match="@*|node()" priority="-2" mode="M48">
      <xsl:apply-templates select="@*|*" mode="M48"/>
   </xsl:template>

   <!--PATTERN md5stemd5-->


	<!--RULE -->
<xsl:template match="ind-def:filemd5_state/ind-def:md5" priority="1000" mode="M49">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the md5 entity of a filemd5_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M49"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M49"/>
   <xsl:template match="@*|node()" priority="-2" mode="M49">
      <xsl:apply-templates select="@*|*" mode="M49"/>
   </xsl:template>

   <!--PATTERN hashtst-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_test/ind-def:object" priority="1001" mode="M50">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:filehash_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a filehash_test must reference a filesha1_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M50"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:filehash_test/ind-def:state" priority="1000" mode="M50">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:filehash_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a filehash_test must reference a filesha1_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M50"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M50"/>
   <xsl:template match="@*|node()" priority="-2" mode="M50">
      <xsl:apply-templates select="@*|*" mode="M50"/>
   </xsl:template>

   <!--PATTERN hashobjfilepath-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_object/ind-def:filepath" priority="1000" mode="M51">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a filehash_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M51"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M51"/>
   <xsl:template match="@*|node()" priority="-2" mode="M51">
      <xsl:apply-templates select="@*|*" mode="M51"/>
   </xsl:template>

   <!--PATTERN hashobjpath-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_object/ind-def:path" priority="1000" mode="M52">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a filehash_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M52"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M52"/>
   <xsl:template match="@*|node()" priority="-2" mode="M52">
      <xsl:apply-templates select="@*|*" mode="M52"/>
   </xsl:template>

   <!--PATTERN hashobjfilename-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_object/ind-def:filename" priority="1000" mode="M53">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a filehash_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M53"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M53"/>
   <xsl:template match="@*|node()" priority="-2" mode="M53">
      <xsl:apply-templates select="@*|*" mode="M53"/>
   </xsl:template>

   <!--PATTERN hashstefilepath-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_state/ind-def:filepath" priority="1000" mode="M54">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a filehash_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M54"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M54"/>
   <xsl:template match="@*|node()" priority="-2" mode="M54">
      <xsl:apply-templates select="@*|*" mode="M54"/>
   </xsl:template>

   <!--PATTERN hashstepath-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_state/ind-def:path" priority="1000" mode="M55">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a filehash_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M55"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M55"/>
   <xsl:template match="@*|node()" priority="-2" mode="M55">
      <xsl:apply-templates select="@*|*" mode="M55"/>
   </xsl:template>

   <!--PATTERN hashstefilename-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_state/ind-def:filename" priority="1000" mode="M56">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a filehash_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M56"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M56"/>
   <xsl:template match="@*|node()" priority="-2" mode="M56">
      <xsl:apply-templates select="@*|*" mode="M56"/>
   </xsl:template>

   <!--PATTERN hashstemd5-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_state/ind-def:md5" priority="1000" mode="M57">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the md5 entity of a filehash_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M57"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M57"/>
   <xsl:template match="@*|node()" priority="-2" mode="M57">
      <xsl:apply-templates select="@*|*" mode="M57"/>
   </xsl:template>

   <!--PATTERN hashstesha1-->


	<!--RULE -->
<xsl:template match="ind-def:filehash_state/ind-def:sha1" priority="1000" mode="M58">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sha1 entity of a filehash_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M58"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M58"/>
   <xsl:template match="@*|node()" priority="-2" mode="M58">
      <xsl:apply-templates select="@*|*" mode="M58"/>
   </xsl:template>

   <!--PATTERN envtst-->


	<!--RULE -->
<xsl:template match="ind-def:environmentvariable_test/ind-def:object" priority="1001"
                 mode="M59">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:environmentvariable_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an environmentvariable_test must reference a environmentvariable_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M59"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:environmentvariable_test/ind-def:state" priority="1000"
                 mode="M59">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:environmentvariable_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an environmentvariable_test must reference a environmentvariable_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M59"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M59"/>
   <xsl:template match="@*|node()" priority="-2" mode="M59">
      <xsl:apply-templates select="@*|*" mode="M59"/>
   </xsl:template>

   <!--PATTERN envobjname-->


	<!--RULE -->
<xsl:template match="ind-def:environmentvariable_object/ind-def:name" priority="1000"
                 mode="M60">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an environmentvariable_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M60"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M60"/>
   <xsl:template match="@*|node()" priority="-2" mode="M60">
      <xsl:apply-templates select="@*|*" mode="M60"/>
   </xsl:template>

   <!--PATTERN envstename-->


	<!--RULE -->
<xsl:template match="ind-def:environmentvariable_state/ind-def:name" priority="1000"
                 mode="M61">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an environmentvariable_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M61"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M61"/>
   <xsl:template match="@*|node()" priority="-2" mode="M61">
      <xsl:apply-templates select="@*|*" mode="M61"/>
   </xsl:template>

   <!--PATTERN envstevalue-->


	<!--RULE -->
<xsl:template match="ind-def:environmentvariable_state/ind-def:value" priority="1000"
                 mode="M62">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M62"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M62"/>
   <xsl:template match="@*|node()" priority="-2" mode="M62">
      <xsl:apply-templates select="@*|*" mode="M62"/>
   </xsl:template>

   <!--PATTERN ldaptst-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_test/ind-def:object" priority="1001" mode="M63">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:ldap_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an ldap_test must reference an ldap_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M63"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:ldap_test/ind-def:state" priority="1000" mode="M63">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:ldap_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an ldap_test must reference an ldap_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M63"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M63"/>
   <xsl:template match="@*|node()" priority="-2" mode="M63">
      <xsl:apply-templates select="@*|*" mode="M63"/>
   </xsl:template>

   <!--PATTERN ldapobjsuffix-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_object/ind-def:suffix" priority="1000" mode="M64">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the suffix entity of an ldap_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M64"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M64"/>
   <xsl:template match="@*|node()" priority="-2" mode="M64">
      <xsl:apply-templates select="@*|*" mode="M64"/>
   </xsl:template>

   <!--PATTERN ldapobjrelative_dn-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_object/ind-def:relative_dn" priority="1000" mode="M65">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the relative_dn entity of an ldap_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M65"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M65"/>
   <xsl:template match="@*|node()" priority="-2" mode="M65">
      <xsl:apply-templates select="@*|*" mode="M65"/>
   </xsl:template>

   <!--PATTERN ldapobjattribute-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_object/ind-def:attribute" priority="1000" mode="M66">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the attribute entity of an ldap_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M66"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M66"/>
   <xsl:template match="@*|node()" priority="-2" mode="M66">
      <xsl:apply-templates select="@*|*" mode="M66"/>
   </xsl:template>

   <!--PATTERN ldapstesuffix-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:suffix" priority="1000" mode="M67">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the suffix entity of an ldap_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M67"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M67"/>
   <xsl:template match="@*|node()" priority="-2" mode="M67">
      <xsl:apply-templates select="@*|*" mode="M67"/>
   </xsl:template>

   <!--PATTERN ldapsterelative_dn-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:relative_dn" priority="1000" mode="M68">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the relative_dn entity of an ldap_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M68"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M68"/>
   <xsl:template match="@*|node()" priority="-2" mode="M68">
      <xsl:apply-templates select="@*|*" mode="M68"/>
   </xsl:template>

   <!--PATTERN ldapsteattribute-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:attribute" priority="1000" mode="M69">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the attribute entity of an ldap_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M69"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M69"/>
   <xsl:template match="@*|node()" priority="-2" mode="M69">
      <xsl:apply-templates select="@*|*" mode="M69"/>
   </xsl:template>

   <!--PATTERN ldapsteobject_class-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:object_class" priority="1000" mode="M70">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the object_class entity of an ldap_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M70"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M70"/>
   <xsl:template match="@*|node()" priority="-2" mode="M70">
      <xsl:apply-templates select="@*|*" mode="M70"/>
   </xsl:template>

   <!--PATTERN ldapsteldaptype-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:ldaptype" priority="1000" mode="M71">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ldaptype entity of an ldap_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M71"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M71"/>
   <xsl:template match="@*|node()" priority="-2" mode="M71">
      <xsl:apply-templates select="@*|*" mode="M71"/>
   </xsl:template>

   <!--PATTERN ldapstevalue-->


	<!--RULE -->
<xsl:template match="ind-def:ldap_state/ind-def:value" priority="1000" mode="M72">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M72"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M72"/>
   <xsl:template match="@*|node()" priority="-2" mode="M72">
      <xsl:apply-templates select="@*|*" mode="M72"/>
   </xsl:template>

   <!--PATTERN sqltst-->


	<!--RULE -->
<xsl:template match="ind-def:sql_test/ind-def:object" priority="1001" mode="M73">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:sql_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a sql_test must reference a sql_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M73"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:sql_test/ind-def:state" priority="1000" mode="M73">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:sql_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a sql_test must reference a sql_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M73"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M73"/>
   <xsl:template match="@*|node()" priority="-2" mode="M73">
      <xsl:apply-templates select="@*|*" mode="M73"/>
   </xsl:template>

   <!--PATTERN sqlobjdengine-->


	<!--RULE -->
<xsl:template match="ind-def:sql_object/ind-def:engine" priority="1000" mode="M74">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the engine entity of an sql_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the engine entity of an sql_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M74"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M74"/>
   <xsl:template match="@*|node()" priority="-2" mode="M74">
      <xsl:apply-templates select="@*|*" mode="M74"/>
   </xsl:template>

   <!--PATTERN sqlobjversion-->


	<!--RULE -->
<xsl:template match="ind-def:sql_object/ind-def:version" priority="1000" mode="M75">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of an sql_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the version entity of an sql_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M75"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M75"/>
   <xsl:template match="@*|node()" priority="-2" mode="M75">
      <xsl:apply-templates select="@*|*" mode="M75"/>
   </xsl:template>

   <!--PATTERN sqlobjconnection_string-->


	<!--RULE -->
<xsl:template match="ind-def:sql_object/ind-def:connection_string" priority="1000" mode="M76">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the connection_string entity of an sql_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the connection_string entity of an sql_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M76"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M76"/>
   <xsl:template match="@*|node()" priority="-2" mode="M76">
      <xsl:apply-templates select="@*|*" mode="M76"/>
   </xsl:template>

   <!--PATTERN sqlobjsql-->


	<!--RULE -->
<xsl:template match="ind-def:sql_object/ind-def:sql" priority="1000" mode="M77">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sql entity of a sql_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the sql entity of an sql_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M77"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M77"/>
   <xsl:template match="@*|node()" priority="-2" mode="M77">
      <xsl:apply-templates select="@*|*" mode="M77"/>
   </xsl:template>

   <!--PATTERN sqlsteengine-->


	<!--RULE -->
<xsl:template match="ind-def:sql_state/ind-def:engine" priority="1000" mode="M78">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the engine entity of an sql_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M78"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M78"/>
   <xsl:template match="@*|node()" priority="-2" mode="M78">
      <xsl:apply-templates select="@*|*" mode="M78"/>
   </xsl:template>

   <!--PATTERN sqlsteversion-->


	<!--RULE -->
<xsl:template match="ind-def:sql_state/ind-def:version" priority="1000" mode="M79">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of an sql_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M79"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M79"/>
   <xsl:template match="@*|node()" priority="-2" mode="M79">
      <xsl:apply-templates select="@*|*" mode="M79"/>
   </xsl:template>

   <!--PATTERN sqlsteconnection_string-->


	<!--RULE -->
<xsl:template match="ind-def:sql_state/ind-def:connection_string" priority="1000" mode="M80">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the connection_string entity of an sql_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M80"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M80"/>
   <xsl:template match="@*|node()" priority="-2" mode="M80">
      <xsl:apply-templates select="@*|*" mode="M80"/>
   </xsl:template>

   <!--PATTERN sqlstesql-->


	<!--RULE -->
<xsl:template match="ind-def:sql_state/ind-def:sql" priority="1000" mode="M81">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sql entity of a sql_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M81"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M81"/>
   <xsl:template match="@*|node()" priority="-2" mode="M81">
      <xsl:apply-templates select="@*|*" mode="M81"/>
   </xsl:template>

   <!--PATTERN sqlsteresult-->


	<!--RULE -->
<xsl:template match="ind-def:sql_state/ind-def:result" priority="1000" mode="M82">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M82"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M82"/>
   <xsl:template match="@*|node()" priority="-2" mode="M82">
      <xsl:apply-templates select="@*|*" mode="M82"/>
   </xsl:template>

   <!--PATTERN txt54tst-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_test/ind-def:object" priority="1001"
                 mode="M83">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:textfilecontent54_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a textfilecontent54_test must reference a textfilecontent54_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M83"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:textfilecontent54_test/ind-def:state" priority="1000" mode="M83">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:textfilecontent54_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a textfilecontent54_test must reference a textfilecontent54_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M83"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M83"/>
   <xsl:template match="@*|node()" priority="-2" mode="M83">
      <xsl:apply-templates select="@*|*" mode="M83"/>
   </xsl:template>

   <!--PATTERN txt54objfilepath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_object/ind-def:filepath" priority="1000"
                 mode="M84">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a textfilecontent54_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M84"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M84"/>
   <xsl:template match="@*|node()" priority="-2" mode="M84">
      <xsl:apply-templates select="@*|*" mode="M84"/>
   </xsl:template>

   <!--PATTERN txt54objpath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_object/ind-def:path" priority="1000"
                 mode="M85">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a textfilecontent54_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M85"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M85"/>
   <xsl:template match="@*|node()" priority="-2" mode="M85">
      <xsl:apply-templates select="@*|*" mode="M85"/>
   </xsl:template>

   <!--PATTERN txt54objfilename-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_object/ind-def:filename" priority="1000"
                 mode="M86">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a textfilecontent54_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M86"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M86"/>
   <xsl:template match="@*|node()" priority="-2" mode="M86">
      <xsl:apply-templates select="@*|*" mode="M86"/>
   </xsl:template>

   <!--PATTERN txt54objpattern-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_object/ind-def:pattern" priority="1000"
                 mode="M87">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pattern entity of a textfilecontent54_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="@operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the pattern entity of a textfilecontent54_object should be 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M87"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M87"/>
   <xsl:template match="@*|node()" priority="-2" mode="M87">
      <xsl:apply-templates select="@*|*" mode="M87"/>
   </xsl:template>

   <!--PATTERN txt54objinstance-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_object/ind-def:instance" priority="1000"
                 mode="M88">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the instance entity of a textfilecontent54_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M88"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M88"/>
   <xsl:template match="@*|node()" priority="-2" mode="M88">
      <xsl:apply-templates select="@*|*" mode="M88"/>
   </xsl:template>

   <!--PATTERN txt54stefilepath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:filepath" priority="1000"
                 mode="M89">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a textfilecontent54_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M89"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M89"/>
   <xsl:template match="@*|node()" priority="-2" mode="M89">
      <xsl:apply-templates select="@*|*" mode="M89"/>
   </xsl:template>

   <!--PATTERN txt54stepath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:path" priority="1000" mode="M90">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a textfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M90"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M90"/>
   <xsl:template match="@*|node()" priority="-2" mode="M90">
      <xsl:apply-templates select="@*|*" mode="M90"/>
   </xsl:template>

   <!--PATTERN txt54stefilename-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:filename" priority="1000"
                 mode="M91">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a textfilecontent54_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M91"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M91"/>
   <xsl:template match="@*|node()" priority="-2" mode="M91">
      <xsl:apply-templates select="@*|*" mode="M91"/>
   </xsl:template>

   <!--PATTERN txt54stepattern-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:pattern" priority="1000"
                 mode="M92">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pattern entity of a textfilecontent54_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M92"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M92"/>
   <xsl:template match="@*|node()" priority="-2" mode="M92">
      <xsl:apply-templates select="@*|*" mode="M92"/>
   </xsl:template>

   <!--PATTERN txt54steinstance-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:instance" priority="1000"
                 mode="M93">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the instance entity of a textfilecontent54_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M93"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M93"/>
   <xsl:template match="@*|node()" priority="-2" mode="M93">
      <xsl:apply-templates select="@*|*" mode="M93"/>
   </xsl:template>

   <!--PATTERN txt54stetext-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:text" priority="1000" mode="M94">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the text entity of a textfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M94"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M94"/>
   <xsl:template match="@*|node()" priority="-2" mode="M94">
      <xsl:apply-templates select="@*|*" mode="M94"/>
   </xsl:template>

   <!--PATTERN txt54stesubexpression-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent54_state/ind-def:subexpression" priority="1000"
                 mode="M95">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M95"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M95"/>
   <xsl:template match="@*|node()" priority="-2" mode="M95">
      <xsl:apply-templates select="@*|*" mode="M95"/>
   </xsl:template>

   <!--PATTERN txttst_dep-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_test" priority="1000" mode="M96">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M96"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M96"/>
   <xsl:template match="@*|node()" priority="-2" mode="M96">
      <xsl:apply-templates select="@*|*" mode="M96"/>
   </xsl:template>

   <!--PATTERN txttst-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_test/ind-def:object" priority="1001" mode="M97">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:textfilecontent_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a textfilecontent_test must reference a textfilecontent_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M97"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:textfilecontent_test/ind-def:state" priority="1000" mode="M97">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:textfilecontent_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a textfilecontent_test must reference a textfilecontent_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M97"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M97"/>
   <xsl:template match="@*|node()" priority="-2" mode="M97">
      <xsl:apply-templates select="@*|*" mode="M97"/>
   </xsl:template>

   <!--PATTERN txtobj_dep-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_object" priority="1000" mode="M98">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M98"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M98"/>
   <xsl:template match="@*|node()" priority="-2" mode="M98">
      <xsl:apply-templates select="@*|*" mode="M98"/>
   </xsl:template>

   <!--PATTERN txtobjpath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_object/ind-def:path" priority="1000" mode="M99">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a textfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M99"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M99"/>
   <xsl:template match="@*|node()" priority="-2" mode="M99">
      <xsl:apply-templates select="@*|*" mode="M99"/>
   </xsl:template>

   <!--PATTERN txtobjfilename-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_object/ind-def:filename" priority="1000"
                 mode="M100">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a textfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M100"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M100"/>
   <xsl:template match="@*|node()" priority="-2" mode="M100">
      <xsl:apply-templates select="@*|*" mode="M100"/>
   </xsl:template>

   <!--PATTERN txtobjline-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_object/ind-def:line" priority="1000" mode="M101">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the line entity of a textfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="@operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the line entity of a textfilecontent_object should be 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M101"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M101"/>
   <xsl:template match="@*|node()" priority="-2" mode="M101">
      <xsl:apply-templates select="@*|*" mode="M101"/>
   </xsl:template>

   <!--PATTERN txtste_dep-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_state" priority="1000" mode="M102">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M102"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M102"/>
   <xsl:template match="@*|node()" priority="-2" mode="M102">
      <xsl:apply-templates select="@*|*" mode="M102"/>
   </xsl:template>

   <!--PATTERN txtstepath-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_state/ind-def:path" priority="1000" mode="M103">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a textfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M103"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M103"/>
   <xsl:template match="@*|node()" priority="-2" mode="M103">
      <xsl:apply-templates select="@*|*" mode="M103"/>
   </xsl:template>

   <!--PATTERN txtstefilename-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_state/ind-def:filename" priority="1000"
                 mode="M104">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a textfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M104"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M104"/>
   <xsl:template match="@*|node()" priority="-2" mode="M104">
      <xsl:apply-templates select="@*|*" mode="M104"/>
   </xsl:template>

   <!--PATTERN txtsteline-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_state/ind-def:line" priority="1000" mode="M105">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the line entity of a textfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M105"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M105"/>
   <xsl:template match="@*|node()" priority="-2" mode="M105">
      <xsl:apply-templates select="@*|*" mode="M105"/>
   </xsl:template>

   <!--PATTERN txtstesubexpression-->


	<!--RULE -->
<xsl:template match="ind-def:textfilecontent_state/ind-def:subexpression" priority="1000"
                 mode="M106">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M106"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M106"/>
   <xsl:template match="@*|node()" priority="-2" mode="M106">
      <xsl:apply-templates select="@*|*" mode="M106"/>
   </xsl:template>

   <!--PATTERN vattst-->


	<!--RULE -->
<xsl:template match="ind-def:variable_test/ind-def:object" priority="1001" mode="M107">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:variable_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a variable_test must reference a variable_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M107"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:variable_test/ind-def:state" priority="1000" mode="M107">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:variable_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a variable_test must reference a variable_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M107"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M107"/>
   <xsl:template match="@*|node()" priority="-2" mode="M107">
      <xsl:apply-templates select="@*|*" mode="M107"/>
   </xsl:template>

   <!--PATTERN varobjvar_ref-->


	<!--RULE -->
<xsl:template match="ind-def:variable_object/ind-def:var_ref" priority="1000" mode="M108">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the var_ref entity of a variable_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@var_ref)"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - var_ref attribute for the var_ref entity of a variable_object is prohibited.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M108"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M108"/>
   <xsl:template match="@*|node()" priority="-2" mode="M108">
      <xsl:apply-templates select="@*|*" mode="M108"/>
   </xsl:template>

   <!--PATTERN varstevar_ref-->


	<!--RULE -->
<xsl:template match="ind-def:variable_state/ind-def:var_ref" priority="1000" mode="M109">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the var_ref entity of a variable_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@var_ref)"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - var_ref attribute for the var_ref entity of a variable_state is prohibited.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M109"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M109"/>
   <xsl:template match="@*|node()" priority="-2" mode="M109">
      <xsl:apply-templates select="@*|*" mode="M109"/>
   </xsl:template>

   <!--PATTERN varstevalue-->


	<!--RULE -->
<xsl:template match="ind-def:variable_state/ind-def:value" priority="1000" mode="M110">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M110"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M110"/>
   <xsl:template match="@*|node()" priority="-2" mode="M110">
      <xsl:apply-templates select="@*|*" mode="M110"/>
   </xsl:template>

   <!--PATTERN xmltst-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_test/ind-def:object" priority="1001" mode="M111">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ind-def:xmlfilecontent_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a xmlfilecontent_test must reference a xmlfilecontent_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M111"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_test/ind-def:state" priority="1000" mode="M111">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ind-def:xmlfilecontent_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a xmlfilecontent_test must reference a xmlfilecontent_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M111"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M111"/>
   <xsl:template match="@*|node()" priority="-2" mode="M111">
      <xsl:apply-templates select="@*|*" mode="M111"/>
   </xsl:template>

   <!--PATTERN xmlobjfilepath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_object/ind-def:filepath" priority="1000"
                 mode="M112">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a xmlfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M112"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M112"/>
   <xsl:template match="@*|node()" priority="-2" mode="M112">
      <xsl:apply-templates select="@*|*" mode="M112"/>
   </xsl:template>

   <!--PATTERN xmlobjpath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_object/ind-def:path" priority="1000" mode="M113">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a xmlfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M113"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M113"/>
   <xsl:template match="@*|node()" priority="-2" mode="M113">
      <xsl:apply-templates select="@*|*" mode="M113"/>
   </xsl:template>

   <!--PATTERN xmlobjfilename-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_object/ind-def:filename" priority="1000"
                 mode="M114">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a xmlfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M114"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M114"/>
   <xsl:template match="@*|node()" priority="-2" mode="M114">
      <xsl:apply-templates select="@*|*" mode="M114"/>
   </xsl:template>

   <!--PATTERN xmlobjxpath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_object/ind-def:xpath" priority="1000" mode="M115">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the xpath entity of a xmlfilecontent_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the xpath entity of a xmlfilecontent_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M115"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M115"/>
   <xsl:template match="@*|node()" priority="-2" mode="M115">
      <xsl:apply-templates select="@*|*" mode="M115"/>
   </xsl:template>

   <!--PATTERN xmlfilestefilepath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_state/ind-def:filepath" priority="1000"
                 mode="M116">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a xmlfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M116"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M116"/>
   <xsl:template match="@*|node()" priority="-2" mode="M116">
      <xsl:apply-templates select="@*|*" mode="M116"/>
   </xsl:template>

   <!--PATTERN xmlstepath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_state/ind-def:path" priority="1000" mode="M117">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a xmlfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M117"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M117"/>
   <xsl:template match="@*|node()" priority="-2" mode="M117">
      <xsl:apply-templates select="@*|*" mode="M117"/>
   </xsl:template>

   <!--PATTERN xmlstefilename-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_state/ind-def:filename" priority="1000"
                 mode="M118">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a xmlfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M118"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M118"/>
   <xsl:template match="@*|node()" priority="-2" mode="M118">
      <xsl:apply-templates select="@*|*" mode="M118"/>
   </xsl:template>

   <!--PATTERN xmlstexpath-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_state/ind-def:xpath" priority="1000" mode="M119">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the xpath entity of a xmlfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M119"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M119"/>
   <xsl:template match="@*|node()" priority="-2" mode="M119">
      <xsl:apply-templates select="@*|*" mode="M119"/>
   </xsl:template>

   <!--PATTERN xmlstevalue_of-->


	<!--RULE -->
<xsl:template match="ind-def:xmlfilecontent_state/ind-def:value_of" priority="1000"
                 mode="M120">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the value_of entity of a xmlfilecontent_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M120"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M120"/>
   <xsl:template match="@*|node()" priority="-2" mode="M120">
      <xsl:apply-templates select="@*|*" mode="M120"/>
   </xsl:template>

   <!--PATTERN interimfixtst-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_test/aix-def:object" priority="1001" mode="M121">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/aix-def:interim_fix_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> must reference a interim_fix_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M121"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="aix-def:interim_fix_test/aix-def:state" priority="1000" mode="M121">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/aix-def:interim_fix_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> must reference a interim_fix_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M121"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M121"/>
   <xsl:template match="@*|node()" priority="-2" mode="M121">
      <xsl:apply-templates select="@*|*" mode="M121"/>
   </xsl:template>

   <!--PATTERN interimfixobjvuid-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_object/aix-def:vuid" priority="1000" mode="M122">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M122"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M122"/>
   <xsl:template match="@*|node()" priority="-2" mode="M122">
      <xsl:apply-templates select="@*|*" mode="M122"/>
   </xsl:template>

   <!--PATTERN interimfixstevuid-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_state/aix-def:vuid" priority="1000" mode="M123">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M123"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M123"/>
   <xsl:template match="@*|node()" priority="-2" mode="M123">
      <xsl:apply-templates select="@*|*" mode="M123"/>
   </xsl:template>

   <!--PATTERN interimfixstelabel-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_state/aix-def:label" priority="1000" mode="M124">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M124"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M124"/>
   <xsl:template match="@*|node()" priority="-2" mode="M124">
      <xsl:apply-templates select="@*|*" mode="M124"/>
   </xsl:template>

   <!--PATTERN interimfixsteabstract-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_state/aix-def:abstract" priority="1000" mode="M125">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M125"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M125"/>
   <xsl:template match="@*|node()" priority="-2" mode="M125">
      <xsl:apply-templates select="@*|*" mode="M125"/>
   </xsl:template>

   <!--PATTERN interimfixstestate-->


	<!--RULE -->
<xsl:template match="aix-def:interim_fix_state/aix-def:state" priority="1000" mode="M126">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M126"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M126"/>
   <xsl:template match="@*|node()" priority="-2" mode="M126">
      <xsl:apply-templates select="@*|*" mode="M126"/>
   </xsl:template>

   <!--PATTERN filesettst-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_test/aix-def:object" priority="1001" mode="M127">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/aix-def:fileset_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fileset_test must reference a fileset_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M127"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="aix-def:fileset_test/aix-def:state" priority="1000" mode="M127">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/aix-def:fileset_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fileset_test must reference a fileset_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M127"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M127"/>
   <xsl:template match="@*|node()" priority="-2" mode="M127">
      <xsl:apply-templates select="@*|*" mode="M127"/>
   </xsl:template>

   <!--PATTERN filesetobjflstinst-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_object/aix-def:flstinst" priority="1000" mode="M128">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the flstinst entity of a fileset_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M128"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M128"/>
   <xsl:template match="@*|node()" priority="-2" mode="M128">
      <xsl:apply-templates select="@*|*" mode="M128"/>
   </xsl:template>

   <!--PATTERN filesetsteflstinst-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_state/aix-def:flstinst" priority="1000" mode="M129">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the flstinst entity of a fileset_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M129"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M129"/>
   <xsl:template match="@*|node()" priority="-2" mode="M129">
      <xsl:apply-templates select="@*|*" mode="M129"/>
   </xsl:template>

   <!--PATTERN filesetstelevel-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_state/aix-def:level" priority="1000" mode="M130">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the level entity of a fileset_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M130"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M130"/>
   <xsl:template match="@*|node()" priority="-2" mode="M130">
      <xsl:apply-templates select="@*|*" mode="M130"/>
   </xsl:template>

   <!--PATTERN filesetstestate-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_state/aix-def:state" priority="1000" mode="M131">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the state entity of a fileset_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M131"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M131"/>
   <xsl:template match="@*|node()" priority="-2" mode="M131">
      <xsl:apply-templates select="@*|*" mode="M131"/>
   </xsl:template>

   <!--PATTERN filesetstedescription-->


	<!--RULE -->
<xsl:template match="aix-def:fileset_state/aix-def:description" priority="1000" mode="M132">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of a fileset_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M132"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M132"/>
   <xsl:template match="@*|node()" priority="-2" mode="M132">
      <xsl:apply-templates select="@*|*" mode="M132"/>
   </xsl:template>

   <!--PATTERN fixtst-->


	<!--RULE -->
<xsl:template match="aix-def:fix_test/aix-def:object" priority="1001" mode="M133">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/aix-def:fix_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fix_test must reference a fix_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M133"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="aix-def:fix_test/aix-def:state" priority="1000" mode="M133">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/aix-def:fix_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fix_test must reference a fix_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M133"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M133"/>
   <xsl:template match="@*|node()" priority="-2" mode="M133">
      <xsl:apply-templates select="@*|*" mode="M133"/>
   </xsl:template>

   <!--PATTERN fixobjapar_number-->


	<!--RULE -->
<xsl:template match="aix-def:fix_object/aix-def:apar_number" priority="1000" mode="M134">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the apar_number entity of a fix_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M134"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M134"/>
   <xsl:template match="@*|node()" priority="-2" mode="M134">
      <xsl:apply-templates select="@*|*" mode="M134"/>
   </xsl:template>

   <!--PATTERN fixsteapar_number-->


	<!--RULE -->
<xsl:template match="aix-def:fix_state/aix-def:apar_number" priority="1000" mode="M135">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the apar_number entity of a fix_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M135"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M135"/>
   <xsl:template match="@*|node()" priority="-2" mode="M135">
      <xsl:apply-templates select="@*|*" mode="M135"/>
   </xsl:template>

   <!--PATTERN fixsteabstract-->


	<!--RULE -->
<xsl:template match="aix-def:fix_state/aix-def:abstract" priority="1000" mode="M136">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the abstract entity of a fix_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M136"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M136"/>
   <xsl:template match="@*|node()" priority="-2" mode="M136">
      <xsl:apply-templates select="@*|*" mode="M136"/>
   </xsl:template>

   <!--PATTERN fixstesymptom-->


	<!--RULE -->
<xsl:template match="aix-def:fix_state/aix-def:symptom" priority="1000" mode="M137">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the symptom entity of a fix_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M137"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M137"/>
   <xsl:template match="@*|node()" priority="-2" mode="M137">
      <xsl:apply-templates select="@*|*" mode="M137"/>
   </xsl:template>

   <!--PATTERN fixsteinstallation_status-->


	<!--RULE -->
<xsl:template match="aix-def:fix_state/aix-def:installation_status" priority="1000"
                 mode="M138">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the installation_status entity of a fix_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M138"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M138"/>
   <xsl:template match="@*|node()" priority="-2" mode="M138">
      <xsl:apply-templates select="@*|*" mode="M138"/>
   </xsl:template>

   <!--PATTERN osleveltst-->


	<!--RULE -->
<xsl:template match="aix-def:oslevel_test/aix-def:object" priority="1001" mode="M139">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/aix-def:oslevel_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a oslevel_test must reference a oslevel_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M139"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="aix-def:oslevel_test/aix-def:state" priority="1000" mode="M139">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/aix-def:oslevel_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a oslevel_test must reference a oslevel_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M139"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M139"/>
   <xsl:template match="@*|node()" priority="-2" mode="M139">
      <xsl:apply-templates select="@*|*" mode="M139"/>
   </xsl:template>

   <!--PATTERN oslevelstemaintenance_level-->


	<!--RULE -->
<xsl:template match="aix-def:oslevel_state/aix-def:maintenance_level" priority="1000"
                 mode="M140">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the maintenance_level entity of an oslevel_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M140"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M140"/>
   <xsl:template match="@*|node()" priority="-2" mode="M140">
      <xsl:apply-templates select="@*|*" mode="M140"/>
   </xsl:template>

   <!--PATTERN httpdtst-->


	<!--RULE -->
<xsl:template match="apache-def:httpd_test/apache-def:object" priority="1001" mode="M141">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/apache-def:httpd_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a httpd_test must reference a httpd_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M141"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="apache-def:httpd_test/apache-def:state" priority="1000" mode="M141">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/apache-def:httpd_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a httpd_test must reference a httpd_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M141"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M141"/>
   <xsl:template match="@*|node()" priority="-2" mode="M141">
      <xsl:apply-templates select="@*|*" mode="M141"/>
   </xsl:template>

   <!--PATTERN httpdstepath-->


	<!--RULE -->
<xsl:template match="apache-def:httpd_state/apache-def:path" priority="1000" mode="M142">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a httpd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M142"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M142"/>
   <xsl:template match="@*|node()" priority="-2" mode="M142">
      <xsl:apply-templates select="@*|*" mode="M142"/>
   </xsl:template>

   <!--PATTERN httpdstebinaryname-->


	<!--RULE -->
<xsl:template match="apache-def:httpd_state/apache-def:binary_name" priority="1000"
                 mode="M143">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the binary_name entity of a httpd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M143"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M143"/>
   <xsl:template match="@*|node()" priority="-2" mode="M143">
      <xsl:apply-templates select="@*|*" mode="M143"/>
   </xsl:template>

   <!--PATTERN httpdsteversion-->


	<!--RULE -->
<xsl:template match="apache-def:httpd_state/apache-def:version" priority="1000" mode="M144">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a httpd_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M144"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M144"/>
   <xsl:template match="@*|node()" priority="-2" mode="M144">
      <xsl:apply-templates select="@*|*" mode="M144"/>
   </xsl:template>

   <!--PATTERN apachevertst_dep-->


	<!--RULE -->
<xsl:template match="apache-def:version_test" priority="1000" mode="M145">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M145"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M145"/>
   <xsl:template match="@*|node()" priority="-2" mode="M145">
      <xsl:apply-templates select="@*|*" mode="M145"/>
   </xsl:template>

   <!--PATTERN apachevertst-->


	<!--RULE -->
<xsl:template match="apache-def:version_test/apache-def:object" priority="1001" mode="M146">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/apache-def:version_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a version_test must reference a version_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M146"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="apache-def:version_test/apache-def:state" priority="1000" mode="M146">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/apache-def:version_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a version_test must reference a version_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M146"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M146"/>
   <xsl:template match="@*|node()" priority="-2" mode="M146">
      <xsl:apply-templates select="@*|*" mode="M146"/>
   </xsl:template>

   <!--PATTERN apacheverobj_dep-->


	<!--RULE -->
<xsl:template match="apache-def:version_object" priority="1000" mode="M147">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M147"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M147"/>
   <xsl:template match="@*|node()" priority="-2" mode="M147">
      <xsl:apply-templates select="@*|*" mode="M147"/>
   </xsl:template>

   <!--PATTERN apacheverste_dep-->


	<!--RULE -->
<xsl:template match="apache-def:version_state" priority="1000" mode="M148">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M148"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M148"/>
   <xsl:template match="@*|node()" priority="-2" mode="M148">
      <xsl:apply-templates select="@*|*" mode="M148"/>
   </xsl:template>

   <!--PATTERN apcheversteversion-->


	<!--RULE -->
<xsl:template match="apache-def:version_state/apache-def:version" priority="1000" mode="M149">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of an version_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M149"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M149"/>
   <xsl:template match="@*|node()" priority="-2" mode="M149">
      <xsl:apply-templates select="@*|*" mode="M149"/>
   </xsl:template>

   <!--PATTERN catoslinetst-->


	<!--RULE -->
<xsl:template match="catos-def:line_test/catos-def:object" priority="1001" mode="M150">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/catos-def:line_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a line_test must reference a line_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M150"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="catos-def:line_test/catos-def:state" priority="1000" mode="M150">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/catos-def:line_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a line_test must reference a line_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M150"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M150"/>
   <xsl:template match="@*|node()" priority="-2" mode="M150">
      <xsl:apply-templates select="@*|*" mode="M150"/>
   </xsl:template>

   <!--PATTERN catoslineobjshow_subcommand-->


	<!--RULE -->
<xsl:template match="catos-def:line_object/catos-def:show_subcommand" priority="1000"
                 mode="M151">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M151"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M151"/>
   <xsl:template match="@*|node()" priority="-2" mode="M151">
      <xsl:apply-templates select="@*|*" mode="M151"/>
   </xsl:template>

   <!--PATTERN catoslinesteshow_subcommand-->


	<!--RULE -->
<xsl:template match="catos-def:line_state/catos-def:show_subcommand" priority="1000"
                 mode="M152">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M152"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M152"/>
   <xsl:template match="@*|node()" priority="-2" mode="M152">
      <xsl:apply-templates select="@*|*" mode="M152"/>
   </xsl:template>

   <!--PATTERN catoslinesteconfig_line-->


	<!--RULE -->
<xsl:template match="catos-def:line_state/catos-def:config_line" priority="1000" mode="M153">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the config_line entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M153"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M153"/>
   <xsl:template match="@*|node()" priority="-2" mode="M153">
      <xsl:apply-templates select="@*|*" mode="M153"/>
   </xsl:template>

   <!--PATTERN catosmoduletst-->


	<!--RULE -->
<xsl:template match="catos-def:module_test/catos-def:object" priority="1001" mode="M154">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/catos-def:module_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a module_test must reference a module_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M154"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="catos-def:module_test/catos-def:state" priority="1000" mode="M154">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/catos-def:module_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a module_test must reference a module_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M154"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M154"/>
   <xsl:template match="@*|node()" priority="-2" mode="M154">
      <xsl:apply-templates select="@*|*" mode="M154"/>
   </xsl:template>

   <!--PATTERN moduleobjmodule_number-->


	<!--RULE -->
<xsl:template match="catos-def:module_object/catos-def:module_number" priority="1000"
                 mode="M155">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the module_number entity of a module_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the module_number entity of a module_object should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', or 'less than or equal'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M155"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M155"/>
   <xsl:template match="@*|node()" priority="-2" mode="M155">
      <xsl:apply-templates select="@*|*" mode="M155"/>
   </xsl:template>

   <!--PATTERN catosmodulestemodule_number-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:module_number" priority="1000"
                 mode="M156">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the module_number entity of a module_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M156"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M156"/>
   <xsl:template match="@*|node()" priority="-2" mode="M156">
      <xsl:apply-templates select="@*|*" mode="M156"/>
   </xsl:template>

   <!--PATTERN catosmodulestetype-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:type" priority="1000" mode="M157">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of a module_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M157"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M157"/>
   <xsl:template match="@*|node()" priority="-2" mode="M157">
      <xsl:apply-templates select="@*|*" mode="M157"/>
   </xsl:template>

   <!--PATTERN catosmodulestemodel-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:model" priority="1000" mode="M158">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the model entity of a module_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M158"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M158"/>
   <xsl:template match="@*|node()" priority="-2" mode="M158">
      <xsl:apply-templates select="@*|*" mode="M158"/>
   </xsl:template>

   <!--PATTERN catosmodulestesoftware_major_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:software_major_release" priority="1000"
                 mode="M159">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the software_major_release entity of a module_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M159"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M159"/>
   <xsl:template match="@*|node()" priority="-2" mode="M159">
      <xsl:apply-templates select="@*|*" mode="M159"/>
   </xsl:template>

   <!--PATTERN catosmodulestesoftware_individual_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:software_individual_release"
                 priority="1000"
                 mode="M160">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the software_individual_release entity of a module_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M160"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M160"/>
   <xsl:template match="@*|node()" priority="-2" mode="M160">
      <xsl:apply-templates select="@*|*" mode="M160"/>
   </xsl:template>

   <!--PATTERN catosmodulestesoftware_version_id-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:software_version_id" priority="1000"
                 mode="M161">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the software_version_id entity of a module_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M161"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M161"/>
   <xsl:template match="@*|node()" priority="-2" mode="M161">
      <xsl:apply-templates select="@*|*" mode="M161"/>
   </xsl:template>

   <!--PATTERN catosmodulestehardware_major_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:hardware_major_release" priority="1000"
                 mode="M162">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hardware_major_release entity of a module_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M162"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M162"/>
   <xsl:template match="@*|node()" priority="-2" mode="M162">
      <xsl:apply-templates select="@*|*" mode="M162"/>
   </xsl:template>

   <!--PATTERN catosmodulestehardware_individual_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:hardware_individual_release"
                 priority="1000"
                 mode="M163">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hardware_individual_release entity of a module_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M163"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M163"/>
   <xsl:template match="@*|node()" priority="-2" mode="M163">
      <xsl:apply-templates select="@*|*" mode="M163"/>
   </xsl:template>

   <!--PATTERN catosmodulestefirmware_major_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:firmware_major_release" priority="1000"
                 mode="M164">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the firmware_major_release entity of a module_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M164"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M164"/>
   <xsl:template match="@*|node()" priority="-2" mode="M164">
      <xsl:apply-templates select="@*|*" mode="M164"/>
   </xsl:template>

   <!--PATTERN catosmodulestefirmware_individual_release-->


	<!--RULE -->
<xsl:template match="catos-def:module_state/catos-def:firmware_individual_release"
                 priority="1000"
                 mode="M165">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the firmware_individual_release entity of a module_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M165"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M165"/>
   <xsl:template match="@*|node()" priority="-2" mode="M165">
      <xsl:apply-templates select="@*|*" mode="M165"/>
   </xsl:template>

   <!--PATTERN catosver55stedevice_series-->


	<!--RULE -->
<xsl:template match="catos-def:version55_state/catos-def:swtich_series" priority="1000"
                 mode="M166">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swtich_series entity of a version55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M166"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M166"/>
   <xsl:template match="@*|node()" priority="-2" mode="M166">
      <xsl:apply-templates select="@*|*" mode="M166"/>
   </xsl:template>

   <!--PATTERN catosver55steimage_name-->


	<!--RULE -->
<xsl:template match="catos-def:version55_state/catos-def:image_name" priority="1000"
                 mode="M167">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the image_name entity of a version55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M167"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M167"/>
   <xsl:template match="@*|node()" priority="-2" mode="M167">
      <xsl:apply-templates select="@*|*" mode="M167"/>
   </xsl:template>

   <!--PATTERN catosver55stecatos_release-->


	<!--RULE -->
<xsl:template match="catos-def:version55_state/catos-def:catos_release" priority="1000"
                 mode="M168">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the catos_release entity of a version55_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M168"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M168"/>
   <xsl:template match="@*|node()" priority="-2" mode="M168">
      <xsl:apply-templates select="@*|*" mode="M168"/>
   </xsl:template>

   <!--PATTERN version_test_dep-->


	<!--RULE -->
<xsl:template match="catos-def:version_test" priority="1000" mode="M169">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M169"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M169"/>
   <xsl:template match="@*|node()" priority="-2" mode="M169">
      <xsl:apply-templates select="@*|*" mode="M169"/>
   </xsl:template>

   <!--PATTERN version_object_dep-->


	<!--RULE -->
<xsl:template match="catos-def:version_object" priority="1000" mode="M170">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M170"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M170"/>
   <xsl:template match="@*|node()" priority="-2" mode="M170">
      <xsl:apply-templates select="@*|*" mode="M170"/>
   </xsl:template>

   <!--PATTERN version_state_dep-->


	<!--RULE -->
<xsl:template match="catos-def:version_state" priority="1000" mode="M171">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M171"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M171"/>
   <xsl:template match="@*|node()" priority="-2" mode="M171">
      <xsl:apply-templates select="@*|*" mode="M171"/>
   </xsl:template>

   <!--PATTERN catosverstedevice_series-->


	<!--RULE -->
<xsl:template match="catos-def:version_state/catos-def:swtich_series" priority="1000"
                 mode="M172">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swtich_series entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M172"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M172"/>
   <xsl:template match="@*|node()" priority="-2" mode="M172">
      <xsl:apply-templates select="@*|*" mode="M172"/>
   </xsl:template>

   <!--PATTERN catosversteimage_name-->


	<!--RULE -->
<xsl:template match="catos-def:version_state/catos-def:image_name" priority="1000"
                 mode="M173">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the image_name entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M173"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M173"/>
   <xsl:template match="@*|node()" priority="-2" mode="M173">
      <xsl:apply-templates select="@*|*" mode="M173"/>
   </xsl:template>

   <!--PATTERN catosverstecatos_major_release-->


	<!--RULE -->
<xsl:template match="catos-def:version_state/catos-def:catos_major_release" priority="1000"
                 mode="M174">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the catos_major_release entity of a version_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M174"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M174"/>
   <xsl:template match="@*|node()" priority="-2" mode="M174">
      <xsl:apply-templates select="@*|*" mode="M174"/>
   </xsl:template>

   <!--PATTERN catosverstecatos_individual_release-->


	<!--RULE -->
<xsl:template match="catos-def:version_state/catos-def:catos_individual_release"
                 priority="1000"
                 mode="M175">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the catos_individual_release entity of a version_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M175"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M175"/>
   <xsl:template match="@*|node()" priority="-2" mode="M175">
      <xsl:apply-templates select="@*|*" mode="M175"/>
   </xsl:template>

   <!--PATTERN catosverstecatos_version_id-->


	<!--RULE -->
<xsl:template match="catos-def:version_state/catos-def:catos_version_id" priority="1000"
                 mode="M176">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the catos_version_id entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M176"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M176"/>
   <xsl:template match="@*|node()" priority="-2" mode="M176">
      <xsl:apply-templates select="@*|*" mode="M176"/>
   </xsl:template>

   <!--PATTERN esxpatch56tst-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_test/esx-def:object" priority="1001" mode="M177">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/esx-def:patch56_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a patch56_test must reference a patch56_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M177"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="esx-def:patch56_test/esx-def:state" priority="1000" mode="M177">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/esx-def:patch56_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a patch56_test must reference a patch56_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M177"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M177"/>
   <xsl:template match="@*|node()" priority="-2" mode="M177">
      <xsl:apply-templates select="@*|*" mode="M177"/>
   </xsl:template>

   <!--PATTERN esxpatch56objpatch_name-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_object/esx-def:patch_name" priority="1000" mode="M178">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_name entity of a patch56_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M178"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M178"/>
   <xsl:template match="@*|node()" priority="-2" mode="M178">
      <xsl:apply-templates select="@*|*" mode="M178"/>
   </xsl:template>

   <!--PATTERN esxpatch56stepatch_name-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:patch_name" priority="1000" mode="M179">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_name entity of a patch56_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M179"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M179"/>
   <xsl:template match="@*|node()" priority="-2" mode="M179">
      <xsl:apply-templates select="@*|*" mode="M179"/>
   </xsl:template>

   <!--PATTERN esxpatch56stekbid-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:knowledge_base_id" priority="1000"
                 mode="M180">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the knowledge_base_id entity of a patch56_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M180"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M180"/>
   <xsl:template match="@*|node()" priority="-2" mode="M180">
      <xsl:apply-templates select="@*|*" mode="M180"/>
   </xsl:template>

   <!--PATTERN esxpatch56stebundleid-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:bundle_id" priority="1000" mode="M181">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the bundle_id entity of a patch56_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M181"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M181"/>
   <xsl:template match="@*|node()" priority="-2" mode="M181">
      <xsl:apply-templates select="@*|*" mode="M181"/>
   </xsl:template>

   <!--PATTERN esxpatch56steclassification-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:classification" priority="1000"
                 mode="M182">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the classification entity of a patch56_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M182"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M182"/>
   <xsl:template match="@*|node()" priority="-2" mode="M182">
      <xsl:apply-templates select="@*|*" mode="M182"/>
   </xsl:template>

   <!--PATTERN esxpatch56stesupport_level-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:support_level" priority="1000" mode="M183">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the support_level entity of a patch56_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M183"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M183"/>
   <xsl:template match="@*|node()" priority="-2" mode="M183">
      <xsl:apply-templates select="@*|*" mode="M183"/>
   </xsl:template>

   <!--PATTERN esxpatch56stestatus-->


	<!--RULE -->
<xsl:template match="esx-def:patch56_state/esx-def:status" priority="1000" mode="M184">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the status entity of a patch56_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M184"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M184"/>
   <xsl:template match="@*|node()" priority="-2" mode="M184">
      <xsl:apply-templates select="@*|*" mode="M184"/>
   </xsl:template>

   <!--PATTERN esxpatchtst_dep-->


	<!--RULE -->
<xsl:template match="esx-def:patch_test" priority="1000" mode="M185">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M185"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M185"/>
   <xsl:template match="@*|node()" priority="-2" mode="M185">
      <xsl:apply-templates select="@*|*" mode="M185"/>
   </xsl:template>

   <!--PATTERN esxpatchtst-->


	<!--RULE -->
<xsl:template match="esx-def:patch_test/esx-def:object" priority="1001" mode="M186">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/esx-def:patch_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a patch_test must reference a patch_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M186"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="esx-def:patch_test/esx-def:state" priority="1000" mode="M186">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/esx-def:patch_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a patch_test must reference a patch_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M186"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M186"/>
   <xsl:template match="@*|node()" priority="-2" mode="M186">
      <xsl:apply-templates select="@*|*" mode="M186"/>
   </xsl:template>

   <!--PATTERN esxpatchobj_dep-->


	<!--RULE -->
<xsl:template match="esx-def:patch_object" priority="1000" mode="M187">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M187"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M187"/>
   <xsl:template match="@*|node()" priority="-2" mode="M187">
      <xsl:apply-templates select="@*|*" mode="M187"/>
   </xsl:template>

   <!--PATTERN esxpatchobjpatch_number-->


	<!--RULE -->
<xsl:template match="esx-def:patch_object/esx-def:patch_number" priority="1000" mode="M188">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_number entity of a patch_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M188"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M188"/>
   <xsl:template match="@*|node()" priority="-2" mode="M188">
      <xsl:apply-templates select="@*|*" mode="M188"/>
   </xsl:template>

   <!--PATTERN esxpatchste_dep-->


	<!--RULE -->
<xsl:template match="esx-def:patch_state" priority="1000" mode="M189">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M189"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M189"/>
   <xsl:template match="@*|node()" priority="-2" mode="M189">
      <xsl:apply-templates select="@*|*" mode="M189"/>
   </xsl:template>

   <!--PATTERN esxpatchstepatch_number-->


	<!--RULE -->
<xsl:template match="esx-def:patch_state/esx-def:patch_number" priority="1000" mode="M190">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_number entity of a patch_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M190"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M190"/>
   <xsl:template match="@*|node()" priority="-2" mode="M190">
      <xsl:apply-templates select="@*|*" mode="M190"/>
   </xsl:template>

   <!--PATTERN esxpatchstestatus-->


	<!--RULE -->
<xsl:template match="esx-def:patch_state/esx-def:status" priority="1000" mode="M191">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the status entity of a patch_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M191"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M191"/>
   <xsl:template match="@*|node()" priority="-2" mode="M191">
      <xsl:apply-templates select="@*|*" mode="M191"/>
   </xsl:template>

   <!--PATTERN esxversiontst-->


	<!--RULE -->
<xsl:template match="esx-def:version_test/esx-def:object" priority="1001" mode="M192">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/esx-def:version_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a version_test must reference a version_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M192"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="esx-def:version_test/esx-def:state" priority="1000" mode="M192">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/esx-def:version_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a version_test must reference a version_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M192"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M192"/>
   <xsl:template match="@*|node()" priority="-2" mode="M192">
      <xsl:apply-templates select="@*|*" mode="M192"/>
   </xsl:template>

   <!--PATTERN versionsterelease-->


	<!--RULE -->
<xsl:template match="esx-def:version_state/esx-def:release" priority="1000" mode="M193">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the release entity of an version_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M193"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M193"/>
   <xsl:template match="@*|node()" priority="-2" mode="M193">
      <xsl:apply-templates select="@*|*" mode="M193"/>
   </xsl:template>

   <!--PATTERN versionstebuild-->


	<!--RULE -->
<xsl:template match="esx-def:version_state/esx-def:build" priority="1000" mode="M194">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the build entity of an version_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M194"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M194"/>
   <xsl:template match="@*|node()" priority="-2" mode="M194">
      <xsl:apply-templates select="@*|*" mode="M194"/>
   </xsl:template>

   <!--PATTERN portinfotst-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_test/freebsd-def:object" priority="1001"
                 mode="M195">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/freebsd-def:portinfo_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a portinfo_test must reference an portinfo_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M195"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="freebsd-def:portinfo_test/freebsd-def:state" priority="1000" mode="M195">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/freebsd-def:portinfo_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a portinfo_test must reference an portinfo_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M195"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M195"/>
   <xsl:template match="@*|node()" priority="-2" mode="M195">
      <xsl:apply-templates select="@*|*" mode="M195"/>
   </xsl:template>

   <!--PATTERN portinfoobjpkginst-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_object/freebsd-def:pkginst" priority="1000"
                 mode="M196">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pkginst entity of a portinfo_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M196"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M196"/>
   <xsl:template match="@*|node()" priority="-2" mode="M196">
      <xsl:apply-templates select="@*|*" mode="M196"/>
   </xsl:template>

   <!--PATTERN portinfostepkginst-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:pkginst" priority="1000"
                 mode="M197">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pkginst entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M197"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M197"/>
   <xsl:template match="@*|node()" priority="-2" mode="M197">
      <xsl:apply-templates select="@*|*" mode="M197"/>
   </xsl:template>

   <!--PATTERN portinfostename-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:name" priority="1000" mode="M198">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M198"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M198"/>
   <xsl:template match="@*|node()" priority="-2" mode="M198">
      <xsl:apply-templates select="@*|*" mode="M198"/>
   </xsl:template>

   <!--PATTERN portinfostecategory-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:category" priority="1000"
                 mode="M199">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the category entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M199"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M199"/>
   <xsl:template match="@*|node()" priority="-2" mode="M199">
      <xsl:apply-templates select="@*|*" mode="M199"/>
   </xsl:template>

   <!--PATTERN portinfosteversion-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:version" priority="1000"
                 mode="M200">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M200"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M200"/>
   <xsl:template match="@*|node()" priority="-2" mode="M200">
      <xsl:apply-templates select="@*|*" mode="M200"/>
   </xsl:template>

   <!--PATTERN portinfostevendor-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:vendor" priority="1000"
                 mode="M201">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the vendor entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M201"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M201"/>
   <xsl:template match="@*|node()" priority="-2" mode="M201">
      <xsl:apply-templates select="@*|*" mode="M201"/>
   </xsl:template>

   <!--PATTERN portinfostedescription-->


	<!--RULE -->
<xsl:template match="freebsd-def:portinfo_state/freebsd-def:description" priority="1000"
                 mode="M202">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of a portinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M202"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M202"/>
   <xsl:template match="@*|node()" priority="-2" mode="M202">
      <xsl:apply-templates select="@*|*" mode="M202"/>
   </xsl:template>

   <!--PATTERN gcobjparameter_name-->


	<!--RULE -->
<xsl:template match="hpux-def:getconf_object/hpux-def:parameter_name" priority="1000"
                 mode="M203">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the parameter_name entity of a getconf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M203"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M203"/>
   <xsl:template match="@*|node()" priority="-2" mode="M203">
      <xsl:apply-templates select="@*|*" mode="M203"/>
   </xsl:template>

   <!--PATTERN gcobjpathname-->


	<!--RULE -->
<xsl:template match="hpux-def:getconf_object/hpux-def:pathname" priority="1000" mode="M204">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pathname entity of a getconf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M204"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M204"/>
   <xsl:template match="@*|node()" priority="-2" mode="M204">
      <xsl:apply-templates select="@*|*" mode="M204"/>
   </xsl:template>

   <!--PATTERN gcsteparameter_name-->


	<!--RULE -->
<xsl:template match="hpux-def:getconf_state/hpux-def:parameter_name" priority="1000"
                 mode="M205">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the parameter_name entity of a getconf_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M205"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M205"/>
   <xsl:template match="@*|node()" priority="-2" mode="M205">
      <xsl:apply-templates select="@*|*" mode="M205"/>
   </xsl:template>

   <!--PATTERN gcstepathname-->


	<!--RULE -->
<xsl:template match="hpux-def:getconf_state/hpux-def:pathname" priority="1000" mode="M206">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pathname entity of a getconf_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M206"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M206"/>
   <xsl:template match="@*|node()" priority="-2" mode="M206">
      <xsl:apply-templates select="@*|*" mode="M206"/>
   </xsl:template>

   <!--PATTERN gcsteoutput-->


	<!--RULE -->
<xsl:template match="hpux-def:getconf_state/hpux-def:output" priority="1000" mode="M207">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the output entity of a getconf_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M207"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M207"/>
   <xsl:template match="@*|node()" priority="-2" mode="M207">
      <xsl:apply-templates select="@*|*" mode="M207"/>
   </xsl:template>

   <!--PATTERN patch53objswtype-->


	<!--RULE -->
<xsl:template match="hpux-def:patch53_object/hpux-def:swtype" priority="1000" mode="M208">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swtype entity of a patch53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M208"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M208"/>
   <xsl:template match="@*|node()" priority="-2" mode="M208">
      <xsl:apply-templates select="@*|*" mode="M208"/>
   </xsl:template>

   <!--PATTERN patch53objarea_patched-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_object/hpux-def:area_patched" priority="1000" mode="M209">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the area_patched entity of a patch53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M209"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M209"/>
   <xsl:template match="@*|node()" priority="-2" mode="M209">
      <xsl:apply-templates select="@*|*" mode="M209"/>
   </xsl:template>

   <!--PATTERN patch53objpatch_base-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_object/hpux-def:patch_base" priority="1000" mode="M210">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_base entity of a patch53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M210"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M210"/>
   <xsl:template match="@*|node()" priority="-2" mode="M210">
      <xsl:apply-templates select="@*|*" mode="M210"/>
   </xsl:template>

   <!--PATTERN patch53steswtype-->


	<!--RULE -->
<xsl:template match="hpux-def:patch53_state/hpux-def:swtype" priority="1000" mode="M211">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swtype entity of a patch53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M211"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M211"/>
   <xsl:template match="@*|node()" priority="-2" mode="M211">
      <xsl:apply-templates select="@*|*" mode="M211"/>
   </xsl:template>

   <!--PATTERN patch53stearea_patched-->


	<!--RULE -->
<xsl:template match="hpux-def:patch53_state/hpux-def:area_patched" priority="1000"
                 mode="M212">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the area_patched entity of a patch53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M212"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M212"/>
   <xsl:template match="@*|node()" priority="-2" mode="M212">
      <xsl:apply-templates select="@*|*" mode="M212"/>
   </xsl:template>

   <!--PATTERN patch53stepatch_base-->


	<!--RULE -->
<xsl:template match="hpux-def:patch53_state/hpux-def:patch_base" priority="1000" mode="M213">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_base entity of a patch53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M213"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M213"/>
   <xsl:template match="@*|node()" priority="-2" mode="M213">
      <xsl:apply-templates select="@*|*" mode="M213"/>
   </xsl:template>

   <!--PATTERN patch_test_dep-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_test" priority="1000" mode="M214">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M214"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M214"/>
   <xsl:template match="@*|node()" priority="-2" mode="M214">
      <xsl:apply-templates select="@*|*" mode="M214"/>
   </xsl:template>

   <!--PATTERN patch_object_dep-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_object" priority="1000" mode="M215">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M215"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M215"/>
   <xsl:template match="@*|node()" priority="-2" mode="M215">
      <xsl:apply-templates select="@*|*" mode="M215"/>
   </xsl:template>

   <!--PATTERN patchobjpatch_name-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_object/hpux-def:patch_name" priority="1000" mode="M216">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_name entity of a patch_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M216"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M216"/>
   <xsl:template match="@*|node()" priority="-2" mode="M216">
      <xsl:apply-templates select="@*|*" mode="M216"/>
   </xsl:template>

   <!--PATTERN patch_state_dep-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_state" priority="1000" mode="M217">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M217"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M217"/>
   <xsl:template match="@*|node()" priority="-2" mode="M217">
      <xsl:apply-templates select="@*|*" mode="M217"/>
   </xsl:template>

   <!--PATTERN patchstepatch_name-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_state/hpux-def:patch_name" priority="1000" mode="M218">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_name entity of a patch_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M218"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M218"/>
   <xsl:template match="@*|node()" priority="-2" mode="M218">
      <xsl:apply-templates select="@*|*" mode="M218"/>
   </xsl:template>

   <!--PATTERN patchsteswtype-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_state/hpux-def:swtype" priority="1000" mode="M219">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swtype entity of a patch_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M219"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M219"/>
   <xsl:template match="@*|node()" priority="-2" mode="M219">
      <xsl:apply-templates select="@*|*" mode="M219"/>
   </xsl:template>

   <!--PATTERN patchstearea_patched-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_state/hpux-def:area_patched" priority="1000" mode="M220">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the area_patched entity of a patch_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M220"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M220"/>
   <xsl:template match="@*|node()" priority="-2" mode="M220">
      <xsl:apply-templates select="@*|*" mode="M220"/>
   </xsl:template>

   <!--PATTERN patchstepatch_base-->


	<!--RULE -->
<xsl:template match="hpux-def:patch_state/hpux-def:patch_base" priority="1000" mode="M221">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the patch_base entity of a patch_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M221"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M221"/>
   <xsl:template match="@*|node()" priority="-2" mode="M221">
      <xsl:apply-templates select="@*|*" mode="M221"/>
   </xsl:template>

   <!--PATTERN swlistobjswlist-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_object/hpux-def:swlist" priority="1000" mode="M222">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swlist entity of a swlist_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M222"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M222"/>
   <xsl:template match="@*|node()" priority="-2" mode="M222">
      <xsl:apply-templates select="@*|*" mode="M222"/>
   </xsl:template>

   <!--PATTERN swliststeswlist-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:swlist" priority="1000" mode="M223">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the swlist entity of a swlist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M223"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M223"/>
   <xsl:template match="@*|node()" priority="-2" mode="M223">
      <xsl:apply-templates select="@*|*" mode="M223"/>
   </xsl:template>

   <!--PATTERN swliststebundle-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:bundle" priority="1000" mode="M224">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the bundle entity of a swlist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M224"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M224"/>
   <xsl:template match="@*|node()" priority="-2" mode="M224">
      <xsl:apply-templates select="@*|*" mode="M224"/>
   </xsl:template>

   <!--PATTERN swliststefileset-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:fileset" priority="1000" mode="M225">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the fileset entity of a swlist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M225"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M225"/>
   <xsl:template match="@*|node()" priority="-2" mode="M225">
      <xsl:apply-templates select="@*|*" mode="M225"/>
   </xsl:template>

   <!--PATTERN swliststeversion-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:version" priority="1000" mode="M226">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='fileset_revision'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a swlist_state should be 'fileset_revision'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M226"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M226"/>
   <xsl:template match="@*|node()" priority="-2" mode="M226">
      <xsl:apply-templates select="@*|*" mode="M226"/>
   </xsl:template>

   <!--PATTERN swliststetitle-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:title" priority="1000" mode="M227">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the title entity of a swlist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M227"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M227"/>
   <xsl:template match="@*|node()" priority="-2" mode="M227">
      <xsl:apply-templates select="@*|*" mode="M227"/>
   </xsl:template>

   <!--PATTERN swliststevendor-->


	<!--RULE -->
<xsl:template match="hpux-def:swlist_state/hpux-def:vendor" priority="1000" mode="M228">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the vendor entity of a swlist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M228"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M228"/>
   <xsl:template match="@*|node()" priority="-2" mode="M228">
      <xsl:apply-templates select="@*|*" mode="M228"/>
   </xsl:template>

   <!--PATTERN trustobjusername-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_object/hpux-def:username" priority="1000" mode="M229">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a trusted_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M229"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M229"/>
   <xsl:template match="@*|node()" priority="-2" mode="M229">
      <xsl:apply-templates select="@*|*" mode="M229"/>
   </xsl:template>

   <!--PATTERN truststeusername-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:username" priority="1000" mode="M230">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M230"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M230"/>
   <xsl:template match="@*|node()" priority="-2" mode="M230">
      <xsl:apply-templates select="@*|*" mode="M230"/>
   </xsl:template>

   <!--PATTERN truststeuid-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:uid" priority="1000" mode="M231">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uid entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M231"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M231"/>
   <xsl:template match="@*|node()" priority="-2" mode="M231">
      <xsl:apply-templates select="@*|*" mode="M231"/>
   </xsl:template>

   <!--PATTERN truststepassword-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:password" priority="1000" mode="M232">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M232"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M232"/>
   <xsl:template match="@*|node()" priority="-2" mode="M232">
      <xsl:apply-templates select="@*|*" mode="M232"/>
   </xsl:template>

   <!--PATTERN truststeaccount_owner-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:account_owner" priority="1000"
                 mode="M233">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the account_owner entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M233"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M233"/>
   <xsl:template match="@*|node()" priority="-2" mode="M233">
      <xsl:apply-templates select="@*|*" mode="M233"/>
   </xsl:template>

   <!--PATTERN truststeboot_auth-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:boot_auth" priority="1000" mode="M234">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the boot_auth entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M234"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M234"/>
   <xsl:template match="@*|node()" priority="-2" mode="M234">
      <xsl:apply-templates select="@*|*" mode="M234"/>
   </xsl:template>

   <!--PATTERN truststeaudit_id-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:audit_id" priority="1000" mode="M235">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the audit_id entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M235"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M235"/>
   <xsl:template match="@*|node()" priority="-2" mode="M235">
      <xsl:apply-templates select="@*|*" mode="M235"/>
   </xsl:template>

   <!--PATTERN truststeaudit_flag-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:audit_flag" priority="1000" mode="M236">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the audit_flag entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M236"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M236"/>
   <xsl:template match="@*|node()" priority="-2" mode="M236">
      <xsl:apply-templates select="@*|*" mode="M236"/>
   </xsl:template>

   <!--PATTERN truststepw_change_min-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_change_min" priority="1000"
                 mode="M237">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_change_min entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M237"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M237"/>
   <xsl:template match="@*|node()" priority="-2" mode="M237">
      <xsl:apply-templates select="@*|*" mode="M237"/>
   </xsl:template>

   <!--PATTERN truststepw_max_size-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_max_size" priority="1000" mode="M238">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_max_size entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M238"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M238"/>
   <xsl:template match="@*|node()" priority="-2" mode="M238">
      <xsl:apply-templates select="@*|*" mode="M238"/>
   </xsl:template>

   <!--PATTERN truststepw_expiration-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_expiration" priority="1000"
                 mode="M239">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_expiration entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M239"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M239"/>
   <xsl:template match="@*|node()" priority="-2" mode="M239">
      <xsl:apply-templates select="@*|*" mode="M239"/>
   </xsl:template>

   <!--PATTERN truststepw_life-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_life" priority="1000" mode="M240">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_life entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M240"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M240"/>
   <xsl:template match="@*|node()" priority="-2" mode="M240">
      <xsl:apply-templates select="@*|*" mode="M240"/>
   </xsl:template>

   <!--PATTERN truststepw_change_s-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_change_s" priority="1000" mode="M241">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_change_s entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M241"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M241"/>
   <xsl:template match="@*|node()" priority="-2" mode="M241">
      <xsl:apply-templates select="@*|*" mode="M241"/>
   </xsl:template>

   <!--PATTERN truststepw_change_u-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_change_u" priority="1000" mode="M242">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_change_u entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M242"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M242"/>
   <xsl:template match="@*|node()" priority="-2" mode="M242">
      <xsl:apply-templates select="@*|*" mode="M242"/>
   </xsl:template>

   <!--PATTERN truststeacct_expire-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:acct_expire" priority="1000" mode="M243">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the acct_expire entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M243"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M243"/>
   <xsl:template match="@*|node()" priority="-2" mode="M243">
      <xsl:apply-templates select="@*|*" mode="M243"/>
   </xsl:template>

   <!--PATTERN truststemax_llogin-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:max_llogin" priority="1000" mode="M244">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the max_llogin entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M244"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M244"/>
   <xsl:template match="@*|node()" priority="-2" mode="M244">
      <xsl:apply-templates select="@*|*" mode="M244"/>
   </xsl:template>

   <!--PATTERN truststeexp_warning-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:exp_warning" priority="1000" mode="M245">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exp_warning entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M245"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M245"/>
   <xsl:template match="@*|node()" priority="-2" mode="M245">
      <xsl:apply-templates select="@*|*" mode="M245"/>
   </xsl:template>

   <!--PATTERN truststeusr_chg_pw-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:usr_chg_pw" priority="1000" mode="M246">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the usr_chg_pw entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M246"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M246"/>
   <xsl:template match="@*|node()" priority="-2" mode="M246">
      <xsl:apply-templates select="@*|*" mode="M246"/>
   </xsl:template>

   <!--PATTERN truststegen_pw-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:gen_pw" priority="1000" mode="M247">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gen_pw entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M247"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M247"/>
   <xsl:template match="@*|node()" priority="-2" mode="M247">
      <xsl:apply-templates select="@*|*" mode="M247"/>
   </xsl:template>

   <!--PATTERN truststepw_restrict-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_restrict" priority="1000" mode="M248">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_restrict entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M248"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M248"/>
   <xsl:template match="@*|node()" priority="-2" mode="M248">
      <xsl:apply-templates select="@*|*" mode="M248"/>
   </xsl:template>

   <!--PATTERN truststepw_null-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_null" priority="1000" mode="M249">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_null entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M249"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M249"/>
   <xsl:template match="@*|node()" priority="-2" mode="M249">
      <xsl:apply-templates select="@*|*" mode="M249"/>
   </xsl:template>

   <!--PATTERN truststepw_gen_char-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_gen_char" priority="1000" mode="M250">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_gen_char entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M250"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M250"/>
   <xsl:template match="@*|node()" priority="-2" mode="M250">
      <xsl:apply-templates select="@*|*" mode="M250"/>
   </xsl:template>

   <!--PATTERN truststepw_gen_let-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_gen_let" priority="1000" mode="M251">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_gen_let entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M251"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M251"/>
   <xsl:template match="@*|node()" priority="-2" mode="M251">
      <xsl:apply-templates select="@*|*" mode="M251"/>
   </xsl:template>

   <!--PATTERN truststelogin_time-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:login_time" priority="1000" mode="M252">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_time entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M252"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M252"/>
   <xsl:template match="@*|node()" priority="-2" mode="M252">
      <xsl:apply-templates select="@*|*" mode="M252"/>
   </xsl:template>

   <!--PATTERN truststepw_changer-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:pw_changer" priority="1000" mode="M253">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pw_changer entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M253"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M253"/>
   <xsl:template match="@*|node()" priority="-2" mode="M253">
      <xsl:apply-templates select="@*|*" mode="M253"/>
   </xsl:template>

   <!--PATTERN truststelogin_time_s-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:login_time_s" priority="1000"
                 mode="M254">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_time_s entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M254"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M254"/>
   <xsl:template match="@*|node()" priority="-2" mode="M254">
      <xsl:apply-templates select="@*|*" mode="M254"/>
   </xsl:template>

   <!--PATTERN truststelogin_time_u-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:login_time_u" priority="1000"
                 mode="M255">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_time_u entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M255"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M255"/>
   <xsl:template match="@*|node()" priority="-2" mode="M255">
      <xsl:apply-templates select="@*|*" mode="M255"/>
   </xsl:template>

   <!--PATTERN truststelogin_tty_s-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:login_tty_s" priority="1000" mode="M256">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_tty_s entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M256"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M256"/>
   <xsl:template match="@*|node()" priority="-2" mode="M256">
      <xsl:apply-templates select="@*|*" mode="M256"/>
   </xsl:template>

   <!--PATTERN truststelogin_tty_u-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:login_tty_u" priority="1000" mode="M257">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_tty_u entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M257"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M257"/>
   <xsl:template match="@*|node()" priority="-2" mode="M257">
      <xsl:apply-templates select="@*|*" mode="M257"/>
   </xsl:template>

   <!--PATTERN truststenum_u_logins-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:num_u_logins" priority="1000"
                 mode="M258">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the num_u_logins entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M258"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M258"/>
   <xsl:template match="@*|node()" priority="-2" mode="M258">
      <xsl:apply-templates select="@*|*" mode="M258"/>
   </xsl:template>

   <!--PATTERN truststemax_u_logins-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:max_u_logins" priority="1000"
                 mode="M259">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the max_u_logins entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M259"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M259"/>
   <xsl:template match="@*|node()" priority="-2" mode="M259">
      <xsl:apply-templates select="@*|*" mode="M259"/>
   </xsl:template>

   <!--PATTERN truststelock_flag-->


	<!--RULE -->
<xsl:template match="hpux-def:trusted_state/hpux-def:lock_flag" priority="1000" mode="M260">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the lock_flag entity of a trusted_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M260"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M260"/>
   <xsl:template match="@*|node()" priority="-2" mode="M260">
      <xsl:apply-templates select="@*|*" mode="M260"/>
   </xsl:template>

   <!--PATTERN globaltst-->


	<!--RULE -->
<xsl:template match="ios-def:global_test/ios-def:object" priority="1001" mode="M261">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:global_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a global_test must reference a global_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M261"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:global_test/ios-def:state" priority="1000" mode="M261">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:global_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a global_test must reference a global_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M261"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M261"/>
   <xsl:template match="@*|node()" priority="-2" mode="M261">
      <xsl:apply-templates select="@*|*" mode="M261"/>
   </xsl:template>

   <!--PATTERN globalobjglobal_command-->


	<!--RULE -->
<xsl:template match="ios-def:global_object/ios-def:global_command" priority="1000"
                 mode="M262">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the global_command entity of a global_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M262"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M262"/>
   <xsl:template match="@*|node()" priority="-2" mode="M262">
      <xsl:apply-templates select="@*|*" mode="M262"/>
   </xsl:template>

   <!--PATTERN globalsteglobal_command-->


	<!--RULE -->
<xsl:template match="ios-def:global_state/ios-def:global_command" priority="1000" mode="M263">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the global_command entity of a global_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M263"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M263"/>
   <xsl:template match="@*|node()" priority="-2" mode="M263">
      <xsl:apply-templates select="@*|*" mode="M263"/>
   </xsl:template>

   <!--PATTERN iosinterfacetst-->


	<!--RULE -->
<xsl:template match="ios-def:interface_test/ios-def:object" priority="1001" mode="M264">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:interface_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an interface_test must reference an interface_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M264"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:interface_test/ios-def:state" priority="1000" mode="M264">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:interface_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an interface_test must reference an interface_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M264"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M264"/>
   <xsl:template match="@*|node()" priority="-2" mode="M264">
      <xsl:apply-templates select="@*|*" mode="M264"/>
   </xsl:template>

   <!--PATTERN iosinterfaceobjname-->


	<!--RULE -->
<xsl:template match="ios-def:interface_object/ios-def:name" priority="1000" mode="M265">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an interface_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M265"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M265"/>
   <xsl:template match="@*|node()" priority="-2" mode="M265">
      <xsl:apply-templates select="@*|*" mode="M265"/>
   </xsl:template>

   <!--PATTERN iosinterfacestename-->


	<!--RULE -->
<xsl:template match="ios-def:interface_state/ios-def:name" priority="1000" mode="M266">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M266"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M266"/>
   <xsl:template match="@*|node()" priority="-2" mode="M266">
      <xsl:apply-templates select="@*|*" mode="M266"/>
   </xsl:template>

   <!--PATTERN iosinterfacesteip_directed_broadcast_command-->


	<!--RULE -->
<xsl:template match="ios-def:interface_state/ios-def:ip_directed_broadcast_command"
                 priority="1000"
                 mode="M267">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ip_directed_broadcast_command entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M267"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M267"/>
   <xsl:template match="@*|node()" priority="-2" mode="M267">
      <xsl:apply-templates select="@*|*" mode="M267"/>
   </xsl:template>

   <!--PATTERN iosinterfacesteno_ip_directed_broadcast_command-->


	<!--RULE -->
<xsl:template match="ios-def:interface_state/ios-def:no_ip_directed_broadcast_command"
                 priority="1000"
                 mode="M268">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the no_ip_directed_broadcast_command entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M268"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M268"/>
   <xsl:template match="@*|node()" priority="-2" mode="M268">
      <xsl:apply-templates select="@*|*" mode="M268"/>
   </xsl:template>

   <!--PATTERN iosinterfacesteproxy_arp_command-->


	<!--RULE -->
<xsl:template match="ios-def:interface_state/ios-def:proxy_arp_command" priority="1000"
                 mode="M269">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the proxy_arp_command entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M269"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M269"/>
   <xsl:template match="@*|node()" priority="-2" mode="M269">
      <xsl:apply-templates select="@*|*" mode="M269"/>
   </xsl:template>

   <!--PATTERN iosinterfacesteshutdown_command-->


	<!--RULE -->
<xsl:template match="ios-def:interface_state/ios-def:shutdown_command" priority="1000"
                 mode="M270">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the shutdown_command entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M270"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M270"/>
   <xsl:template match="@*|node()" priority="-2" mode="M270">
      <xsl:apply-templates select="@*|*" mode="M270"/>
   </xsl:template>

   <!--PATTERN ioslinetst-->


	<!--RULE -->
<xsl:template match="ios-def:line_test/ios-def:object" priority="1001" mode="M271">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:line_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a line_test must reference a line_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M271"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:line_test/ios-def:state" priority="1000" mode="M271">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:line_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a line_test must reference a line_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M271"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M271"/>
   <xsl:template match="@*|node()" priority="-2" mode="M271">
      <xsl:apply-templates select="@*|*" mode="M271"/>
   </xsl:template>

   <!--PATTERN ioslineobjshow_subcommand-->


	<!--RULE -->
<xsl:template match="ios-def:line_object/ios-def:show_subcommand" priority="1000" mode="M272">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M272"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M272"/>
   <xsl:template match="@*|node()" priority="-2" mode="M272">
      <xsl:apply-templates select="@*|*" mode="M272"/>
   </xsl:template>

   <!--PATTERN ioslinesteshow_subcommand-->


	<!--RULE -->
<xsl:template match="ios-def:line_state/ios-def:show_subcommand" priority="1000" mode="M273">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M273"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M273"/>
   <xsl:template match="@*|node()" priority="-2" mode="M273">
      <xsl:apply-templates select="@*|*" mode="M273"/>
   </xsl:template>

   <!--PATTERN ioslinesteconfig_line-->


	<!--RULE -->
<xsl:template match="ios-def:line_state/ios-def:config_line" priority="1000" mode="M274">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the config_line entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M274"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M274"/>
   <xsl:template match="@*|node()" priority="-2" mode="M274">
      <xsl:apply-templates select="@*|*" mode="M274"/>
   </xsl:template>

   <!--PATTERN snmptst-->


	<!--RULE -->
<xsl:template match="ios-def:snmp_test/ios-def:object" priority="1001" mode="M275">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:snmp_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a snmp_test must reference a snmp_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M275"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:snmp_test/ios-def:state" priority="1000" mode="M275">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:snmp_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a snmp_test must reference a snmp_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M275"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M275"/>
   <xsl:template match="@*|node()" priority="-2" mode="M275">
      <xsl:apply-templates select="@*|*" mode="M275"/>
   </xsl:template>

   <!--PATTERN snmpsteaccess_list-->


	<!--RULE -->
<xsl:template match="ios-def:snmp_state/ios-def:access_list" priority="1000" mode="M276">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_list entity of a snmp_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M276"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M276"/>
   <xsl:template match="@*|node()" priority="-2" mode="M276">
      <xsl:apply-templates select="@*|*" mode="M276"/>
   </xsl:template>

   <!--PATTERN snmpstecommunity_name-->


	<!--RULE -->
<xsl:template match="ios-def:snmp_state/ios-def:community_name" priority="1000" mode="M277">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the community_name entity of a snmp_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M277"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M277"/>
   <xsl:template match="@*|node()" priority="-2" mode="M277">
      <xsl:apply-templates select="@*|*" mode="M277"/>
   </xsl:template>

   <!--PATTERN tclshtst-->


	<!--RULE -->
<xsl:template match="ios-def:tclsh_test/ios-def:object" priority="1001" mode="M278">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:tclsh_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a tclsh_test must reference a tclsh_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M278"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:tclsh_test/ios-def:state" priority="1000" mode="M278">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:tclsh_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a tclsh_test must reference a tclsh_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M278"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M278"/>
   <xsl:template match="@*|node()" priority="-2" mode="M278">
      <xsl:apply-templates select="@*|*" mode="M278"/>
   </xsl:template>

   <!--PATTERN tclshsteavailable-->


	<!--RULE -->
<xsl:template match="ios-def:tclsh_state/ios-def:available" priority="1000" mode="M279">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the available entity of a tclsh_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M279"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M279"/>
   <xsl:template match="@*|node()" priority="-2" mode="M279">
      <xsl:apply-templates select="@*|*" mode="M279"/>
   </xsl:template>

   <!--PATTERN iosver55tst-->


	<!--RULE -->
<xsl:template match="ios-def:version55_test/ios-def:object" priority="1001" mode="M280">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:version55_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a version55_test must reference a version_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M280"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:version55_test/ios-def:state" priority="1000" mode="M280">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:version55_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a version55_test must reference a version_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M280"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M280"/>
   <xsl:template match="@*|node()" priority="-2" mode="M280">
      <xsl:apply-templates select="@*|*" mode="M280"/>
   </xsl:template>

   <!--PATTERN iosver55stemajorversion-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:major_version" priority="1000"
                 mode="M281">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the major_version entity of a version55_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M281"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M281"/>
   <xsl:template match="@*|node()" priority="-2" mode="M281">
      <xsl:apply-templates select="@*|*" mode="M281"/>
   </xsl:template>

   <!--PATTERN iosver55steminorversion-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:minor_version" priority="1000"
                 mode="M282">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the minor_version entity of a version55_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M282"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M282"/>
   <xsl:template match="@*|node()" priority="-2" mode="M282">
      <xsl:apply-templates select="@*|*" mode="M282"/>
   </xsl:template>

   <!--PATTERN iosver55sterelease-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:release" priority="1000" mode="M283">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the release entity of a version55_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M283"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M283"/>
   <xsl:template match="@*|node()" priority="-2" mode="M283">
      <xsl:apply-templates select="@*|*" mode="M283"/>
   </xsl:template>

   <!--PATTERN iosver55stetrain_identifier-->


	<!--RULE -->
<xsl:template match="ios-def:version_state/ios-def:train_identifier" priority="1000"
                 mode="M284">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the train_identifier entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M284"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M284"/>
   <xsl:template match="@*|node()" priority="-2" mode="M284">
      <xsl:apply-templates select="@*|*" mode="M284"/>
   </xsl:template>

   <!--PATTERN iosver55sterebuild-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:rebuild" priority="1000" mode="M285">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the rebuild entity of a version55_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M285"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M285"/>
   <xsl:template match="@*|node()" priority="-2" mode="M285">
      <xsl:apply-templates select="@*|*" mode="M285"/>
   </xsl:template>

   <!--PATTERN iosver55stesubrebuild-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:subrebuild" priority="1000" mode="M286">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the subrebuild entity of a version55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M286"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M286"/>
   <xsl:template match="@*|node()" priority="-2" mode="M286">
      <xsl:apply-templates select="@*|*" mode="M286"/>
   </xsl:template>

   <!--PATTERN iosver55stemainlinerebuild-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:mainline_rebuild" priority="1000"
                 mode="M287">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the mainline_rebuild entity of a version55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M287"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M287"/>
   <xsl:template match="@*|node()" priority="-2" mode="M287">
      <xsl:apply-templates select="@*|*" mode="M287"/>
   </xsl:template>

   <!--PATTERN iosver55steversionstring-->


	<!--RULE -->
<xsl:template match="ios-def:version55_state/ios-def:version_string" priority="1000"
                 mode="M288">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='ios_version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version_string entity of a version55_state should be 'ios_version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M288"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M288"/>
   <xsl:template match="@*|node()" priority="-2" mode="M288">
      <xsl:apply-templates select="@*|*" mode="M288"/>
   </xsl:template>

   <!--PATTERN iosvertst_dep-->


	<!--RULE -->
<xsl:template match="ios-def:version_test" priority="1000" mode="M289">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M289"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M289"/>
   <xsl:template match="@*|node()" priority="-2" mode="M289">
      <xsl:apply-templates select="@*|*" mode="M289"/>
   </xsl:template>

   <!--PATTERN iosvertst-->


	<!--RULE -->
<xsl:template match="ios-def:version_test/ios-def:object" priority="1001" mode="M290">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/ios-def:version_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a version_test must reference a version_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M290"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="ios-def:version_test/ios-def:state" priority="1000" mode="M290">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/ios-def:version_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a version_test must reference a version_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M290"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M290"/>
   <xsl:template match="@*|node()" priority="-2" mode="M290">
      <xsl:apply-templates select="@*|*" mode="M290"/>
   </xsl:template>

   <!--PATTERN iosverobj_dep-->


	<!--RULE -->
<xsl:template match="ios-def:version_object" priority="1000" mode="M291">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M291"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M291"/>
   <xsl:template match="@*|node()" priority="-2" mode="M291">
      <xsl:apply-templates select="@*|*" mode="M291"/>
   </xsl:template>

   <!--PATTERN iosverste_dep-->


	<!--RULE -->
<xsl:template match="ios-def:version_state" priority="1000" mode="M292">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M292"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M292"/>
   <xsl:template match="@*|node()" priority="-2" mode="M292">
      <xsl:apply-templates select="@*|*" mode="M292"/>
   </xsl:template>

   <!--PATTERN iosverstemajor_release-->


	<!--RULE -->
<xsl:template match="ios-def:version_state/ios-def:major_release" priority="1000" mode="M293">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the major_release entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M293"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M293"/>
   <xsl:template match="@*|node()" priority="-2" mode="M293">
      <xsl:apply-templates select="@*|*" mode="M293"/>
   </xsl:template>

   <!--PATTERN iosverstetrain_number-->


	<!--RULE -->
<xsl:template match="ios-def:version_state/ios-def:train_number" priority="1000" mode="M294">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the train_number entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M294"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M294"/>
   <xsl:template match="@*|node()" priority="-2" mode="M294">
      <xsl:apply-templates select="@*|*" mode="M294"/>
   </xsl:template>

   <!--PATTERN iosverstetrain_identifier-->


	<!--RULE -->
<xsl:template match="ios-def:version_state/ios-def:train_identifier" priority="1000"
                 mode="M295">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the train_identifier entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M295"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M295"/>
   <xsl:template match="@*|node()" priority="-2" mode="M295">
      <xsl:apply-templates select="@*|*" mode="M295"/>
   </xsl:template>

   <!--PATTERN iosversteversion_string-->


	<!--RULE -->
<xsl:template match="ios-def:version_state/ios-def:version_string" priority="1000"
                 mode="M296">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='ios_version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version_string entity of a version_state should be 'ios_version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M296"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M296"/>
   <xsl:template match="@*|node()" priority="-2" mode="M296">
      <xsl:apply-templates select="@*|*" mode="M296"/>
   </xsl:template>

   <!--PATTERN dpkgobjname-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_object/linux-def:name" priority="1000" mode="M297">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a dpkginfo_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a dpkginfo_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M297"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M297"/>
   <xsl:template match="@*|node()" priority="-2" mode="M297">
      <xsl:apply-templates select="@*|*" mode="M297"/>
   </xsl:template>

   <!--PATTERN dpkgstename-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:name" priority="1000" mode="M298">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a dpkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a dpkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M298"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M298"/>
   <xsl:template match="@*|node()" priority="-2" mode="M298">
      <xsl:apply-templates select="@*|*" mode="M298"/>
   </xsl:template>

   <!--PATTERN dpkgstearch-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:arch" priority="1000" mode="M299">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the arch entity of a dpkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the arch entity of a dpkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M299"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M299"/>
   <xsl:template match="@*|node()" priority="-2" mode="M299">
      <xsl:apply-templates select="@*|*" mode="M299"/>
   </xsl:template>

   <!--PATTERN dpkgsteepoch-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:epoch" priority="1000" mode="M300">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the epoch entity of a dpkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or 'pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the epoch entity of a dpkginfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M300"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M300"/>
   <xsl:template match="@*|node()" priority="-2" mode="M300">
      <xsl:apply-templates select="@*|*" mode="M300"/>
   </xsl:template>

   <!--PATTERN dpkgsterelease-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:release" priority="1000" mode="M301">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the release entity of a dpkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or 'pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the release entity of a dpkginfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M301"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M301"/>
   <xsl:template match="@*|node()" priority="-2" mode="M301">
      <xsl:apply-templates select="@*|*" mode="M301"/>
   </xsl:template>

   <!--PATTERN dpkgsteversion-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:version" priority="1000" mode="M302">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a dpkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or 'pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the version entity of a dpkginfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M302"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M302"/>
   <xsl:template match="@*|node()" priority="-2" mode="M302">
      <xsl:apply-templates select="@*|*" mode="M302"/>
   </xsl:template>

   <!--PATTERN dpkgsteevr-->


	<!--RULE -->
<xsl:template match="linux-def:dpkginfo_state/linux-def:evr" priority="1000" mode="M303">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='evr_string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the evr entity of a dpkginfo_state should be 'evr_string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or 'pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the evr entity of a dpkginfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M303"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M303"/>
   <xsl:template match="@*|node()" priority="-2" mode="M303">
      <xsl:apply-templates select="@*|*" mode="M303"/>
   </xsl:template>

   <!--PATTERN ilsobjprotocol-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_object/linux-def:protocol"
                 priority="1000"
                 mode="M304">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an inetlisteningservers_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the protocol entity of an inetlisteningservers_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M304"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M304"/>
   <xsl:template match="@*|node()" priority="-2" mode="M304">
      <xsl:apply-templates select="@*|*" mode="M304"/>
   </xsl:template>

   <!--PATTERN ilsobjlocal_address-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_object/linux-def:local_address"
                 priority="1000"
                 mode="M305">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_address entity of an inetlisteningservers_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the local_address entity of an inetlisteningservers_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M305"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M305"/>
   <xsl:template match="@*|node()" priority="-2" mode="M305">
      <xsl:apply-templates select="@*|*" mode="M305"/>
   </xsl:template>

   <!--PATTERN ilsobjlocal_port-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_object/linux-def:local_port"
                 priority="1000"
                 mode="M306">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_port entity of an inetlisteningservers_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the local_port entity of an inetlisteningservers_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M306"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M306"/>
   <xsl:template match="@*|node()" priority="-2" mode="M306">
      <xsl:apply-templates select="@*|*" mode="M306"/>
   </xsl:template>

   <!--PATTERN ilssteprotocol-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:protocol" priority="1000"
                 mode="M307">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the protocol entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M307"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M307"/>
   <xsl:template match="@*|node()" priority="-2" mode="M307">
      <xsl:apply-templates select="@*|*" mode="M307"/>
   </xsl:template>

   <!--PATTERN ilsstelocal_address-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:local_address"
                 priority="1000"
                 mode="M308">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the local_address entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M308"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M308"/>
   <xsl:template match="@*|node()" priority="-2" mode="M308">
      <xsl:apply-templates select="@*|*" mode="M308"/>
   </xsl:template>

   <!--PATTERN ilsstelocal_port-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:local_port"
                 priority="1000"
                 mode="M309">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_port entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the local_port entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M309"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M309"/>
   <xsl:template match="@*|node()" priority="-2" mode="M309">
      <xsl:apply-templates select="@*|*" mode="M309"/>
   </xsl:template>

   <!--PATTERN ilsstelocal_full_address-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:local_full_address"
                 priority="1000"
                 mode="M310">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_full_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the local_full_address entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M310"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M310"/>
   <xsl:template match="@*|node()" priority="-2" mode="M310">
      <xsl:apply-templates select="@*|*" mode="M310"/>
   </xsl:template>

   <!--PATTERN ilssteprogram_name-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:program_name"
                 priority="1000"
                 mode="M311">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the program_name entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the program_name entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M311"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M311"/>
   <xsl:template match="@*|node()" priority="-2" mode="M311">
      <xsl:apply-templates select="@*|*" mode="M311"/>
   </xsl:template>

   <!--PATTERN ilssteforeign_address-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:foreign_address"
                 priority="1000"
                 mode="M312">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the foreign_address entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M312"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M312"/>
   <xsl:template match="@*|node()" priority="-2" mode="M312">
      <xsl:apply-templates select="@*|*" mode="M312"/>
   </xsl:template>

   <!--PATTERN ilssteforeign_port-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:foreign_port"
                 priority="1000"
                 mode="M313">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_port entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the foreign_port entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M313"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M313"/>
   <xsl:template match="@*|node()" priority="-2" mode="M313">
      <xsl:apply-templates select="@*|*" mode="M313"/>
   </xsl:template>

   <!--PATTERN ilssteforeign_full_address-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:foreign_full_address"
                 priority="1000"
                 mode="M314">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_full_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the foreign_full_address entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M314"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M314"/>
   <xsl:template match="@*|node()" priority="-2" mode="M314">
      <xsl:apply-templates select="@*|*" mode="M314"/>
   </xsl:template>

   <!--PATTERN ilsstepid-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:pid" priority="1000"
                 mode="M315">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pid entity of an inetlisteningservers_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the pid entity of an inetlisteningservers_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', or 'less than or equal'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M315"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M315"/>
   <xsl:template match="@*|node()" priority="-2" mode="M315">
      <xsl:apply-templates select="@*|*" mode="M315"/>
   </xsl:template>

   <!--PATTERN ilssteuser_id-->


	<!--RULE -->
<xsl:template match="linux-def:inetlisteningservers_state/linux-def:user_id" priority="1000"
                 mode="M316">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_id entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the user_id entity of an inetlisteningservers_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M316"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M316"/>
   <xsl:template match="@*|node()" priority="-2" mode="M316">
      <xsl:apply-templates select="@*|*" mode="M316"/>
   </xsl:template>

   <!--PATTERN rpmobjname-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_object/linux-def:name" priority="1000" mode="M317">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a rpminfo_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a rpminfo_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M317"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M317"/>
   <xsl:template match="@*|node()" priority="-2" mode="M317">
      <xsl:apply-templates select="@*|*" mode="M317"/>
   </xsl:template>

   <!--PATTERN rpmstename-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:name" priority="1000" mode="M318">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a rpminfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M318"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M318"/>
   <xsl:template match="@*|node()" priority="-2" mode="M318">
      <xsl:apply-templates select="@*|*" mode="M318"/>
   </xsl:template>

   <!--PATTERN rpmstearch-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:arch" priority="1000" mode="M319">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the arch entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the arch entity of a rpminfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M319"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M319"/>
   <xsl:template match="@*|node()" priority="-2" mode="M319">
      <xsl:apply-templates select="@*|*" mode="M319"/>
   </xsl:template>

   <!--PATTERN rpmsteepoch-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:epoch" priority="1000" mode="M320">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the epoch entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the epoch entity of a rpminfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M320"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M320"/>
   <xsl:template match="@*|node()" priority="-2" mode="M320">
      <xsl:apply-templates select="@*|*" mode="M320"/>
   </xsl:template>

   <!--PATTERN rpmsterelease-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:release" priority="1000" mode="M321">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string' or @datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the release entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the release entity of a rpminfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M321"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M321"/>
   <xsl:template match="@*|node()" priority="-2" mode="M321">
      <xsl:apply-templates select="@*|*" mode="M321"/>
   </xsl:template>

   <!--PATTERN rpmsteversion-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:version" priority="1000" mode="M322">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string' or @datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the version entity of a rpminfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M322"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M322"/>
   <xsl:template match="@*|node()" priority="-2" mode="M322">
      <xsl:apply-templates select="@*|*" mode="M322"/>
   </xsl:template>

   <!--PATTERN rpmsteevr-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:evr" priority="1000" mode="M323">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='evr_string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the evr entity of a rpminfo_state should be 'evr_string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='greater than' or @operation='greater than or equal' or @operation='less than' or @operation='less than or equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the evr entity of a rpminfo_state should be 'equals', 'not equal', 'greater than', 'greater than or equal', 'less than', 'less than or equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M323"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M323"/>
   <xsl:template match="@*|node()" priority="-2" mode="M323">
      <xsl:apply-templates select="@*|*" mode="M323"/>
   </xsl:template>

   <!--PATTERN rpmstesignaturekeyid-->


	<!--RULE -->
<xsl:template match="linux-def:rpminfo_state/linux-def:signature_keyid" priority="1000"
                 mode="M324">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the signature_keyid entity of a rpminfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the signature_keyid entity of a rpminfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M324"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M324"/>
   <xsl:template match="@*|node()" priority="-2" mode="M324">
      <xsl:apply-templates select="@*|*" mode="M324"/>
   </xsl:template>

   <!--PATTERN spkginfoobjname-->


	<!--RULE -->
<xsl:template match="linux-def:slackwarepkginfo_object/linux-def:name" priority="1000"
                 mode="M325">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a slackwarepkginfo_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a slackwarepkginfo_object should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M325"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M325"/>
   <xsl:template match="@*|node()" priority="-2" mode="M325">
      <xsl:apply-templates select="@*|*" mode="M325"/>
   </xsl:template>

   <!--PATTERN spkginfostename-->


	<!--RULE -->
<xsl:template match="linux-def:slackwarepkginfo_state/linux-def:name" priority="1000"
                 mode="M326">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a slackwarepkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the name entity of a slackwarepkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M326"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M326"/>
   <xsl:template match="@*|node()" priority="-2" mode="M326">
      <xsl:apply-templates select="@*|*" mode="M326"/>
   </xsl:template>

   <!--PATTERN spkginfosteversion-->


	<!--RULE -->
<xsl:template match="linux-def:slackwarepkginfo_state/linux-def:version" priority="1000"
                 mode="M327">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a slackwarepkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the version entity of a slackwarepkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M327"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M327"/>
   <xsl:template match="@*|node()" priority="-2" mode="M327">
      <xsl:apply-templates select="@*|*" mode="M327"/>
   </xsl:template>

   <!--PATTERN spkginfostearch-->


	<!--RULE -->
<xsl:template match="linux-def:slackwarepkginfo_state/linux-def:architecture" priority="1000"
                 mode="M328">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the architecture entity of a slackwarepkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the architecture entity of a slackwarepkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M328"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M328"/>
   <xsl:template match="@*|node()" priority="-2" mode="M328">
      <xsl:apply-templates select="@*|*" mode="M328"/>
   </xsl:template>

   <!--PATTERN spkginfosterevision-->


	<!--RULE -->
<xsl:template match="linux-def:slackwarepkginfo_state/linux-def:revision" priority="1000"
                 mode="M329">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the revision entity of a slackwarepkginfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals' or @operation='not equal' or @operation='pattern match'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the revision entity of a slackwarepkginfo_state should be 'equals', 'not equal', or 'pattern match'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M329"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M329"/>
   <xsl:template match="@*|node()" priority="-2" mode="M329">
      <xsl:apply-templates select="@*|*" mode="M329"/>
   </xsl:template>

   <!--PATTERN accountobjusername-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_object/macos-def:username" priority="1000"
                 mode="M330">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of an accountinfo_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M330"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M330"/>
   <xsl:template match="@*|node()" priority="-2" mode="M330">
      <xsl:apply-templates select="@*|*" mode="M330"/>
   </xsl:template>

   <!--PATTERN accountsteusername-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:username" priority="1000"
                 mode="M331">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of an accountinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M331"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M331"/>
   <xsl:template match="@*|node()" priority="-2" mode="M331">
      <xsl:apply-templates select="@*|*" mode="M331"/>
   </xsl:template>

   <!--PATTERN accountstepassword-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:password" priority="1000"
                 mode="M332">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password entity of an accountinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M332"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M332"/>
   <xsl:template match="@*|node()" priority="-2" mode="M332">
      <xsl:apply-templates select="@*|*" mode="M332"/>
   </xsl:template>

   <!--PATTERN accountsteuid-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:uid" priority="1000" mode="M333">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uid entity of an accountinfo_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M333"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M333"/>
   <xsl:template match="@*|node()" priority="-2" mode="M333">
      <xsl:apply-templates select="@*|*" mode="M333"/>
   </xsl:template>

   <!--PATTERN accountstegid-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:gid" priority="1000" mode="M334">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gid entity of an accountinfo_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M334"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M334"/>
   <xsl:template match="@*|node()" priority="-2" mode="M334">
      <xsl:apply-templates select="@*|*" mode="M334"/>
   </xsl:template>

   <!--PATTERN accountsterealname-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:realname" priority="1000"
                 mode="M335">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the realname entity of an accountinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M335"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M335"/>
   <xsl:template match="@*|node()" priority="-2" mode="M335">
      <xsl:apply-templates select="@*|*" mode="M335"/>
   </xsl:template>

   <!--PATTERN accountstehome_dir-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:home_dir" priority="1000"
                 mode="M336">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the home_dir entity of an accountinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M336"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M336"/>
   <xsl:template match="@*|node()" priority="-2" mode="M336">
      <xsl:apply-templates select="@*|*" mode="M336"/>
   </xsl:template>

   <!--PATTERN accountstelogin_shell-->


	<!--RULE -->
<xsl:template match="macos-def:accountinfo_state/macos-def:login_shell" priority="1000"
                 mode="M337">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_shell entity of an accountinfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M337"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M337"/>
   <xsl:template match="@*|node()" priority="-2" mode="M337">
      <xsl:apply-templates select="@*|*" mode="M337"/>
   </xsl:template>

   <!--PATTERN macosilsobjprogram_name-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_object/macos-def:program_name"
                 priority="1000"
                 mode="M338">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the program_name entity of an inetlisteningservers_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M338"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M338"/>
   <xsl:template match="@*|node()" priority="-2" mode="M338">
      <xsl:apply-templates select="@*|*" mode="M338"/>
   </xsl:template>

   <!--PATTERN macosilssteprogram_name-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:program_name"
                 priority="1000"
                 mode="M339">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the program_name entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M339"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M339"/>
   <xsl:template match="@*|node()" priority="-2" mode="M339">
      <xsl:apply-templates select="@*|*" mode="M339"/>
   </xsl:template>

   <!--PATTERN macosilsstelocal_address-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:local_address"
                 priority="1000"
                 mode="M340">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M340"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M340"/>
   <xsl:template match="@*|node()" priority="-2" mode="M340">
      <xsl:apply-templates select="@*|*" mode="M340"/>
   </xsl:template>

   <!--PATTERN macosilsstelocal_full_address-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:local_full_address"
                 priority="1000"
                 mode="M341">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_full_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M341"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M341"/>
   <xsl:template match="@*|node()" priority="-2" mode="M341">
      <xsl:apply-templates select="@*|*" mode="M341"/>
   </xsl:template>

   <!--PATTERN macosilsstelocal_port-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:local_port"
                 priority="1000"
                 mode="M342">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_port entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M342"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M342"/>
   <xsl:template match="@*|node()" priority="-2" mode="M342">
      <xsl:apply-templates select="@*|*" mode="M342"/>
   </xsl:template>

   <!--PATTERN macosilssteforeign_address-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:foreign_address"
                 priority="1000"
                 mode="M343">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M343"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M343"/>
   <xsl:template match="@*|node()" priority="-2" mode="M343">
      <xsl:apply-templates select="@*|*" mode="M343"/>
   </xsl:template>

   <!--PATTERN macosilssteforeign_full_address-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:foreign_full_address"
                 priority="1000"
                 mode="M344">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_full_address entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M344"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M344"/>
   <xsl:template match="@*|node()" priority="-2" mode="M344">
      <xsl:apply-templates select="@*|*" mode="M344"/>
   </xsl:template>

   <!--PATTERN macosilssteforeign_port-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:foreign_port"
                 priority="1000"
                 mode="M345">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the foreign_port entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M345"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M345"/>
   <xsl:template match="@*|node()" priority="-2" mode="M345">
      <xsl:apply-templates select="@*|*" mode="M345"/>
   </xsl:template>

   <!--PATTERN macosilsstepid-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:pid" priority="1000"
                 mode="M346">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pid entity of an inetlisteningservers_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M346"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M346"/>
   <xsl:template match="@*|node()" priority="-2" mode="M346">
      <xsl:apply-templates select="@*|*" mode="M346"/>
   </xsl:template>

   <!--PATTERN macosilssteprotocol-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:protocol" priority="1000"
                 mode="M347">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M347"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M347"/>
   <xsl:template match="@*|node()" priority="-2" mode="M347">
      <xsl:apply-templates select="@*|*" mode="M347"/>
   </xsl:template>

   <!--PATTERN macosilssteuser_id-->


	<!--RULE -->
<xsl:template match="macos-def:inetlisteningservers_state/macos-def:user_id" priority="1000"
                 mode="M348">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_id entity of an inetlisteningservers_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M348"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M348"/>
   <xsl:template match="@*|node()" priority="-2" mode="M348">
      <xsl:apply-templates select="@*|*" mode="M348"/>
   </xsl:template>

   <!--PATTERN nvramobjnvram_var-->


	<!--RULE -->
<xsl:template match="macos-def:nvram_object/macos-def:nvram_var" priority="1000" mode="M349">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the nvram_var entity of a nvram_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M349"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M349"/>
   <xsl:template match="@*|node()" priority="-2" mode="M349">
      <xsl:apply-templates select="@*|*" mode="M349"/>
   </xsl:template>

   <!--PATTERN nvramstenvram_var-->


	<!--RULE -->
<xsl:template match="macos-def:nvram_state/macos-def:nvram_var" priority="1000" mode="M350">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the nvram_var entity of a nvram_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M350"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M350"/>
   <xsl:template match="@*|node()" priority="-2" mode="M350">
      <xsl:apply-templates select="@*|*" mode="M350"/>
   </xsl:template>

   <!--PATTERN nvramstenvram_value-->


	<!--RULE -->
<xsl:template match="macos-def:nvram_state/macos-def:nvram_value" priority="1000" mode="M351">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the nvram_value entity of a nvram_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M351"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M351"/>
   <xsl:template match="@*|node()" priority="-2" mode="M351">
      <xsl:apply-templates select="@*|*" mode="M351"/>
   </xsl:template>

   <!--PATTERN pwpobjusername-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_object/macos-def:username" priority="1000"
                 mode="M352">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a pwpolicy_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M352"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M352"/>
   <xsl:template match="@*|node()" priority="-2" mode="M352">
      <xsl:apply-templates select="@*|*" mode="M352"/>
   </xsl:template>

   <!--PATTERN pwpobjuserpass-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_object/macos-def:userpass" priority="1000"
                 mode="M353">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the userpass entity of a pwpolicy_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the userpass entity of a pwpolicy_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M353"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M353"/>
   <xsl:template match="@*|node()" priority="-2" mode="M353">
      <xsl:apply-templates select="@*|*" mode="M353"/>
   </xsl:template>

   <!--PATTERN pwpobjdirectory_node-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_object/macos-def:directory_node" priority="1000"
                 mode="M354">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_node entity of a pwpolicy_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M354"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M354"/>
   <xsl:template match="@*|node()" priority="-2" mode="M354">
      <xsl:apply-templates select="@*|*" mode="M354"/>
   </xsl:template>

   <!--PATTERN pwpsteusername-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:username" priority="1000" mode="M355">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a pwpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M355"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M355"/>
   <xsl:template match="@*|node()" priority="-2" mode="M355">
      <xsl:apply-templates select="@*|*" mode="M355"/>
   </xsl:template>

   <!--PATTERN pwpsteuserpass-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:userpass" priority="1000" mode="M356">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the userpass entity of a pwpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M356"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M356"/>
   <xsl:template match="@*|node()" priority="-2" mode="M356">
      <xsl:apply-templates select="@*|*" mode="M356"/>
   </xsl:template>

   <!--PATTERN pwpstedirectory_node-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:directory_node" priority="1000"
                 mode="M357">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_node entity of a pwpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M357"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M357"/>
   <xsl:template match="@*|node()" priority="-2" mode="M357">
      <xsl:apply-templates select="@*|*" mode="M357"/>
   </xsl:template>

   <!--PATTERN pwpstemaxChars-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:maxChars" priority="1000" mode="M358">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the maxChars entity of a pwpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M358"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M358"/>
   <xsl:template match="@*|node()" priority="-2" mode="M358">
      <xsl:apply-templates select="@*|*" mode="M358"/>
   </xsl:template>

   <!--PATTERN pwpstemaxFailedLoginAttempts-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:maxFailedLoginAttempts"
                 priority="1000"
                 mode="M359">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the maxFailedLoginAttempts entity of a pwpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M359"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M359"/>
   <xsl:template match="@*|node()" priority="-2" mode="M359">
      <xsl:apply-templates select="@*|*" mode="M359"/>
   </xsl:template>

   <!--PATTERN pwpsteminChars-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:minChars" priority="1000" mode="M360">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the minChars entity of a pwpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M360"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M360"/>
   <xsl:template match="@*|node()" priority="-2" mode="M360">
      <xsl:apply-templates select="@*|*" mode="M360"/>
   </xsl:template>

   <!--PATTERN pwpstepasswordCannotBeName-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:passwordCannotBeName" priority="1000"
                 mode="M361">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the passwordCannotBeName entity of a pwpolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M361"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M361"/>
   <xsl:template match="@*|node()" priority="-2" mode="M361">
      <xsl:apply-templates select="@*|*" mode="M361"/>
   </xsl:template>

   <!--PATTERN pwpsterequiresAlpha-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:requiresAlpha" priority="1000"
                 mode="M362">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the requiresAlpha entity of a pwpolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M362"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M362"/>
   <xsl:template match="@*|node()" priority="-2" mode="M362">
      <xsl:apply-templates select="@*|*" mode="M362"/>
   </xsl:template>

   <!--PATTERN pwpsterequiresNumeric-->


	<!--RULE -->
<xsl:template match="macos-def:pwpolicy_state/macos-def:requiresNumeric" priority="1000"
                 mode="M363">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the requiresNumeric entity of a pwpolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M363"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M363"/>
   <xsl:template match="@*|node()" priority="-2" mode="M363">
      <xsl:apply-templates select="@*|*" mode="M363"/>
   </xsl:template>

   <!--PATTERN pixlinetst-->


	<!--RULE -->
<xsl:template match="pixos-def:line_test/pixos-def:object" priority="1001" mode="M364">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/pixos-def:line_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a line_test must reference a line_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M364"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="pixos-def:line_test/pixos-def:state" priority="1000" mode="M364">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/pixos-def:line_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a line_test must reference a line_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M364"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M364"/>
   <xsl:template match="@*|node()" priority="-2" mode="M364">
      <xsl:apply-templates select="@*|*" mode="M364"/>
   </xsl:template>

   <!--PATTERN pixlineobjshow_subcommand-->


	<!--RULE -->
<xsl:template match="pixos-def:line_object/pixos-def:show_subcommand" priority="1000"
                 mode="M365">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M365"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M365"/>
   <xsl:template match="@*|node()" priority="-2" mode="M365">
      <xsl:apply-templates select="@*|*" mode="M365"/>
   </xsl:template>

   <!--PATTERN pixlinesteshow_subcommand-->


	<!--RULE -->
<xsl:template match="pixos-def:line_state/pixos-def:show_subcommand" priority="1000"
                 mode="M366">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the show_subcommand entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M366"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M366"/>
   <xsl:template match="@*|node()" priority="-2" mode="M366">
      <xsl:apply-templates select="@*|*" mode="M366"/>
   </xsl:template>

   <!--PATTERN pixlinesteconfig_line-->


	<!--RULE -->
<xsl:template match="pixos-def:line_state/pixos-def:config_line" priority="1000" mode="M367">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the config_line entity of a line_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M367"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M367"/>
   <xsl:template match="@*|node()" priority="-2" mode="M367">
      <xsl:apply-templates select="@*|*" mode="M367"/>
   </xsl:template>

   <!--PATTERN pixvertst-->


	<!--RULE -->
<xsl:template match="pixos-def:version_test/pixos-def:object" priority="1001" mode="M368">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/pixos-def:version_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a version_test must reference a version_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M368"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="pixos-def:version_test/pixos-def:state" priority="1000" mode="M368">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/pixos-def:version_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a version_test must reference a version_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M368"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M368"/>
   <xsl:template match="@*|node()" priority="-2" mode="M368">
      <xsl:apply-templates select="@*|*" mode="M368"/>
   </xsl:template>

   <!--PATTERN pixverstepix_release-->


	<!--RULE -->
<xsl:template match="pixos-def:version_state/pixos-def:pix_release" priority="1000"
                 mode="M369">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pix_release entity of a version_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M369"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M369"/>
   <xsl:template match="@*|node()" priority="-2" mode="M369">
      <xsl:apply-templates select="@*|*" mode="M369"/>
   </xsl:template>

   <!--PATTERN pixverstepix_major_release-->


	<!--RULE -->
<xsl:template match="pixos-def:version_state/pixos-def:pix_major_release" priority="1000"
                 mode="M370">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pix_major_release entity of a version_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M370"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M370"/>
   <xsl:template match="@*|node()" priority="-2" mode="M370">
      <xsl:apply-templates select="@*|*" mode="M370"/>
   </xsl:template>

   <!--PATTERN pixverstepix_minor_release-->


	<!--RULE -->
<xsl:template match="pixos-def:version_state/pixos-def:pix_minor_release" priority="1000"
                 mode="M371">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pix_minor_release entity of a version_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M371"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M371"/>
   <xsl:template match="@*|node()" priority="-2" mode="M371">
      <xsl:apply-templates select="@*|*" mode="M371"/>
   </xsl:template>

   <!--PATTERN pixverstepix_build-->


	<!--RULE -->
<xsl:template match="pixos-def:version_state/pixos-def:pix_build" priority="1000" mode="M372">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pix_build entity of a version_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M372"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M372"/>
   <xsl:template match="@*|node()" priority="-2" mode="M372">
      <xsl:apply-templates select="@*|*" mode="M372"/>
   </xsl:template>

   <!--PATTERN spwebapptst-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_test/sp-def:object" priority="1001" mode="M373">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spwebapplication_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spwebapplication_test must reference an spwebapplication_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M373"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spwebapplication_test/sp-def:state" priority="1000" mode="M373">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spwebapplication_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spwebapplication_test must reference an spwebapplication_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M373"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M373"/>
   <xsl:template match="@*|node()" priority="-2" mode="M373">
      <xsl:apply-templates select="@*|*" mode="M373"/>
   </xsl:template>

   <!--PATTERN spwebappobjwebapplicationurl-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_object/sp-def:webapplicationurl" priority="1000"
                 mode="M374">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webapplicationurl entity of a spwebapplication_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M374"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M374"/>
   <xsl:template match="@*|node()" priority="-2" mode="M374">
      <xsl:apply-templates select="@*|*" mode="M374"/>
   </xsl:template>

   <!--PATTERN spwebappstewebapplicationurl-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:webapplicationurl" priority="1000"
                 mode="M375">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webapplicationurl entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M375"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M375"/>
   <xsl:template match="@*|node()" priority="-2" mode="M375">
      <xsl:apply-templates select="@*|*" mode="M375"/>
   </xsl:template>

   <!--PATTERN spwebappsteallowparttopartcommunication-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:allowparttopartcommunication"
                 priority="1000"
                 mode="M376">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the allowparttopartcommunication entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M376"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M376"/>
   <xsl:template match="@*|node()" priority="-2" mode="M376">
      <xsl:apply-templates select="@*|*" mode="M376"/>
   </xsl:template>

   <!--PATTERN spwebappsteallowaccesstowebpartcatalog-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:allowaccesstowebpartcatalog"
                 priority="1000"
                 mode="M377">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the allowaccesstowebpartcatalog entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M377"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M377"/>
   <xsl:template match="@*|node()" priority="-2" mode="M377">
      <xsl:apply-templates select="@*|*" mode="M377"/>
   </xsl:template>

   <!--PATTERN spwebappsteblockedfileextention-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:blockedfileextention"
                 priority="1000"
                 mode="M378">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the blockedfileextention entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M378"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M378"/>
   <xsl:template match="@*|node()" priority="-2" mode="M378">
      <xsl:apply-templates select="@*|*" mode="M378"/>
   </xsl:template>

   <!--PATTERN spwebappstedefaultquotatemplate-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:defaultquotatemplate"
                 priority="1000"
                 mode="M379">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the defaultquotatemplate entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M379"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M379"/>
   <xsl:template match="@*|node()" priority="-2" mode="M379">
      <xsl:apply-templates select="@*|*" mode="M379"/>
   </xsl:template>

   <!--PATTERN spwebappsteexternalworkflowparticipantsenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:externalworkflowparticipantsenabled"
                 priority="1000"
                 mode="M380">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the externalworkflowparticipantsenabled entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M380"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M380"/>
   <xsl:template match="@*|node()" priority="-2" mode="M380">
      <xsl:apply-templates select="@*|*" mode="M380"/>
   </xsl:template>

   <!--PATTERN spwebappsterecyclebinenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:recyclebinenabled" priority="1000"
                 mode="M381">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the recyclebinenabled entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M381"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M381"/>
   <xsl:template match="@*|node()" priority="-2" mode="M381">
      <xsl:apply-templates select="@*|*" mode="M381"/>
   </xsl:template>

   <!--PATTERN spwebappsteautomaticallydeleteunusedsitecollections-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:automaticallydeleteunusedsitecollections"
                 priority="1000"
                 mode="M382">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the automaticallydeleteunusedsitecollections entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M382"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M382"/>
   <xsl:template match="@*|node()" priority="-2" mode="M382">
      <xsl:apply-templates select="@*|*" mode="M382"/>
   </xsl:template>

   <!--PATTERN spwebappsteselfservicesitecreationenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:selfservicesitecreationenabled"
                 priority="1000"
                 mode="M383">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the selfservicesitecreationenabled entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M383"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M383"/>
   <xsl:template match="@*|node()" priority="-2" mode="M383">
      <xsl:apply-templates select="@*|*" mode="M383"/>
   </xsl:template>

   <!--PATTERN spwebappstesecondstagerecyclebinquota-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:secondstagerecyclebinquota"
                 priority="1000"
                 mode="M384">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secondstagerecyclebinquota entity of a spwebapplication_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M384"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M384"/>
   <xsl:template match="@*|node()" priority="-2" mode="M384">
      <xsl:apply-templates select="@*|*" mode="M384"/>
   </xsl:template>

   <!--PATTERN spwebappsterecyclebinretentionperiod-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:recyclebinretentionperiod"
                 priority="1000"
                 mode="M385">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the recyclebinretentionperiod entity of a spwebapplication_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M385"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M385"/>
   <xsl:template match="@*|node()" priority="-2" mode="M385">
      <xsl:apply-templates select="@*|*" mode="M385"/>
   </xsl:template>

   <!--PATTERN spwebappsteoutboundmailserverinstance-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:outboundmailserverinstance"
                 priority="1000"
                 mode="M386">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the outboundmailserverinstance entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M386"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M386"/>
   <xsl:template match="@*|node()" priority="-2" mode="M386">
      <xsl:apply-templates select="@*|*" mode="M386"/>
   </xsl:template>

   <!--PATTERN spwebappsteoutboundmailsenderaddress-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:outboundmailsenderaddress"
                 priority="1000"
                 mode="M387">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for theoutboundmailsenderaddress entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M387"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M387"/>
   <xsl:template match="@*|node()" priority="-2" mode="M387">
      <xsl:apply-templates select="@*|*" mode="M387"/>
   </xsl:template>

   <!--PATTERN spwebappsteoutboundmailreplytoaddress-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:outboundmailreplytoaddress"
                 priority="1000"
                 mode="M388">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the outboundmailreplytoaddress entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M388"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M388"/>
   <xsl:template match="@*|node()" priority="-2" mode="M388">
      <xsl:apply-templates select="@*|*" mode="M388"/>
   </xsl:template>

   <!--PATTERN spwebappstesecvalexpires-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:secvalexpires" priority="1000"
                 mode="M389">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secvalexpires entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M389"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M389"/>
   <xsl:template match="@*|node()" priority="-2" mode="M389">
      <xsl:apply-templates select="@*|*" mode="M389"/>
   </xsl:template>

   <!--PATTERN spwebappstetimeout-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:timout" priority="1000" mode="M390">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the timeout entity of a spwebapplication_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M390"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M390"/>
   <xsl:template match="@*|node()" priority="-2" mode="M390">
      <xsl:apply-templates select="@*|*" mode="M390"/>
   </xsl:template>

   <!--PATTERN spwebsteisadministrationwebapplication-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_item/sp-def:isadministrationwebapplication"
                 priority="1000"
                 mode="M391">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>item <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the isadministrationwebapplication entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M391"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M391"/>
   <xsl:template match="@*|node()" priority="-2" mode="M391">
      <xsl:apply-templates select="@*|*" mode="M391"/>
   </xsl:template>

   <!--PATTERN spwebappsteapplicationpoolname-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:applicationpoolname"
                 priority="1000"
                 mode="M392">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the applicationpoolname entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M392"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M392"/>
   <xsl:template match="@*|node()" priority="-2" mode="M392">
      <xsl:apply-templates select="@*|*" mode="M392"/>
   </xsl:template>

   <!--PATTERN spwebappsteapplicationpoolusername-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:applicationpoolusername"
                 priority="1000"
                 mode="M393">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the applicationpoolusername entity of a spwebapplication_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M393"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M393"/>
   <xsl:template match="@*|node()" priority="-2" mode="M393">
      <xsl:apply-templates select="@*|*" mode="M393"/>
   </xsl:template>

   <!--PATTERN spwebappsteopenitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:openitems" priority="1000"
                 mode="M394">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the openitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M394"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M394"/>
   <xsl:template match="@*|node()" priority="-2" mode="M394">
      <xsl:apply-templates select="@*|*" mode="M394"/>
   </xsl:template>

   <!--PATTERN spwebappsteaddlistitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:addlistitems" priority="1000"
                 mode="M395">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the addlistitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M395"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M395"/>
   <xsl:template match="@*|node()" priority="-2" mode="M395">
      <xsl:apply-templates select="@*|*" mode="M395"/>
   </xsl:template>

   <!--PATTERN spwebappsteapproveitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:approveitems" priority="1000"
                 mode="M396">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the approveitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M396"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M396"/>
   <xsl:template match="@*|node()" priority="-2" mode="M396">
      <xsl:apply-templates select="@*|*" mode="M396"/>
   </xsl:template>

   <!--PATTERN spwebappstedeletelistitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:deletelistitems" priority="1000"
                 mode="M397">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the deletelistitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M397"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M397"/>
   <xsl:template match="@*|node()" priority="-2" mode="M397">
      <xsl:apply-templates select="@*|*" mode="M397"/>
   </xsl:template>

   <!--PATTERN spwebappstedeleteversions-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:deleteversions" priority="1000"
                 mode="M398">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the deleteversions entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M398"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M398"/>
   <xsl:template match="@*|node()" priority="-2" mode="M398">
      <xsl:apply-templates select="@*|*" mode="M398"/>
   </xsl:template>

   <!--PATTERN spwebappsteeditlistitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:editlistitems" priority="1000"
                 mode="M399">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the editlistitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M399"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M399"/>
   <xsl:template match="@*|node()" priority="-2" mode="M399">
      <xsl:apply-templates select="@*|*" mode="M399"/>
   </xsl:template>

   <!--PATTERN spwebappstemanagelists-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:managelists" priority="1000"
                 mode="M400">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the managelists entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M400"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M400"/>
   <xsl:template match="@*|node()" priority="-2" mode="M400">
      <xsl:apply-templates select="@*|*" mode="M400"/>
   </xsl:template>

   <!--PATTERN spwebappsteviewversions-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:viewversions" priority="1000"
                 mode="M401">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the viewversions entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M401"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M401"/>
   <xsl:template match="@*|node()" priority="-2" mode="M401">
      <xsl:apply-templates select="@*|*" mode="M401"/>
   </xsl:template>

   <!--PATTERN spwebappsteviewlistitems-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:viewlistitems" priority="1000"
                 mode="M402">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the viewlistitems entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M402"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M402"/>
   <xsl:template match="@*|node()" priority="-2" mode="M402">
      <xsl:apply-templates select="@*|*" mode="M402"/>
   </xsl:template>

   <!--PATTERN spwebappstecancelcheckout-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:cancelcheckout" priority="1000"
                 mode="M403">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the cancelcheckout entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M403"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M403"/>
   <xsl:template match="@*|node()" priority="-2" mode="M403">
      <xsl:apply-templates select="@*|*" mode="M403"/>
   </xsl:template>

   <!--PATTERN spwebappstecreatealerts-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:createalerts" priority="1000"
                 mode="M404">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the createalerts entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M404"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M404"/>
   <xsl:template match="@*|node()" priority="-2" mode="M404">
      <xsl:apply-templates select="@*|*" mode="M404"/>
   </xsl:template>

   <!--PATTERN spwebappsteviewformpagess-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:viewformpages" priority="1000"
                 mode="M405">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the viewformpages entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M405"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M405"/>
   <xsl:template match="@*|node()" priority="-2" mode="M405">
      <xsl:apply-templates select="@*|*" mode="M405"/>
   </xsl:template>

   <!--PATTERN spwebappsteviewpages-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:viewpages" priority="1000"
                 mode="M406">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the viewpages entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M406"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M406"/>
   <xsl:template match="@*|node()" priority="-2" mode="M406">
      <xsl:apply-templates select="@*|*" mode="M406"/>
   </xsl:template>

   <!--PATTERN spwebappsteaddandcustomizepages-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:addandcustomizepages"
                 priority="1000"
                 mode="M407">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the addandcustomizepages entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M407"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M407"/>
   <xsl:template match="@*|node()" priority="-2" mode="M407">
      <xsl:apply-templates select="@*|*" mode="M407"/>
   </xsl:template>

   <!--PATTERN spwebappsteapplystylesheets-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:applystylesheets" priority="1000"
                 mode="M408">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the applystylesheets entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M408"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M408"/>
   <xsl:template match="@*|node()" priority="-2" mode="M408">
      <xsl:apply-templates select="@*|*" mode="M408"/>
   </xsl:template>

   <!--PATTERN spwebappsteapplythemeandborder-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:applythemeandborder"
                 priority="1000"
                 mode="M409">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the applythemeandborder entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M409"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M409"/>
   <xsl:template match="@*|node()" priority="-2" mode="M409">
      <xsl:apply-templates select="@*|*" mode="M409"/>
   </xsl:template>

   <!--PATTERN spwebappstebrowsedirectories-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:browsedirectories" priority="1000"
                 mode="M410">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the browsedirectories entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M410"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M410"/>
   <xsl:template match="@*|node()" priority="-2" mode="M410">
      <xsl:apply-templates select="@*|*" mode="M410"/>
   </xsl:template>

   <!--PATTERN spwebappstebrowseuserinfo-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:browseuserinfo" priority="1000"
                 mode="M411">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the browseuserinfo entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M411"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M411"/>
   <xsl:template match="@*|node()" priority="-2" mode="M411">
      <xsl:apply-templates select="@*|*" mode="M411"/>
   </xsl:template>

   <!--PATTERN spwebappstecreategroups-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:creategroups" priority="1000"
                 mode="M412">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the creategroups entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M412"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M412"/>
   <xsl:template match="@*|node()" priority="-2" mode="M412">
      <xsl:apply-templates select="@*|*" mode="M412"/>
   </xsl:template>

   <!--PATTERN spwebappstecreatesscsite-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:createsscsite" priority="1000"
                 mode="M413">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the createsscsite entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M413"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M413"/>
   <xsl:template match="@*|node()" priority="-2" mode="M413">
      <xsl:apply-templates select="@*|*" mode="M413"/>
   </xsl:template>

   <!--PATTERN spwebappsteeditmyuserinfo-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:editmyuserinfo" priority="1000"
                 mode="M414">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the editmyuserinfo entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M414"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M414"/>
   <xsl:template match="@*|node()" priority="-2" mode="M414">
      <xsl:apply-templates select="@*|*" mode="M414"/>
   </xsl:template>

   <!--PATTERN spwebappsteenumeratepermissions-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:enumeratepermissions"
                 priority="1000"
                 mode="M415">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enumeratepermissions entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M415"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M415"/>
   <xsl:template match="@*|node()" priority="-2" mode="M415">
      <xsl:apply-templates select="@*|*" mode="M415"/>
   </xsl:template>

   <!--PATTERN spwebappstemanagealerts-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:managealerts" priority="1000"
                 mode="M416">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the managealerts entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M416"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M416"/>
   <xsl:template match="@*|node()" priority="-2" mode="M416">
      <xsl:apply-templates select="@*|*" mode="M416"/>
   </xsl:template>

   <!--PATTERN spwebappstemanagepermissions-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:managepermissions" priority="1000"
                 mode="M417">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the managepermissions entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M417"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M417"/>
   <xsl:template match="@*|node()" priority="-2" mode="M417">
      <xsl:apply-templates select="@*|*" mode="M417"/>
   </xsl:template>

   <!--PATTERN spwebappstemanagesubwebs-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:managesubwebs" priority="1000"
                 mode="M418">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the managesubwebs entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M418"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M418"/>
   <xsl:template match="@*|node()" priority="-2" mode="M418">
      <xsl:apply-templates select="@*|*" mode="M418"/>
   </xsl:template>

   <!--PATTERN spwebappstemanageweb-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:manageweb" priority="1000"
                 mode="M419">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the manageweb entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M419"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M419"/>
   <xsl:template match="@*|node()" priority="-2" mode="M419">
      <xsl:apply-templates select="@*|*" mode="M419"/>
   </xsl:template>

   <!--PATTERN spwebappsteopens-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:open" priority="1000" mode="M420">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the open entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M420"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M420"/>
   <xsl:template match="@*|node()" priority="-2" mode="M420">
      <xsl:apply-templates select="@*|*" mode="M420"/>
   </xsl:template>

   <!--PATTERN spwebappsteuseclientintegration-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:useclientintegration"
                 priority="1000"
                 mode="M421">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the useclientintegration entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M421"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M421"/>
   <xsl:template match="@*|node()" priority="-2" mode="M421">
      <xsl:apply-templates select="@*|*" mode="M421"/>
   </xsl:template>

   <!--PATTERN spwebappsteuseremoteapis-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:useremoteapis" priority="1000"
                 mode="M422">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the useremoteapis entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M422"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M422"/>
   <xsl:template match="@*|node()" priority="-2" mode="M422">
      <xsl:apply-templates select="@*|*" mode="M422"/>
   </xsl:template>

   <!--PATTERN spwebappsteviewusagedata-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:viewusagedata" priority="1000"
                 mode="M423">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the viewusagedata entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M423"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M423"/>
   <xsl:template match="@*|node()" priority="-2" mode="M423">
      <xsl:apply-templates select="@*|*" mode="M423"/>
   </xsl:template>

   <!--PATTERN spwebappstemanagepersonalviews-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:managepersonalviews"
                 priority="1000"
                 mode="M424">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the managepersonalviews entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M424"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M424"/>
   <xsl:template match="@*|node()" priority="-2" mode="M424">
      <xsl:apply-templates select="@*|*" mode="M424"/>
   </xsl:template>

   <!--PATTERN spwebappsteadddelprivatewebparts-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:adddelprivatewebparts"
                 priority="1000"
                 mode="M425">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the adddelprivatewebparts entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M425"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M425"/>
   <xsl:template match="@*|node()" priority="-2" mode="M425">
      <xsl:apply-templates select="@*|*" mode="M425"/>
   </xsl:template>

   <!--PATTERN spwebappsteupdatepersonalwebparts-->


	<!--RULE -->
<xsl:template match="sp-def:spwebapplication_state/sp-def:updatepersonalwebparts"
                 priority="1000"
                 mode="M426">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the updatepersonalwebparts entity of a spwebapplication_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M426"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M426"/>
   <xsl:template match="@*|node()" priority="-2" mode="M426">
      <xsl:apply-templates select="@*|*" mode="M426"/>
   </xsl:template>

   <!--PATTERN spgrptst-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_test/sp-def:object" priority="1001" mode="M427">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spgroup_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spgroup_test must reference a spgroup_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M427"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spgroup_test/sp-def:state" priority="1000" mode="M427">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spgroup_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spgroup_test must reference a spgroup_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M427"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M427"/>
   <xsl:template match="@*|node()" priority="-2" mode="M427">
      <xsl:apply-templates select="@*|*" mode="M427"/>
   </xsl:template>

   <!--PATTERN spgrpobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_object/sp-def:sitecollectionurl" priority="1000"
                 mode="M428">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spgroup_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M428"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M428"/>
   <xsl:template match="@*|node()" priority="-2" mode="M428">
      <xsl:apply-templates select="@*|*" mode="M428"/>
   </xsl:template>

   <!--PATTERN spgrpstesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_state/sp-def:sitecollectionurl" priority="1000"
                 mode="M429">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spgroup_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M429"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M429"/>
   <xsl:template match="@*|node()" priority="-2" mode="M429">
      <xsl:apply-templates select="@*|*" mode="M429"/>
   </xsl:template>

   <!--PATTERN spgrpstegname-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_state/sp-def:gname" priority="1000" mode="M430">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gname entity of a spgroup_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M430"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M430"/>
   <xsl:template match="@*|node()" priority="-2" mode="M430">
      <xsl:apply-templates select="@*|*" mode="M430"/>
   </xsl:template>

   <!--PATTERN spgrpsteautoacceptrequesttojoinleave-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_state/sp-def:autoacceptrequesttojoinleave"
                 priority="1000"
                 mode="M431">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the autoacceptrequesttojoinleave entity of a spgroup_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M431"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M431"/>
   <xsl:template match="@*|node()" priority="-2" mode="M431">
      <xsl:apply-templates select="@*|*" mode="M431"/>
   </xsl:template>

   <!--PATTERN spgrpsteallowmemberseditmembership-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_state/sp-def:allowmemberseditmembership" priority="1000"
                 mode="M432">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the autoacceptrequesttojoinleave entity of a spgroup_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M432"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M432"/>
   <xsl:template match="@*|node()" priority="-2" mode="M432">
      <xsl:apply-templates select="@*|*" mode="M432"/>
   </xsl:template>

   <!--PATTERN spgrpsteonlyallowmembersviewmembership-->


	<!--RULE -->
<xsl:template match="sp-def:spgroup_state/sp-def:onlyallowmembersviewmembership"
                 priority="1000"
                 mode="M433">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the onlyallowmembersviewmembership entity of a spgroup_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M433"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M433"/>
   <xsl:template match="@*|node()" priority="-2" mode="M433">
      <xsl:apply-templates select="@*|*" mode="M433"/>
   </xsl:template>

   <!--PATTERN spwebtst-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_test/sp-def:object" priority="1001" mode="M434">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spweb_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spweb_test must reference an spweb_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M434"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spweb_test/sp-def:state" priority="1000" mode="M434">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spweb_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spweb_test must reference an spweb_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M434"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M434"/>
   <xsl:template match="@*|node()" priority="-2" mode="M434">
      <xsl:apply-templates select="@*|*" mode="M434"/>
   </xsl:template>

   <!--PATTERN spwebobjwebcollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_object/sp-def:webcollectionurl" priority="1000" mode="M435">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webcollectionurl entity of a spweb_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M435"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M435"/>
   <xsl:template match="@*|node()" priority="-2" mode="M435">
      <xsl:apply-templates select="@*|*" mode="M435"/>
   </xsl:template>

   <!--PATTERN spwebobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_object/sp-def:sitecollectionurl" priority="1000"
                 mode="M436">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spweb_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M436"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M436"/>
   <xsl:template match="@*|node()" priority="-2" mode="M436">
      <xsl:apply-templates select="@*|*" mode="M436"/>
   </xsl:template>

   <!--PATTERN spwebstewebcollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_state/sp-def:webcollectionurl" priority="1000" mode="M437">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webcollectionurl entity of a spweb_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M437"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M437"/>
   <xsl:template match="@*|node()" priority="-2" mode="M437">
      <xsl:apply-templates select="@*|*" mode="M437"/>
   </xsl:template>

   <!--PATTERN spwebstesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_state/sp-def:sitecollectionurl" priority="1000" mode="M438">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spweb_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M438"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M438"/>
   <xsl:template match="@*|node()" priority="-2" mode="M438">
      <xsl:apply-templates select="@*|*" mode="M438"/>
   </xsl:template>

   <!--PATTERN spwebstesecondarysitecolladmin-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_state/sp-def:secondarysitecolladmin" priority="1000"
                 mode="M439">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secondarysitecolladmin entity of a spweb_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M439"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M439"/>
   <xsl:template match="@*|node()" priority="-2" mode="M439">
      <xsl:apply-templates select="@*|*" mode="M439"/>
   </xsl:template>

   <!--PATTERN spwebstesecondsitecolladminenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_state/sp-def:secondsitecolladminenabled" priority="1000"
                 mode="M440">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secondsitecolladminenabled entity of a spweb_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M440"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M440"/>
   <xsl:template match="@*|node()" priority="-2" mode="M440">
      <xsl:apply-templates select="@*|*" mode="M440"/>
   </xsl:template>

   <!--PATTERN spwebsteallowanonymousaccess-->


	<!--RULE -->
<xsl:template match="sp-def:spweb_state/sp-def:allowanonymousaccess" priority="1000"
                 mode="M441">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the allowanonymousaccess entity of a spweb_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M441"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M441"/>
   <xsl:template match="@*|node()" priority="-2" mode="M441">
      <xsl:apply-templates select="@*|*" mode="M441"/>
   </xsl:template>

   <!--PATTERN splisttst-->


	<!--RULE -->
<xsl:template match="sp-def:splist_test/sp-def:object" priority="1001" mode="M442">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:splist_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a splist_test must reference an splist_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M442"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:splist_test/sp-def:state" priority="1000" mode="M442">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:splist_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a splist_test must reference an splist_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M442"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M442"/>
   <xsl:template match="@*|node()" priority="-2" mode="M442">
      <xsl:apply-templates select="@*|*" mode="M442"/>
   </xsl:template>

   <!--PATTERN splistobjspsiteurl-->


	<!--RULE -->
<xsl:template match="sp-def:splist_object/sp-def:spsiteurl" priority="1000" mode="M443">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spwebsiteurl entity of a splist_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M443"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M443"/>
   <xsl:template match="@*|node()" priority="-2" mode="M443">
      <xsl:apply-templates select="@*|*" mode="M443"/>
   </xsl:template>

   <!--PATTERN spliststesiteurl-->


	<!--RULE -->
<xsl:template match="sp-def:splist_object/sp-def:spsiteurl" priority="1000" mode="M444">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spsiteurl entity of a splist_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M444"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M444"/>
   <xsl:template match="@*|node()" priority="-2" mode="M444">
      <xsl:apply-templates select="@*|*" mode="M444"/>
   </xsl:template>

   <!--PATTERN spliststeirmenabled-->


	<!--RULE -->
<xsl:template match="sp-def:splist_state/sp-def:irmenabled" priority="1000" mode="M445">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the irmenabled entity of a splist_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M445"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M445"/>
   <xsl:template match="@*|node()" priority="-2" mode="M445">
      <xsl:apply-templates select="@*|*" mode="M445"/>
   </xsl:template>

   <!--PATTERN spliststeenableversioning-->


	<!--RULE -->
<xsl:template match="sp-def:splist_state/sp-def:enableversioning" priority="1000" mode="M446">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enableversioning entity of a splist_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M446"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M446"/>
   <xsl:template match="@*|node()" priority="-2" mode="M446">
      <xsl:apply-templates select="@*|*" mode="M446"/>
   </xsl:template>

   <!--PATTERN spliststenocrawl-->


	<!--RULE -->
<xsl:template match="sp-def:splist_state/sp-def:nocrawl" priority="1000" mode="M447">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the nocrawl entity of a splist_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M447"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M447"/>
   <xsl:template match="@*|node()" priority="-2" mode="M447">
      <xsl:apply-templates select="@*|*" mode="M447"/>
   </xsl:template>

   <!--PATTERN spavstst-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_test/sp-def:object" priority="1001"
                 mode="M448">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spantivirussettings_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spantivirussettings_test must reference an spantivirussettings_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M448"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spantivirussettings_test/sp-def:state" priority="1000"
                 mode="M448">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spantivirussettings_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spantivirussettings_test must reference an spantivirussettings_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M448"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M448"/>
   <xsl:template match="@*|node()" priority="-2" mode="M448">
      <xsl:apply-templates select="@*|*" mode="M448"/>
   </xsl:template>

   <!--PATTERN spavsobjwebservicename-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_object/sp-def:spwebservicename"
                 priority="1000"
                 mode="M449">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spwebservicename entity of a spantivirussettings_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M449"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M449"/>
   <xsl:template match="@*|node()" priority="-2" mode="M449">
      <xsl:apply-templates select="@*|*" mode="M449"/>
   </xsl:template>

   <!--PATTERN spavsobjfarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_object/sp-def:spfarmname" priority="1000"
                 mode="M450">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spfarmname entity of a spantivirussettings_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M450"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M450"/>
   <xsl:template match="@*|node()" priority="-2" mode="M450">
      <xsl:apply-templates select="@*|*" mode="M450"/>
   </xsl:template>

   <!--PATTERN spavsstewebservicename-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_object/sp-def:spwebservicename"
                 priority="1000"
                 mode="M451">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spwebservicename entity of a spantivirusservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M451"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M451"/>
   <xsl:template match="@*|node()" priority="-2" mode="M451">
      <xsl:apply-templates select="@*|*" mode="M451"/>
   </xsl:template>

   <!--PATTERN spavsstespfarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_object/sp-def:spfarmname" priority="1000"
                 mode="M452">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spfarmname entity of a spantivirusservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M452"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M452"/>
   <xsl:template match="@*|node()" priority="-2" mode="M452">
      <xsl:apply-templates select="@*|*" mode="M452"/>
   </xsl:template>

   <!--PATTERN spavssteallowdownload-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:allowdownload" priority="1000"
                 mode="M453">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the allowdownload entity of a spantivirussettings_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M453"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M453"/>
   <xsl:template match="@*|node()" priority="-2" mode="M453">
      <xsl:apply-templates select="@*|*" mode="M453"/>
   </xsl:template>

   <!--PATTERN spavsstecleaningenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:cleaningenabled" priority="1000"
                 mode="M454">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the cleaningenabled entity of a spantivirussettings_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M454"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M454"/>
   <xsl:template match="@*|node()" priority="-2" mode="M454">
      <xsl:apply-templates select="@*|*" mode="M454"/>
   </xsl:template>

   <!--PATTERN spavsstedownloadscanenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:downloadscanenabled"
                 priority="1000"
                 mode="M455">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the downloadscanenabled entity of a spantivirussettings_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M455"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M455"/>
   <xsl:template match="@*|node()" priority="-2" mode="M455">
      <xsl:apply-templates select="@*|*" mode="M455"/>
   </xsl:template>

   <!--PATTERN spavsstenumberofthreads-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:numberofthreads" priority="1000"
                 mode="M456">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the numberofthreads entity of a spantivirussettings_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M456"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M456"/>
   <xsl:template match="@*|node()" priority="-2" mode="M456">
      <xsl:apply-templates select="@*|*" mode="M456"/>
   </xsl:template>

   <!--PATTERN spavssteskipsearchcrawl-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:skipsearchcrawl" priority="1000"
                 mode="M457">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the skipsearchcrawl entity of a spantivirussettings_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M457"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M457"/>
   <xsl:template match="@*|node()" priority="-2" mode="M457">
      <xsl:apply-templates select="@*|*" mode="M457"/>
   </xsl:template>

   <!--PATTERN spavsstetimeout-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:timeout" priority="1000"
                 mode="M458">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the timeout entity of a spantivirussettings_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M458"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M458"/>
   <xsl:template match="@*|node()" priority="-2" mode="M458">
      <xsl:apply-templates select="@*|*" mode="M458"/>
   </xsl:template>

   <!--PATTERN spavssteuploadscanenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:uploadscanenabled"
                 priority="1000"
                 mode="M459">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uploadscanenabled entity of a spantivirussettings_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M459"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M459"/>
   <xsl:template match="@*|node()" priority="-2" mode="M459">
      <xsl:apply-templates select="@*|*" mode="M459"/>
   </xsl:template>

   <!--PATTERN spavsstevendorupdatecount-->


	<!--RULE -->
<xsl:template match="sp-def:spantivirussettings_state/sp-def:vendorupdatecount"
                 priority="1000"
                 mode="M460">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the vendorupdatecount entity of a spantivirussettings_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M460"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M460"/>
   <xsl:template match="@*|node()" priority="-2" mode="M460">
      <xsl:apply-templates select="@*|*" mode="M460"/>
   </xsl:template>

   <!--PATTERN spsiteadmintst-->


	<!--RULE -->
<xsl:template match="sp-def:spsiteadministration_test/sp-def:object" priority="1001"
                 mode="M461">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spsiteadministration_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spsiteadministration_test must reference an spsiteadministration_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M461"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spsiteadministration_test/sp-def:state" priority="1000"
                 mode="M461">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spsiteadministration_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spsiteadministration_test must reference an spsiteadministration_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M461"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M461"/>
   <xsl:template match="@*|node()" priority="-2" mode="M461">
      <xsl:apply-templates select="@*|*" mode="M461"/>
   </xsl:template>

   <!--PATTERN spsiteadminobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spsiteadministration_object/sp-def:sitecollectionurl"
                 priority="1000"
                 mode="M462">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spsiteadministration_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M462"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M462"/>
   <xsl:template match="@*|node()" priority="-2" mode="M462">
      <xsl:apply-templates select="@*|*" mode="M462"/>
   </xsl:template>

   <!--PATTERN spsiteadminstesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spsiteadministration_state/sp-def:sitecollectionurl"
                 priority="1000"
                 mode="M463">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spsiteadministration_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M463"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M463"/>
   <xsl:template match="@*|node()" priority="-2" mode="M463">
      <xsl:apply-templates select="@*|*" mode="M463"/>
   </xsl:template>

   <!--PATTERN spsiteadminstestoragemaxlevel-->


	<!--RULE -->
<xsl:template match="sp-def:spsiteadministration_state/sp-def:storagemaxlevel"
                 priority="1000"
                 mode="M464">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for thestoragemaxlevel entity of a spsiteadministration_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M464"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M464"/>
   <xsl:template match="@*|node()" priority="-2" mode="M464">
      <xsl:apply-templates select="@*|*" mode="M464"/>
   </xsl:template>

   <!--PATTERN spsiteadminstestoragewarninglevel-->


	<!--RULE -->
<xsl:template match="sp-def:spsiteadministration_state/sp-def:storagewarninglevel"
                 priority="1000"
                 mode="M465">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the storagewarninglevel entity of a spsiteadministration_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M465"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M465"/>
   <xsl:template match="@*|node()" priority="-2" mode="M465">
      <xsl:apply-templates select="@*|*" mode="M465"/>
   </xsl:template>

   <!--PATTERN spsitetst-->


	<!--RULE -->
<xsl:template match="sp-def:spsite_test/sp-def:object" priority="1001" mode="M466">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spsite_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spsite_test must reference an spsite_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M466"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spsite_test/sp-def:state" priority="1000" mode="M466">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spsite_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spsite_test must reference an spsite_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M466"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M466"/>
   <xsl:template match="@*|node()" priority="-2" mode="M466">
      <xsl:apply-templates select="@*|*" mode="M466"/>
   </xsl:template>

   <!--PATTERN spsiteobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spsite_object/sp-def:sitecollectionurl" priority="1000"
                 mode="M467">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spsite_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M467"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M467"/>
   <xsl:template match="@*|node()" priority="-2" mode="M467">
      <xsl:apply-templates select="@*|*" mode="M467"/>
   </xsl:template>

   <!--PATTERN spsitestesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:spsite_state/sp-def:sitecollectionurl" priority="1000"
                 mode="M468">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a spsite_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M468"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M468"/>
   <xsl:template match="@*|node()" priority="-2" mode="M468">
      <xsl:apply-templates select="@*|*" mode="M468"/>
   </xsl:template>

   <!--PATTERN spsitestequotaname-->


	<!--RULE -->
<xsl:template match="sp-def:spsite_state/sp-def:quotaname" priority="1000" mode="M469">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the quotaname entity of a spsite_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M469"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M469"/>
   <xsl:template match="@*|node()" priority="-2" mode="M469">
      <xsl:apply-templates select="@*|*" mode="M469"/>
   </xsl:template>

   <!--PATTERN spsitesteurl-->


	<!--RULE -->
<xsl:template match="sp-def:spsite_state/sp-def:url" priority="1000" mode="M470">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the url entity of a spsite_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M470"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M470"/>
   <xsl:template match="@*|node()" priority="-2" mode="M470">
      <xsl:apply-templates select="@*|*" mode="M470"/>
   </xsl:template>

   <!--PATTERN spcrtst-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_test/sp-def:object" priority="1001" mode="M471">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spcrawlrule_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spcrawlrule_test must reference an spcrawlrule_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M471"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spcrawlrule_test/sp-def:state" priority="1000" mode="M471">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spcrawlrule_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spcrawlrule_test must reference an spcrawlrule_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M471"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M471"/>
   <xsl:template match="@*|node()" priority="-2" mode="M471">
      <xsl:apply-templates select="@*|*" mode="M471"/>
   </xsl:template>

   <!--PATTERN spcrobjsiteurl-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_object/sp-def:spsiteurl" priority="1000" mode="M472">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spsiteurl entity of a spcrawlrule_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M472"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M472"/>
   <xsl:template match="@*|node()" priority="-2" mode="M472">
      <xsl:apply-templates select="@*|*" mode="M472"/>
   </xsl:template>

   <!--PATTERN spcrstespsiteurl-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:spsiteurl" priority="1000" mode="M473">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the spsiteurl entity of a spcrawlrule_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M473"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M473"/>
   <xsl:template match="@*|node()" priority="-2" mode="M473">
      <xsl:apply-templates select="@*|*" mode="M473"/>
   </xsl:template>

   <!--PATTERN spcrstecrawlashttp-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:crawlashttp" priority="1000" mode="M474">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the crawlashttp entity of a spcrawlrule_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M474"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M474"/>
   <xsl:template match="@*|node()" priority="-2" mode="M474">
      <xsl:apply-templates select="@*|*" mode="M474"/>
   </xsl:template>

   <!--PATTERN spcrsteenabled-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:enabled" priority="1000" mode="M475">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enabled entity of a spcrawlrule_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M475"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M475"/>
   <xsl:template match="@*|node()" priority="-2" mode="M475">
      <xsl:apply-templates select="@*|*" mode="M475"/>
   </xsl:template>

   <!--PATTERN spcrstefollowcomplexurls-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:followcomplexurls" priority="1000"
                 mode="M476">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the followcomplexurls entity of a spcrawlrule_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M476"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M476"/>
   <xsl:template match="@*|node()" priority="-2" mode="M476">
      <xsl:apply-templates select="@*|*" mode="M476"/>
   </xsl:template>

   <!--PATTERN spcrstepath-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:path" priority="1000" mode="M477">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a spcrawlrule_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M477"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M477"/>
   <xsl:template match="@*|node()" priority="-2" mode="M477">
      <xsl:apply-templates select="@*|*" mode="M477"/>
   </xsl:template>

   <!--PATTERN spcrstepriority-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:priority" priority="1000" mode="M478">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the priority entity of a spcrawlrule_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M478"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M478"/>
   <xsl:template match="@*|node()" priority="-2" mode="M478">
      <xsl:apply-templates select="@*|*" mode="M478"/>
   </xsl:template>

   <!--PATTERN spcrstesuppressindexing-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:suppressindexing" priority="1000"
                 mode="M479">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the suppressindexing entity of a spcrawlrule_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M479"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M479"/>
   <xsl:template match="@*|node()" priority="-2" mode="M479">
      <xsl:apply-templates select="@*|*" mode="M479"/>
   </xsl:template>

   <!--PATTERN spcrsteaccountname-->


	<!--RULE -->
<xsl:template match="sp-def:spcrawlrule_state/sp-def:accountname" priority="1000" mode="M480">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the accountname entity of a spcrawlrule_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M480"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M480"/>
   <xsl:template match="@*|node()" priority="-2" mode="M480">
      <xsl:apply-templates select="@*|*" mode="M480"/>
   </xsl:template>

   <!--PATTERN spjobdeftst-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_test/sp-def:object" priority="1001" mode="M481">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spjobdefinition_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a spjobdefinition_test must reference an spjobdefinition_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M481"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spjobdefinition_test/sp-def:state" priority="1000" mode="M481">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spjobdefinition_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a spjobdefinition_test must reference an spjobdefinition_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M481"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M481"/>
   <xsl:template match="@*|node()" priority="-2" mode="M481">
      <xsl:apply-templates select="@*|*" mode="M481"/>
   </xsl:template>

   <!--PATTERN spjobdefobjwebappuri-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_object/sp-def:webappuri" priority="1000"
                 mode="M482">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webappuri entity of a spjobdefinition_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M482"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M482"/>
   <xsl:template match="@*|node()" priority="-2" mode="M482">
      <xsl:apply-templates select="@*|*" mode="M482"/>
   </xsl:template>

   <!--PATTERN spjobdefstewebappuri-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_state/sp-def:webappuri" priority="1000"
                 mode="M483">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webappuri entity of a spjobdefinition_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M483"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M483"/>
   <xsl:template match="@*|node()" priority="-2" mode="M483">
      <xsl:apply-templates select="@*|*" mode="M483"/>
   </xsl:template>

   <!--PATTERN spjobdefstedisplayname-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_state/sp-def:displayname" priority="1000"
                 mode="M484">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the displayname entity of a spjobdefinition_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M484"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M484"/>
   <xsl:template match="@*|node()" priority="-2" mode="M484">
      <xsl:apply-templates select="@*|*" mode="M484"/>
   </xsl:template>

   <!--PATTERN spjobdefsteisdisabled-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_state/sp-def:isdisabled" priority="1000"
                 mode="M485">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the isdisabled entity of a spjobdefinition_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M485"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M485"/>
   <xsl:template match="@*|node()" priority="-2" mode="M485">
      <xsl:apply-templates select="@*|*" mode="M485"/>
   </xsl:template>

   <!--PATTERN spjobdefsteretry-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_state/sp-def:retry" priority="1000" mode="M486">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the retry entity of a spjobdefinition_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M486"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M486"/>
   <xsl:template match="@*|node()" priority="-2" mode="M486">
      <xsl:apply-templates select="@*|*" mode="M486"/>
   </xsl:template>

   <!--PATTERN spjobdefstetitle-->


	<!--RULE -->
<xsl:template match="sp-def:spjobdefinition_state/sp-def:title" priority="1000" mode="M487">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the title entity of a spjobdefinition_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M487"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M487"/>
   <xsl:template match="@*|node()" priority="-2" mode="M487">
      <xsl:apply-templates select="@*|*" mode="M487"/>
   </xsl:template>

   <!--PATTERN bbtst-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_test/sp-def:object" priority="1001" mode="M488">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:bestbet_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a bestbet_test must reference an bestbet_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M488"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:bestbet_test/sp-def:state" priority="1000" mode="M488">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:bestbet_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a bestbet_test must reference an bestbet_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M488"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M488"/>
   <xsl:template match="@*|node()" priority="-2" mode="M488">
      <xsl:apply-templates select="@*|*" mode="M488"/>
   </xsl:template>

   <!--PATTERN bbobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_object/sp-def:sitecollectionurl" priority="1000"
                 mode="M489">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a bestbet_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M489"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M489"/>
   <xsl:template match="@*|node()" priority="-2" mode="M489">
      <xsl:apply-templates select="@*|*" mode="M489"/>
   </xsl:template>

   <!--PATTERN bbobjbestbeturl-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_object/sp-def:bestbeturl" priority="1000" mode="M490">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the bestbeturl entity of a bestbet_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M490"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M490"/>
   <xsl:template match="@*|node()" priority="-2" mode="M490">
      <xsl:apply-templates select="@*|*" mode="M490"/>
   </xsl:template>

   <!--PATTERN bbstesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_state/sp-def:sitecollectionurl" priority="1000"
                 mode="M491">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a bestbet_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M491"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M491"/>
   <xsl:template match="@*|node()" priority="-2" mode="M491">
      <xsl:apply-templates select="@*|*" mode="M491"/>
   </xsl:template>

   <!--PATTERN bbstebestbeturl-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_state/sp-def:bestbeturl" priority="1000" mode="M492">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the bestbeturl entity of a bestbet_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M492"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M492"/>
   <xsl:template match="@*|node()" priority="-2" mode="M492">
      <xsl:apply-templates select="@*|*" mode="M492"/>
   </xsl:template>

   <!--PATTERN bbstetitle-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_state/sp-def:title" priority="1000" mode="M493">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the title entity of a bestbet_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M493"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M493"/>
   <xsl:template match="@*|node()" priority="-2" mode="M493">
      <xsl:apply-templates select="@*|*" mode="M493"/>
   </xsl:template>

   <!--PATTERN bbstedescription-->


	<!--RULE -->
<xsl:template match="sp-def:bestbet_state/sp-def:description" priority="1000" mode="M494">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of a bestbet_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M494"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M494"/>
   <xsl:template match="@*|node()" priority="-2" mode="M494">
      <xsl:apply-templates select="@*|*" mode="M494"/>
   </xsl:template>

   <!--PATTERN infopolicycolltst-->


	<!--RULE -->
<xsl:template match="sp-def:policycoll_test/sp-def:object" priority="1001" mode="M495">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:policycoll_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a policycoll_test must reference an policycoll_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M495"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:policycoll_test/sp-def:state" priority="1000" mode="M495">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:policycoll_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a policycoll_test must reference an policycoll_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M495"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M495"/>
   <xsl:template match="@*|node()" priority="-2" mode="M495">
      <xsl:apply-templates select="@*|*" mode="M495"/>
   </xsl:template>

   <!--PATTERN infopolicycollobjsitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_object/sp-def:sitecollectionurl" priority="1000"
                 mode="M496">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M496"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M496"/>
   <xsl:template match="@*|node()" priority="-2" mode="M496">
      <xsl:apply-templates select="@*|*" mode="M496"/>
   </xsl:template>

   <!--PATTERN infopolicycollobjid-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_object/sp-def:id" priority="1000" mode="M497">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the id entity of a infopolicycoll_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M497"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M497"/>
   <xsl:template match="@*|node()" priority="-2" mode="M497">
      <xsl:apply-templates select="@*|*" mode="M497"/>
   </xsl:template>

   <!--PATTERN infopolicycollstesitecollectionurl-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_state/sp-def:sitecollectionurl" priority="1000"
                 mode="M498">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sitecollectionurl entity of a infopolicycoll_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M498"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M498"/>
   <xsl:template match="@*|node()" priority="-2" mode="M498">
      <xsl:apply-templates select="@*|*" mode="M498"/>
   </xsl:template>

   <!--PATTERN infopolicycollsteid-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_state/sp-def:id" priority="1000" mode="M499">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the id entity of a infopolicycoll_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M499"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M499"/>
   <xsl:template match="@*|node()" priority="-2" mode="M499">
      <xsl:apply-templates select="@*|*" mode="M499"/>
   </xsl:template>

   <!--PATTERN infopolicycollstename-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_state/sp-def:name" priority="1000" mode="M500">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a infopolicycoll_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M500"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M500"/>
   <xsl:template match="@*|node()" priority="-2" mode="M500">
      <xsl:apply-templates select="@*|*" mode="M500"/>
   </xsl:template>

   <!--PATTERN infopolicycollstedescription-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_state/sp-def:description" priority="1000"
                 mode="M501">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of a infopolicycoll_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M501"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M501"/>
   <xsl:template match="@*|node()" priority="-2" mode="M501">
      <xsl:apply-templates select="@*|*" mode="M501"/>
   </xsl:template>

   <!--PATTERN infopolicycollstelongdescription-->


	<!--RULE -->
<xsl:template match="sp-def:infopolicycoll_state/sp-def:longdescription" priority="1000"
                 mode="M502">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the longdescription entity of a infopolicycoll_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M502"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M502"/>
   <xsl:template match="@*|node()" priority="-2" mode="M502">
      <xsl:apply-templates select="@*|*" mode="M502"/>
   </xsl:template>

   <!--PATTERN spdiagnosticsservicetest-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_test/sp-def:object" priority="1001"
                 mode="M503">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spdiagnosticsservice_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an spdiagnosticsservice_test must reference an spdiagnosticsservice_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M503"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_test/sp-def:state" priority="1000"
                 mode="M503">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spdiagnosticsservice_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an spdiagnosticsservice_test must reference an spdiagnosticsservice_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M503"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M503"/>
   <xsl:template match="@*|node()" priority="-2" mode="M503">
      <xsl:apply-templates select="@*|*" mode="M503"/>
   </xsl:template>

   <!--PATTERN spdsobjfarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_object/sp-def:farmname" priority="1000"
                 mode="M504">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an spdiagnosticsservice_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M504"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M504"/>
   <xsl:template match="@*|node()" priority="-2" mode="M504">
      <xsl:apply-templates select="@*|*" mode="M504"/>
   </xsl:template>

   <!--PATTERN spdsstefarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:farmname" priority="1000"
                 mode="M505">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an spdiagnosticsservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M505"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M505"/>
   <xsl:template match="@*|node()" priority="-2" mode="M505">
      <xsl:apply-templates select="@*|*" mode="M505"/>
   </xsl:template>

   <!--PATTERN spdsstedisplayname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:displayname" priority="1000"
                 mode="M506">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the displayname entity of an spdiagnosticsservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M506"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M506"/>
   <xsl:template match="@*|node()" priority="-2" mode="M506">
      <xsl:apply-templates select="@*|*" mode="M506"/>
   </xsl:template>

   <!--PATTERN spdsstelogcutinterval-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:logcutinterval" priority="1000"
                 mode="M507">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the logcutinterval entity of an spdiagnosticsservice_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M507"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M507"/>
   <xsl:template match="@*|node()" priority="-2" mode="M507">
      <xsl:apply-templates select="@*|*" mode="M507"/>
   </xsl:template>

   <!--PATTERN spdssteloglocation-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:loglocation" priority="1000"
                 mode="M508">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the loglocation entity of an spdiagnosticsservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M508"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M508"/>
   <xsl:template match="@*|node()" priority="-2" mode="M508">
      <xsl:apply-templates select="@*|*" mode="M508"/>
   </xsl:template>

   <!--PATTERN spdsstelogstokeep-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:logstokeep" priority="1000"
                 mode="M509">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='integer'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the logstokeep entity of an spdiagnosticsservice_state should be 'integer'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M509"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M509"/>
   <xsl:template match="@*|node()" priority="-2" mode="M509">
      <xsl:apply-templates select="@*|*" mode="M509"/>
   </xsl:template>

   <!--PATTERN spdssterequired-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:required" priority="1000"
                 mode="M510">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the required entity of an spdiagnosticsservice_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M510"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M510"/>
   <xsl:template match="@*|node()" priority="-2" mode="M510">
      <xsl:apply-templates select="@*|*" mode="M510"/>
   </xsl:template>

   <!--PATTERN spdsstetypename-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticsservice_state/sp-def:typename" priority="1000"
                 mode="M511">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the typename entity of an spdiagnosticsservice_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M511"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M511"/>
   <xsl:template match="@*|node()" priority="-2" mode="M511">
      <xsl:apply-templates select="@*|*" mode="M511"/>
   </xsl:template>

   <!--PATTERN -->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_test/sp-def:object" priority="1001"
                 mode="M512">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:spdiagnosticslevel_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an spdiagnosticslevel_test must reference an spdiagnosticslevel_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M512"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_test/sp-def:state" priority="1000" mode="M512">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:spdiagnosticslevel_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an spdiagnosticslevel_test must reference an spdiagnosticslevel_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M512"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M512"/>
   <xsl:template match="@*|node()" priority="-2" mode="M512">
      <xsl:apply-templates select="@*|*" mode="M512"/>
   </xsl:template>

   <!--PATTERN spdlobjfarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_object/sp-def:farmname" priority="1000"
                 mode="M513">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an spdiagnosticslevel_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M513"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M513"/>
   <xsl:template match="@*|node()" priority="-2" mode="M513">
      <xsl:apply-templates select="@*|*" mode="M513"/>
   </xsl:template>

   <!--PATTERN spdlstefarmname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_state/sp-def:farmname" priority="1000"
                 mode="M514">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an spdiagnosticslevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M514"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M514"/>
   <xsl:template match="@*|node()" priority="-2" mode="M514">
      <xsl:apply-templates select="@*|*" mode="M514"/>
   </xsl:template>

   <!--PATTERN spdlsteeventseverity-->


	<!--RULE -->
<xsl:template match="spdiagnosticslevel_state/sp-def:eventseverity" priority="1000"
                 mode="M515">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the eventseverity entity of an spdiagnosticslevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M515"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M515"/>
   <xsl:template match="@*|node()" priority="-2" mode="M515">
      <xsl:apply-templates select="@*|*" mode="M515"/>
   </xsl:template>

   <!--PATTERN spdlstehidden-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_state/sp-def:hidden" priority="1000"
                 mode="M516">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hidden entity of an spdiagnosticslevel_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M516"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M516"/>
   <xsl:template match="@*|node()" priority="-2" mode="M516">
      <xsl:apply-templates select="@*|*" mode="M516"/>
   </xsl:template>

   <!--PATTERN spdlstelevelid-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_state/sp-def:levelid" priority="1000"
                 mode="M517">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the levelid entity of an spdiagnosticslevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M517"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M517"/>
   <xsl:template match="@*|node()" priority="-2" mode="M517">
      <xsl:apply-templates select="@*|*" mode="M517"/>
   </xsl:template>

   <!--PATTERN spdlstelevelname-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_state/sp-def:levelname" priority="1000"
                 mode="M518">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the levelname entity of an spdiagnosticslevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M518"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M518"/>
   <xsl:template match="@*|node()" priority="-2" mode="M518">
      <xsl:apply-templates select="@*|*" mode="M518"/>
   </xsl:template>

   <!--PATTERN spdlstetraceseverity-->


	<!--RULE -->
<xsl:template match="sp-def:spdiagnosticslevel_state/sp-def:traceseverity" priority="1000"
                 mode="M519">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the traceseverity entity of an spdiagnosticslevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M519"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M519"/>
   <xsl:template match="@*|node()" priority="-2" mode="M519">
      <xsl:apply-templates select="@*|*" mode="M519"/>
   </xsl:template>

   <!--PATTERN -->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_test/sp-def:object" priority="1001" mode="M520">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:sppolicyfeature_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an sppolicyfeature_test must reference an sppolicyfeature_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M520"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_test/sp-def:state" priority="1000" mode="M520">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:sppolicyfeature_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an sppolicyfeature_test must reference an sppolicyfeature_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M520"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M520"/>
   <xsl:template match="@*|node()" priority="-2" mode="M520">
      <xsl:apply-templates select="@*|*" mode="M520"/>
   </xsl:template>

   <!--PATTERN sppfobjfarmname-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_object/sp-def:farmname" priority="1000"
                 mode="M521">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an sppolicyfeature_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M521"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M521"/>
   <xsl:template match="@*|node()" priority="-2" mode="M521">
      <xsl:apply-templates select="@*|*" mode="M521"/>
   </xsl:template>

   <!--PATTERN sppfstefarmname-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:farmname" priority="1000"
                 mode="M522">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the farmname entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M522"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M522"/>
   <xsl:template match="@*|node()" priority="-2" mode="M522">
      <xsl:apply-templates select="@*|*" mode="M522"/>
   </xsl:template>

   <!--PATTERN sppfsteconfigpage-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:configpage" priority="1000"
                 mode="M523">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the configpage entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M523"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M523"/>
   <xsl:template match="@*|node()" priority="-2" mode="M523">
      <xsl:apply-templates select="@*|*" mode="M523"/>
   </xsl:template>

   <!--PATTERN sppfstedefaultcustomdata-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:defaultcustomdata" priority="1000"
                 mode="M524">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the defaultcustomdata entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M524"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M524"/>
   <xsl:template match="@*|node()" priority="-2" mode="M524">
      <xsl:apply-templates select="@*|*" mode="M524"/>
   </xsl:template>

   <!--PATTERN sppfstedescription-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:description" priority="1000"
                 mode="M525">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M525"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M525"/>
   <xsl:template match="@*|node()" priority="-2" mode="M525">
      <xsl:apply-templates select="@*|*" mode="M525"/>
   </xsl:template>

   <!--PATTERN sppfsteglobalconfigpage-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:globalconfigpage" priority="1000"
                 mode="M526">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the globalconfigpage entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M526"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M526"/>
   <xsl:template match="@*|node()" priority="-2" mode="M526">
      <xsl:apply-templates select="@*|*" mode="M526"/>
   </xsl:template>

   <!--PATTERN sppfsteglobalcustomdata-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:globalcustomdata" priority="1000"
                 mode="M527">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the globalconfigpage entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M527"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M527"/>
   <xsl:template match="@*|node()" priority="-2" mode="M527">
      <xsl:apply-templates select="@*|*" mode="M527"/>
   </xsl:template>

   <!--PATTERN sppfstegroup-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:group" priority="1000" mode="M528">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M528"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M528"/>
   <xsl:template match="@*|node()" priority="-2" mode="M528">
      <xsl:apply-templates select="@*|*" mode="M528"/>
   </xsl:template>

   <!--PATTERN sppfstename-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:name" priority="1000" mode="M529">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M529"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M529"/>
   <xsl:template match="@*|node()" priority="-2" mode="M529">
      <xsl:apply-templates select="@*|*" mode="M529"/>
   </xsl:template>

   <!--PATTERN sppfstepublisher-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:publisher" priority="1000"
                 mode="M530">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the publisher entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M530"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M530"/>
   <xsl:template match="@*|node()" priority="-2" mode="M530">
      <xsl:apply-templates select="@*|*" mode="M530"/>
   </xsl:template>

   <!--PATTERN sppfstestate-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyfeature_state/sp-def:state" priority="1000" mode="M531">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the state entity of an sppolicyfeature_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M531"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M531"/>
   <xsl:template match="@*|node()" priority="-2" mode="M531">
      <xsl:apply-templates select="@*|*" mode="M531"/>
   </xsl:template>

   <!--PATTERN -->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_test/sp-def:object" priority="1001" mode="M532">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sp-def:sppolicy_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an sppolicy_test must reference an sppolicy_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M532"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sp-def:sppolicy_test/sp-def:state" priority="1000" mode="M532">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sp-def:sppolicy_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an sppolicy_test must reference an sppolicy_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M532"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M532"/>
   <xsl:template match="@*|node()" priority="-2" mode="M532">
      <xsl:apply-templates select="@*|*" mode="M532"/>
   </xsl:template>

   <!--PATTERN sppolicyobjwebappuri-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_object/sp-def:webappuri" priority="1000" mode="M533">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webappuri entity of an sppolicy_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M533"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M533"/>
   <xsl:template match="@*|node()" priority="-2" mode="M533">
      <xsl:apply-templates select="@*|*" mode="M533"/>
   </xsl:template>

   <!--PATTERN sppolicyobjurlzone-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_object/sp-def:urlzone" priority="1000" mode="M534">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the urlzone entity of an sppolicy_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M534"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M534"/>
   <xsl:template match="@*|node()" priority="-2" mode="M534">
      <xsl:apply-templates select="@*|*" mode="M534"/>
   </xsl:template>

   <!--PATTERN sppolicystewebappuri-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_state/sp-def:webappuri" priority="1000" mode="M535">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the webappuri entity of an sppolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M535"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M535"/>
   <xsl:template match="@*|node()" priority="-2" mode="M535">
      <xsl:apply-templates select="@*|*" mode="M535"/>
   </xsl:template>

   <!--PATTERN sppolicysteurlzone-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_state/sp-def:urlzone" priority="1000" mode="M536">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the urlzone entity of an sppolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M536"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M536"/>
   <xsl:template match="@*|node()" priority="-2" mode="M536">
      <xsl:apply-templates select="@*|*" mode="M536"/>
   </xsl:template>

   <!--PATTERN sppolicystedisplayname-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_state/sp-def:displayname" priority="1000" mode="M537">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the displayname entity of an sppolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M537"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M537"/>
   <xsl:template match="@*|node()" priority="-2" mode="M537">
      <xsl:apply-templates select="@*|*" mode="M537"/>
   </xsl:template>

   <!--PATTERN sppolicysteissystemuser-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_state/sp-def:issystemuser" priority="1000" mode="M538">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the issystemuser entity of an sppolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M538"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M538"/>
   <xsl:template match="@*|node()" priority="-2" mode="M538">
      <xsl:apply-templates select="@*|*" mode="M538"/>
   </xsl:template>

   <!--PATTERN sppolicysteusername-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicy_state/sp-def:username" priority="1000" mode="M539">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of an sppolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M539"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M539"/>
   <xsl:template match="@*|node()" priority="-2" mode="M539">
      <xsl:apply-templates select="@*|*" mode="M539"/>
   </xsl:template>

   <!--PATTERN sppolicystepolicyroletype-->


	<!--RULE -->
<xsl:template match="sp-def:sppolicyrole_state/sp-def:policyroletype" priority="1000"
                 mode="M540">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the policyroletype entity of an sppolicyrole_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M540"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M540"/>
   <xsl:template match="@*|node()" priority="-2" mode="M540">
      <xsl:apply-templates select="@*|*" mode="M540"/>
   </xsl:template>

   <!--PATTERN isainfotst-->


	<!--RULE -->
<xsl:template match="sol-def:isainfo_test/sol-def:object" priority="1001" mode="M541">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sol-def:isainfo_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an isainfo_test must reference an isainfo_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M541"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sol-def:isainfo_test/sol-def:state" priority="1000" mode="M541">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sol-def:isainfo_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an isainfo_test must reference an isainfo_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M541"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M541"/>
   <xsl:template match="@*|node()" priority="-2" mode="M541">
      <xsl:apply-templates select="@*|*" mode="M541"/>
   </xsl:template>

   <!--PATTERN isastebits-->


	<!--RULE -->
<xsl:template match="sol-def:isainfo_state/sol-def:bits" priority="1000" mode="M542">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the bits entity of an isainfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M542"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M542"/>
   <xsl:template match="@*|node()" priority="-2" mode="M542">
      <xsl:apply-templates select="@*|*" mode="M542"/>
   </xsl:template>

   <!--PATTERN isastekernel_isa-->


	<!--RULE -->
<xsl:template match="sol-def:isainfo_state/sol-def:kernel_isa" priority="1000" mode="M543">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the kernel_isa entity of an isainfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M543"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M543"/>
   <xsl:template match="@*|node()" priority="-2" mode="M543">
      <xsl:apply-templates select="@*|*" mode="M543"/>
   </xsl:template>

   <!--PATTERN isasteapplication_isa-->


	<!--RULE -->
<xsl:template match="sol-def:isainfo_state/sol-def:application_isa" priority="1000"
                 mode="M544">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the application_isa entity of an isainfo_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M544"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M544"/>
   <xsl:template match="@*|node()" priority="-2" mode="M544">
      <xsl:apply-templates select="@*|*" mode="M544"/>
   </xsl:template>

   <!--PATTERN packagetst-->


	<!--RULE -->
<xsl:template match="sol-def:package_test/sol-def:object" priority="1001" mode="M545">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sol-def:package_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a package_test must reference a package_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M545"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sol-def:package_test/sol-def:state" priority="1000" mode="M545">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sol-def:package_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a package_test must reference a package_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M545"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M545"/>
   <xsl:template match="@*|node()" priority="-2" mode="M545">
      <xsl:apply-templates select="@*|*" mode="M545"/>
   </xsl:template>

   <!--PATTERN packageobjpkginst-->


	<!--RULE -->
<xsl:template match="sol-def:package_object/sol-def:pkginst" priority="1000" mode="M546">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pkginst entity of a package_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M546"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M546"/>
   <xsl:template match="@*|node()" priority="-2" mode="M546">
      <xsl:apply-templates select="@*|*" mode="M546"/>
   </xsl:template>

   <!--PATTERN packagestepkginst-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:pkginst" priority="1000" mode="M547">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pkginst entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M547"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M547"/>
   <xsl:template match="@*|node()" priority="-2" mode="M547">
      <xsl:apply-templates select="@*|*" mode="M547"/>
   </xsl:template>

   <!--PATTERN packagestename-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:name" priority="1000" mode="M548">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M548"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M548"/>
   <xsl:template match="@*|node()" priority="-2" mode="M548">
      <xsl:apply-templates select="@*|*" mode="M548"/>
   </xsl:template>

   <!--PATTERN packagestecategory-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:category" priority="1000" mode="M549">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the category entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M549"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M549"/>
   <xsl:template match="@*|node()" priority="-2" mode="M549">
      <xsl:apply-templates select="@*|*" mode="M549"/>
   </xsl:template>

   <!--PATTERN packagesteversion-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:version" priority="1000" mode="M550">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M550"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M550"/>
   <xsl:template match="@*|node()" priority="-2" mode="M550">
      <xsl:apply-templates select="@*|*" mode="M550"/>
   </xsl:template>

   <!--PATTERN packagestevendor-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:vendor" priority="1000" mode="M551">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the vendor entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M551"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M551"/>
   <xsl:template match="@*|node()" priority="-2" mode="M551">
      <xsl:apply-templates select="@*|*" mode="M551"/>
   </xsl:template>

   <!--PATTERN packagestedescription-->


	<!--RULE -->
<xsl:template match="sol-def:package_state/sol-def:description" priority="1000" mode="M552">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the description entity of a package_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M552"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M552"/>
   <xsl:template match="@*|node()" priority="-2" mode="M552">
      <xsl:apply-templates select="@*|*" mode="M552"/>
   </xsl:template>

   <!--PATTERN patch54tst-->


	<!--RULE -->
<xsl:template match="sol-def:patch54_test/sol-def:object" priority="1001" mode="M553">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sol-def:patch54_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a patch54_test must reference a patch54_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M553"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sol-def:patch54_test/sol-def:state" priority="1000" mode="M553">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sol-def:patch_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a patch54_test must reference a patch_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M553"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M553"/>
   <xsl:template match="@*|node()" priority="-2" mode="M553">
      <xsl:apply-templates select="@*|*" mode="M553"/>
   </xsl:template>

   <!--PATTERN patchtst_dep-->


	<!--RULE -->
<xsl:template match="sol-def:patch_test" priority="1000" mode="M554">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M554"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M554"/>
   <xsl:template match="@*|node()" priority="-2" mode="M554">
      <xsl:apply-templates select="@*|*" mode="M554"/>
   </xsl:template>

   <!--PATTERN patchtst-->


	<!--RULE -->
<xsl:template match="sol-def:patch_test/sol-def:object" priority="1001" mode="M555">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sol-def:patch_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a patch_test must reference a patch_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M555"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sol-def:patch_test/sol-def:state" priority="1000" mode="M555">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sol-def:patch_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a patch_test must reference a patch_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M555"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M555"/>
   <xsl:template match="@*|node()" priority="-2" mode="M555">
      <xsl:apply-templates select="@*|*" mode="M555"/>
   </xsl:template>

   <!--PATTERN patch54objbase-->


	<!--RULE -->
<xsl:template match="sol-def:patch54_object/sol-def:base" priority="1000" mode="M556">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the base entity of a patch54_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M556"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M556"/>
   <xsl:template match="@*|node()" priority="-2" mode="M556">
      <xsl:apply-templates select="@*|*" mode="M556"/>
   </xsl:template>

   <!--PATTERN patch54objversion-->


	<!--RULE -->
<xsl:template match="sol-def:patch54_object/sol-def:version" priority="1000" mode="M557">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a patch54_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M557"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M557"/>
   <xsl:template match="@*|node()" priority="-2" mode="M557">
      <xsl:apply-templates select="@*|*" mode="M557"/>
   </xsl:template>

   <!--PATTERN patchobj_dep-->


	<!--RULE -->
<xsl:template match="sol-def:patch_object" priority="1000" mode="M558">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M558"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M558"/>
   <xsl:template match="@*|node()" priority="-2" mode="M558">
      <xsl:apply-templates select="@*|*" mode="M558"/>
   </xsl:template>

   <!--PATTERN patchobjbase-->


	<!--RULE -->
<xsl:template match="sol-def:patch_object/sol-def:base" priority="1000" mode="M559">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the base entity of a patch_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M559"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M559"/>
   <xsl:template match="@*|node()" priority="-2" mode="M559">
      <xsl:apply-templates select="@*|*" mode="M559"/>
   </xsl:template>

   <!--PATTERN patchstebase-->


	<!--RULE -->
<xsl:template match="sol-def:patch_state/sol-def:base" priority="1000" mode="M560">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the base entity of a patch_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M560"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M560"/>
   <xsl:template match="@*|node()" priority="-2" mode="M560">
      <xsl:apply-templates select="@*|*" mode="M560"/>
   </xsl:template>

   <!--PATTERN patchsteversion-->


	<!--RULE -->
<xsl:template match="sol-def:patch_state/sol-def:version" priority="1000" mode="M561">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a patch_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M561"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M561"/>
   <xsl:template match="@*|node()" priority="-2" mode="M561">
      <xsl:apply-templates select="@*|*" mode="M561"/>
   </xsl:template>

   <!--PATTERN smftst-->


	<!--RULE -->
<xsl:template match="sol-def:smf_test/sol-def:object" priority="1001" mode="M562">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/sol-def:smf_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a smf_test must reference a smf_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M562"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="sol-def:smf_test/sol-def:state" priority="1000" mode="M562">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/sol-def:smf_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a smf_test must reference a smf_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M562"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M562"/>
   <xsl:template match="@*|node()" priority="-2" mode="M562">
      <xsl:apply-templates select="@*|*" mode="M562"/>
   </xsl:template>

   <!--PATTERN fmriobjbase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_object/sol-def:fmri" priority="1000" mode="M563">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the fmri entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M563"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M563"/>
   <xsl:template match="@*|node()" priority="-2" mode="M563">
      <xsl:apply-templates select="@*|*" mode="M563"/>
   </xsl:template>

   <!--PATTERN fmristebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:fmri" priority="1000" mode="M564">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the fmri entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M564"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M564"/>
   <xsl:template match="@*|node()" priority="-2" mode="M564">
      <xsl:apply-templates select="@*|*" mode="M564"/>
   </xsl:template>

   <!--PATTERN srvnamestebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:service_name" priority="1000" mode="M565">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M565"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M565"/>
   <xsl:template match="@*|node()" priority="-2" mode="M565">
      <xsl:apply-templates select="@*|*" mode="M565"/>
   </xsl:template>

   <!--PATTERN srvstatestebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:service_state" priority="1000" mode="M566">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_state entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M566"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M566"/>
   <xsl:template match="@*|node()" priority="-2" mode="M566">
      <xsl:apply-templates select="@*|*" mode="M566"/>
   </xsl:template>

   <!--PATTERN protocolstebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:protocol" priority="1000" mode="M567">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M567"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M567"/>
   <xsl:template match="@*|node()" priority="-2" mode="M567">
      <xsl:apply-templates select="@*|*" mode="M567"/>
   </xsl:template>

   <!--PATTERN srvexestebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:server_executable" priority="1000" mode="M568">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server_executable entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M568"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M568"/>
   <xsl:template match="@*|node()" priority="-2" mode="M568">
      <xsl:apply-templates select="@*|*" mode="M568"/>
   </xsl:template>

   <!--PATTERN srvargsstebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:server_arguements" priority="1000" mode="M569">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server_arguements entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M569"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M569"/>
   <xsl:template match="@*|node()" priority="-2" mode="M569">
      <xsl:apply-templates select="@*|*" mode="M569"/>
   </xsl:template>

   <!--PATTERN execasuserstebase-->


	<!--RULE -->
<xsl:template match="sol-def:smf_state/sol-def:exec_as_user" priority="1000" mode="M570">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exec_as_user entity of a smf_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M570"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M570"/>
   <xsl:template match="@*|node()" priority="-2" mode="M570">
      <xsl:apply-templates select="@*|*" mode="M570"/>
   </xsl:template>

   <!--PATTERN unixfiletst-->


	<!--RULE -->
<xsl:template match="unix-def:file_test/unix-def:object" priority="1001" mode="M571">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:file_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a file_test must reference a file_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M571"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:file_test/unix-def:state" priority="1000" mode="M571">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:file_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a file_test must reference a file_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M571"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M571"/>
   <xsl:template match="@*|node()" priority="-2" mode="M571">
      <xsl:apply-templates select="@*|*" mode="M571"/>
   </xsl:template>

   <!--PATTERN unixfileobjfilepath-->


	<!--RULE -->
<xsl:template match="unix-def:file_object/unix-def:filepath" priority="1000" mode="M572">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M572"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M572"/>
   <xsl:template match="@*|node()" priority="-2" mode="M572">
      <xsl:apply-templates select="@*|*" mode="M572"/>
   </xsl:template>

   <!--PATTERN unixfileobjpath-->


	<!--RULE -->
<xsl:template match="unix-def:file_object/unix-def:path" priority="1000" mode="M573">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M573"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M573"/>
   <xsl:template match="@*|node()" priority="-2" mode="M573">
      <xsl:apply-templates select="@*|*" mode="M573"/>
   </xsl:template>

   <!--PATTERN unixfileobjfilename-->


	<!--RULE -->
<xsl:template match="unix-def:file_object/unix-def:filename" priority="1000" mode="M574">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M574"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M574"/>
   <xsl:template match="@*|node()" priority="-2" mode="M574">
      <xsl:apply-templates select="@*|*" mode="M574"/>
   </xsl:template>

   <!--PATTERN unixfilestefilepath-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:filepath" priority="1000" mode="M575">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M575"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M575"/>
   <xsl:template match="@*|node()" priority="-2" mode="M575">
      <xsl:apply-templates select="@*|*" mode="M575"/>
   </xsl:template>

   <!--PATTERN unixfilestepath-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:path" priority="1000" mode="M576">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M576"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M576"/>
   <xsl:template match="@*|node()" priority="-2" mode="M576">
      <xsl:apply-templates select="@*|*" mode="M576"/>
   </xsl:template>

   <!--PATTERN unixfilestefilename-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:filename" priority="1000" mode="M577">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M577"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M577"/>
   <xsl:template match="@*|node()" priority="-2" mode="M577">
      <xsl:apply-templates select="@*|*" mode="M577"/>
   </xsl:template>

   <!--PATTERN unixfilestetype-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:type" priority="1000" mode="M578">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M578"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M578"/>
   <xsl:template match="@*|node()" priority="-2" mode="M578">
      <xsl:apply-templates select="@*|*" mode="M578"/>
   </xsl:template>

   <!--PATTERN unixfilestegroup_id-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:group_id" priority="1000" mode="M579">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_id entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M579"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M579"/>
   <xsl:template match="@*|node()" priority="-2" mode="M579">
      <xsl:apply-templates select="@*|*" mode="M579"/>
   </xsl:template>

   <!--PATTERN unixfilesteuser_id-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:user_id" priority="1000" mode="M580">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_id entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M580"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M580"/>
   <xsl:template match="@*|node()" priority="-2" mode="M580">
      <xsl:apply-templates select="@*|*" mode="M580"/>
   </xsl:template>

   <!--PATTERN unixfilestea_time-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:a_time" priority="1000" mode="M581">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the a_time entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M581"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M581"/>
   <xsl:template match="@*|node()" priority="-2" mode="M581">
      <xsl:apply-templates select="@*|*" mode="M581"/>
   </xsl:template>

   <!--PATTERN unixfilestec_time-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:c_time" priority="1000" mode="M582">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the c_time entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M582"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M582"/>
   <xsl:template match="@*|node()" priority="-2" mode="M582">
      <xsl:apply-templates select="@*|*" mode="M582"/>
   </xsl:template>

   <!--PATTERN unixfilestem_time-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:m_time" priority="1000" mode="M583">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the m_time entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M583"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M583"/>
   <xsl:template match="@*|node()" priority="-2" mode="M583">
      <xsl:apply-templates select="@*|*" mode="M583"/>
   </xsl:template>

   <!--PATTERN unixfilestesize-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:size" priority="1000" mode="M584">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the size entity of a file_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M584"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M584"/>
   <xsl:template match="@*|node()" priority="-2" mode="M584">
      <xsl:apply-templates select="@*|*" mode="M584"/>
   </xsl:template>

   <!--PATTERN unixfilestesuid-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:suid" priority="1000" mode="M585">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the suid entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M585"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M585"/>
   <xsl:template match="@*|node()" priority="-2" mode="M585">
      <xsl:apply-templates select="@*|*" mode="M585"/>
   </xsl:template>

   <!--PATTERN unixfilestesgid-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:sgid" priority="1000" mode="M586">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sgid entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M586"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M586"/>
   <xsl:template match="@*|node()" priority="-2" mode="M586">
      <xsl:apply-templates select="@*|*" mode="M586"/>
   </xsl:template>

   <!--PATTERN unixfilestesticky-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:sticky" priority="1000" mode="M587">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sticky entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M587"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M587"/>
   <xsl:template match="@*|node()" priority="-2" mode="M587">
      <xsl:apply-templates select="@*|*" mode="M587"/>
   </xsl:template>

   <!--PATTERN unixfilesteuread-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:uread" priority="1000" mode="M588">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uread entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M588"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M588"/>
   <xsl:template match="@*|node()" priority="-2" mode="M588">
      <xsl:apply-templates select="@*|*" mode="M588"/>
   </xsl:template>

   <!--PATTERN unixfilesteuwrite-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:uwrite" priority="1000" mode="M589">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uwrite entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M589"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M589"/>
   <xsl:template match="@*|node()" priority="-2" mode="M589">
      <xsl:apply-templates select="@*|*" mode="M589"/>
   </xsl:template>

   <!--PATTERN unixfilesteuexec-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:uexec" priority="1000" mode="M590">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the uexec entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M590"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M590"/>
   <xsl:template match="@*|node()" priority="-2" mode="M590">
      <xsl:apply-templates select="@*|*" mode="M590"/>
   </xsl:template>

   <!--PATTERN unixfilestegread-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:gread" priority="1000" mode="M591">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gread entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M591"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M591"/>
   <xsl:template match="@*|node()" priority="-2" mode="M591">
      <xsl:apply-templates select="@*|*" mode="M591"/>
   </xsl:template>

   <!--PATTERN unixfilestegwrite-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:gwrite" priority="1000" mode="M592">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gwrite entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M592"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M592"/>
   <xsl:template match="@*|node()" priority="-2" mode="M592">
      <xsl:apply-templates select="@*|*" mode="M592"/>
   </xsl:template>

   <!--PATTERN unixfilestegexec-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:gexec" priority="1000" mode="M593">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gexec entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M593"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M593"/>
   <xsl:template match="@*|node()" priority="-2" mode="M593">
      <xsl:apply-templates select="@*|*" mode="M593"/>
   </xsl:template>

   <!--PATTERN unixfilesteoread-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:oread" priority="1000" mode="M594">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the oread entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M594"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M594"/>
   <xsl:template match="@*|node()" priority="-2" mode="M594">
      <xsl:apply-templates select="@*|*" mode="M594"/>
   </xsl:template>

   <!--PATTERN unixfilesteowrite-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:owrite" priority="1000" mode="M595">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the owrite entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M595"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M595"/>
   <xsl:template match="@*|node()" priority="-2" mode="M595">
      <xsl:apply-templates select="@*|*" mode="M595"/>
   </xsl:template>

   <!--PATTERN unixfilesteoexec-->


	<!--RULE -->
<xsl:template match="unix-def:file_state/unix-def:oexec" priority="1000" mode="M596">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the oexec entity of a file_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M596"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M596"/>
   <xsl:template match="@*|node()" priority="-2" mode="M596">
      <xsl:apply-templates select="@*|*" mode="M596"/>
   </xsl:template>

   <!--PATTERN recurse_value_file_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/unix-def:file_object/unix-def:behaviors"
                 priority="1000"
                 mode="M597">

		<!--REPORT -->
<xsl:if test="@recurse='files'">DEPRECATED ATTRIBUTE VALUE IN: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ATTRIBUTE VALUE: <xsl:text/>
         <xsl:value-of select="@recurse"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>

		    <!--REPORT -->
<xsl:if test="@recurse='files and directories'">DEPRECATED ATTRIBUTE VALUE IN: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ATTRIBUTE VALUE: <xsl:text/>
         <xsl:value-of select="@recurse"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>

		    <!--REPORT -->
<xsl:if test="@recurse='none'"> DEPRECATED ATTRIBUTE VALUE IN: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ATTRIBUTE VALUE: <xsl:text/>
         <xsl:value-of select="@recurse"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M597"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M597"/>
   <xsl:template match="@*|node()" priority="-2" mode="M597">
      <xsl:apply-templates select="@*|*" mode="M597"/>
   </xsl:template>

   <!--PATTERN unixinetdtst-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_test/unix-def:object" priority="1001" mode="M598">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:inetd_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an inetd_test must reference an inetd_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M598"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:inetd_test/unix-def:state" priority="1000" mode="M598">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:inetd_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an inetd_test must reference an inetd_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M598"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M598"/>
   <xsl:template match="@*|node()" priority="-2" mode="M598">
      <xsl:apply-templates select="@*|*" mode="M598"/>
   </xsl:template>

   <!--PATTERN inetdobjprotocol-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_object/unix-def:protocol" priority="1000" mode="M599">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an inetd_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M599"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M599"/>
   <xsl:template match="@*|node()" priority="-2" mode="M599">
      <xsl:apply-templates select="@*|*" mode="M599"/>
   </xsl:template>

   <!--PATTERN inetdobjservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_object/unix-def:service_name" priority="1000" mode="M600">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of an inetd_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M600"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M600"/>
   <xsl:template match="@*|node()" priority="-2" mode="M600">
      <xsl:apply-templates select="@*|*" mode="M600"/>
   </xsl:template>

   <!--PATTERN inetdsteprotocol-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:protocol" priority="1000" mode="M601">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M601"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M601"/>
   <xsl:template match="@*|node()" priority="-2" mode="M601">
      <xsl:apply-templates select="@*|*" mode="M601"/>
   </xsl:template>

   <!--PATTERN inetdsteservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:service_name" priority="1000" mode="M602">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M602"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M602"/>
   <xsl:template match="@*|node()" priority="-2" mode="M602">
      <xsl:apply-templates select="@*|*" mode="M602"/>
   </xsl:template>

   <!--PATTERN inetdsteserver_program-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:server_program" priority="1000"
                 mode="M603">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server_program entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M603"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M603"/>
   <xsl:template match="@*|node()" priority="-2" mode="M603">
      <xsl:apply-templates select="@*|*" mode="M603"/>
   </xsl:template>

   <!--PATTERN inetdsteserver_arguments-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:server_arguments" priority="1000"
                 mode="M604">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server_arguments entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M604"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M604"/>
   <xsl:template match="@*|node()" priority="-2" mode="M604">
      <xsl:apply-templates select="@*|*" mode="M604"/>
   </xsl:template>

   <!--PATTERN inetdsteendpoint_type-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:endpoint_type" priority="1000" mode="M605">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the endpoint_type entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M605"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M605"/>
   <xsl:template match="@*|node()" priority="-2" mode="M605">
      <xsl:apply-templates select="@*|*" mode="M605"/>
   </xsl:template>

   <!--PATTERN inetdsteexec_as_user-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:exec_as_user" priority="1000" mode="M606">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exec_as_user entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M606"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M606"/>
   <xsl:template match="@*|node()" priority="-2" mode="M606">
      <xsl:apply-templates select="@*|*" mode="M606"/>
   </xsl:template>

   <!--PATTERN inetdstewait_status-->


	<!--RULE -->
<xsl:template match="unix-def:inetd_state/unix-def:wait_status" priority="1000" mode="M607">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the wait_status entity of an inetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M607"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M607"/>
   <xsl:template match="@*|node()" priority="-2" mode="M607">
      <xsl:apply-templates select="@*|*" mode="M607"/>
   </xsl:template>

   <!--PATTERN unixinterfacetst-->


	<!--RULE -->
<xsl:template match="unix-def:interface_test/unix-def:object" priority="1001" mode="M608">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:interface_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an interface_test must reference an interface_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M608"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:interface_test/unix-def:state" priority="1000" mode="M608">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:interface_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an interface_test must reference an interface_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M608"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M608"/>
   <xsl:template match="@*|node()" priority="-2" mode="M608">
      <xsl:apply-templates select="@*|*" mode="M608"/>
   </xsl:template>

   <!--PATTERN unixinterfaceobjname-->


	<!--RULE -->
<xsl:template match="unix-def:interface_object/unix-def:name" priority="1000" mode="M609">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an interface_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M609"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M609"/>
   <xsl:template match="@*|node()" priority="-2" mode="M609">
      <xsl:apply-templates select="@*|*" mode="M609"/>
   </xsl:template>

   <!--PATTERN unixinterfacestename-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:name" priority="1000" mode="M610">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M610"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M610"/>
   <xsl:template match="@*|node()" priority="-2" mode="M610">
      <xsl:apply-templates select="@*|*" mode="M610"/>
   </xsl:template>

   <!--PATTERN unixinterfacestetype-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:type" priority="1000" mode="M611">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M611"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M611"/>
   <xsl:template match="@*|node()" priority="-2" mode="M611">
      <xsl:apply-templates select="@*|*" mode="M611"/>
   </xsl:template>

   <!--PATTERN unixinterfacestehardware_addr-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:hardware_addr" priority="1000"
                 mode="M612">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hardware_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M612"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M612"/>
   <xsl:template match="@*|node()" priority="-2" mode="M612">
      <xsl:apply-templates select="@*|*" mode="M612"/>
   </xsl:template>

   <!--PATTERN unixinterfacesteinet_addr-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:inet_addr" priority="1000" mode="M613">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the inet_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M613"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M613"/>
   <xsl:template match="@*|node()" priority="-2" mode="M613">
      <xsl:apply-templates select="@*|*" mode="M613"/>
   </xsl:template>

   <!--PATTERN unixinterfacestebroadcast_addr-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:broadcast_addr" priority="1000"
                 mode="M614">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the broadcast_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M614"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M614"/>
   <xsl:template match="@*|node()" priority="-2" mode="M614">
      <xsl:apply-templates select="@*|*" mode="M614"/>
   </xsl:template>

   <!--PATTERN unixinterfacestenetmask-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:netmask" priority="1000" mode="M615">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the netmask entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M615"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M615"/>
   <xsl:template match="@*|node()" priority="-2" mode="M615">
      <xsl:apply-templates select="@*|*" mode="M615"/>
   </xsl:template>

   <!--PATTERN unixinterfacesteflag-->


	<!--RULE -->
<xsl:template match="unix-def:interface_state/unix-def:flag" priority="1000" mode="M616">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for a flag entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M616"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M616"/>
   <xsl:template match="@*|node()" priority="-2" mode="M616">
      <xsl:apply-templates select="@*|*" mode="M616"/>
   </xsl:template>

   <!--PATTERN unixpasswordtst-->


	<!--RULE -->
<xsl:template match="unix-def:password_test/unix-def:object" priority="1001" mode="M617">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:password_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a password_test must reference a password_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M617"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:password_test/unix-def:state" priority="1000" mode="M617">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:password_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a password_test must reference a password_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M617"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M617"/>
   <xsl:template match="@*|node()" priority="-2" mode="M617">
      <xsl:apply-templates select="@*|*" mode="M617"/>
   </xsl:template>

   <!--PATTERN passwordobjusername-->


	<!--RULE -->
<xsl:template match="unix-def:password_object/unix-def:username" priority="1000" mode="M618">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a password_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M618"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M618"/>
   <xsl:template match="@*|node()" priority="-2" mode="M618">
      <xsl:apply-templates select="@*|*" mode="M618"/>
   </xsl:template>

   <!--PATTERN passwordsteusername-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:username" priority="1000" mode="M619">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M619"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M619"/>
   <xsl:template match="@*|node()" priority="-2" mode="M619">
      <xsl:apply-templates select="@*|*" mode="M619"/>
   </xsl:template>

   <!--PATTERN passwordstepassword-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:password" priority="1000" mode="M620">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M620"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M620"/>
   <xsl:template match="@*|node()" priority="-2" mode="M620">
      <xsl:apply-templates select="@*|*" mode="M620"/>
   </xsl:template>

   <!--PATTERN passwordsteuser_id-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:user_id" priority="1000" mode="M621">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_id entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M621"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M621"/>
   <xsl:template match="@*|node()" priority="-2" mode="M621">
      <xsl:apply-templates select="@*|*" mode="M621"/>
   </xsl:template>

   <!--PATTERN passwordstegroup_id-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:group_id" priority="1000" mode="M622">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_id entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M622"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M622"/>
   <xsl:template match="@*|node()" priority="-2" mode="M622">
      <xsl:apply-templates select="@*|*" mode="M622"/>
   </xsl:template>

   <!--PATTERN passwordstegcos-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:gcos" priority="1000" mode="M623">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the gcos entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M623"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M623"/>
   <xsl:template match="@*|node()" priority="-2" mode="M623">
      <xsl:apply-templates select="@*|*" mode="M623"/>
   </xsl:template>

   <!--PATTERN passwordstehome_dir-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:home_dir" priority="1000" mode="M624">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the home_dir entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M624"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M624"/>
   <xsl:template match="@*|node()" priority="-2" mode="M624">
      <xsl:apply-templates select="@*|*" mode="M624"/>
   </xsl:template>

   <!--PATTERN passwordstelogin_shell-->


	<!--RULE -->
<xsl:template match="unix-def:password_state/unix-def:login_shell" priority="1000"
                 mode="M625">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the login_shell entity of a password_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M625"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M625"/>
   <xsl:template match="@*|node()" priority="-2" mode="M625">
      <xsl:apply-templates select="@*|*" mode="M625"/>
   </xsl:template>

   <!--PATTERN unixprocesstst-->


	<!--RULE -->
<xsl:template match="unix-def:process_test/unix-def:object" priority="1001" mode="M626">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:process_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a process_test must reference a process_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M626"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:process_test/unix-def:state" priority="1000" mode="M626">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:process_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a process_test must reference a process_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M626"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M626"/>
   <xsl:template match="@*|node()" priority="-2" mode="M626">
      <xsl:apply-templates select="@*|*" mode="M626"/>
   </xsl:template>

   <!--PATTERN unixprocessobjcommand-->


	<!--RULE -->
<xsl:template match="unix-def:process_object/unix-def:command" priority="1000" mode="M627">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the command entity of a process_object be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M627"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M627"/>
   <xsl:template match="@*|node()" priority="-2" mode="M627">
      <xsl:apply-templates select="@*|*" mode="M627"/>
   </xsl:template>

   <!--PATTERN unixprocessstecommand-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:command" priority="1000" mode="M628">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the command entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M628"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M628"/>
   <xsl:template match="@*|node()" priority="-2" mode="M628">
      <xsl:apply-templates select="@*|*" mode="M628"/>
   </xsl:template>

   <!--PATTERN unixprocesssteexec_time-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:exec_time" priority="1000" mode="M629">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exec_time entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M629"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M629"/>
   <xsl:template match="@*|node()" priority="-2" mode="M629">
      <xsl:apply-templates select="@*|*" mode="M629"/>
   </xsl:template>

   <!--PATTERN unixprocessstepid-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:pid" priority="1000" mode="M630">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pid entity of a process_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M630"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M630"/>
   <xsl:template match="@*|node()" priority="-2" mode="M630">
      <xsl:apply-templates select="@*|*" mode="M630"/>
   </xsl:template>

   <!--PATTERN unixprocesssteppid-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:ppid" priority="1000" mode="M631">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ppid entity of a process_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M631"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M631"/>
   <xsl:template match="@*|node()" priority="-2" mode="M631">
      <xsl:apply-templates select="@*|*" mode="M631"/>
   </xsl:template>

   <!--PATTERN unixprocessstepriority-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:priority" priority="1000" mode="M632">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the priority entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M632"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M632"/>
   <xsl:template match="@*|node()" priority="-2" mode="M632">
      <xsl:apply-templates select="@*|*" mode="M632"/>
   </xsl:template>

   <!--PATTERN unixprocessstescheduling_class-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:scheduling_class" priority="1000"
                 mode="M633">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the scheduling_class entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M633"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M633"/>
   <xsl:template match="@*|node()" priority="-2" mode="M633">
      <xsl:apply-templates select="@*|*" mode="M633"/>
   </xsl:template>

   <!--PATTERN unixprocessstestart_time-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:start_time" priority="1000" mode="M634">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the start_time entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M634"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M634"/>
   <xsl:template match="@*|node()" priority="-2" mode="M634">
      <xsl:apply-templates select="@*|*" mode="M634"/>
   </xsl:template>

   <!--PATTERN unixprocessstetty-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:tty" priority="1000" mode="M635">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the tty entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M635"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M635"/>
   <xsl:template match="@*|node()" priority="-2" mode="M635">
      <xsl:apply-templates select="@*|*" mode="M635"/>
   </xsl:template>

   <!--PATTERN unixprocesssteuser_id-->


	<!--RULE -->
<xsl:template match="unix-def:process_state/unix-def:user_id" priority="1000" mode="M636">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_id entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M636"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M636"/>
   <xsl:template match="@*|node()" priority="-2" mode="M636">
      <xsl:apply-templates select="@*|*" mode="M636"/>
   </xsl:template>

   <!--PATTERN unixrunleveltst-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_test/unix-def:object" priority="1001" mode="M637">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:runlevel_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a runlevel_test must reference a runlevel_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M637"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:runlevel_test/unix-def:state" priority="1000" mode="M637">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:runlevel_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a runlevel_test must reference a runlevel_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M637"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M637"/>
   <xsl:template match="@*|node()" priority="-2" mode="M637">
      <xsl:apply-templates select="@*|*" mode="M637"/>
   </xsl:template>

   <!--PATTERN unixrlobjservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_object/unix-def:service_name" priority="1000"
                 mode="M638">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of a runlevel_object be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M638"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M638"/>
   <xsl:template match="@*|node()" priority="-2" mode="M638">
      <xsl:apply-templates select="@*|*" mode="M638"/>
   </xsl:template>

   <!--PATTERN unixrlobjrunlevel-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_object/unix-def:runlevel" priority="1000" mode="M639">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the runlevel entity of a runlevel_object be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M639"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M639"/>
   <xsl:template match="@*|node()" priority="-2" mode="M639">
      <xsl:apply-templates select="@*|*" mode="M639"/>
   </xsl:template>

   <!--PATTERN unixrlsteservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_state/unix-def:service_name" priority="1000"
                 mode="M640">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of a runlevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M640"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M640"/>
   <xsl:template match="@*|node()" priority="-2" mode="M640">
      <xsl:apply-templates select="@*|*" mode="M640"/>
   </xsl:template>

   <!--PATTERN unixrlsterunlevel-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_state/unix-def:runlevel" priority="1000" mode="M641">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the runlevel entity of a runlevel_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M641"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M641"/>
   <xsl:template match="@*|node()" priority="-2" mode="M641">
      <xsl:apply-templates select="@*|*" mode="M641"/>
   </xsl:template>

   <!--PATTERN unixrlstestart-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_state/unix-def:start" priority="1000" mode="M642">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the start entity of a runlevel_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M642"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M642"/>
   <xsl:template match="@*|node()" priority="-2" mode="M642">
      <xsl:apply-templates select="@*|*" mode="M642"/>
   </xsl:template>

   <!--PATTERN unixrlstekill-->


	<!--RULE -->
<xsl:template match="unix-def:runlevel_state/unix-def:kill" priority="1000" mode="M643">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the kill entity of a runlevel_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M643"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M643"/>
   <xsl:template match="@*|node()" priority="-2" mode="M643">
      <xsl:apply-templates select="@*|*" mode="M643"/>
   </xsl:template>

   <!--PATTERN unixsccstst-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_test/unix-def:object" priority="1001" mode="M644">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:sccs_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a sccs_test must reference a sccs_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M644"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:sccs_test/unix-def:state" priority="1000" mode="M644">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:sccs_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a sccs_test must reference a sccs_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M644"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M644"/>
   <xsl:template match="@*|node()" priority="-2" mode="M644">
      <xsl:apply-templates select="@*|*" mode="M644"/>
   </xsl:template>

   <!--PATTERN sccsobjfilepath-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_object/unix-def:filepath" priority="1000" mode="M645">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a sccs_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M645"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M645"/>
   <xsl:template match="@*|node()" priority="-2" mode="M645">
      <xsl:apply-templates select="@*|*" mode="M645"/>
   </xsl:template>

   <!--PATTERN sccsobjpath-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_object/unix-def:path" priority="1000" mode="M646">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a sccs_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M646"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M646"/>
   <xsl:template match="@*|node()" priority="-2" mode="M646">
      <xsl:apply-templates select="@*|*" mode="M646"/>
   </xsl:template>

   <!--PATTERN sccsobjfilename-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_object/unix-def:filename" priority="1000" mode="M647">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a sccs_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M647"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M647"/>
   <xsl:template match="@*|node()" priority="-2" mode="M647">
      <xsl:apply-templates select="@*|*" mode="M647"/>
   </xsl:template>

   <!--PATTERN sccsstefilepath-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:filepath" priority="1000" mode="M648">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M648"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M648"/>
   <xsl:template match="@*|node()" priority="-2" mode="M648">
      <xsl:apply-templates select="@*|*" mode="M648"/>
   </xsl:template>

   <!--PATTERN sccsstepath-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:path" priority="1000" mode="M649">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M649"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M649"/>
   <xsl:template match="@*|node()" priority="-2" mode="M649">
      <xsl:apply-templates select="@*|*" mode="M649"/>
   </xsl:template>

   <!--PATTERN sccsstefilename-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:filename" priority="1000" mode="M650">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M650"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M650"/>
   <xsl:template match="@*|node()" priority="-2" mode="M650">
      <xsl:apply-templates select="@*|*" mode="M650"/>
   </xsl:template>

   <!--PATTERN sccsstemodule_name-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:module_name" priority="1000" mode="M651">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the module_name entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M651"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M651"/>
   <xsl:template match="@*|node()" priority="-2" mode="M651">
      <xsl:apply-templates select="@*|*" mode="M651"/>
   </xsl:template>

   <!--PATTERN sccsstemodule_type-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:module_type" priority="1000" mode="M652">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the module_type entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M652"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M652"/>
   <xsl:template match="@*|node()" priority="-2" mode="M652">
      <xsl:apply-templates select="@*|*" mode="M652"/>
   </xsl:template>

   <!--PATTERN sccssterelease-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:release" priority="1000" mode="M653">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the release entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M653"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M653"/>
   <xsl:template match="@*|node()" priority="-2" mode="M653">
      <xsl:apply-templates select="@*|*" mode="M653"/>
   </xsl:template>

   <!--PATTERN sccsstelevel-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:level" priority="1000" mode="M654">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the level entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M654"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M654"/>
   <xsl:template match="@*|node()" priority="-2" mode="M654">
      <xsl:apply-templates select="@*|*" mode="M654"/>
   </xsl:template>

   <!--PATTERN sccsstebranch-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:branch" priority="1000" mode="M655">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the branch entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M655"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M655"/>
   <xsl:template match="@*|node()" priority="-2" mode="M655">
      <xsl:apply-templates select="@*|*" mode="M655"/>
   </xsl:template>

   <!--PATTERN sccsstesequence-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:sequence" priority="1000" mode="M656">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sequence entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M656"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M656"/>
   <xsl:template match="@*|node()" priority="-2" mode="M656">
      <xsl:apply-templates select="@*|*" mode="M656"/>
   </xsl:template>

   <!--PATTERN sccsstewhat_string-->


	<!--RULE -->
<xsl:template match="unix-def:sccs_state/unix-def:what_string" priority="1000" mode="M657">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the what_string entity of a sccs_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M657"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M657"/>
   <xsl:template match="@*|node()" priority="-2" mode="M657">
      <xsl:apply-templates select="@*|*" mode="M657"/>
   </xsl:template>

   <!--PATTERN unixshadowtst-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_test/unix-def:object" priority="1001" mode="M658">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:shadow_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a shadow_test must reference a shadow_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M658"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:shadow_test/unix-def:state" priority="1000" mode="M658">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:shadow_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a shadow_test must reference a shadow_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M658"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M658"/>
   <xsl:template match="@*|node()" priority="-2" mode="M658">
      <xsl:apply-templates select="@*|*" mode="M658"/>
   </xsl:template>

   <!--PATTERN shadowobjusername-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_object/unix-def:username" priority="1000" mode="M659">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a shadow_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M659"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M659"/>
   <xsl:template match="@*|node()" priority="-2" mode="M659">
      <xsl:apply-templates select="@*|*" mode="M659"/>
   </xsl:template>

   <!--PATTERN shadowsteusername-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:username" priority="1000" mode="M660">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the username entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M660"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M660"/>
   <xsl:template match="@*|node()" priority="-2" mode="M660">
      <xsl:apply-templates select="@*|*" mode="M660"/>
   </xsl:template>

   <!--PATTERN shadowstepassword-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:password" priority="1000" mode="M661">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M661"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M661"/>
   <xsl:template match="@*|node()" priority="-2" mode="M661">
      <xsl:apply-templates select="@*|*" mode="M661"/>
   </xsl:template>

   <!--PATTERN shadowstechg_lst-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:chg_lst" priority="1000" mode="M662">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the chg_lst entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M662"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M662"/>
   <xsl:template match="@*|node()" priority="-2" mode="M662">
      <xsl:apply-templates select="@*|*" mode="M662"/>
   </xsl:template>

   <!--PATTERN shadowstechg_allow-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:chg_allow" priority="1000" mode="M663">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the chg_allow entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M663"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M663"/>
   <xsl:template match="@*|node()" priority="-2" mode="M663">
      <xsl:apply-templates select="@*|*" mode="M663"/>
   </xsl:template>

   <!--PATTERN shadowstechg_req-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:chg_req" priority="1000" mode="M664">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the chg_req entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M664"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M664"/>
   <xsl:template match="@*|node()" priority="-2" mode="M664">
      <xsl:apply-templates select="@*|*" mode="M664"/>
   </xsl:template>

   <!--PATTERN shadowsteexp_warn-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:exp_warn" priority="1000" mode="M665">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exp_warn entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M665"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M665"/>
   <xsl:template match="@*|node()" priority="-2" mode="M665">
      <xsl:apply-templates select="@*|*" mode="M665"/>
   </xsl:template>

   <!--PATTERN shadowsteexp_inact-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:exp_inact" priority="1000" mode="M666">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exp_inact entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M666"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M666"/>
   <xsl:template match="@*|node()" priority="-2" mode="M666">
      <xsl:apply-templates select="@*|*" mode="M666"/>
   </xsl:template>

   <!--PATTERN shadowsteexp_date-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:exp_date" priority="1000" mode="M667">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the exp_date entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M667"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M667"/>
   <xsl:template match="@*|node()" priority="-2" mode="M667">
      <xsl:apply-templates select="@*|*" mode="M667"/>
   </xsl:template>

   <!--PATTERN shadowsteflag-->


	<!--RULE -->
<xsl:template match="unix-def:shadow_state/unix-def:flag" priority="1000" mode="M668">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the flag entity of a shadow_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M668"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M668"/>
   <xsl:template match="@*|node()" priority="-2" mode="M668">
      <xsl:apply-templates select="@*|*" mode="M668"/>
   </xsl:template>

   <!--PATTERN unixunametst-->


	<!--RULE -->
<xsl:template match="unix-def:uname_test/unix-def:object" priority="1001" mode="M669">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:uname_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a uname_test must reference a uname_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M669"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:uname_test/unix-def:state" priority="1000" mode="M669">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:uname_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a uname_test must reference a uname_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M669"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M669"/>
   <xsl:template match="@*|node()" priority="-2" mode="M669">
      <xsl:apply-templates select="@*|*" mode="M669"/>
   </xsl:template>

   <!--PATTERN unamestemachine_class-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:machine_class" priority="1000" mode="M670">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the machine_class entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M670"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M670"/>
   <xsl:template match="@*|node()" priority="-2" mode="M670">
      <xsl:apply-templates select="@*|*" mode="M670"/>
   </xsl:template>

   <!--PATTERN unamestenode_name-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:node_name" priority="1000" mode="M671">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the node_name entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M671"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M671"/>
   <xsl:template match="@*|node()" priority="-2" mode="M671">
      <xsl:apply-templates select="@*|*" mode="M671"/>
   </xsl:template>

   <!--PATTERN unamesteos_name-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:os_name" priority="1000" mode="M672">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the os_name entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M672"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M672"/>
   <xsl:template match="@*|node()" priority="-2" mode="M672">
      <xsl:apply-templates select="@*|*" mode="M672"/>
   </xsl:template>

   <!--PATTERN unamesteos_release-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:os_release" priority="1000" mode="M673">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the os_release entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M673"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M673"/>
   <xsl:template match="@*|node()" priority="-2" mode="M673">
      <xsl:apply-templates select="@*|*" mode="M673"/>
   </xsl:template>

   <!--PATTERN unamesteos_version-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:os_version" priority="1000" mode="M674">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the os_version entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M674"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M674"/>
   <xsl:template match="@*|node()" priority="-2" mode="M674">
      <xsl:apply-templates select="@*|*" mode="M674"/>
   </xsl:template>

   <!--PATTERN unamesteprocessor_type-->


	<!--RULE -->
<xsl:template match="unix-def:uname_state/unix-def:processor_type" priority="1000"
                 mode="M675">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the processor_type entity of a uname_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M675"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M675"/>
   <xsl:template match="@*|node()" priority="-2" mode="M675">
      <xsl:apply-templates select="@*|*" mode="M675"/>
   </xsl:template>

   <!--PATTERN unixxinetdtst-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_test/unix-def:object" priority="1001" mode="M676">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/unix-def:xinetd_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a xinetd_test must reference a xinetd_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M676"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="unix-def:xinetd_test/unix-def:state" priority="1000" mode="M676">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/unix-def:xinetd_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a xinetd_test must reference a xinetd_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M676"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M676"/>
   <xsl:template match="@*|node()" priority="-2" mode="M676">
      <xsl:apply-templates select="@*|*" mode="M676"/>
   </xsl:template>

   <!--PATTERN xinetdobjprotocol-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_object/unix-def:protocol" priority="1000" mode="M677">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an xinetd_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M677"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M677"/>
   <xsl:template match="@*|node()" priority="-2" mode="M677">
      <xsl:apply-templates select="@*|*" mode="M677"/>
   </xsl:template>

   <!--PATTERN xinetdobjservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_object/unix-def:service_name" priority="1000"
                 mode="M678">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of an xinetd_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M678"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M678"/>
   <xsl:template match="@*|node()" priority="-2" mode="M678">
      <xsl:apply-templates select="@*|*" mode="M678"/>
   </xsl:template>

   <!--PATTERN xinetdsteprotocol-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:protocol" priority="1000" mode="M679">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M679"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M679"/>
   <xsl:template match="@*|node()" priority="-2" mode="M679">
      <xsl:apply-templates select="@*|*" mode="M679"/>
   </xsl:template>

   <!--PATTERN xinetdsteservice_name-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:service_name" priority="1000" mode="M680">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M680"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M680"/>
   <xsl:template match="@*|node()" priority="-2" mode="M680">
      <xsl:apply-templates select="@*|*" mode="M680"/>
   </xsl:template>

   <!--PATTERN xinetdsteflags-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:flags" priority="1000" mode="M681">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the flags entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M681"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M681"/>
   <xsl:template match="@*|node()" priority="-2" mode="M681">
      <xsl:apply-templates select="@*|*" mode="M681"/>
   </xsl:template>

   <!--PATTERN xinetdstenoaccess-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:no_access" priority="1000" mode="M682">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the no_access entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M682"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M682"/>
   <xsl:template match="@*|node()" priority="-2" mode="M682">
      <xsl:apply-templates select="@*|*" mode="M682"/>
   </xsl:template>

   <!--PATTERN xinetdsteonlyfrom-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:only_from" priority="1000" mode="M683">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the only_from entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M683"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M683"/>
   <xsl:template match="@*|node()" priority="-2" mode="M683">
      <xsl:apply-templates select="@*|*" mode="M683"/>
   </xsl:template>

   <!--PATTERN xinetdsteport-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:port" priority="1000" mode="M684">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the port entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M684"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M684"/>
   <xsl:template match="@*|node()" priority="-2" mode="M684">
      <xsl:apply-templates select="@*|*" mode="M684"/>
   </xsl:template>

   <!--PATTERN xinetdsteserver-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:server" priority="1000" mode="M685">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M685"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M685"/>
   <xsl:template match="@*|node()" priority="-2" mode="M685">
      <xsl:apply-templates select="@*|*" mode="M685"/>
   </xsl:template>

   <!--PATTERN xinetdsteserverarguments-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:server_arguments" priority="1000"
                 mode="M686">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the server_arguments entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M686"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M686"/>
   <xsl:template match="@*|node()" priority="-2" mode="M686">
      <xsl:apply-templates select="@*|*" mode="M686"/>
   </xsl:template>

   <!--PATTERN xinetdstesockettype-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:socket_type" priority="1000" mode="M687">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the socket_type entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M687"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M687"/>
   <xsl:template match="@*|node()" priority="-2" mode="M687">
      <xsl:apply-templates select="@*|*" mode="M687"/>
   </xsl:template>

   <!--PATTERN xinetdstetype-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:type" priority="1000" mode="M688">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M688"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M688"/>
   <xsl:template match="@*|node()" priority="-2" mode="M688">
      <xsl:apply-templates select="@*|*" mode="M688"/>
   </xsl:template>

   <!--PATTERN xinetdsteuser-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:user" priority="1000" mode="M689">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user entity of an xinetd_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M689"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M689"/>
   <xsl:template match="@*|node()" priority="-2" mode="M689">
      <xsl:apply-templates select="@*|*" mode="M689"/>
   </xsl:template>

   <!--PATTERN xinetdstewait-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:wait" priority="1000" mode="M690">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the wait entity of an xinetd_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M690"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M690"/>
   <xsl:template match="@*|node()" priority="-2" mode="M690">
      <xsl:apply-templates select="@*|*" mode="M690"/>
   </xsl:template>

   <!--PATTERN xinetdstedisabled-->


	<!--RULE -->
<xsl:template match="unix-def:xinetd_state/unix-def:disabled" priority="1000" mode="M691">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the disabled entity of an xinetd_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M691"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M691"/>
   <xsl:template match="@*|node()" priority="-2" mode="M691">
      <xsl:apply-templates select="@*|*" mode="M691"/>
   </xsl:template>

   <!--PATTERN affected_platform-->


	<!--RULE -->
<xsl:template match="oval-def:affected[@family='windows']" priority="1000" mode="M692">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(oval-def:platform) or oval-def:platform='Microsoft Windows 95' or oval-def:platform='Microsoft Windows 98' or oval-def:platform='Microsoft Windows ME' or oval-def:platform='Microsoft Windows NT' or oval-def:platform='Microsoft Windows 2000' or oval-def:platform='Microsoft Windows XP' or oval-def:platform='Microsoft Windows Server 2003' or oval-def:platform='Microsoft Windows Vista' or oval-def:platform='Microsoft Windows Server 2008' or oval-def:platform='Microsoft Windows 7'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../../@id"/>
            <xsl:text/> - the value "<xsl:text/>
            <xsl:value-of select="oval-def:platform"/>
            <xsl:text/>" found in platform element as part of the affected element is not a valid windows platform.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M692"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M692"/>
   <xsl:template match="@*|node()" priority="-2" mode="M692">
      <xsl:apply-templates select="@*|*" mode="M692"/>
   </xsl:template>

   <!--PATTERN attst-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_test/win-def:object" priority="1001" mode="M693">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:accesstoken_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an accesstoken_test must reference an accesstoken_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M693"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:accesstoken_test/win-def:state" priority="1000" mode="M693">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:accesstoken_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an accesstoken_test must reference an accesstoken_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M693"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M693"/>
   <xsl:template match="@*|node()" priority="-2" mode="M693">
      <xsl:apply-templates select="@*|*" mode="M693"/>
   </xsl:template>

   <!--PATTERN atobjsecurity_principle-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_object/win-def:security_principle" priority="1000"
                 mode="M694">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the security_principle entity of an accesstoken_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M694"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M694"/>
   <xsl:template match="@*|node()" priority="-2" mode="M694">
      <xsl:apply-templates select="@*|*" mode="M694"/>
   </xsl:template>

   <!--PATTERN atstesecurity_principle-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:security_principle" priority="1000"
                 mode="M695">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the security_principle entity of an accesstoken_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M695"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M695"/>
   <xsl:template match="@*|node()" priority="-2" mode="M695">
      <xsl:apply-templates select="@*|*" mode="M695"/>
   </xsl:template>

   <!--PATTERN atsteseassignprimarytokenprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seassignprimarytokenprivilege"
                 priority="1000"
                 mode="M696">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seassignprimarytokenprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M696"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M696"/>
   <xsl:template match="@*|node()" priority="-2" mode="M696">
      <xsl:apply-templates select="@*|*" mode="M696"/>
   </xsl:template>

   <!--PATTERN atsteseauditprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seauditprivilege" priority="1000"
                 mode="M697">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seauditprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M697"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M697"/>
   <xsl:template match="@*|node()" priority="-2" mode="M697">
      <xsl:apply-templates select="@*|*" mode="M697"/>
   </xsl:template>

   <!--PATTERN atstesebackupprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sebackupprivilege" priority="1000"
                 mode="M698">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sebackupprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M698"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M698"/>
   <xsl:template match="@*|node()" priority="-2" mode="M698">
      <xsl:apply-templates select="@*|*" mode="M698"/>
   </xsl:template>

   <!--PATTERN atstesechangenotifyprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sechangenotifyprivilege"
                 priority="1000"
                 mode="M699">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sechangenotifyprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M699"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M699"/>
   <xsl:template match="@*|node()" priority="-2" mode="M699">
      <xsl:apply-templates select="@*|*" mode="M699"/>
   </xsl:template>

   <!--PATTERN atstesecreateglobalprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:secreateglobalprivilege"
                 priority="1000"
                 mode="M700">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secreateglobalprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M700"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M700"/>
   <xsl:template match="@*|node()" priority="-2" mode="M700">
      <xsl:apply-templates select="@*|*" mode="M700"/>
   </xsl:template>

   <!--PATTERN atstesecreatepagefileprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:secreatepagefileprivilege"
                 priority="1000"
                 mode="M701">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secreatepagefileprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M701"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M701"/>
   <xsl:template match="@*|node()" priority="-2" mode="M701">
      <xsl:apply-templates select="@*|*" mode="M701"/>
   </xsl:template>

   <!--PATTERN atstesecreatepermanentprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:secreatepermanentprivilege"
                 priority="1000"
                 mode="M702">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secreatepermanentprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M702"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M702"/>
   <xsl:template match="@*|node()" priority="-2" mode="M702">
      <xsl:apply-templates select="@*|*" mode="M702"/>
   </xsl:template>

   <!--PATTERN atstesecreatesymboliclinkprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:secreatesymboliclinkprivilege"
                 priority="1000"
                 mode="M703">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secreatesymboliclinkprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M703"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M703"/>
   <xsl:template match="@*|node()" priority="-2" mode="M703">
      <xsl:apply-templates select="@*|*" mode="M703"/>
   </xsl:template>

   <!--PATTERN atstesecreatetokenprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:secreatetokenprivilege"
                 priority="1000"
                 mode="M704">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secreatetokenprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M704"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M704"/>
   <xsl:template match="@*|node()" priority="-2" mode="M704">
      <xsl:apply-templates select="@*|*" mode="M704"/>
   </xsl:template>

   <!--PATTERN atstesedebugprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedebugprivilege" priority="1000"
                 mode="M705">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedebugprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M705"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M705"/>
   <xsl:template match="@*|node()" priority="-2" mode="M705">
      <xsl:apply-templates select="@*|*" mode="M705"/>
   </xsl:template>

   <!--PATTERN atsteseenabledelegationprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seenabledelegationprivilege"
                 priority="1000"
                 mode="M706">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seenabledelegationprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M706"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M706"/>
   <xsl:template match="@*|node()" priority="-2" mode="M706">
      <xsl:apply-templates select="@*|*" mode="M706"/>
   </xsl:template>

   <!--PATTERN atsteseimpersonateprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seimpersonateprivilege"
                 priority="1000"
                 mode="M707">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seimpersonateprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M707"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M707"/>
   <xsl:template match="@*|node()" priority="-2" mode="M707">
      <xsl:apply-templates select="@*|*" mode="M707"/>
   </xsl:template>

   <!--PATTERN atsteseincreasebasepriorityprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seincreasebasepriorityprivilege"
                 priority="1000"
                 mode="M708">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seincreasebasepriorityprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M708"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M708"/>
   <xsl:template match="@*|node()" priority="-2" mode="M708">
      <xsl:apply-templates select="@*|*" mode="M708"/>
   </xsl:template>

   <!--PATTERN atsteseincreasequotaprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seincreasequotaprivilege"
                 priority="1000"
                 mode="M709">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seincreasequotaprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M709"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M709"/>
   <xsl:template match="@*|node()" priority="-2" mode="M709">
      <xsl:apply-templates select="@*|*" mode="M709"/>
   </xsl:template>

   <!--PATTERN atsteseincreaseworkingsetprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seincreaseworkingsetprivilege"
                 priority="1000"
                 mode="M710">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seincreaseworkingsetprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M710"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M710"/>
   <xsl:template match="@*|node()" priority="-2" mode="M710">
      <xsl:apply-templates select="@*|*" mode="M710"/>
   </xsl:template>

   <!--PATTERN atsteseloaddriverprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seloaddriverprivilege" priority="1000"
                 mode="M711">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seloaddriverprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M711"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M711"/>
   <xsl:template match="@*|node()" priority="-2" mode="M711">
      <xsl:apply-templates select="@*|*" mode="M711"/>
   </xsl:template>

   <!--PATTERN atsteselockmemoryprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:selockmemoryprivilege" priority="1000"
                 mode="M712">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the selockmemoryprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M712"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M712"/>
   <xsl:template match="@*|node()" priority="-2" mode="M712">
      <xsl:apply-templates select="@*|*" mode="M712"/>
   </xsl:template>

   <!--PATTERN atstesemachineaccountprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:semachineaccountprivilege"
                 priority="1000"
                 mode="M713">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the semachineaccountprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M713"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M713"/>
   <xsl:template match="@*|node()" priority="-2" mode="M713">
      <xsl:apply-templates select="@*|*" mode="M713"/>
   </xsl:template>

   <!--PATTERN atstesemanagevolumeprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:semanagevolumeprivilege"
                 priority="1000"
                 mode="M714">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the semanagevolumeprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M714"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M714"/>
   <xsl:template match="@*|node()" priority="-2" mode="M714">
      <xsl:apply-templates select="@*|*" mode="M714"/>
   </xsl:template>

   <!--PATTERN atsteseprofilesingleprocessprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seprofilesingleprocessprivilege"
                 priority="1000"
                 mode="M715">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seprofilesingleprocessprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M715"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M715"/>
   <xsl:template match="@*|node()" priority="-2" mode="M715">
      <xsl:apply-templates select="@*|*" mode="M715"/>
   </xsl:template>

   <!--PATTERN atsteserelabelprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:serelabelprivilege" priority="1000"
                 mode="M716">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the serelabelprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M716"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M716"/>
   <xsl:template match="@*|node()" priority="-2" mode="M716">
      <xsl:apply-templates select="@*|*" mode="M716"/>
   </xsl:template>

   <!--PATTERN atsteseremoteshutdownprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seremoteshutdownprivilege"
                 priority="1000"
                 mode="M717">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seremoteshutdownprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M717"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M717"/>
   <xsl:template match="@*|node()" priority="-2" mode="M717">
      <xsl:apply-templates select="@*|*" mode="M717"/>
   </xsl:template>

   <!--PATTERN atsteserestoreprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:serestoreprivilege" priority="1000"
                 mode="M718">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the serestoreprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M718"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M718"/>
   <xsl:template match="@*|node()" priority="-2" mode="M718">
      <xsl:apply-templates select="@*|*" mode="M718"/>
   </xsl:template>

   <!--PATTERN atstesesecurityprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sesecurityprivilege" priority="1000"
                 mode="M719">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sesecurityprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M719"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M719"/>
   <xsl:template match="@*|node()" priority="-2" mode="M719">
      <xsl:apply-templates select="@*|*" mode="M719"/>
   </xsl:template>

   <!--PATTERN atsteseshutdownprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seshutdownprivilege" priority="1000"
                 mode="M720">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seshutdownprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M720"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M720"/>
   <xsl:template match="@*|node()" priority="-2" mode="M720">
      <xsl:apply-templates select="@*|*" mode="M720"/>
   </xsl:template>

   <!--PATTERN atstesesyncagentprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sesyncagentprivilege" priority="1000"
                 mode="M721">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sesyncagentprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M721"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M721"/>
   <xsl:template match="@*|node()" priority="-2" mode="M721">
      <xsl:apply-templates select="@*|*" mode="M721"/>
   </xsl:template>

   <!--PATTERN atstesesystemenvironmentprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sesystemenvironmentprivilege"
                 priority="1000"
                 mode="M722">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sesystemenvironmentprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M722"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M722"/>
   <xsl:template match="@*|node()" priority="-2" mode="M722">
      <xsl:apply-templates select="@*|*" mode="M722"/>
   </xsl:template>

   <!--PATTERN atstesesystemprofileprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sesystemprofileprivilege"
                 priority="1000"
                 mode="M723">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sesystemprofileprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M723"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M723"/>
   <xsl:template match="@*|node()" priority="-2" mode="M723">
      <xsl:apply-templates select="@*|*" mode="M723"/>
   </xsl:template>

   <!--PATTERN atstesesystemtimeprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sesystemtimeprivilege" priority="1000"
                 mode="M724">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sesystemtimeprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M724"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M724"/>
   <xsl:template match="@*|node()" priority="-2" mode="M724">
      <xsl:apply-templates select="@*|*" mode="M724"/>
   </xsl:template>

   <!--PATTERN atstesetakeownershipprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:setakeownershipprivilege"
                 priority="1000"
                 mode="M725">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the setakeownershipprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M725"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M725"/>
   <xsl:template match="@*|node()" priority="-2" mode="M725">
      <xsl:apply-templates select="@*|*" mode="M725"/>
   </xsl:template>

   <!--PATTERN atstesetcbprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:setcbprivilege" priority="1000"
                 mode="M726">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the setcbprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M726"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M726"/>
   <xsl:template match="@*|node()" priority="-2" mode="M726">
      <xsl:apply-templates select="@*|*" mode="M726"/>
   </xsl:template>

   <!--PATTERN atstesetimezoneprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:setimezoneprivilege" priority="1000"
                 mode="M727">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the setimezoneprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M727"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M727"/>
   <xsl:template match="@*|node()" priority="-2" mode="M727">
      <xsl:apply-templates select="@*|*" mode="M727"/>
   </xsl:template>

   <!--PATTERN atsteseundockprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seundockprivilege" priority="1000"
                 mode="M728">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seundockprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M728"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M728"/>
   <xsl:template match="@*|node()" priority="-2" mode="M728">
      <xsl:apply-templates select="@*|*" mode="M728"/>
   </xsl:template>

   <!--PATTERN atsteseunsolicitedinputprivilege-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seunsolicitedinputprivilege"
                 priority="1000"
                 mode="M729">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seunsolicitedinputprivilege entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M729"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M729"/>
   <xsl:template match="@*|node()" priority="-2" mode="M729">
      <xsl:apply-templates select="@*|*" mode="M729"/>
   </xsl:template>

   <!--PATTERN atstesebatchlogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sebatchlogonright" priority="1000"
                 mode="M730">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sebatchlogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M730"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M730"/>
   <xsl:template match="@*|node()" priority="-2" mode="M730">
      <xsl:apply-templates select="@*|*" mode="M730"/>
   </xsl:template>

   <!--PATTERN atsteseinteractivelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seinteractivelogonright"
                 priority="1000"
                 mode="M731">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seinteractivelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M731"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M731"/>
   <xsl:template match="@*|node()" priority="-2" mode="M731">
      <xsl:apply-templates select="@*|*" mode="M731"/>
   </xsl:template>

   <!--PATTERN atstesenetworklogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:senetworklogonright" priority="1000"
                 mode="M732">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the senetworklogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M732"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M732"/>
   <xsl:template match="@*|node()" priority="-2" mode="M732">
      <xsl:apply-templates select="@*|*" mode="M732"/>
   </xsl:template>

   <!--PATTERN atsteseremoteinteractivelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seremoteinteractivelogonright"
                 priority="1000"
                 mode="M733">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seremoteinteractivelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M733"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M733"/>
   <xsl:template match="@*|node()" priority="-2" mode="M733">
      <xsl:apply-templates select="@*|*" mode="M733"/>
   </xsl:template>

   <!--PATTERN atsteseservicelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:seservicelogonright" priority="1000"
                 mode="M734">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the seservicelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M734"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M734"/>
   <xsl:template match="@*|node()" priority="-2" mode="M734">
      <xsl:apply-templates select="@*|*" mode="M734"/>
   </xsl:template>

   <!--PATTERN atstesedenybatchLogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedenybatchLogonright" priority="1000"
                 mode="M735">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedenybatchLogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M735"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M735"/>
   <xsl:template match="@*|node()" priority="-2" mode="M735">
      <xsl:apply-templates select="@*|*" mode="M735"/>
   </xsl:template>

   <!--PATTERN atstesedenyinteractivelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedenyinteractivelogonright"
                 priority="1000"
                 mode="M736">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedenyinteractivelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M736"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M736"/>
   <xsl:template match="@*|node()" priority="-2" mode="M736">
      <xsl:apply-templates select="@*|*" mode="M736"/>
   </xsl:template>

   <!--PATTERN atstesedenynetworklogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedenynetworklogonright"
                 priority="1000"
                 mode="M737">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedenynetworklogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M737"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M737"/>
   <xsl:template match="@*|node()" priority="-2" mode="M737">
      <xsl:apply-templates select="@*|*" mode="M737"/>
   </xsl:template>

   <!--PATTERN atstesedenyremoteInteractivelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedenyremoteInteractivelogonright"
                 priority="1000"
                 mode="M738">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedenyremoteInteractivelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M738"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M738"/>
   <xsl:template match="@*|node()" priority="-2" mode="M738">
      <xsl:apply-templates select="@*|*" mode="M738"/>
   </xsl:template>

   <!--PATTERN atstesedenyservicelogonright-->


	<!--RULE -->
<xsl:template match="win-def:accesstoken_state/win-def:sedenyservicelogonright"
                 priority="1000"
                 mode="M739">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sedenyservicelogonright entity of an accesstoken_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M739"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M739"/>
   <xsl:template match="@*|node()" priority="-2" mode="M739">
      <xsl:apply-templates select="@*|*" mode="M739"/>
   </xsl:template>

   <!--PATTERN at_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:accesstoken_object/win-def:behaviors"
                 priority="1000"
                 mode="M740">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: win-def:accesstoken_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M740"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M740"/>
   <xsl:template match="@*|node()" priority="-2" mode="M740">
      <xsl:apply-templates select="@*|*" mode="M740"/>
   </xsl:template>

   <!--PATTERN adtst-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_test/win-def:object" priority="1001" mode="M741">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:activedirectory_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an activedirectory_test must reference an activedirectory_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M741"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:activedirectory_test/win-def:state" priority="1000" mode="M741">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:activedirectory_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an activedirectory_test must reference an activedirectory_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M741"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M741"/>
   <xsl:template match="@*|node()" priority="-2" mode="M741">
      <xsl:apply-templates select="@*|*" mode="M741"/>
   </xsl:template>

   <!--PATTERN adobjnaming_context-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_object/win-def:naming_context" priority="1000"
                 mode="M742">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the naming_context entity of an activedirectory_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M742"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M742"/>
   <xsl:template match="@*|node()" priority="-2" mode="M742">
      <xsl:apply-templates select="@*|*" mode="M742"/>
   </xsl:template>

   <!--PATTERN adobjrelative_dn-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_object/win-def:relative_dn" priority="1000"
                 mode="M743">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the relative_dn entity of an activedirectory_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M743"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M743"/>
   <xsl:template match="@*|node()" priority="-2" mode="M743">
      <xsl:apply-templates select="@*|*" mode="M743"/>
   </xsl:template>

   <!--PATTERN adobjattribute-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_object/win-def:attribute" priority="1000"
                 mode="M744">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the attribute entity of an activedirectory_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M744"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M744"/>
   <xsl:template match="@*|node()" priority="-2" mode="M744">
      <xsl:apply-templates select="@*|*" mode="M744"/>
   </xsl:template>

   <!--PATTERN adstenaming_context-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:naming_context" priority="1000"
                 mode="M745">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the naming_context entity of an activedirectory_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M745"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M745"/>
   <xsl:template match="@*|node()" priority="-2" mode="M745">
      <xsl:apply-templates select="@*|*" mode="M745"/>
   </xsl:template>

   <!--PATTERN adsterelative_dn-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:relative_dn" priority="1000"
                 mode="M746">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the relative_dn entity of an activedirectory_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M746"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M746"/>
   <xsl:template match="@*|node()" priority="-2" mode="M746">
      <xsl:apply-templates select="@*|*" mode="M746"/>
   </xsl:template>

   <!--PATTERN adsteattribute-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:attribute" priority="1000"
                 mode="M747">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the attribute entity of an activedirectory_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M747"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M747"/>
   <xsl:template match="@*|node()" priority="-2" mode="M747">
      <xsl:apply-templates select="@*|*" mode="M747"/>
   </xsl:template>

   <!--PATTERN adsteobject_class-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:object_class" priority="1000"
                 mode="M748">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the object_class entity of an activedirectory_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M748"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M748"/>
   <xsl:template match="@*|node()" priority="-2" mode="M748">
      <xsl:apply-templates select="@*|*" mode="M748"/>
   </xsl:template>

   <!--PATTERN adsteadstype-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:adstype" priority="1000"
                 mode="M749">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the adstype entity of an activedirectory_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M749"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M749"/>
   <xsl:template match="@*|node()" priority="-2" mode="M749">
      <xsl:apply-templates select="@*|*" mode="M749"/>
   </xsl:template>

   <!--PATTERN adstevalue-->


	<!--RULE -->
<xsl:template match="win-def:activedirectory_state/win-def:value" priority="1000" mode="M750">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M750"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M750"/>
   <xsl:template match="@*|node()" priority="-2" mode="M750">
      <xsl:apply-templates select="@*|*" mode="M750"/>
   </xsl:template>

   <!--PATTERN aeptst-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_test/win-def:object" priority="1001"
                 mode="M751">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:auditeventpolicy_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an auditeventpolicy_test must reference an auditeventpolicy_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M751"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:auditeventpolicy_test/win-def:state" priority="1000" mode="M751">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:auditeventpolicy_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an auditeventpolicy_test must reference an auditeventpolicy_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M751"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M751"/>
   <xsl:template match="@*|node()" priority="-2" mode="M751">
      <xsl:apply-templates select="@*|*" mode="M751"/>
   </xsl:template>

   <!--PATTERN aepsteaccount_logon-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:account_logon" priority="1000"
                 mode="M752">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the account_logon entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M752"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M752"/>
   <xsl:template match="@*|node()" priority="-2" mode="M752">
      <xsl:apply-templates select="@*|*" mode="M752"/>
   </xsl:template>

   <!--PATTERN aepsteaccount_management-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:account_management"
                 priority="1000"
                 mode="M753">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the account_management entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M753"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M753"/>
   <xsl:template match="@*|node()" priority="-2" mode="M753">
      <xsl:apply-templates select="@*|*" mode="M753"/>
   </xsl:template>

   <!--PATTERN aepstedetailed_tracking-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:detailed_tracking"
                 priority="1000"
                 mode="M754">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the detailed_tracking entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M754"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M754"/>
   <xsl:template match="@*|node()" priority="-2" mode="M754">
      <xsl:apply-templates select="@*|*" mode="M754"/>
   </xsl:template>

   <!--PATTERN aepstedirectory_service_access-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:directory_service_access"
                 priority="1000"
                 mode="M755">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_service_access entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M755"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M755"/>
   <xsl:template match="@*|node()" priority="-2" mode="M755">
      <xsl:apply-templates select="@*|*" mode="M755"/>
   </xsl:template>

   <!--PATTERN aepstelogon-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:logon" priority="1000"
                 mode="M756">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the logon entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M756"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M756"/>
   <xsl:template match="@*|node()" priority="-2" mode="M756">
      <xsl:apply-templates select="@*|*" mode="M756"/>
   </xsl:template>

   <!--PATTERN aepsteobject_access-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:object_access" priority="1000"
                 mode="M757">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the object_access entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M757"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M757"/>
   <xsl:template match="@*|node()" priority="-2" mode="M757">
      <xsl:apply-templates select="@*|*" mode="M757"/>
   </xsl:template>

   <!--PATTERN aepstepolicy_change-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:policy_change" priority="1000"
                 mode="M758">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the policy_change entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M758"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M758"/>
   <xsl:template match="@*|node()" priority="-2" mode="M758">
      <xsl:apply-templates select="@*|*" mode="M758"/>
   </xsl:template>

   <!--PATTERN aepsteprivilege_use-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:privilege_use" priority="1000"
                 mode="M759">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the privilege_use entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M759"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M759"/>
   <xsl:template match="@*|node()" priority="-2" mode="M759">
      <xsl:apply-templates select="@*|*" mode="M759"/>
   </xsl:template>

   <!--PATTERN aepstesystem-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicy_state/win-def:system" priority="1000"
                 mode="M760">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the system entity of an auditeventpolicy_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M760"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M760"/>
   <xsl:template match="@*|node()" priority="-2" mode="M760">
      <xsl:apply-templates select="@*|*" mode="M760"/>
   </xsl:template>

   <!--PATTERN aepstst-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_test/win-def:object"
                 priority="1001"
                 mode="M761">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:auditeventpolicysubcategories_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an auditeventpolicysubcategories_test must reference an auditeventpolicysubcategories_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M761"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_test/win-def:state"
                 priority="1000"
                 mode="M761">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:auditeventpolicysubcategories_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an auditeventpolicysubcategories_test must reference an auditeventpolicysubcategories_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M761"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M761"/>
   <xsl:template match="@*|node()" priority="-2" mode="M761">
      <xsl:apply-templates select="@*|*" mode="M761"/>
   </xsl:template>

   <!--PATTERN aepsstecredentialvalidation-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:credential_validation"
                 priority="1000"
                 mode="M762">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the credential_validation entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M762"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M762"/>
   <xsl:template match="@*|node()" priority="-2" mode="M762">
      <xsl:apply-templates select="@*|*" mode="M762"/>
   </xsl:template>

   <!--PATTERN aepsstekerberosticketevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:kerberos_ticket_events"
                 priority="1000"
                 mode="M763">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the kerberos_ticket_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M763"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M763"/>
   <xsl:template match="@*|node()" priority="-2" mode="M763">
      <xsl:apply-templates select="@*|*" mode="M763"/>
   </xsl:template>

   <!--PATTERN aepssteotheraccountlogonevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_account_logon_events"
                 priority="1000"
                 mode="M764">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_account_logon_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M764"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M764"/>
   <xsl:template match="@*|node()" priority="-2" mode="M764">
      <xsl:apply-templates select="@*|*" mode="M764"/>
   </xsl:template>

   <!--PATTERN aepssteapplicationgroupmanagement-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:application_group_management"
                 priority="1000"
                 mode="M765">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the application_group_management entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M765"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M765"/>
   <xsl:template match="@*|node()" priority="-2" mode="M765">
      <xsl:apply-templates select="@*|*" mode="M765"/>
   </xsl:template>

   <!--PATTERN aepsstecomputeraccountmanagement-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:computer_account_management"
                 priority="1000"
                 mode="M766">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the computer_account_management entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M766"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M766"/>
   <xsl:template match="@*|node()" priority="-2" mode="M766">
      <xsl:apply-templates select="@*|*" mode="M766"/>
   </xsl:template>

   <!--PATTERN aepsstedistributiongroupmanagement-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:distribution_group_management"
                 priority="1000"
                 mode="M767">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the distribution_group_management entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M767"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M767"/>
   <xsl:template match="@*|node()" priority="-2" mode="M767">
      <xsl:apply-templates select="@*|*" mode="M767"/>
   </xsl:template>

   <!--PATTERN aepssteotheraccountmanagementevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_account_management_events"
                 priority="1000"
                 mode="M768">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_account_management_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M768"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M768"/>
   <xsl:template match="@*|node()" priority="-2" mode="M768">
      <xsl:apply-templates select="@*|*" mode="M768"/>
   </xsl:template>

   <!--PATTERN aepsstesecuritygroupmanagement-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:security_group_management"
                 priority="1000"
                 mode="M769">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the security_group_management entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M769"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M769"/>
   <xsl:template match="@*|node()" priority="-2" mode="M769">
      <xsl:apply-templates select="@*|*" mode="M769"/>
   </xsl:template>

   <!--PATTERN aepssteuseraccountmanagement-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:user_account_management"
                 priority="1000"
                 mode="M770">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_account_management entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M770"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M770"/>
   <xsl:template match="@*|node()" priority="-2" mode="M770">
      <xsl:apply-templates select="@*|*" mode="M770"/>
   </xsl:template>

   <!--PATTERN aepsstedpapiactivity-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:dpapi_activity"
                 priority="1000"
                 mode="M771">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the dpapi_activity entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M771"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M771"/>
   <xsl:template match="@*|node()" priority="-2" mode="M771">
      <xsl:apply-templates select="@*|*" mode="M771"/>
   </xsl:template>

   <!--PATTERN aepssteprocesscreation-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:process_creation"
                 priority="1000"
                 mode="M772">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the process_creation entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M772"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M772"/>
   <xsl:template match="@*|node()" priority="-2" mode="M772">
      <xsl:apply-templates select="@*|*" mode="M772"/>
   </xsl:template>

   <!--PATTERN aepssteprocesstermination-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:process_termination"
                 priority="1000"
                 mode="M773">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the process_termination entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M773"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M773"/>
   <xsl:template match="@*|node()" priority="-2" mode="M773">
      <xsl:apply-templates select="@*|*" mode="M773"/>
   </xsl:template>

   <!--PATTERN aepssterpcevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:rpc_events"
                 priority="1000"
                 mode="M774">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the rpc_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M774"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M774"/>
   <xsl:template match="@*|node()" priority="-2" mode="M774">
      <xsl:apply-templates select="@*|*" mode="M774"/>
   </xsl:template>

   <!--PATTERN aepsstedirectoryserviceaccess-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:directory_service_access"
                 priority="1000"
                 mode="M775">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_service_access entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M775"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M775"/>
   <xsl:template match="@*|node()" priority="-2" mode="M775">
      <xsl:apply-templates select="@*|*" mode="M775"/>
   </xsl:template>

   <!--PATTERN aepsstedirectoryservicechanges-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:directory_service_changes"
                 priority="1000"
                 mode="M776">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_service_changes entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M776"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M776"/>
   <xsl:template match="@*|node()" priority="-2" mode="M776">
      <xsl:apply-templates select="@*|*" mode="M776"/>
   </xsl:template>

   <!--PATTERN aepsstedirectoryservicereplication-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:directory_service_replication"
                 priority="1000"
                 mode="M777">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the directory_service_replication entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M777"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M777"/>
   <xsl:template match="@*|node()" priority="-2" mode="M777">
      <xsl:apply-templates select="@*|*" mode="M777"/>
   </xsl:template>

   <!--PATTERN aepsstedetaileddirectoryservicereplication-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:detailed_directory_service_replication"
                 priority="1000"
                 mode="M778">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the detailed_directory_service_replication entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M778"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M778"/>
   <xsl:template match="@*|node()" priority="-2" mode="M778">
      <xsl:apply-templates select="@*|*" mode="M778"/>
   </xsl:template>

   <!--PATTERN aepssteaccountlockout-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:account_lockout"
                 priority="1000"
                 mode="M779">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the account_lockout entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M779"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M779"/>
   <xsl:template match="@*|node()" priority="-2" mode="M779">
      <xsl:apply-templates select="@*|*" mode="M779"/>
   </xsl:template>

   <!--PATTERN aepssteipsecextendedmode-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:ipsec_extended_mode"
                 priority="1000"
                 mode="M780">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ipsec_extended_mode entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M780"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M780"/>
   <xsl:template match="@*|node()" priority="-2" mode="M780">
      <xsl:apply-templates select="@*|*" mode="M780"/>
   </xsl:template>

   <!--PATTERN aepssteipsecmainmode-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:ipsec_main_mode"
                 priority="1000"
                 mode="M781">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ipsec_main_mode entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M781"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M781"/>
   <xsl:template match="@*|node()" priority="-2" mode="M781">
      <xsl:apply-templates select="@*|*" mode="M781"/>
   </xsl:template>

   <!--PATTERN aepssteipsec_quick_mode-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:ipsec_quick_mode"
                 priority="1000"
                 mode="M782">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ipsec_quick_mode entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M782"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M782"/>
   <xsl:template match="@*|node()" priority="-2" mode="M782">
      <xsl:apply-templates select="@*|*" mode="M782"/>
   </xsl:template>

   <!--PATTERN aepsstelogoff-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:logoff"
                 priority="1000"
                 mode="M783">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the logoff entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M783"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M783"/>
   <xsl:template match="@*|node()" priority="-2" mode="M783">
      <xsl:apply-templates select="@*|*" mode="M783"/>
   </xsl:template>

   <!--PATTERN aepsstelogon-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:logon"
                 priority="1000"
                 mode="M784">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the logon entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M784"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M784"/>
   <xsl:template match="@*|node()" priority="-2" mode="M784">
      <xsl:apply-templates select="@*|*" mode="M784"/>
   </xsl:template>

   <!--PATTERN aepssteotherlogonlogoffevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_logon_logoff_events"
                 priority="1000"
                 mode="M785">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_logon_logoff_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M785"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M785"/>
   <xsl:template match="@*|node()" priority="-2" mode="M785">
      <xsl:apply-templates select="@*|*" mode="M785"/>
   </xsl:template>

   <!--PATTERN aepsstespeciallogon-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:special_logon"
                 priority="1000"
                 mode="M786">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the special_logon entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M786"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M786"/>
   <xsl:template match="@*|node()" priority="-2" mode="M786">
      <xsl:apply-templates select="@*|*" mode="M786"/>
   </xsl:template>

   <!--PATTERN aepssteapplicationgenerated-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:application_generated"
                 priority="1000"
                 mode="M787">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the application_generated entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M787"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M787"/>
   <xsl:template match="@*|node()" priority="-2" mode="M787">
      <xsl:apply-templates select="@*|*" mode="M787"/>
   </xsl:template>

   <!--PATTERN aepsstecertificationservices-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:certification_services"
                 priority="1000"
                 mode="M788">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the certification_services entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M788"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M788"/>
   <xsl:template match="@*|node()" priority="-2" mode="M788">
      <xsl:apply-templates select="@*|*" mode="M788"/>
   </xsl:template>

   <!--PATTERN aepsstefileshare-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:file_share"
                 priority="1000"
                 mode="M789">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_share entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M789"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M789"/>
   <xsl:template match="@*|node()" priority="-2" mode="M789">
      <xsl:apply-templates select="@*|*" mode="M789"/>
   </xsl:template>

   <!--PATTERN aepsstefilesystem-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:file_system"
                 priority="1000"
                 mode="M790">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_system entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M790"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M790"/>
   <xsl:template match="@*|node()" priority="-2" mode="M790">
      <xsl:apply-templates select="@*|*" mode="M790"/>
   </xsl:template>

   <!--PATTERN aepsstefilteringplatformconnection-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:filtering_platform_connection"
                 priority="1000"
                 mode="M791">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filtering_platform_connection entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M791"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M791"/>
   <xsl:template match="@*|node()" priority="-2" mode="M791">
      <xsl:apply-templates select="@*|*" mode="M791"/>
   </xsl:template>

   <!--PATTERN aepsstefilteringplatformpacketdrop-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:filtering_platform_packet_drop"
                 priority="1000"
                 mode="M792">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filtering_platform_packet_drop entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M792"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M792"/>
   <xsl:template match="@*|node()" priority="-2" mode="M792">
      <xsl:apply-templates select="@*|*" mode="M792"/>
   </xsl:template>

   <!--PATTERN aepsstehandlemanipulation-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:handle_manipulation"
                 priority="1000"
                 mode="M793">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the handle_manipulation entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M793"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M793"/>
   <xsl:template match="@*|node()" priority="-2" mode="M793">
      <xsl:apply-templates select="@*|*" mode="M793"/>
   </xsl:template>

   <!--PATTERN aepsstekernelobject-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:kernel_object"
                 priority="1000"
                 mode="M794">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the kernel_object entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M794"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M794"/>
   <xsl:template match="@*|node()" priority="-2" mode="M794">
      <xsl:apply-templates select="@*|*" mode="M794"/>
   </xsl:template>

   <!--PATTERN aepssteotherobjectaccessevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_object_access_events"
                 priority="1000"
                 mode="M795">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_object_access_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M795"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M795"/>
   <xsl:template match="@*|node()" priority="-2" mode="M795">
      <xsl:apply-templates select="@*|*" mode="M795"/>
   </xsl:template>

   <!--PATTERN aepssteregistry-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:registry"
                 priority="1000"
                 mode="M796">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the registry entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M796"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M796"/>
   <xsl:template match="@*|node()" priority="-2" mode="M796">
      <xsl:apply-templates select="@*|*" mode="M796"/>
   </xsl:template>

   <!--PATTERN aepsstesam-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:sam" priority="1000"
                 mode="M797">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sam entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M797"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M797"/>
   <xsl:template match="@*|node()" priority="-2" mode="M797">
      <xsl:apply-templates select="@*|*" mode="M797"/>
   </xsl:template>

   <!--PATTERN aepssteauditpolicychange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:audit_policy_change"
                 priority="1000"
                 mode="M798">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the audit_policy_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M798"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M798"/>
   <xsl:template match="@*|node()" priority="-2" mode="M798">
      <xsl:apply-templates select="@*|*" mode="M798"/>
   </xsl:template>

   <!--PATTERN aepssteauthenticationpolicychange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:authentication_policy_change"
                 priority="1000"
                 mode="M799">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the authentication_policy_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M799"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M799"/>
   <xsl:template match="@*|node()" priority="-2" mode="M799">
      <xsl:apply-templates select="@*|*" mode="M799"/>
   </xsl:template>

   <!--PATTERN aepssteauthorizationpolicychange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:authorization_policy_change"
                 priority="1000"
                 mode="M800">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the authorization_policy_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M800"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M800"/>
   <xsl:template match="@*|node()" priority="-2" mode="M800">
      <xsl:apply-templates select="@*|*" mode="M800"/>
   </xsl:template>

   <!--PATTERN aepsstefilteringplatformpolicychange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:filtering_platform_policy_change"
                 priority="1000"
                 mode="M801">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filtering_platform_policy_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M801"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M801"/>
   <xsl:template match="@*|node()" priority="-2" mode="M801">
      <xsl:apply-templates select="@*|*" mode="M801"/>
   </xsl:template>

   <!--PATTERN aepsstempssvcrulelevelpolicychange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:mpssvc_rule_level_policy_change"
                 priority="1000"
                 mode="M802">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the mpssvc_rule_level_policy_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M802"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M802"/>
   <xsl:template match="@*|node()" priority="-2" mode="M802">
      <xsl:apply-templates select="@*|*" mode="M802"/>
   </xsl:template>

   <!--PATTERN aepssteotherpolicychangeevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_policy_change_events"
                 priority="1000"
                 mode="M803">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_policy_change_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M803"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M803"/>
   <xsl:template match="@*|node()" priority="-2" mode="M803">
      <xsl:apply-templates select="@*|*" mode="M803"/>
   </xsl:template>

   <!--PATTERN aepsstenonsensitiveprivilegeuse-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:non_sensitive_privilege_use"
                 priority="1000"
                 mode="M804">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the non_sensitive_privilege_use entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M804"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M804"/>
   <xsl:template match="@*|node()" priority="-2" mode="M804">
      <xsl:apply-templates select="@*|*" mode="M804"/>
   </xsl:template>

   <!--PATTERN aepssteotherprivilegeuseevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_privilege_use_events"
                 priority="1000"
                 mode="M805">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_privilege_use_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M805"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M805"/>
   <xsl:template match="@*|node()" priority="-2" mode="M805">
      <xsl:apply-templates select="@*|*" mode="M805"/>
   </xsl:template>

   <!--PATTERN aepsstesensitive_privilege_use-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:sensitive_privilege_use"
                 priority="1000"
                 mode="M806">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the sensitive_privilege_use entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M806"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M806"/>
   <xsl:template match="@*|node()" priority="-2" mode="M806">
      <xsl:apply-templates select="@*|*" mode="M806"/>
   </xsl:template>

   <!--PATTERN aepssteipsecdriver-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:ipsec_driver"
                 priority="1000"
                 mode="M807">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ipsec_driver entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M807"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M807"/>
   <xsl:template match="@*|node()" priority="-2" mode="M807">
      <xsl:apply-templates select="@*|*" mode="M807"/>
   </xsl:template>

   <!--PATTERN aepssteothersystemevents-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:other_system_events"
                 priority="1000"
                 mode="M808">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the other_system_events entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M808"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M808"/>
   <xsl:template match="@*|node()" priority="-2" mode="M808">
      <xsl:apply-templates select="@*|*" mode="M808"/>
   </xsl:template>

   <!--PATTERN aepsstesecuritystatechange-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:security_state_change"
                 priority="1000"
                 mode="M809">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the security_state_change entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M809"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M809"/>
   <xsl:template match="@*|node()" priority="-2" mode="M809">
      <xsl:apply-templates select="@*|*" mode="M809"/>
   </xsl:template>

   <!--PATTERN aepsstesecuritysystemextension-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:security_system_extension"
                 priority="1000"
                 mode="M810">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the security_system_extension entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M810"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M810"/>
   <xsl:template match="@*|node()" priority="-2" mode="M810">
      <xsl:apply-templates select="@*|*" mode="M810"/>
   </xsl:template>

   <!--PATTERN aepsstesystemintegrity-->


	<!--RULE -->
<xsl:template match="win-def:auditeventpolicysubcategories_state/win-def:system_integrity"
                 priority="1000"
                 mode="M811">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the system_integrity entity of an auditeventpolicysubcategories_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M811"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M811"/>
   <xsl:template match="@*|node()" priority="-2" mode="M811">
      <xsl:apply-templates select="@*|*" mode="M811"/>
   </xsl:template>

   <!--PATTERN filetst-->


	<!--RULE -->
<xsl:template match="win-def:file_test/win-def:object" priority="1001" mode="M812">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:file_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a file_test must reference a file_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M812"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:file_test/win-def:state" priority="1000" mode="M812">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:file_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a file_test must reference a file_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M812"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M812"/>
   <xsl:template match="@*|node()" priority="-2" mode="M812">
      <xsl:apply-templates select="@*|*" mode="M812"/>
   </xsl:template>

   <!--PATTERN fileobjfilepath-->


	<!--RULE -->
<xsl:template match="win-def:file_object/win-def:filepath" priority="1000" mode="M813">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M813"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M813"/>
   <xsl:template match="@*|node()" priority="-2" mode="M813">
      <xsl:apply-templates select="@*|*" mode="M813"/>
   </xsl:template>

   <!--PATTERN fileobjpath-->


	<!--RULE -->
<xsl:template match="win-def:file_object/win-def:path" priority="1000" mode="M814">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M814"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M814"/>
   <xsl:template match="@*|node()" priority="-2" mode="M814">
      <xsl:apply-templates select="@*|*" mode="M814"/>
   </xsl:template>

   <!--PATTERN fileobjfilename-->


	<!--RULE -->
<xsl:template match="win-def:file_object/win-def:filename" priority="1000" mode="M815">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a file_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M815"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M815"/>
   <xsl:template match="@*|node()" priority="-2" mode="M815">
      <xsl:apply-templates select="@*|*" mode="M815"/>
   </xsl:template>

   <!--PATTERN filestefilepath-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:filepath" priority="1000" mode="M816">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M816"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M816"/>
   <xsl:template match="@*|node()" priority="-2" mode="M816">
      <xsl:apply-templates select="@*|*" mode="M816"/>
   </xsl:template>

   <!--PATTERN filestepath-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:path" priority="1000" mode="M817">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M817"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M817"/>
   <xsl:template match="@*|node()" priority="-2" mode="M817">
      <xsl:apply-templates select="@*|*" mode="M817"/>
   </xsl:template>

   <!--PATTERN filestefilename-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:filename" priority="1000" mode="M818">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M818"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M818"/>
   <xsl:template match="@*|node()" priority="-2" mode="M818">
      <xsl:apply-templates select="@*|*" mode="M818"/>
   </xsl:template>

   <!--PATTERN filesteowner-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:owner" priority="1000" mode="M819">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the owner entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M819"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M819"/>
   <xsl:template match="@*|node()" priority="-2" mode="M819">
      <xsl:apply-templates select="@*|*" mode="M819"/>
   </xsl:template>

   <!--PATTERN filestesize-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:size" priority="1000" mode="M820">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the size entity of a file_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M820"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M820"/>
   <xsl:template match="@*|node()" priority="-2" mode="M820">
      <xsl:apply-templates select="@*|*" mode="M820"/>
   </xsl:template>

   <!--PATTERN filestea_time-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:a_time" priority="1000" mode="M821">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the a_time entity of a file_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M821"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M821"/>
   <xsl:template match="@*|node()" priority="-2" mode="M821">
      <xsl:apply-templates select="@*|*" mode="M821"/>
   </xsl:template>

   <!--PATTERN filestec_time-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:c_time" priority="1000" mode="M822">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the c_time entity of a file_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M822"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M822"/>
   <xsl:template match="@*|node()" priority="-2" mode="M822">
      <xsl:apply-templates select="@*|*" mode="M822"/>
   </xsl:template>

   <!--PATTERN filestem_time-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:m_time" priority="1000" mode="M823">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the m_time entity of a file_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M823"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M823"/>
   <xsl:template match="@*|node()" priority="-2" mode="M823">
      <xsl:apply-templates select="@*|*" mode="M823"/>
   </xsl:template>

   <!--PATTERN filestems_checksum-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:ms_checksum" priority="1000" mode="M824">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ms_checksum entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M824"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M824"/>
   <xsl:template match="@*|node()" priority="-2" mode="M824">
      <xsl:apply-templates select="@*|*" mode="M824"/>
   </xsl:template>

   <!--PATTERN filesteversion-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:version" priority="1000" mode="M825">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the version entity of a file_state should be 'version'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M825"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M825"/>
   <xsl:template match="@*|node()" priority="-2" mode="M825">
      <xsl:apply-templates select="@*|*" mode="M825"/>
   </xsl:template>

   <!--PATTERN filestetype-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:type" priority="1000" mode="M826">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M826"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M826"/>
   <xsl:template match="@*|node()" priority="-2" mode="M826">
      <xsl:apply-templates select="@*|*" mode="M826"/>
   </xsl:template>

   <!--PATTERN filestedevelopment_class-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:development_class" priority="1000"
                 mode="M827">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the development_class entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M827"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M827"/>
   <xsl:template match="@*|node()" priority="-2" mode="M827">
      <xsl:apply-templates select="@*|*" mode="M827"/>
   </xsl:template>

   <!--PATTERN filestecompany-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:company" priority="1000" mode="M828">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the company entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M828"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M828"/>
   <xsl:template match="@*|node()" priority="-2" mode="M828">
      <xsl:apply-templates select="@*|*" mode="M828"/>
   </xsl:template>

   <!--PATTERN filesteinternalname-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:internal_name" priority="1000" mode="M829">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the internal_name entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M829"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M829"/>
   <xsl:template match="@*|node()" priority="-2" mode="M829">
      <xsl:apply-templates select="@*|*" mode="M829"/>
   </xsl:template>

   <!--PATTERN filestelanguage-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:language" priority="1000" mode="M830">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the language entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M830"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M830"/>
   <xsl:template match="@*|node()" priority="-2" mode="M830">
      <xsl:apply-templates select="@*|*" mode="M830"/>
   </xsl:template>

   <!--PATTERN filesteoriginalfilename-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:original_filename" priority="1000"
                 mode="M831">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the original_filename entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M831"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M831"/>
   <xsl:template match="@*|node()" priority="-2" mode="M831">
      <xsl:apply-templates select="@*|*" mode="M831"/>
   </xsl:template>

   <!--PATTERN filesteproductname-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:product_name" priority="1000" mode="M832">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the product_name entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M832"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M832"/>
   <xsl:template match="@*|node()" priority="-2" mode="M832">
      <xsl:apply-templates select="@*|*" mode="M832"/>
   </xsl:template>

   <!--PATTERN filesteproductversion-->


	<!--RULE -->
<xsl:template match="win-def:file_state/win-def:product_version" priority="1000" mode="M833">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='version'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the product_version entity of a file_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M833"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M833"/>
   <xsl:template match="@*|node()" priority="-2" mode="M833">
      <xsl:apply-templates select="@*|*" mode="M833"/>
   </xsl:template>

   <!--PATTERN fap53tst-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_test/win-def:object" priority="1001"
                 mode="M834">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:fileauditedpermissions53_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fileauditedpermissions53_test must reference a fileauditedpermissions53_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M834"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_test/win-def:state" priority="1000"
                 mode="M834">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:fileauditedpermissions53_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fileauditedpermissions53_test must reference a fileauditedpermissions53_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M834"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M834"/>
   <xsl:template match="@*|node()" priority="-2" mode="M834">
      <xsl:apply-templates select="@*|*" mode="M834"/>
   </xsl:template>

   <!--PATTERN fap53objfilepath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_object/win-def:filepath"
                 priority="1000"
                 mode="M835">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a fileauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M835"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M835"/>
   <xsl:template match="@*|node()" priority="-2" mode="M835">
      <xsl:apply-templates select="@*|*" mode="M835"/>
   </xsl:template>

   <!--PATTERN fap53objpath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_object/win-def:path" priority="1000"
                 mode="M836">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M836"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M836"/>
   <xsl:template match="@*|node()" priority="-2" mode="M836">
      <xsl:apply-templates select="@*|*" mode="M836"/>
   </xsl:template>

   <!--PATTERN fap53objfilename-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_object/win-def:filename"
                 priority="1000"
                 mode="M837">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M837"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M837"/>
   <xsl:template match="@*|node()" priority="-2" mode="M837">
      <xsl:apply-templates select="@*|*" mode="M837"/>
   </xsl:template>

   <!--PATTERN fap53objtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M838">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a fileauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M838"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M838"/>
   <xsl:template match="@*|node()" priority="-2" mode="M838">
      <xsl:apply-templates select="@*|*" mode="M838"/>
   </xsl:template>

   <!--PATTERN fap53stefilepath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:filepath" priority="1000"
                 mode="M839">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M839"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M839"/>
   <xsl:template match="@*|node()" priority="-2" mode="M839">
      <xsl:apply-templates select="@*|*" mode="M839"/>
   </xsl:template>

   <!--PATTERN fap53stepath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:path" priority="1000"
                 mode="M840">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M840"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M840"/>
   <xsl:template match="@*|node()" priority="-2" mode="M840">
      <xsl:apply-templates select="@*|*" mode="M840"/>
   </xsl:template>

   <!--PATTERN fap53stefilename-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:filename" priority="1000"
                 mode="M841">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M841"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M841"/>
   <xsl:template match="@*|node()" priority="-2" mode="M841">
      <xsl:apply-templates select="@*|*" mode="M841"/>
   </xsl:template>

   <!--PATTERN fap53stetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:trustee_sid"
                 priority="1000"
                 mode="M842">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M842"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M842"/>
   <xsl:template match="@*|node()" priority="-2" mode="M842">
      <xsl:apply-templates select="@*|*" mode="M842"/>
   </xsl:template>

   <!--PATTERN fap53stestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:standard_delete"
                 priority="1000"
                 mode="M843">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M843"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M843"/>
   <xsl:template match="@*|node()" priority="-2" mode="M843">
      <xsl:apply-templates select="@*|*" mode="M843"/>
   </xsl:template>

   <!--PATTERN fap53stestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M844">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M844"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M844"/>
   <xsl:template match="@*|node()" priority="-2" mode="M844">
      <xsl:apply-templates select="@*|*" mode="M844"/>
   </xsl:template>

   <!--PATTERN fap53stestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M845">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M845"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M845"/>
   <xsl:template match="@*|node()" priority="-2" mode="M845">
      <xsl:apply-templates select="@*|*" mode="M845"/>
   </xsl:template>

   <!--PATTERN fap53stestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M846">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M846"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M846"/>
   <xsl:template match="@*|node()" priority="-2" mode="M846">
      <xsl:apply-templates select="@*|*" mode="M846"/>
   </xsl:template>

   <!--PATTERN fap53stestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M847">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M847"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M847"/>
   <xsl:template match="@*|node()" priority="-2" mode="M847">
      <xsl:apply-templates select="@*|*" mode="M847"/>
   </xsl:template>

   <!--PATTERN fap53steaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:access_system_security"
                 priority="1000"
                 mode="M848">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M848"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M848"/>
   <xsl:template match="@*|node()" priority="-2" mode="M848">
      <xsl:apply-templates select="@*|*" mode="M848"/>
   </xsl:template>

   <!--PATTERN fap53stegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:generic_read"
                 priority="1000"
                 mode="M849">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M849"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M849"/>
   <xsl:template match="@*|node()" priority="-2" mode="M849">
      <xsl:apply-templates select="@*|*" mode="M849"/>
   </xsl:template>

   <!--PATTERN fap53stegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:generic_write"
                 priority="1000"
                 mode="M850">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M850"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M850"/>
   <xsl:template match="@*|node()" priority="-2" mode="M850">
      <xsl:apply-templates select="@*|*" mode="M850"/>
   </xsl:template>

   <!--PATTERN fap53stegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:generic_execute"
                 priority="1000"
                 mode="M851">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M851"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M851"/>
   <xsl:template match="@*|node()" priority="-2" mode="M851">
      <xsl:apply-templates select="@*|*" mode="M851"/>
   </xsl:template>

   <!--PATTERN fap53stegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:generic_all"
                 priority="1000"
                 mode="M852">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M852"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M852"/>
   <xsl:template match="@*|node()" priority="-2" mode="M852">
      <xsl:apply-templates select="@*|*" mode="M852"/>
   </xsl:template>

   <!--PATTERN fap53stefile_read_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_read_data"
                 priority="1000"
                 mode="M853">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_data entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M853"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M853"/>
   <xsl:template match="@*|node()" priority="-2" mode="M853">
      <xsl:apply-templates select="@*|*" mode="M853"/>
   </xsl:template>

   <!--PATTERN fap53stefile_write_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_write_data"
                 priority="1000"
                 mode="M854">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_data entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M854"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M854"/>
   <xsl:template match="@*|node()" priority="-2" mode="M854">
      <xsl:apply-templates select="@*|*" mode="M854"/>
   </xsl:template>

   <!--PATTERN fap53stefile_append_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_append_data"
                 priority="1000"
                 mode="M855">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_append_data entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M855"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M855"/>
   <xsl:template match="@*|node()" priority="-2" mode="M855">
      <xsl:apply-templates select="@*|*" mode="M855"/>
   </xsl:template>

   <!--PATTERN fap53stefile_read_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_read_ea"
                 priority="1000"
                 mode="M856">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_ea entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M856"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M856"/>
   <xsl:template match="@*|node()" priority="-2" mode="M856">
      <xsl:apply-templates select="@*|*" mode="M856"/>
   </xsl:template>

   <!--PATTERN fap53stefile_write_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_write_ea"
                 priority="1000"
                 mode="M857">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_ea entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M857"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M857"/>
   <xsl:template match="@*|node()" priority="-2" mode="M857">
      <xsl:apply-templates select="@*|*" mode="M857"/>
   </xsl:template>

   <!--PATTERN fap53stefile_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_execute"
                 priority="1000"
                 mode="M858">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_execute entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M858"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M858"/>
   <xsl:template match="@*|node()" priority="-2" mode="M858">
      <xsl:apply-templates select="@*|*" mode="M858"/>
   </xsl:template>

   <!--PATTERN fap53stefile_delete_child-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_delete_child"
                 priority="1000"
                 mode="M859">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_delete_child entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M859"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M859"/>
   <xsl:template match="@*|node()" priority="-2" mode="M859">
      <xsl:apply-templates select="@*|*" mode="M859"/>
   </xsl:template>

   <!--PATTERN fap53stefile_read_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_read_attributes"
                 priority="1000"
                 mode="M860">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_attributes entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M860"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M860"/>
   <xsl:template match="@*|node()" priority="-2" mode="M860">
      <xsl:apply-templates select="@*|*" mode="M860"/>
   </xsl:template>

   <!--PATTERN fap53stefile_write_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions53_state/win-def:file_write_attributes"
                 priority="1000"
                 mode="M861">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_attributes entity of a fileauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M861"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M861"/>
   <xsl:template match="@*|node()" priority="-2" mode="M861">
      <xsl:apply-templates select="@*|*" mode="M861"/>
   </xsl:template>

   <!--PATTERN fap53_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:fileauditedpermissions53_object/win-def:behaviors"
                 priority="1000"
                 mode="M862">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: fileauditedpermissions53_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M862"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M862"/>
   <xsl:template match="@*|node()" priority="-2" mode="M862">
      <xsl:apply-templates select="@*|*" mode="M862"/>
   </xsl:template>

   <!--PATTERN faptst_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_test" priority="1000" mode="M863">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M863"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M863"/>
   <xsl:template match="@*|node()" priority="-2" mode="M863">
      <xsl:apply-templates select="@*|*" mode="M863"/>
   </xsl:template>

   <!--PATTERN faptst-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_test/win-def:object" priority="1001"
                 mode="M864">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:fileauditedpermissions_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fileauditedpermissions_test must reference a fileauditedpermissions_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M864"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_test/win-def:state" priority="1000"
                 mode="M864">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:fileauditedpermissions_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fileauditedpermissions_test must reference a fileauditedpermissions_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M864"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M864"/>
   <xsl:template match="@*|node()" priority="-2" mode="M864">
      <xsl:apply-templates select="@*|*" mode="M864"/>
   </xsl:template>

   <!--PATTERN fapobj_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_object" priority="1000" mode="M865">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M865"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M865"/>
   <xsl:template match="@*|node()" priority="-2" mode="M865">
      <xsl:apply-templates select="@*|*" mode="M865"/>
   </xsl:template>

   <!--PATTERN fapobjpath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_object/win-def:path" priority="1000"
                 mode="M866">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M866"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M866"/>
   <xsl:template match="@*|node()" priority="-2" mode="M866">
      <xsl:apply-templates select="@*|*" mode="M866"/>
   </xsl:template>

   <!--PATTERN fapobjfilename-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_object/win-def:filename" priority="1000"
                 mode="M867">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M867"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M867"/>
   <xsl:template match="@*|node()" priority="-2" mode="M867">
      <xsl:apply-templates select="@*|*" mode="M867"/>
   </xsl:template>

   <!--PATTERN fapobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_object/win-def:trustee_name"
                 priority="1000"
                 mode="M868">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a fileauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M868"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M868"/>
   <xsl:template match="@*|node()" priority="-2" mode="M868">
      <xsl:apply-templates select="@*|*" mode="M868"/>
   </xsl:template>

   <!--PATTERN fapste_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state" priority="1000" mode="M869">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M869"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M869"/>
   <xsl:template match="@*|node()" priority="-2" mode="M869">
      <xsl:apply-templates select="@*|*" mode="M869"/>
   </xsl:template>

   <!--PATTERN fapstepath-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:path" priority="1000"
                 mode="M870">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M870"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M870"/>
   <xsl:template match="@*|node()" priority="-2" mode="M870">
      <xsl:apply-templates select="@*|*" mode="M870"/>
   </xsl:template>

   <!--PATTERN fapstefilename-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:filename" priority="1000"
                 mode="M871">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M871"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M871"/>
   <xsl:template match="@*|node()" priority="-2" mode="M871">
      <xsl:apply-templates select="@*|*" mode="M871"/>
   </xsl:template>

   <!--PATTERN fapstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:trustee_name"
                 priority="1000"
                 mode="M872">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M872"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M872"/>
   <xsl:template match="@*|node()" priority="-2" mode="M872">
      <xsl:apply-templates select="@*|*" mode="M872"/>
   </xsl:template>

   <!--PATTERN fapstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:standard_delete"
                 priority="1000"
                 mode="M873">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M873"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M873"/>
   <xsl:template match="@*|node()" priority="-2" mode="M873">
      <xsl:apply-templates select="@*|*" mode="M873"/>
   </xsl:template>

   <!--PATTERN fapstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M874">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M874"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M874"/>
   <xsl:template match="@*|node()" priority="-2" mode="M874">
      <xsl:apply-templates select="@*|*" mode="M874"/>
   </xsl:template>

   <!--PATTERN fapstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M875">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M875"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M875"/>
   <xsl:template match="@*|node()" priority="-2" mode="M875">
      <xsl:apply-templates select="@*|*" mode="M875"/>
   </xsl:template>

   <!--PATTERN fapstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M876">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M876"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M876"/>
   <xsl:template match="@*|node()" priority="-2" mode="M876">
      <xsl:apply-templates select="@*|*" mode="M876"/>
   </xsl:template>

   <!--PATTERN fapstestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M877">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M877"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M877"/>
   <xsl:template match="@*|node()" priority="-2" mode="M877">
      <xsl:apply-templates select="@*|*" mode="M877"/>
   </xsl:template>

   <!--PATTERN fapsteaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:access_system_security"
                 priority="1000"
                 mode="M878">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M878"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M878"/>
   <xsl:template match="@*|node()" priority="-2" mode="M878">
      <xsl:apply-templates select="@*|*" mode="M878"/>
   </xsl:template>

   <!--PATTERN fapstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:generic_read"
                 priority="1000"
                 mode="M879">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M879"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M879"/>
   <xsl:template match="@*|node()" priority="-2" mode="M879">
      <xsl:apply-templates select="@*|*" mode="M879"/>
   </xsl:template>

   <!--PATTERN fapstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:generic_write"
                 priority="1000"
                 mode="M880">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M880"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M880"/>
   <xsl:template match="@*|node()" priority="-2" mode="M880">
      <xsl:apply-templates select="@*|*" mode="M880"/>
   </xsl:template>

   <!--PATTERN fapstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:generic_execute"
                 priority="1000"
                 mode="M881">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M881"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M881"/>
   <xsl:template match="@*|node()" priority="-2" mode="M881">
      <xsl:apply-templates select="@*|*" mode="M881"/>
   </xsl:template>

   <!--PATTERN fapstegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:generic_all"
                 priority="1000"
                 mode="M882">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M882"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M882"/>
   <xsl:template match="@*|node()" priority="-2" mode="M882">
      <xsl:apply-templates select="@*|*" mode="M882"/>
   </xsl:template>

   <!--PATTERN fapstefile_read_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_read_data"
                 priority="1000"
                 mode="M883">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_data entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M883"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M883"/>
   <xsl:template match="@*|node()" priority="-2" mode="M883">
      <xsl:apply-templates select="@*|*" mode="M883"/>
   </xsl:template>

   <!--PATTERN fapstefile_write_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_write_data"
                 priority="1000"
                 mode="M884">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_data entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M884"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M884"/>
   <xsl:template match="@*|node()" priority="-2" mode="M884">
      <xsl:apply-templates select="@*|*" mode="M884"/>
   </xsl:template>

   <!--PATTERN fapstefile_append_data-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_append_data"
                 priority="1000"
                 mode="M885">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_append_data entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M885"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M885"/>
   <xsl:template match="@*|node()" priority="-2" mode="M885">
      <xsl:apply-templates select="@*|*" mode="M885"/>
   </xsl:template>

   <!--PATTERN fapstefile_read_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_read_ea"
                 priority="1000"
                 mode="M886">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_ea entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M886"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M886"/>
   <xsl:template match="@*|node()" priority="-2" mode="M886">
      <xsl:apply-templates select="@*|*" mode="M886"/>
   </xsl:template>

   <!--PATTERN fapstefile_write_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_write_ea"
                 priority="1000"
                 mode="M887">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_ea entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M887"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M887"/>
   <xsl:template match="@*|node()" priority="-2" mode="M887">
      <xsl:apply-templates select="@*|*" mode="M887"/>
   </xsl:template>

   <!--PATTERN fapstefile_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_execute"
                 priority="1000"
                 mode="M888">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_execute entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M888"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M888"/>
   <xsl:template match="@*|node()" priority="-2" mode="M888">
      <xsl:apply-templates select="@*|*" mode="M888"/>
   </xsl:template>

   <!--PATTERN fapstefile_delete_child-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_delete_child"
                 priority="1000"
                 mode="M889">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_delete_child entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M889"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M889"/>
   <xsl:template match="@*|node()" priority="-2" mode="M889">
      <xsl:apply-templates select="@*|*" mode="M889"/>
   </xsl:template>

   <!--PATTERN fapstefile_read_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_read_attributes"
                 priority="1000"
                 mode="M890">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_attributes entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M890"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M890"/>
   <xsl:template match="@*|node()" priority="-2" mode="M890">
      <xsl:apply-templates select="@*|*" mode="M890"/>
   </xsl:template>

   <!--PATTERN fapstefile_write_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileauditedpermissions_state/win-def:file_write_attributes"
                 priority="1000"
                 mode="M891">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_attributes entity of a fileauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M891"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M891"/>
   <xsl:template match="@*|node()" priority="-2" mode="M891">
      <xsl:apply-templates select="@*|*" mode="M891"/>
   </xsl:template>

   <!--PATTERN fap_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:fileauditedpermissions_object/win-def:behaviors"
                 priority="1000"
                 mode="M892">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: fileauditedpermissions_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M892"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M892"/>
   <xsl:template match="@*|node()" priority="-2" mode="M892">
      <xsl:apply-templates select="@*|*" mode="M892"/>
   </xsl:template>

   <!--PATTERN fer53tst-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_test/win-def:object" priority="1001"
                 mode="M893">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:fileeffectiverights53_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fileeffectiverights53_test must reference a fileeffectiverights53_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M893"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_test/win-def:state" priority="1000"
                 mode="M893">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:fileeffectiverights53_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fileeffectiverights53_test must reference a fileeffectiverights53_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M893"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M893"/>
   <xsl:template match="@*|node()" priority="-2" mode="M893">
      <xsl:apply-templates select="@*|*" mode="M893"/>
   </xsl:template>

   <!--PATTERN fer53objfilepath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_object/win-def:filepath" priority="1000"
                 mode="M894">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a fileeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M894"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M894"/>
   <xsl:template match="@*|node()" priority="-2" mode="M894">
      <xsl:apply-templates select="@*|*" mode="M894"/>
   </xsl:template>

   <!--PATTERN fer53objpath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_object/win-def:path" priority="1000"
                 mode="M895">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M895"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M895"/>
   <xsl:template match="@*|node()" priority="-2" mode="M895">
      <xsl:apply-templates select="@*|*" mode="M895"/>
   </xsl:template>

   <!--PATTERN fer53objfilename-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_object/win-def:filename" priority="1000"
                 mode="M896">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M896"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M896"/>
   <xsl:template match="@*|node()" priority="-2" mode="M896">
      <xsl:apply-templates select="@*|*" mode="M896"/>
   </xsl:template>

   <!--PATTERN fer53objtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M897">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a fileeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M897"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M897"/>
   <xsl:template match="@*|node()" priority="-2" mode="M897">
      <xsl:apply-templates select="@*|*" mode="M897"/>
   </xsl:template>

   <!--PATTERN fer53stefilepath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:filepath" priority="1000"
                 mode="M898">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filepath entity of a fileeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M898"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M898"/>
   <xsl:template match="@*|node()" priority="-2" mode="M898">
      <xsl:apply-templates select="@*|*" mode="M898"/>
   </xsl:template>

   <!--PATTERN fer53stepath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:path" priority="1000"
                 mode="M899">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M899"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M899"/>
   <xsl:template match="@*|node()" priority="-2" mode="M899">
      <xsl:apply-templates select="@*|*" mode="M899"/>
   </xsl:template>

   <!--PATTERN fer53stefilename-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:filename" priority="1000"
                 mode="M900">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M900"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M900"/>
   <xsl:template match="@*|node()" priority="-2" mode="M900">
      <xsl:apply-templates select="@*|*" mode="M900"/>
   </xsl:template>

   <!--PATTERN fer53stetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:trustee_sid" priority="1000"
                 mode="M901">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a fileeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M901"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M901"/>
   <xsl:template match="@*|node()" priority="-2" mode="M901">
      <xsl:apply-templates select="@*|*" mode="M901"/>
   </xsl:template>

   <!--PATTERN fer53stestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:standard_delete"
                 priority="1000"
                 mode="M902">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M902"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M902"/>
   <xsl:template match="@*|node()" priority="-2" mode="M902">
      <xsl:apply-templates select="@*|*" mode="M902"/>
   </xsl:template>

   <!--PATTERN fer53stestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M903">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M903"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M903"/>
   <xsl:template match="@*|node()" priority="-2" mode="M903">
      <xsl:apply-templates select="@*|*" mode="M903"/>
   </xsl:template>

   <!--PATTERN fer53stestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M904">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M904"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M904"/>
   <xsl:template match="@*|node()" priority="-2" mode="M904">
      <xsl:apply-templates select="@*|*" mode="M904"/>
   </xsl:template>

   <!--PATTERN fer53stestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M905">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M905"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M905"/>
   <xsl:template match="@*|node()" priority="-2" mode="M905">
      <xsl:apply-templates select="@*|*" mode="M905"/>
   </xsl:template>

   <!--PATTERN fer53stestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M906">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M906"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M906"/>
   <xsl:template match="@*|node()" priority="-2" mode="M906">
      <xsl:apply-templates select="@*|*" mode="M906"/>
   </xsl:template>

   <!--PATTERN fer53steaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:access_system_security"
                 priority="1000"
                 mode="M907">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M907"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M907"/>
   <xsl:template match="@*|node()" priority="-2" mode="M907">
      <xsl:apply-templates select="@*|*" mode="M907"/>
   </xsl:template>

   <!--PATTERN fer53stegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:generic_read"
                 priority="1000"
                 mode="M908">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M908"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M908"/>
   <xsl:template match="@*|node()" priority="-2" mode="M908">
      <xsl:apply-templates select="@*|*" mode="M908"/>
   </xsl:template>

   <!--PATTERN fer53stegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:generic_write"
                 priority="1000"
                 mode="M909">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M909"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M909"/>
   <xsl:template match="@*|node()" priority="-2" mode="M909">
      <xsl:apply-templates select="@*|*" mode="M909"/>
   </xsl:template>

   <!--PATTERN fer53stegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:generic_execute"
                 priority="1000"
                 mode="M910">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M910"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M910"/>
   <xsl:template match="@*|node()" priority="-2" mode="M910">
      <xsl:apply-templates select="@*|*" mode="M910"/>
   </xsl:template>

   <!--PATTERN fer53stegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:generic_all" priority="1000"
                 mode="M911">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M911"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M911"/>
   <xsl:template match="@*|node()" priority="-2" mode="M911">
      <xsl:apply-templates select="@*|*" mode="M911"/>
   </xsl:template>

   <!--PATTERN fer53stefile_read_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_read_data"
                 priority="1000"
                 mode="M912">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_data entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M912"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M912"/>
   <xsl:template match="@*|node()" priority="-2" mode="M912">
      <xsl:apply-templates select="@*|*" mode="M912"/>
   </xsl:template>

   <!--PATTERN fer53stefile_write_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_write_data"
                 priority="1000"
                 mode="M913">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_data entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M913"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M913"/>
   <xsl:template match="@*|node()" priority="-2" mode="M913">
      <xsl:apply-templates select="@*|*" mode="M913"/>
   </xsl:template>

   <!--PATTERN fer53stefile_append_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_append_data"
                 priority="1000"
                 mode="M914">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_append_data entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M914"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M914"/>
   <xsl:template match="@*|node()" priority="-2" mode="M914">
      <xsl:apply-templates select="@*|*" mode="M914"/>
   </xsl:template>

   <!--PATTERN fer53stefile_read_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_read_ea"
                 priority="1000"
                 mode="M915">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_ea entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M915"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M915"/>
   <xsl:template match="@*|node()" priority="-2" mode="M915">
      <xsl:apply-templates select="@*|*" mode="M915"/>
   </xsl:template>

   <!--PATTERN fer53stefile_write_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_write_ea"
                 priority="1000"
                 mode="M916">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_ea entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M916"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M916"/>
   <xsl:template match="@*|node()" priority="-2" mode="M916">
      <xsl:apply-templates select="@*|*" mode="M916"/>
   </xsl:template>

   <!--PATTERN fer53stefile_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_execute"
                 priority="1000"
                 mode="M917">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_execute entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M917"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M917"/>
   <xsl:template match="@*|node()" priority="-2" mode="M917">
      <xsl:apply-templates select="@*|*" mode="M917"/>
   </xsl:template>

   <!--PATTERN fer53stefile_delete_child-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_delete_child"
                 priority="1000"
                 mode="M918">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_delete_child entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M918"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M918"/>
   <xsl:template match="@*|node()" priority="-2" mode="M918">
      <xsl:apply-templates select="@*|*" mode="M918"/>
   </xsl:template>

   <!--PATTERN fer53stefile_read_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_read_attributes"
                 priority="1000"
                 mode="M919">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_attributes entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M919"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M919"/>
   <xsl:template match="@*|node()" priority="-2" mode="M919">
      <xsl:apply-templates select="@*|*" mode="M919"/>
   </xsl:template>

   <!--PATTERN fer53stefile_write_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights53_state/win-def:file_write_attributes"
                 priority="1000"
                 mode="M920">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_attributes entity of a fileeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M920"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M920"/>
   <xsl:template match="@*|node()" priority="-2" mode="M920">
      <xsl:apply-templates select="@*|*" mode="M920"/>
   </xsl:template>

   <!--PATTERN ffr53_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:fileeffectiverights53_object/win-def:behaviors"
                 priority="1000"
                 mode="M921">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: fileeffectiverights53_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M921"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M921"/>
   <xsl:template match="@*|node()" priority="-2" mode="M921">
      <xsl:apply-templates select="@*|*" mode="M921"/>
   </xsl:template>

   <!--PATTERN fertst_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_test" priority="1000" mode="M922">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M922"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M922"/>
   <xsl:template match="@*|node()" priority="-2" mode="M922">
      <xsl:apply-templates select="@*|*" mode="M922"/>
   </xsl:template>

   <!--PATTERN fertst-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_test/win-def:object" priority="1001"
                 mode="M923">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:fileeffectiverights_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a fileeffectiverights_test must reference a fileeffectiverights_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M923"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:fileeffectiverights_test/win-def:state" priority="1000"
                 mode="M923">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:fileeffectiverights_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a fileeffectiverights_test must reference a fileeffectiverights_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M923"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M923"/>
   <xsl:template match="@*|node()" priority="-2" mode="M923">
      <xsl:apply-templates select="@*|*" mode="M923"/>
   </xsl:template>

   <!--PATTERN ferobj_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_object" priority="1000" mode="M924">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M924"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M924"/>
   <xsl:template match="@*|node()" priority="-2" mode="M924">
      <xsl:apply-templates select="@*|*" mode="M924"/>
   </xsl:template>

   <!--PATTERN fefobjpath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_object/win-def:path" priority="1000"
                 mode="M925">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M925"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M925"/>
   <xsl:template match="@*|node()" priority="-2" mode="M925">
      <xsl:apply-templates select="@*|*" mode="M925"/>
   </xsl:template>

   <!--PATTERN fefobjfilename-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_object/win-def:filename" priority="1000"
                 mode="M926">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M926"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M926"/>
   <xsl:template match="@*|node()" priority="-2" mode="M926">
      <xsl:apply-templates select="@*|*" mode="M926"/>
   </xsl:template>

   <!--PATTERN fefobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_object/win-def:trustee_name" priority="1000"
                 mode="M927">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a fileeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M927"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M927"/>
   <xsl:template match="@*|node()" priority="-2" mode="M927">
      <xsl:apply-templates select="@*|*" mode="M927"/>
   </xsl:template>

   <!--PATTERN ferste_dep-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state" priority="1000" mode="M928">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M928"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M928"/>
   <xsl:template match="@*|node()" priority="-2" mode="M928">
      <xsl:apply-templates select="@*|*" mode="M928"/>
   </xsl:template>

   <!--PATTERN ferstepath-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:path" priority="1000"
                 mode="M929">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the path entity of a fileeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M929"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M929"/>
   <xsl:template match="@*|node()" priority="-2" mode="M929">
      <xsl:apply-templates select="@*|*" mode="M929"/>
   </xsl:template>

   <!--PATTERN ferstefilename-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:filename" priority="1000"
                 mode="M930">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the filename entity of a fileeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="(not(contains(.,'\') or contains(.,'/') or contains(.,':') or contains(.,'*') or contains(.,'?') or contains(.,'&gt;') or contains(.,'|'))) or (@operation='pattern match')"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - filename entity can not contain the characters / \ : * ? &gt; | <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M930"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M930"/>
   <xsl:template match="@*|node()" priority="-2" mode="M930">
      <xsl:apply-templates select="@*|*" mode="M930"/>
   </xsl:template>

   <!--PATTERN ferstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:trustee_name" priority="1000"
                 mode="M931">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a fileeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M931"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M931"/>
   <xsl:template match="@*|node()" priority="-2" mode="M931">
      <xsl:apply-templates select="@*|*" mode="M931"/>
   </xsl:template>

   <!--PATTERN ferstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:standard_delete"
                 priority="1000"
                 mode="M932">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M932"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M932"/>
   <xsl:template match="@*|node()" priority="-2" mode="M932">
      <xsl:apply-templates select="@*|*" mode="M932"/>
   </xsl:template>

   <!--PATTERN ferstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M933">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M933"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M933"/>
   <xsl:template match="@*|node()" priority="-2" mode="M933">
      <xsl:apply-templates select="@*|*" mode="M933"/>
   </xsl:template>

   <!--PATTERN ferstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M934">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M934"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M934"/>
   <xsl:template match="@*|node()" priority="-2" mode="M934">
      <xsl:apply-templates select="@*|*" mode="M934"/>
   </xsl:template>

   <!--PATTERN ferstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M935">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M935"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M935"/>
   <xsl:template match="@*|node()" priority="-2" mode="M935">
      <xsl:apply-templates select="@*|*" mode="M935"/>
   </xsl:template>

   <!--PATTERN ferstestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M936">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M936"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M936"/>
   <xsl:template match="@*|node()" priority="-2" mode="M936">
      <xsl:apply-templates select="@*|*" mode="M936"/>
   </xsl:template>

   <!--PATTERN fersteaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:access_system_security"
                 priority="1000"
                 mode="M937">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M937"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M937"/>
   <xsl:template match="@*|node()" priority="-2" mode="M937">
      <xsl:apply-templates select="@*|*" mode="M937"/>
   </xsl:template>

   <!--PATTERN ferstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:generic_read" priority="1000"
                 mode="M938">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M938"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M938"/>
   <xsl:template match="@*|node()" priority="-2" mode="M938">
      <xsl:apply-templates select="@*|*" mode="M938"/>
   </xsl:template>

   <!--PATTERN ferstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:generic_write" priority="1000"
                 mode="M939">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M939"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M939"/>
   <xsl:template match="@*|node()" priority="-2" mode="M939">
      <xsl:apply-templates select="@*|*" mode="M939"/>
   </xsl:template>

   <!--PATTERN ferstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:generic_execute"
                 priority="1000"
                 mode="M940">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M940"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M940"/>
   <xsl:template match="@*|node()" priority="-2" mode="M940">
      <xsl:apply-templates select="@*|*" mode="M940"/>
   </xsl:template>

   <!--PATTERN ferstegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:generic_all" priority="1000"
                 mode="M941">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M941"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M941"/>
   <xsl:template match="@*|node()" priority="-2" mode="M941">
      <xsl:apply-templates select="@*|*" mode="M941"/>
   </xsl:template>

   <!--PATTERN ferstefile_read_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_read_data"
                 priority="1000"
                 mode="M942">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_data entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M942"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M942"/>
   <xsl:template match="@*|node()" priority="-2" mode="M942">
      <xsl:apply-templates select="@*|*" mode="M942"/>
   </xsl:template>

   <!--PATTERN ferstefile_write_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_write_data"
                 priority="1000"
                 mode="M943">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_data entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M943"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M943"/>
   <xsl:template match="@*|node()" priority="-2" mode="M943">
      <xsl:apply-templates select="@*|*" mode="M943"/>
   </xsl:template>

   <!--PATTERN ferstefile_append_data-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_append_data"
                 priority="1000"
                 mode="M944">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_append_data entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M944"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M944"/>
   <xsl:template match="@*|node()" priority="-2" mode="M944">
      <xsl:apply-templates select="@*|*" mode="M944"/>
   </xsl:template>

   <!--PATTERN ferstefile_read_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_read_ea" priority="1000"
                 mode="M945">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_ea entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M945"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M945"/>
   <xsl:template match="@*|node()" priority="-2" mode="M945">
      <xsl:apply-templates select="@*|*" mode="M945"/>
   </xsl:template>

   <!--PATTERN ferstefile_write_ea-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_write_ea" priority="1000"
                 mode="M946">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_ea entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M946"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M946"/>
   <xsl:template match="@*|node()" priority="-2" mode="M946">
      <xsl:apply-templates select="@*|*" mode="M946"/>
   </xsl:template>

   <!--PATTERN ferstefile_execute-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_execute" priority="1000"
                 mode="M947">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_execute entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M947"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M947"/>
   <xsl:template match="@*|node()" priority="-2" mode="M947">
      <xsl:apply-templates select="@*|*" mode="M947"/>
   </xsl:template>

   <!--PATTERN ferstefile_delete_child-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_delete_child"
                 priority="1000"
                 mode="M948">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_delete_child entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M948"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M948"/>
   <xsl:template match="@*|node()" priority="-2" mode="M948">
      <xsl:apply-templates select="@*|*" mode="M948"/>
   </xsl:template>

   <!--PATTERN ferstefile_read_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_read_attributes"
                 priority="1000"
                 mode="M949">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_attributes entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M949"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M949"/>
   <xsl:template match="@*|node()" priority="-2" mode="M949">
      <xsl:apply-templates select="@*|*" mode="M949"/>
   </xsl:template>

   <!--PATTERN ferstefile_write_attributes-->


	<!--RULE -->
<xsl:template match="win-def:fileeffectiverights_state/win-def:file_write_attributes"
                 priority="1000"
                 mode="M950">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_write_attributes entity of a fileeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M950"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M950"/>
   <xsl:template match="@*|node()" priority="-2" mode="M950">
      <xsl:apply-templates select="@*|*" mode="M950"/>
   </xsl:template>

   <!--PATTERN ffr_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:fileeffectiverights_object/win-def:behaviors"
                 priority="1000"
                 mode="M951">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: fileeffectiverights_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M951"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M951"/>
   <xsl:template match="@*|node()" priority="-2" mode="M951">
      <xsl:apply-templates select="@*|*" mode="M951"/>
   </xsl:template>

   <!--PATTERN grouptst-->


	<!--RULE -->
<xsl:template match="win-def:group_test/win-def:object" priority="1001" mode="M952">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:group_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a group_test must reference a group_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M952"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:group_test/win-def:state" priority="1000" mode="M952">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:group_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a group_test must reference a group_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M952"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M952"/>
   <xsl:template match="@*|node()" priority="-2" mode="M952">
      <xsl:apply-templates select="@*|*" mode="M952"/>
   </xsl:template>

   <!--PATTERN groupobjgroup-->


	<!--RULE -->
<xsl:template match="win-def:group_object/win-def:group" priority="1000" mode="M953">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group entity of a group_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M953"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M953"/>
   <xsl:template match="@*|node()" priority="-2" mode="M953">
      <xsl:apply-templates select="@*|*" mode="M953"/>
   </xsl:template>

   <!--PATTERN groupstegroup-->


	<!--RULE -->
<xsl:template match="win-def:group_state/win-def:group" priority="1000" mode="M954">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group entity of a group_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M954"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M954"/>
   <xsl:template match="@*|node()" priority="-2" mode="M954">
      <xsl:apply-templates select="@*|*" mode="M954"/>
   </xsl:template>

   <!--PATTERN groupsteuser-->


	<!--RULE -->
<xsl:template match="win-def:group_state/win-def:user" priority="1000" mode="M955">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user entity of a group_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M955"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M955"/>
   <xsl:template match="@*|node()" priority="-2" mode="M955">
      <xsl:apply-templates select="@*|*" mode="M955"/>
   </xsl:template>

   <!--PATTERN groupsidtst-->


	<!--RULE -->
<xsl:template match="win-def:group_sid_test/win-def:object" priority="1001" mode="M956">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:group_sid_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a group_sid_test must reference a group_sid_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M956"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:group_sid_test/win-def:state" priority="1000" mode="M956">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:group_sid_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a group_sid_test must reference a group_sid_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M956"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M956"/>
   <xsl:template match="@*|node()" priority="-2" mode="M956">
      <xsl:apply-templates select="@*|*" mode="M956"/>
   </xsl:template>

   <!--PATTERN groupsidobjgroup-->


	<!--RULE -->
<xsl:template match="win-def:group_sid_object/win-def:group_sid" priority="1000" mode="M957">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_sid entity of a group_sid_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M957"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M957"/>
   <xsl:template match="@*|node()" priority="-2" mode="M957">
      <xsl:apply-templates select="@*|*" mode="M957"/>
   </xsl:template>

   <!--PATTERN groupsidstegroup-->


	<!--RULE -->
<xsl:template match="win-def:group_sid_state/win-def:group_sid" priority="1000" mode="M958">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_sid entity of a group_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M958"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M958"/>
   <xsl:template match="@*|node()" priority="-2" mode="M958">
      <xsl:apply-templates select="@*|*" mode="M958"/>
   </xsl:template>

   <!--PATTERN groupsidsteuser-->


	<!--RULE -->
<xsl:template match="win-def:group_sid_state/win-def:user_sid" priority="1000" mode="M959">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_sid entity of a group_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M959"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M959"/>
   <xsl:template match="@*|node()" priority="-2" mode="M959">
      <xsl:apply-templates select="@*|*" mode="M959"/>
   </xsl:template>

   <!--PATTERN wininterfacetst-->


	<!--RULE -->
<xsl:template match="win-def:interface_test/win-def:object" priority="1001" mode="M960">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:interface_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of an interface_test must reference an interface_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M960"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:interface_test/win-def:state" priority="1000" mode="M960">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:interface_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of an interface_test must reference an interface_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M960"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M960"/>
   <xsl:template match="@*|node()" priority="-2" mode="M960">
      <xsl:apply-templates select="@*|*" mode="M960"/>
   </xsl:template>

   <!--PATTERN wininterfaceobjname-->


	<!--RULE -->
<xsl:template match="win-def:interface_object/win-def:name" priority="1000" mode="M961">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a interface_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M961"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M961"/>
   <xsl:template match="@*|node()" priority="-2" mode="M961">
      <xsl:apply-templates select="@*|*" mode="M961"/>
   </xsl:template>

   <!--PATTERN wininterfacestename-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:name" priority="1000" mode="M962">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M962"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M962"/>
   <xsl:template match="@*|node()" priority="-2" mode="M962">
      <xsl:apply-templates select="@*|*" mode="M962"/>
   </xsl:template>

   <!--PATTERN wininterfacesteindex-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:index" priority="1000" mode="M963">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the index entity of an interface_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M963"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M963"/>
   <xsl:template match="@*|node()" priority="-2" mode="M963">
      <xsl:apply-templates select="@*|*" mode="M963"/>
   </xsl:template>

   <!--PATTERN wininterfacestetype-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:type" priority="1000" mode="M964">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M964"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M964"/>
   <xsl:template match="@*|node()" priority="-2" mode="M964">
      <xsl:apply-templates select="@*|*" mode="M964"/>
   </xsl:template>

   <!--PATTERN wininterfacestehardware_addr-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:hardware_addr" priority="1000"
                 mode="M965">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hardware_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M965"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M965"/>
   <xsl:template match="@*|node()" priority="-2" mode="M965">
      <xsl:apply-templates select="@*|*" mode="M965"/>
   </xsl:template>

   <!--PATTERN wininterfacesteinet_addr-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:inet_addr" priority="1000" mode="M966">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the inet_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M966"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M966"/>
   <xsl:template match="@*|node()" priority="-2" mode="M966">
      <xsl:apply-templates select="@*|*" mode="M966"/>
   </xsl:template>

   <!--PATTERN wininterfacestebroadcast_addr-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:broadcast_addr" priority="1000"
                 mode="M967">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the broadcast_addr entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M967"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M967"/>
   <xsl:template match="@*|node()" priority="-2" mode="M967">
      <xsl:apply-templates select="@*|*" mode="M967"/>
   </xsl:template>

   <!--PATTERN wininterfacestenetmask-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:netmask" priority="1000" mode="M968">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the netmask entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M968"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M968"/>
   <xsl:template match="@*|node()" priority="-2" mode="M968">
      <xsl:apply-templates select="@*|*" mode="M968"/>
   </xsl:template>

   <!--PATTERN wininterfacesteaddr_type-->


	<!--RULE -->
<xsl:template match="win-def:interface_state/win-def:addr_type" priority="1000" mode="M969">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the addr_type entity of an interface_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M969"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M969"/>
   <xsl:template match="@*|node()" priority="-2" mode="M969">
      <xsl:apply-templates select="@*|*" mode="M969"/>
   </xsl:template>

   <!--PATTERN lptst-->


	<!--RULE -->
<xsl:template match="win-def:lockoutpolicy_test/win-def:object" priority="1001" mode="M970">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:lockoutpolicy_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a lockoutpolicy_test must reference a lockoutpolicy_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M970"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:lockoutpolicy_test/win-def:state" priority="1000" mode="M970">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:lockoutpolicy_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a lockoutpolicy_test must reference a lockoutpolicy_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M970"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M970"/>
   <xsl:template match="@*|node()" priority="-2" mode="M970">
      <xsl:apply-templates select="@*|*" mode="M970"/>
   </xsl:template>

   <!--PATTERN lpsteforce_logoff-->


	<!--RULE -->
<xsl:template match="win-def:lockoutpolicy_state/win-def:force_logoff" priority="1000"
                 mode="M971">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the force_logoff entity of a lockoutpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M971"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M971"/>
   <xsl:template match="@*|node()" priority="-2" mode="M971">
      <xsl:apply-templates select="@*|*" mode="M971"/>
   </xsl:template>

   <!--PATTERN lpstelockout_duration-->


	<!--RULE -->
<xsl:template match="win-def:lockoutpolicy_state/win-def:lockout_duration" priority="1000"
                 mode="M972">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the lockout_duration entity of a lockoutpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M972"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M972"/>
   <xsl:template match="@*|node()" priority="-2" mode="M972">
      <xsl:apply-templates select="@*|*" mode="M972"/>
   </xsl:template>

   <!--PATTERN lpstelockout_observation_window-->


	<!--RULE -->
<xsl:template match="win-def:lockoutpolicy_state/win-def:lockout_observation_window"
                 priority="1000"
                 mode="M973">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the lockout_observation_window entity of a lockoutpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M973"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M973"/>
   <xsl:template match="@*|node()" priority="-2" mode="M973">
      <xsl:apply-templates select="@*|*" mode="M973"/>
   </xsl:template>

   <!--PATTERN lpstelockout_threshold-->


	<!--RULE -->
<xsl:template match="win-def:lockoutpolicy_state/win-def:lockout_threshold" priority="1000"
                 mode="M974">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the lockout_threshold entity of a lockoutpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M974"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M974"/>
   <xsl:template match="@*|node()" priority="-2" mode="M974">
      <xsl:apply-templates select="@*|*" mode="M974"/>
   </xsl:template>

   <!--PATTERN metabasetst-->


	<!--RULE -->
<xsl:template match="win-def:metabase_test/win-def:object" priority="1001" mode="M975">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:metabase_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a metabase_test must reference a metabase_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M975"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:metabase_test/win-def:state" priority="1000" mode="M975">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:metabase_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a metabase_test must reference a metabase_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M975"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M975"/>
   <xsl:template match="@*|node()" priority="-2" mode="M975">
      <xsl:apply-templates select="@*|*" mode="M975"/>
   </xsl:template>

   <!--PATTERN metabaseobjkey-->


	<!--RULE -->
<xsl:template match="win-def:metabase_object/win-def:key" priority="1000" mode="M976">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a metabase_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M976"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M976"/>
   <xsl:template match="@*|node()" priority="-2" mode="M976">
      <xsl:apply-templates select="@*|*" mode="M976"/>
   </xsl:template>

   <!--PATTERN metabaseobjid-->


	<!--RULE -->
<xsl:template match="win-def:metabase_object/win-def:id" priority="1000" mode="M977">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the id entity of a metabase_object should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M977"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M977"/>
   <xsl:template match="@*|node()" priority="-2" mode="M977">
      <xsl:apply-templates select="@*|*" mode="M977"/>
   </xsl:template>

   <!--PATTERN metabasestekey-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:key" priority="1000" mode="M978">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a metabase_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M978"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M978"/>
   <xsl:template match="@*|node()" priority="-2" mode="M978">
      <xsl:apply-templates select="@*|*" mode="M978"/>
   </xsl:template>

   <!--PATTERN metabasesteid-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:id" priority="1000" mode="M979">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the id entity of a metabase_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M979"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M979"/>
   <xsl:template match="@*|node()" priority="-2" mode="M979">
      <xsl:apply-templates select="@*|*" mode="M979"/>
   </xsl:template>

   <!--PATTERN metabasestename-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:name" priority="1000" mode="M980">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a metabase_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M980"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M980"/>
   <xsl:template match="@*|node()" priority="-2" mode="M980">
      <xsl:apply-templates select="@*|*" mode="M980"/>
   </xsl:template>

   <!--PATTERN metabasesteuser_type-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:user_type" priority="1000" mode="M981">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_type entity of a metabase_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M981"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M981"/>
   <xsl:template match="@*|node()" priority="-2" mode="M981">
      <xsl:apply-templates select="@*|*" mode="M981"/>
   </xsl:template>

   <!--PATTERN metabasestedata_type-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:data_type" priority="1000" mode="M982">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the data_type entity of a metabase_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M982"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M982"/>
   <xsl:template match="@*|node()" priority="-2" mode="M982">
      <xsl:apply-templates select="@*|*" mode="M982"/>
   </xsl:template>

   <!--PATTERN metabasestedata-->


	<!--RULE -->
<xsl:template match="win-def:metabase_state/win-def:data" priority="1000" mode="M983">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M983"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M983"/>
   <xsl:template match="@*|node()" priority="-2" mode="M983">
      <xsl:apply-templates select="@*|*" mode="M983"/>
   </xsl:template>

   <!--PATTERN pptst-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_test/win-def:object" priority="1001" mode="M984">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:passwordpolicy_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a passwordpolicy_test must reference a passwordpolicy_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M984"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:passwordpolicy_test/win-def:state" priority="1000" mode="M984">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:passwordpolicy_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a passwordpolicy_test must reference a passwordpolicy_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M984"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M984"/>
   <xsl:template match="@*|node()" priority="-2" mode="M984">
      <xsl:apply-templates select="@*|*" mode="M984"/>
   </xsl:template>

   <!--PATTERN ppstemax_passwd_age-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:max_passwd_age" priority="1000"
                 mode="M985">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the max_passwd_age entity of a passwordpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M985"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M985"/>
   <xsl:template match="@*|node()" priority="-2" mode="M985">
      <xsl:apply-templates select="@*|*" mode="M985"/>
   </xsl:template>

   <!--PATTERN ppstemin_passwd_age-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:min_passwd_age" priority="1000"
                 mode="M986">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the min_passwd_age entity of a passwordpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M986"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M986"/>
   <xsl:template match="@*|node()" priority="-2" mode="M986">
      <xsl:apply-templates select="@*|*" mode="M986"/>
   </xsl:template>

   <!--PATTERN ppstemin_passwd_len-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:min_passwd_len" priority="1000"
                 mode="M987">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the min_passwd_len entity of a passwordpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M987"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M987"/>
   <xsl:template match="@*|node()" priority="-2" mode="M987">
      <xsl:apply-templates select="@*|*" mode="M987"/>
   </xsl:template>

   <!--PATTERN ppstepassword_hist_len-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:password_hist_len" priority="1000"
                 mode="M988">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password_hist_len entity of a passwordpolicy_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M988"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M988"/>
   <xsl:template match="@*|node()" priority="-2" mode="M988">
      <xsl:apply-templates select="@*|*" mode="M988"/>
   </xsl:template>

   <!--PATTERN ppstepassword_complexity-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:password_complexity"
                 priority="1000"
                 mode="M989">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the password_complexity entity of an passwordpolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M989"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M989"/>
   <xsl:template match="@*|node()" priority="-2" mode="M989">
      <xsl:apply-templates select="@*|*" mode="M989"/>
   </xsl:template>

   <!--PATTERN ppstereversible_encryption-->


	<!--RULE -->
<xsl:template match="win-def:passwordpolicy_state/win-def:reversible_encryption"
                 priority="1000"
                 mode="M990">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the reversible_encryption entity of an passwordpolicy_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M990"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M990"/>
   <xsl:template match="@*|node()" priority="-2" mode="M990">
      <xsl:apply-templates select="@*|*" mode="M990"/>
   </xsl:template>

   <!--PATTERN winporttst-->


	<!--RULE -->
<xsl:template match="win-def:port_test/win-def:object" priority="1001" mode="M991">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:port_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a port_test must reference a port_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M991"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:port_test/win-def:state" priority="1000" mode="M991">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:port_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a port_test must reference a port_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M991"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M991"/>
   <xsl:template match="@*|node()" priority="-2" mode="M991">
      <xsl:apply-templates select="@*|*" mode="M991"/>
   </xsl:template>

   <!--PATTERN winportobjlocal_address-->


	<!--RULE -->
<xsl:template match="win-def:port_object/win-def:local_address" priority="1000" mode="M992">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_address entity of a port_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M992"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M992"/>
   <xsl:template match="@*|node()" priority="-2" mode="M992">
      <xsl:apply-templates select="@*|*" mode="M992"/>
   </xsl:template>

   <!--PATTERN winportobjlocal_port-->


	<!--RULE -->
<xsl:template match="win-def:port_object/win-def:local_port" priority="1000" mode="M993">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_port entity of a port_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M993"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M993"/>
   <xsl:template match="@*|node()" priority="-2" mode="M993">
      <xsl:apply-templates select="@*|*" mode="M993"/>
   </xsl:template>

   <!--PATTERN winportobjprotocol-->


	<!--RULE -->
<xsl:template match="win-def:port_object/win-def:protocol" priority="1000" mode="M994">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of a port_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M994"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M994"/>
   <xsl:template match="@*|node()" priority="-2" mode="M994">
      <xsl:apply-templates select="@*|*" mode="M994"/>
   </xsl:template>

   <!--PATTERN winportstelocal_address-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:local_address" priority="1000" mode="M995">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_address entity of a port_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M995"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M995"/>
   <xsl:template match="@*|node()" priority="-2" mode="M995">
      <xsl:apply-templates select="@*|*" mode="M995"/>
   </xsl:template>

   <!--PATTERN winportstelocal_port-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:local_port" priority="1000" mode="M996">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_port entity of a port_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M996"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M996"/>
   <xsl:template match="@*|node()" priority="-2" mode="M996">
      <xsl:apply-templates select="@*|*" mode="M996"/>
   </xsl:template>

   <!--PATTERN winportsteprotocol-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:protocol" priority="1000" mode="M997">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the protocol entity of a port_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M997"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M997"/>
   <xsl:template match="@*|node()" priority="-2" mode="M997">
      <xsl:apply-templates select="@*|*" mode="M997"/>
   </xsl:template>

   <!--PATTERN winportstepid-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:pid" priority="1000" mode="M998">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pid entity of a port_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M998"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M998"/>
   <xsl:template match="@*|node()" priority="-2" mode="M998">
      <xsl:apply-templates select="@*|*" mode="M998"/>
   </xsl:template>

   <!--PATTERN pertst-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_test/win-def:object" priority="1001"
                 mode="M999">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:printereffectiverights_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a printereffectiverights_test must reference a printereffectiverights_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M999"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:printereffectiverights_test/win-def:state" priority="1000"
                 mode="M999">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:printereffectiverights_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a printereffectiverights_test must reference a printereffectiverights_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M999"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M999"/>
   <xsl:template match="@*|node()" priority="-2" mode="M999">
      <xsl:apply-templates select="@*|*" mode="M999"/>
   </xsl:template>

   <!--PATTERN perobjprinter_name-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_object/win-def:printer_name"
                 priority="1000"
                 mode="M1000">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the kprinter_nameey entity of a printereffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1000"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1000"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1000">
      <xsl:apply-templates select="@*|*" mode="M1000"/>
   </xsl:template>

   <!--PATTERN perobjtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M1001">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a printereffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1001"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1001"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1001">
      <xsl:apply-templates select="@*|*" mode="M1001"/>
   </xsl:template>

   <!--PATTERN rersteprinter_name-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:printer_name"
                 priority="1000"
                 mode="M1002">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the printer_name entity of a printereffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1002"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1002"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1002">
      <xsl:apply-templates select="@*|*" mode="M1002"/>
   </xsl:template>

   <!--PATTERN perstetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:trustee_sid"
                 priority="1000"
                 mode="M1003">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a printereffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1003"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1003"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1003">
      <xsl:apply-templates select="@*|*" mode="M1003"/>
   </xsl:template>

   <!--PATTERN perstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1004">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1004"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1004"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1004">
      <xsl:apply-templates select="@*|*" mode="M1004"/>
   </xsl:template>

   <!--PATTERN perstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1005">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1005"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1005"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1005">
      <xsl:apply-templates select="@*|*" mode="M1005"/>
   </xsl:template>

   <!--PATTERN perstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1006">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1006"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1006"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1006">
      <xsl:apply-templates select="@*|*" mode="M1006"/>
   </xsl:template>

   <!--PATTERN perstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1007">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1007"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1007"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1007">
      <xsl:apply-templates select="@*|*" mode="M1007"/>
   </xsl:template>

   <!--PATTERN perstestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M1008">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1008"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1008"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1008">
      <xsl:apply-templates select="@*|*" mode="M1008"/>
   </xsl:template>

   <!--PATTERN persteaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:access_system_security"
                 priority="1000"
                 mode="M1009">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1009"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1009"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1009">
      <xsl:apply-templates select="@*|*" mode="M1009"/>
   </xsl:template>

   <!--PATTERN perstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:generic_read"
                 priority="1000"
                 mode="M1010">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1010"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1010"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1010">
      <xsl:apply-templates select="@*|*" mode="M1010"/>
   </xsl:template>

   <!--PATTERN perstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:generic_write"
                 priority="1000"
                 mode="M1011">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1011"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1011"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1011">
      <xsl:apply-templates select="@*|*" mode="M1011"/>
   </xsl:template>

   <!--PATTERN perstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1012">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1012"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1012"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1012">
      <xsl:apply-templates select="@*|*" mode="M1012"/>
   </xsl:template>

   <!--PATTERN perstegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:generic_all"
                 priority="1000"
                 mode="M1013">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1013"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1013"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1013">
      <xsl:apply-templates select="@*|*" mode="M1013"/>
   </xsl:template>

   <!--PATTERN persteprinter_access_administer-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:printer_access_administer"
                 priority="1000"
                 mode="M1014">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the printer_access_administer entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1014"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1014"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1014">
      <xsl:apply-templates select="@*|*" mode="M1014"/>
   </xsl:template>

   <!--PATTERN persteprinter_access_use-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:printer_access_use"
                 priority="1000"
                 mode="M1015">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the printer_access_use entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1015"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1015"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1015">
      <xsl:apply-templates select="@*|*" mode="M1015"/>
   </xsl:template>

   <!--PATTERN perstejob_access_administer-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:job_access_administer"
                 priority="1000"
                 mode="M1016">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the job_access_administer entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1016"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1016"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1016">
      <xsl:apply-templates select="@*|*" mode="M1016"/>
   </xsl:template>

   <!--PATTERN perstejob_access_read-->


	<!--RULE -->
<xsl:template match="win-def:printereffectiverights_state/win-def:job_access_read"
                 priority="1000"
                 mode="M1017">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the job_access_read entity of a printereffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1017"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1017"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1017">
      <xsl:apply-templates select="@*|*" mode="M1017"/>
   </xsl:template>

   <!--PATTERN pef_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:printereffectiverights_object/win-def:behaviors"
                 priority="1000"
                 mode="M1018">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: printereffectiverights_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1018"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1018"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1018">
      <xsl:apply-templates select="@*|*" mode="M1018"/>
   </xsl:template>

   <!--PATTERN processtst-->


	<!--RULE -->
<xsl:template match="win-def:process_test/win-def:object" priority="1001" mode="M1019">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:process_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a process_test must reference a process_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1019"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:process_test/win-def:state" priority="1000" mode="M1019">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:process_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a process_test must reference a process_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1019"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1019"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1019">
      <xsl:apply-templates select="@*|*" mode="M1019"/>
   </xsl:template>

   <!--PATTERN processobjcommand_line-->


	<!--RULE -->
<xsl:template match="win-def:process_object/win-def:command_line" priority="1000"
                 mode="M1020">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the command_line entity of a process_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1020"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1020"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1020">
      <xsl:apply-templates select="@*|*" mode="M1020"/>
   </xsl:template>

   <!--PATTERN processstecommand_line-->


	<!--RULE -->
<xsl:template match="win-def:process_state/win-def:command_line" priority="1000" mode="M1021">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the command_line entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1021"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1021"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1021">
      <xsl:apply-templates select="@*|*" mode="M1021"/>
   </xsl:template>

   <!--PATTERN processstepid-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:pid" priority="1000" mode="M1022">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the pid entity of a port_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1022"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1022"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1022">
      <xsl:apply-templates select="@*|*" mode="M1022"/>
   </xsl:template>

   <!--PATTERN processsteppid-->


	<!--RULE -->
<xsl:template match="win-def:port_state/win-def:ppid" priority="1000" mode="M1023">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the ppid entity of a port_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1023"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1023"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1023">
      <xsl:apply-templates select="@*|*" mode="M1023"/>
   </xsl:template>

   <!--PATTERN processstepriority-->


	<!--RULE -->
<xsl:template match="win-def:process_state/win-def:priority" priority="1000" mode="M1024">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the priority entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1024"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1024"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1024">
      <xsl:apply-templates select="@*|*" mode="M1024"/>
   </xsl:template>

   <!--PATTERN processsteimage_path-->


	<!--RULE -->
<xsl:template match="win-def:process_state/win-def:image_path" priority="1000" mode="M1025">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the image_path entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1025"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1025"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1025">
      <xsl:apply-templates select="@*|*" mode="M1025"/>
   </xsl:template>

   <!--PATTERN processstecurrent_dir-->


	<!--RULE -->
<xsl:template match="win-def:process_state/win-def:current_dir" priority="1000" mode="M1026">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the current_dir entity of a process_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1026"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1026"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1026">
      <xsl:apply-templates select="@*|*" mode="M1026"/>
   </xsl:template>

   <!--PATTERN regtst-->


	<!--RULE -->
<xsl:template match="win-def:registry_test/win-def:object" priority="1001" mode="M1027">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:registry_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a registry_test must reference a registry_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1027"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:registry_test/win-def:state" priority="1000" mode="M1027">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:registry_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a registry_test must reference a registry_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1027"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1027"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1027">
      <xsl:apply-templates select="@*|*" mode="M1027"/>
   </xsl:template>

   <!--PATTERN regobjhive-->


	<!--RULE -->
<xsl:template match="win-def:registry_object/win-def:hive" priority="1000" mode="M1028">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a registry_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1028"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1028"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1028">
      <xsl:apply-templates select="@*|*" mode="M1028"/>
   </xsl:template>

   <!--PATTERN regobjkey-->


	<!--RULE -->
<xsl:template match="win-def:registry_object/win-def:key" priority="1000" mode="M1029">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a registry_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@xsi:nil='true') or ../win-def:name/@xsi:nil='true'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - name entity must be nil when key is nil<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1029"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1029"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1029">
      <xsl:apply-templates select="@*|*" mode="M1029"/>
   </xsl:template>

   <!--PATTERN regobjname-->


	<!--RULE -->
<xsl:template match="win-def:registry_object/win-def:name" priority="1000" mode="M1030">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a registry_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1030"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1030"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1030">
      <xsl:apply-templates select="@*|*" mode="M1030"/>
   </xsl:template>

   <!--PATTERN regstehive-->


	<!--RULE -->
<xsl:template match="win-def:registry_state/win-def:hive" priority="1000" mode="M1031">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a registry_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1031"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1031"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1031">
      <xsl:apply-templates select="@*|*" mode="M1031"/>
   </xsl:template>

   <!--PATTERN regstekey-->


	<!--RULE -->
<xsl:template match="win-def:registry_state/win-def:key" priority="1000" mode="M1032">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a registry_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1032"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1032"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1032">
      <xsl:apply-templates select="@*|*" mode="M1032"/>
   </xsl:template>

   <!--PATTERN regstename-->


	<!--RULE -->
<xsl:template match="win-def:registry_state/win-def:name" priority="1000" mode="M1033">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a registry_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1033"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1033"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1033">
      <xsl:apply-templates select="@*|*" mode="M1033"/>
   </xsl:template>

   <!--PATTERN regstetype-->


	<!--RULE -->
<xsl:template match="win-def:registry_state/win-def:type" priority="1000" mode="M1034">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the type entity of a registry_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1034"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1034"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1034">
      <xsl:apply-templates select="@*|*" mode="M1034"/>
   </xsl:template>

   <!--PATTERN regstevalue-->


	<!--RULE -->
<xsl:template match="win-def:registry_state/win-def:value" priority="1000" mode="M1035">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1035"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1035"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1035">
      <xsl:apply-templates select="@*|*" mode="M1035"/>
   </xsl:template>

   <!--PATTERN rap53tst-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_test/win-def:object" priority="1001"
                 mode="M1036">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:regkeyauditedpermissions53_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a regkeyauditedpermissions53_test must reference a regkeyauditedpermissions53_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1036"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_test/win-def:state" priority="1000"
                 mode="M1036">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:regkeyauditedpermissions53_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a regkeyauditedpermissions53_test must reference a regkeyauditedpermissions53_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1036"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1036"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1036">
      <xsl:apply-templates select="@*|*" mode="M1036"/>
   </xsl:template>

   <!--PATTERN rap53objhive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_object/win-def:hive" priority="1000"
                 mode="M1037">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1037"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1037"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1037">
      <xsl:apply-templates select="@*|*" mode="M1037"/>
   </xsl:template>

   <!--PATTERN rap53objkey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_object/win-def:key" priority="1000"
                 mode="M1038">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1038"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1038"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1038">
      <xsl:apply-templates select="@*|*" mode="M1038"/>
   </xsl:template>

   <!--PATTERN rap53objtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M1039">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a regkeyauditedpermissions53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1039"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1039"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1039">
      <xsl:apply-templates select="@*|*" mode="M1039"/>
   </xsl:template>

   <!--PATTERN rap53stehive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:hive" priority="1000"
                 mode="M1040">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1040"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1040"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1040">
      <xsl:apply-templates select="@*|*" mode="M1040"/>
   </xsl:template>

   <!--PATTERN rap53stekey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key" priority="1000"
                 mode="M1041">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1041"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1041"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1041">
      <xsl:apply-templates select="@*|*" mode="M1041"/>
   </xsl:template>

   <!--PATTERN rap53stetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:trustee_sid"
                 priority="1000"
                 mode="M1042">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1042"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1042"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1042">
      <xsl:apply-templates select="@*|*" mode="M1042"/>
   </xsl:template>

   <!--PATTERN rap53stestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1043">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1043"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1043"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1043">
      <xsl:apply-templates select="@*|*" mode="M1043"/>
   </xsl:template>

   <!--PATTERN rap53stestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1044">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1044"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1044"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1044">
      <xsl:apply-templates select="@*|*" mode="M1044"/>
   </xsl:template>

   <!--PATTERN rap53stestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1045">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1045"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1045"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1045">
      <xsl:apply-templates select="@*|*" mode="M1045"/>
   </xsl:template>

   <!--PATTERN rap53stestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1046">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1046"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1046"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1046">
      <xsl:apply-templates select="@*|*" mode="M1046"/>
   </xsl:template>

   <!--PATTERN rap53stestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M1047">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED ELEMENT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>item <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1047"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1047"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1047">
      <xsl:apply-templates select="@*|*" mode="M1047"/>
   </xsl:template>

   <!--PATTERN rap53steaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:access_system_security"
                 priority="1000"
                 mode="M1048">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1048"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1048"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1048">
      <xsl:apply-templates select="@*|*" mode="M1048"/>
   </xsl:template>

   <!--PATTERN rap53stegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:generic_read"
                 priority="1000"
                 mode="M1049">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1049"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1049"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1049">
      <xsl:apply-templates select="@*|*" mode="M1049"/>
   </xsl:template>

   <!--PATTERN rap53stegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:generic_write"
                 priority="1000"
                 mode="M1050">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1050"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1050"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1050">
      <xsl:apply-templates select="@*|*" mode="M1050"/>
   </xsl:template>

   <!--PATTERN rap53stegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1051">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1051"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1051"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1051">
      <xsl:apply-templates select="@*|*" mode="M1051"/>
   </xsl:template>

   <!--PATTERN rap53stegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:generic_all"
                 priority="1000"
                 mode="M1052">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1052"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1052"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1052">
      <xsl:apply-templates select="@*|*" mode="M1052"/>
   </xsl:template>

   <!--PATTERN rap53stekey_query_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_query_value"
                 priority="1000"
                 mode="M1053">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_query_value entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1053"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1053"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1053">
      <xsl:apply-templates select="@*|*" mode="M1053"/>
   </xsl:template>

   <!--PATTERN rap53stekey_set_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_set_value"
                 priority="1000"
                 mode="M1054">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_set_value entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1054"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1054"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1054">
      <xsl:apply-templates select="@*|*" mode="M1054"/>
   </xsl:template>

   <!--PATTERN rap53stekey_create_sub_key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_create_sub_key"
                 priority="1000"
                 mode="M1055">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_sub_key entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1055"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1055"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1055">
      <xsl:apply-templates select="@*|*" mode="M1055"/>
   </xsl:template>

   <!--PATTERN rap53stekey_enumerate_sub_keys-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_enumerate_sub_keys"
                 priority="1000"
                 mode="M1056">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_enumerate_sub_keys entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1056"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1056"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1056">
      <xsl:apply-templates select="@*|*" mode="M1056"/>
   </xsl:template>

   <!--PATTERN rap53stekey_notify-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_notify"
                 priority="1000"
                 mode="M1057">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_notify entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1057"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1057"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1057">
      <xsl:apply-templates select="@*|*" mode="M1057"/>
   </xsl:template>

   <!--PATTERN rap53stekey_create_link-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_create_link"
                 priority="1000"
                 mode="M1058">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_link entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1058"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1058"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1058">
      <xsl:apply-templates select="@*|*" mode="M1058"/>
   </xsl:template>

   <!--PATTERN rap53stekey_wow64_64key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_wow64_64key"
                 priority="1000"
                 mode="M1059">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_64key entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1059"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1059"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1059">
      <xsl:apply-templates select="@*|*" mode="M1059"/>
   </xsl:template>

   <!--PATTERN rap53stekey_wow64_32key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_wow64_32key"
                 priority="1000"
                 mode="M1060">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_32key entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1060"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1060"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1060">
      <xsl:apply-templates select="@*|*" mode="M1060"/>
   </xsl:template>

   <!--PATTERN rap53stekey_wow64_res-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions53_state/win-def:key_wow64_res"
                 priority="1000"
                 mode="M1061">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_res entity of a regkeyauditedpermissions53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1061"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1061"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1061">
      <xsl:apply-templates select="@*|*" mode="M1061"/>
   </xsl:template>

   <!--PATTERN rka53_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:regkeyauditedpermissions53_object/win-def:behaviors"
                 priority="1000"
                 mode="M1062">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: regkeyauditedpermissions53_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1062"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1062"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1062">
      <xsl:apply-templates select="@*|*" mode="M1062"/>
   </xsl:template>

   <!--PATTERN raptst_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_test" priority="1000" mode="M1063">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1063"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1063"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1063">
      <xsl:apply-templates select="@*|*" mode="M1063"/>
   </xsl:template>

   <!--PATTERN raptst-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_test/win-def:object" priority="1001"
                 mode="M1064">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:regkeyauditedpermissions_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a regkeyauditedpermissions_test must reference a regkeyauditedpermissions_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1064"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_test/win-def:state" priority="1000"
                 mode="M1064">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:regkeyauditedpermissions_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a regkeyauditedpermissions_test must reference a regkeyauditedpermissions_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1064"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1064"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1064">
      <xsl:apply-templates select="@*|*" mode="M1064"/>
   </xsl:template>

   <!--PATTERN rapobj_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_object" priority="1000" mode="M1065">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1065"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1065"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1065">
      <xsl:apply-templates select="@*|*" mode="M1065"/>
   </xsl:template>

   <!--PATTERN rapobjhive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_object/win-def:hive" priority="1000"
                 mode="M1066">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1066"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1066"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1066">
      <xsl:apply-templates select="@*|*" mode="M1066"/>
   </xsl:template>

   <!--PATTERN rapobjkey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_object/win-def:key" priority="1000"
                 mode="M1067">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1067"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1067"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1067">
      <xsl:apply-templates select="@*|*" mode="M1067"/>
   </xsl:template>

   <!--PATTERN rapobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_object/win-def:trustee_name"
                 priority="1000"
                 mode="M1068">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a regkeyauditedpermissions_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1068"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1068"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1068">
      <xsl:apply-templates select="@*|*" mode="M1068"/>
   </xsl:template>

   <!--PATTERN rapste_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state" priority="1000" mode="M1069">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1069"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1069"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1069">
      <xsl:apply-templates select="@*|*" mode="M1069"/>
   </xsl:template>

   <!--PATTERN rapstehive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:hive" priority="1000"
                 mode="M1070">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1070"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1070"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1070">
      <xsl:apply-templates select="@*|*" mode="M1070"/>
   </xsl:template>

   <!--PATTERN rapstekey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key" priority="1000"
                 mode="M1071">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1071"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1071"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1071">
      <xsl:apply-templates select="@*|*" mode="M1071"/>
   </xsl:template>

   <!--PATTERN rapstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:trustee_name"
                 priority="1000"
                 mode="M1072">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1072"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1072"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1072">
      <xsl:apply-templates select="@*|*" mode="M1072"/>
   </xsl:template>

   <!--PATTERN rapstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1073">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1073"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1073"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1073">
      <xsl:apply-templates select="@*|*" mode="M1073"/>
   </xsl:template>

   <!--PATTERN rapstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1074">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1074"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1074"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1074">
      <xsl:apply-templates select="@*|*" mode="M1074"/>
   </xsl:template>

   <!--PATTERN rapstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1075">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1075"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1075"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1075">
      <xsl:apply-templates select="@*|*" mode="M1075"/>
   </xsl:template>

   <!--PATTERN rapstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1076">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1076"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1076"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1076">
      <xsl:apply-templates select="@*|*" mode="M1076"/>
   </xsl:template>

   <!--PATTERN rapstestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M1077">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1077"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1077"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1077">
      <xsl:apply-templates select="@*|*" mode="M1077"/>
   </xsl:template>

   <!--PATTERN rapsteaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:access_system_security"
                 priority="1000"
                 mode="M1078">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1078"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1078"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1078">
      <xsl:apply-templates select="@*|*" mode="M1078"/>
   </xsl:template>

   <!--PATTERN rapstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:generic_read"
                 priority="1000"
                 mode="M1079">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1079"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1079"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1079">
      <xsl:apply-templates select="@*|*" mode="M1079"/>
   </xsl:template>

   <!--PATTERN rapstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:generic_write"
                 priority="1000"
                 mode="M1080">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1080"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1080"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1080">
      <xsl:apply-templates select="@*|*" mode="M1080"/>
   </xsl:template>

   <!--PATTERN rapstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1081">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1081"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1081"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1081">
      <xsl:apply-templates select="@*|*" mode="M1081"/>
   </xsl:template>

   <!--PATTERN rapstegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:generic_all"
                 priority="1000"
                 mode="M1082">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1082"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1082"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1082">
      <xsl:apply-templates select="@*|*" mode="M1082"/>
   </xsl:template>

   <!--PATTERN rapstekey_query_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_query_value"
                 priority="1000"
                 mode="M1083">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_query_value entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1083"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1083"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1083">
      <xsl:apply-templates select="@*|*" mode="M1083"/>
   </xsl:template>

   <!--PATTERN rapstekey_set_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_set_value"
                 priority="1000"
                 mode="M1084">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_set_value entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1084"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1084"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1084">
      <xsl:apply-templates select="@*|*" mode="M1084"/>
   </xsl:template>

   <!--PATTERN rapstekey_create_sub_key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_create_sub_key"
                 priority="1000"
                 mode="M1085">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_sub_key entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1085"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1085"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1085">
      <xsl:apply-templates select="@*|*" mode="M1085"/>
   </xsl:template>

   <!--PATTERN rapstekey_enumerate_sub_keys-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_enumerate_sub_keys"
                 priority="1000"
                 mode="M1086">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_enumerate_sub_keys entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1086"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1086"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1086">
      <xsl:apply-templates select="@*|*" mode="M1086"/>
   </xsl:template>

   <!--PATTERN rapstekey_notify-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_notify"
                 priority="1000"
                 mode="M1087">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_notify entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1087"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1087"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1087">
      <xsl:apply-templates select="@*|*" mode="M1087"/>
   </xsl:template>

   <!--PATTERN rapstekey_create_link-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_create_link"
                 priority="1000"
                 mode="M1088">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_link entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1088"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1088"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1088">
      <xsl:apply-templates select="@*|*" mode="M1088"/>
   </xsl:template>

   <!--PATTERN rapstekey_wow64_64key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_wow64_64key"
                 priority="1000"
                 mode="M1089">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_64key entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1089"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1089"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1089">
      <xsl:apply-templates select="@*|*" mode="M1089"/>
   </xsl:template>

   <!--PATTERN rapstekey_wow64_32key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_wow64_32key"
                 priority="1000"
                 mode="M1090">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_32key entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1090"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1090"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1090">
      <xsl:apply-templates select="@*|*" mode="M1090"/>
   </xsl:template>

   <!--PATTERN rapstekey_wow64_res-->


	<!--RULE -->
<xsl:template match="win-def:regkeyauditedpermissions_state/win-def:key_wow64_res"
                 priority="1000"
                 mode="M1091">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_res entity of a regkeyauditedpermissions_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1091"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1091"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1091">
      <xsl:apply-templates select="@*|*" mode="M1091"/>
   </xsl:template>

   <!--PATTERN rka_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:regkeyauditedpermissions_object/win-def:behaviors"
                 priority="1000"
                 mode="M1092">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: regkeyauditedpermissions_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1092"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1092"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1092">
      <xsl:apply-templates select="@*|*" mode="M1092"/>
   </xsl:template>

   <!--PATTERN rer53tst-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_test/win-def:object" priority="1001"
                 mode="M1093">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:regkeyeffectiverights53_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a regkeyeffectiverights53_test must reference a regkeyeffectiverights53_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1093"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_test/win-def:state" priority="1000"
                 mode="M1093">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:regkeyeffectiverights53_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a regkeyeffectiverights53_test must reference a regkeyeffectiverights53_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1093"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1093"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1093">
      <xsl:apply-templates select="@*|*" mode="M1093"/>
   </xsl:template>

   <!--PATTERN rer53objhive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_object/win-def:hive" priority="1000"
                 mode="M1094">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1094"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1094"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1094">
      <xsl:apply-templates select="@*|*" mode="M1094"/>
   </xsl:template>

   <!--PATTERN rer53objkey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_object/win-def:key" priority="1000"
                 mode="M1095">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1095"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1095"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1095">
      <xsl:apply-templates select="@*|*" mode="M1095"/>
   </xsl:template>

   <!--PATTERN rer53objtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M1096">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a regkeyeffectiverights53_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1096"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1096"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1096">
      <xsl:apply-templates select="@*|*" mode="M1096"/>
   </xsl:template>

   <!--PATTERN rer53stehive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:hive" priority="1000"
                 mode="M1097">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1097"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1097"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1097">
      <xsl:apply-templates select="@*|*" mode="M1097"/>
   </xsl:template>

   <!--PATTERN rer53stekey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key" priority="1000"
                 mode="M1098">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1098"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1098"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1098">
      <xsl:apply-templates select="@*|*" mode="M1098"/>
   </xsl:template>

   <!--PATTERN rer53stetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:trustee_sid"
                 priority="1000"
                 mode="M1099">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a regkeyeffectiverights53_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1099"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1099"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1099">
      <xsl:apply-templates select="@*|*" mode="M1099"/>
   </xsl:template>

   <!--PATTERN rer53stestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1100">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1100"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1100"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1100">
      <xsl:apply-templates select="@*|*" mode="M1100"/>
   </xsl:template>

   <!--PATTERN rer53stestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1101">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1101"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1101"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1101">
      <xsl:apply-templates select="@*|*" mode="M1101"/>
   </xsl:template>

   <!--PATTERN rer53stestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1102">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1102"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1102"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1102">
      <xsl:apply-templates select="@*|*" mode="M1102"/>
   </xsl:template>

   <!--PATTERN rer53stestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1103">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1103"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1103"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1103">
      <xsl:apply-templates select="@*|*" mode="M1103"/>
   </xsl:template>

   <!--PATTERN rer53stestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M1104">

		<!--REPORT -->
<xsl:if test="true()">DEPRECATED ELEMENT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1104"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1104"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1104">
      <xsl:apply-templates select="@*|*" mode="M1104"/>
   </xsl:template>

   <!--PATTERN rer53steaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:access_system_security"
                 priority="1000"
                 mode="M1105">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1105"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1105"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1105">
      <xsl:apply-templates select="@*|*" mode="M1105"/>
   </xsl:template>

   <!--PATTERN rer53stegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:generic_read"
                 priority="1000"
                 mode="M1106">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1106"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1106"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1106">
      <xsl:apply-templates select="@*|*" mode="M1106"/>
   </xsl:template>

   <!--PATTERN rer53stegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:generic_write"
                 priority="1000"
                 mode="M1107">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1107"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1107"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1107">
      <xsl:apply-templates select="@*|*" mode="M1107"/>
   </xsl:template>

   <!--PATTERN rer53stegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1108">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1108"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1108"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1108">
      <xsl:apply-templates select="@*|*" mode="M1108"/>
   </xsl:template>

   <!--PATTERN rer53stegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:generic_all"
                 priority="1000"
                 mode="M1109">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1109"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1109"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1109">
      <xsl:apply-templates select="@*|*" mode="M1109"/>
   </xsl:template>

   <!--PATTERN rer53stekey_query_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_query_value"
                 priority="1000"
                 mode="M1110">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_query_value entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1110"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1110"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1110">
      <xsl:apply-templates select="@*|*" mode="M1110"/>
   </xsl:template>

   <!--PATTERN rer53stekey_set_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_set_value"
                 priority="1000"
                 mode="M1111">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_set_value entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1111"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1111"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1111">
      <xsl:apply-templates select="@*|*" mode="M1111"/>
   </xsl:template>

   <!--PATTERN rer53stekey_create_sub_key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_create_sub_key"
                 priority="1000"
                 mode="M1112">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_sub_key entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1112"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1112"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1112">
      <xsl:apply-templates select="@*|*" mode="M1112"/>
   </xsl:template>

   <!--PATTERN rer53stekey_enumerate_sub_keys-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_enumerate_sub_keys"
                 priority="1000"
                 mode="M1113">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_enumerate_sub_keys entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1113"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1113"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1113">
      <xsl:apply-templates select="@*|*" mode="M1113"/>
   </xsl:template>

   <!--PATTERN rer53stekey_notify-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_notify"
                 priority="1000"
                 mode="M1114">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_notify entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1114"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1114"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1114">
      <xsl:apply-templates select="@*|*" mode="M1114"/>
   </xsl:template>

   <!--PATTERN rer53stekey_create_link-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_create_link"
                 priority="1000"
                 mode="M1115">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_link entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1115"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1115"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1115">
      <xsl:apply-templates select="@*|*" mode="M1115"/>
   </xsl:template>

   <!--PATTERN rer53stekey_wow64_64key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_wow64_64key"
                 priority="1000"
                 mode="M1116">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_64key entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1116"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1116"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1116">
      <xsl:apply-templates select="@*|*" mode="M1116"/>
   </xsl:template>

   <!--PATTERN rer53stekey_wow64_32key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_wow64_32key"
                 priority="1000"
                 mode="M1117">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_32key entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1117"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1117"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1117">
      <xsl:apply-templates select="@*|*" mode="M1117"/>
   </xsl:template>

   <!--PATTERN rer53stekey_wow64_res-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights53_state/win-def:key_wow64_res"
                 priority="1000"
                 mode="M1118">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_res entity of a regkeyeffectiverights53_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1118"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1118"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1118">
      <xsl:apply-templates select="@*|*" mode="M1118"/>
   </xsl:template>

   <!--PATTERN rke53_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:regkeyeffectiverights53_object/win-def:behaviors"
                 priority="1000"
                 mode="M1119">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: regkeyeffectiverights53_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1119"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1119"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1119">
      <xsl:apply-templates select="@*|*" mode="M1119"/>
   </xsl:template>

   <!--PATTERN rertst_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_test" priority="1000" mode="M1120">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1120"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1120"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1120">
      <xsl:apply-templates select="@*|*" mode="M1120"/>
   </xsl:template>

   <!--PATTERN rertst-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_test/win-def:object" priority="1001"
                 mode="M1121">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:regkeyeffectiverights_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a regkeyeffectiverights_test must reference a regkeyeffectiverights_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1121"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_test/win-def:state" priority="1000"
                 mode="M1121">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:regkeyeffectiverights_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a regkeyeffectiverights_test must reference a regkeyeffectiverights_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1121"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1121"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1121">
      <xsl:apply-templates select="@*|*" mode="M1121"/>
   </xsl:template>

   <!--PATTERN rerobj_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_object" priority="1000" mode="M1122">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1122"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1122"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1122">
      <xsl:apply-templates select="@*|*" mode="M1122"/>
   </xsl:template>

   <!--PATTERN rerobjhive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_object/win-def:hive" priority="1000"
                 mode="M1123">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1123"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1123"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1123">
      <xsl:apply-templates select="@*|*" mode="M1123"/>
   </xsl:template>

   <!--PATTERN rerobjkey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_object/win-def:key" priority="1000"
                 mode="M1124">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1124"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1124"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1124">
      <xsl:apply-templates select="@*|*" mode="M1124"/>
   </xsl:template>

   <!--PATTERN rerobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_object/win-def:trustee_name"
                 priority="1000"
                 mode="M1125">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a regkeyeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1125"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1125"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1125">
      <xsl:apply-templates select="@*|*" mode="M1125"/>
   </xsl:template>

   <!--PATTERN rerste_dep-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state" priority="1000" mode="M1126">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1126"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1126"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1126">
      <xsl:apply-templates select="@*|*" mode="M1126"/>
   </xsl:template>

   <!--PATTERN rerstehive-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:hive" priority="1000"
                 mode="M1127">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the hive entity of a regkeyeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1127"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1127"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1127">
      <xsl:apply-templates select="@*|*" mode="M1127"/>
   </xsl:template>

   <!--PATTERN rerstekey-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key" priority="1000"
                 mode="M1128">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key entity of a regkeyeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1128"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1128"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1128">
      <xsl:apply-templates select="@*|*" mode="M1128"/>
   </xsl:template>

   <!--PATTERN rerstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:trustee_name"
                 priority="1000"
                 mode="M1129">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a regkeyeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1129"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1129"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1129">
      <xsl:apply-templates select="@*|*" mode="M1129"/>
   </xsl:template>

   <!--PATTERN rerstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1130">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1130"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1130"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1130">
      <xsl:apply-templates select="@*|*" mode="M1130"/>
   </xsl:template>

   <!--PATTERN rerstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1131">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1131"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1131"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1131">
      <xsl:apply-templates select="@*|*" mode="M1131"/>
   </xsl:template>

   <!--PATTERN rerstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1132">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1132"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1132"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1132">
      <xsl:apply-templates select="@*|*" mode="M1132"/>
   </xsl:template>

   <!--PATTERN rerstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1133">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1133"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1133"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1133">
      <xsl:apply-templates select="@*|*" mode="M1133"/>
   </xsl:template>

   <!--PATTERN rerstestandard_synchronize-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:standard_synchronize"
                 priority="1000"
                 mode="M1134">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_synchronize entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1134"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1134"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1134">
      <xsl:apply-templates select="@*|*" mode="M1134"/>
   </xsl:template>

   <!--PATTERN rersteaccess_system_security-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:access_system_security"
                 priority="1000"
                 mode="M1135">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_system_security entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1135"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1135"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1135">
      <xsl:apply-templates select="@*|*" mode="M1135"/>
   </xsl:template>

   <!--PATTERN rerstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:generic_read"
                 priority="1000"
                 mode="M1136">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1136"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1136"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1136">
      <xsl:apply-templates select="@*|*" mode="M1136"/>
   </xsl:template>

   <!--PATTERN rerstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:generic_write"
                 priority="1000"
                 mode="M1137">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1137"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1137"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1137">
      <xsl:apply-templates select="@*|*" mode="M1137"/>
   </xsl:template>

   <!--PATTERN rerstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1138">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1138"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1138"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1138">
      <xsl:apply-templates select="@*|*" mode="M1138"/>
   </xsl:template>

   <!--PATTERN rerstegeneric_all-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:generic_all" priority="1000"
                 mode="M1139">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_all entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1139"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1139"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1139">
      <xsl:apply-templates select="@*|*" mode="M1139"/>
   </xsl:template>

   <!--PATTERN rerstekey_query_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_query_value"
                 priority="1000"
                 mode="M1140">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_query_value entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1140"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1140"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1140">
      <xsl:apply-templates select="@*|*" mode="M1140"/>
   </xsl:template>

   <!--PATTERN rerstekey_set_value-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_set_value"
                 priority="1000"
                 mode="M1141">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_set_value entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1141"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1141"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1141">
      <xsl:apply-templates select="@*|*" mode="M1141"/>
   </xsl:template>

   <!--PATTERN rerstekey_create_sub_key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_create_sub_key"
                 priority="1000"
                 mode="M1142">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_sub_key entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1142"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1142"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1142">
      <xsl:apply-templates select="@*|*" mode="M1142"/>
   </xsl:template>

   <!--PATTERN rerstekey_enumerate_sub_keys-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_enumerate_sub_keys"
                 priority="1000"
                 mode="M1143">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_enumerate_sub_keys entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1143"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1143"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1143">
      <xsl:apply-templates select="@*|*" mode="M1143"/>
   </xsl:template>

   <!--PATTERN rerstekey_notify-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_notify" priority="1000"
                 mode="M1144">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_notify entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1144"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1144"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1144">
      <xsl:apply-templates select="@*|*" mode="M1144"/>
   </xsl:template>

   <!--PATTERN rerstekey_create_link-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_create_link"
                 priority="1000"
                 mode="M1145">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_create_link entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1145"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1145"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1145">
      <xsl:apply-templates select="@*|*" mode="M1145"/>
   </xsl:template>

   <!--PATTERN rerstekey_wow64_64key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_wow64_64key"
                 priority="1000"
                 mode="M1146">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_64key entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1146"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1146"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1146">
      <xsl:apply-templates select="@*|*" mode="M1146"/>
   </xsl:template>

   <!--PATTERN rerstekey_wow64_32key-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_wow64_32key"
                 priority="1000"
                 mode="M1147">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_32key entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1147"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1147"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1147">
      <xsl:apply-templates select="@*|*" mode="M1147"/>
   </xsl:template>

   <!--PATTERN rerstekey_wow64_res-->


	<!--RULE -->
<xsl:template match="win-def:regkeyeffectiverights_state/win-def:key_wow64_res"
                 priority="1000"
                 mode="M1148">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the key_wow64_res entity of a regkeyeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1148"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1148"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1148">
      <xsl:apply-templates select="@*|*" mode="M1148"/>
   </xsl:template>

   <!--PATTERN rke_resolve_group_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:objects/win-def:regkeyeffectiverights_object/win-def:behaviors"
                 priority="1000"
                 mode="M1149">

		<!--REPORT -->
<xsl:if test="@resolve_group">DEPRECATED BEHAVIOR IN: regkeyeffectiverights_object <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1149"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1149"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1149">
      <xsl:apply-templates select="@*|*" mode="M1149"/>
   </xsl:template>

   <!--PATTERN svcertst-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_test/win-def:object" priority="1001"
                 mode="M1150">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:serviceeffectiverights_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a serviceeffectiverights_test must reference a serviceeffectiverights_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1150"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_test/win-def:state" priority="1000"
                 mode="M1150">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:serviceeffectiverights_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a serviceeffectiverights_test must reference a serviceeffectiverights_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1150"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1150"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1150">
      <xsl:apply-templates select="@*|*" mode="M1150"/>
   </xsl:template>

   <!--PATTERN svcerobjservice_name-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_object/win-def:service_name"
                 priority="1000"
                 mode="M1151">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of a serviceeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1151"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1151"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1151">
      <xsl:apply-templates select="@*|*" mode="M1151"/>
   </xsl:template>

   <!--PATTERN svcerobjtrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_object/win-def:trustee_sid"
                 priority="1000"
                 mode="M1152">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a serviceeffectiverights_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1152"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1152"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1152">
      <xsl:apply-templates select="@*|*" mode="M1152"/>
   </xsl:template>

   <!--PATTERN svcersteservice_name-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_name"
                 priority="1000"
                 mode="M1153">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_name entity of a serviceeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1153"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1153"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1153">
      <xsl:apply-templates select="@*|*" mode="M1153"/>
   </xsl:template>

   <!--PATTERN svcerstetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:trustee_sid"
                 priority="1000"
                 mode="M1154">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a serviceeffectiverights_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1154"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1154"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1154">
      <xsl:apply-templates select="@*|*" mode="M1154"/>
   </xsl:template>

   <!--PATTERN svcerstestandard_delete-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:standard_delete"
                 priority="1000"
                 mode="M1155">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_delete entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1155"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1155"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1155">
      <xsl:apply-templates select="@*|*" mode="M1155"/>
   </xsl:template>

   <!--PATTERN svcerstestandard_read_control-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:standard_read_control"
                 priority="1000"
                 mode="M1156">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_read_control entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1156"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1156"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1156">
      <xsl:apply-templates select="@*|*" mode="M1156"/>
   </xsl:template>

   <!--PATTERN svcerstestandard_write_dac-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:standard_write_dac"
                 priority="1000"
                 mode="M1157">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_dac entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1157"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1157"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1157">
      <xsl:apply-templates select="@*|*" mode="M1157"/>
   </xsl:template>

   <!--PATTERN svcerstestandard_write_owner-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:standard_write_owner"
                 priority="1000"
                 mode="M1158">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the standard_write_owner entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1158"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1158"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1158">
      <xsl:apply-templates select="@*|*" mode="M1158"/>
   </xsl:template>

   <!--PATTERN svcerstegeneric_read-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:generic_read"
                 priority="1000"
                 mode="M1159">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_read entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1159"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1159"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1159">
      <xsl:apply-templates select="@*|*" mode="M1159"/>
   </xsl:template>

   <!--PATTERN svcerstegeneric_write-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:generic_write"
                 priority="1000"
                 mode="M1160">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_write entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1160"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1160"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1160">
      <xsl:apply-templates select="@*|*" mode="M1160"/>
   </xsl:template>

   <!--PATTERN svcerstegeneric_execute-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:generic_execute"
                 priority="1000"
                 mode="M1161">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the generic_execute entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1161"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1161"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1161">
      <xsl:apply-templates select="@*|*" mode="M1161"/>
   </xsl:template>

   <!--PATTERN svcersteservice_query_conf-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_query_conf"
                 priority="1000"
                 mode="M1162">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_query_conf entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1162"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1162"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1162">
      <xsl:apply-templates select="@*|*" mode="M1162"/>
   </xsl:template>

   <!--PATTERN svcersteservice_change_conf-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_change_conf"
                 priority="1000"
                 mode="M1163">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_change_conf entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1163"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1163"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1163">
      <xsl:apply-templates select="@*|*" mode="M1163"/>
   </xsl:template>

   <!--PATTERN svcersteservice_query_stat-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_query_stat"
                 priority="1000"
                 mode="M1164">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_query_stat entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1164"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1164"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1164">
      <xsl:apply-templates select="@*|*" mode="M1164"/>
   </xsl:template>

   <!--PATTERN svcersteserviceenum_dependents-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_enum_dependents"
                 priority="1000"
                 mode="M1165">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_enum_dependents entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1165"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1165"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1165">
      <xsl:apply-templates select="@*|*" mode="M1165"/>
   </xsl:template>

   <!--PATTERN svcersteservice_start-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_start"
                 priority="1000"
                 mode="M1166">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_start entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1166"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1166"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1166">
      <xsl:apply-templates select="@*|*" mode="M1166"/>
   </xsl:template>

   <!--PATTERN svcersteservice_stop-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_stop"
                 priority="1000"
                 mode="M1167">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_stop entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1167"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1167"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1167">
      <xsl:apply-templates select="@*|*" mode="M1167"/>
   </xsl:template>

   <!--PATTERN svcersteservice_pause-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_pause"
                 priority="1000"
                 mode="M1168">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_pause entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1168"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1168"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1168">
      <xsl:apply-templates select="@*|*" mode="M1168"/>
   </xsl:template>

   <!--PATTERN svcersteservice_interrogate-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_interrogate"
                 priority="1000"
                 mode="M1169">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_interrogate entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1169"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1169"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1169">
      <xsl:apply-templates select="@*|*" mode="M1169"/>
   </xsl:template>

   <!--PATTERN svcersteservice_user_defined-->


	<!--RULE -->
<xsl:template match="win-def:serviceeffectiverights_state/win-def:service_user_defined"
                 priority="1000"
                 mode="M1170">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the service_user_defined entity of a serviceeffectiverights_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1170"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1170"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1170">
      <xsl:apply-templates select="@*|*" mode="M1170"/>
   </xsl:template>

   <!--PATTERN srtst-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_test/win-def:object" priority="1001" mode="M1171">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:sharedresource_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a sharedresource_test must reference a sharedresource_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1171"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:sharedresource_test/win-def:state" priority="1000" mode="M1171">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:sharedresource_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a sharedresource_test must reference a sharedresource_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1171"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1171"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1171">
      <xsl:apply-templates select="@*|*" mode="M1171"/>
   </xsl:template>

   <!--PATTERN srobjnetname-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_object/win-def:netname" priority="1000"
                 mode="M1172">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the netname entity of a sharedresource_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1172"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1172"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1172">
      <xsl:apply-templates select="@*|*" mode="M1172"/>
   </xsl:template>

   <!--PATTERN srstenetname-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:netname" priority="1000"
                 mode="M1173">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the netname entity of a sharedresource_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1173"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1173"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1173">
      <xsl:apply-templates select="@*|*" mode="M1173"/>
   </xsl:template>

   <!--PATTERN srsteshared_type-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:shared_type" priority="1000"
                 mode="M1174">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the shared_type entity of a sharedresource_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1174"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1174"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1174">
      <xsl:apply-templates select="@*|*" mode="M1174"/>
   </xsl:template>

   <!--PATTERN srstemax_uses-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:max_uses" priority="1000"
                 mode="M1175">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the max_uses entity of a sharedresource_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1175"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1175"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1175">
      <xsl:apply-templates select="@*|*" mode="M1175"/>
   </xsl:template>

   <!--PATTERN srstecurrent_uses-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:current_uses" priority="1000"
                 mode="M1176">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the current_uses entity of a sharedresource_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1176"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1176"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1176">
      <xsl:apply-templates select="@*|*" mode="M1176"/>
   </xsl:template>

   <!--PATTERN srstelocal_path-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:local_path" priority="1000"
                 mode="M1177">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the local_path entity of a sharedresource_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1177"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1177"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1177">
      <xsl:apply-templates select="@*|*" mode="M1177"/>
   </xsl:template>

   <!--PATTERN srsteaccess_read_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_read_permission"
                 priority="1000"
                 mode="M1178">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_read_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1178"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1178"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1178">
      <xsl:apply-templates select="@*|*" mode="M1178"/>
   </xsl:template>

   <!--PATTERN srsteaccess_write_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_write_permission"
                 priority="1000"
                 mode="M1179">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_write_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1179"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1179"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1179">
      <xsl:apply-templates select="@*|*" mode="M1179"/>
   </xsl:template>

   <!--PATTERN srsteaccess_create_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_create_permission"
                 priority="1000"
                 mode="M1180">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_create_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1180"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1180"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1180">
      <xsl:apply-templates select="@*|*" mode="M1180"/>
   </xsl:template>

   <!--PATTERN srsteaccess_exec_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_exec_permission"
                 priority="1000"
                 mode="M1181">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_exec_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1181"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1181"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1181">
      <xsl:apply-templates select="@*|*" mode="M1181"/>
   </xsl:template>

   <!--PATTERN srsteaccess_delete_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_delete_permission"
                 priority="1000"
                 mode="M1182">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_delete_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1182"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1182"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1182">
      <xsl:apply-templates select="@*|*" mode="M1182"/>
   </xsl:template>

   <!--PATTERN srsteaccess_atrib_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_atrib_permission"
                 priority="1000"
                 mode="M1183">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_atrib_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1183"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1183"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1183">
      <xsl:apply-templates select="@*|*" mode="M1183"/>
   </xsl:template>

   <!--PATTERN srsteaccess_perm_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_perm_permission"
                 priority="1000"
                 mode="M1184">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_perm_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1184"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1184"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1184">
      <xsl:apply-templates select="@*|*" mode="M1184"/>
   </xsl:template>

   <!--PATTERN srsteaccess_all_permission-->


	<!--RULE -->
<xsl:template match="win-def:sharedresource_state/win-def:access_all_permission"
                 priority="1000"
                 mode="M1185">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the access_all_permission entity of a sharedresource_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1185"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1185"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1185">
      <xsl:apply-templates select="@*|*" mode="M1185"/>
   </xsl:template>

   <!--PATTERN sidtst-->


	<!--RULE -->
<xsl:template match="win-def:sid_test/win-def:object" priority="1001" mode="M1186">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:sid_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a sid_test must reference a sid_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1186"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:sid_test/win-def:state" priority="1000" mode="M1186">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:sid_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a sid_test must reference a sid_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1186"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1186"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1186">
      <xsl:apply-templates select="@*|*" mode="M1186"/>
   </xsl:template>

   <!--PATTERN sidobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:sid_object/win-def:trustee_name" priority="1000" mode="M1187">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a sid_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1187"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1187"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1187">
      <xsl:apply-templates select="@*|*" mode="M1187"/>
   </xsl:template>

   <!--PATTERN sidstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:sid_state/win-def:trustee_name" priority="1000" mode="M1188">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1188"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1188"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1188">
      <xsl:apply-templates select="@*|*" mode="M1188"/>
   </xsl:template>

   <!--PATTERN sidstetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:sid_state/win-def:trustee_sid" priority="1000" mode="M1189">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1189"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1189"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1189">
      <xsl:apply-templates select="@*|*" mode="M1189"/>
   </xsl:template>

   <!--PATTERN sidstetrustee_domain-->


	<!--RULE -->
<xsl:template match="win-def:sid_state/win-def:trustee_domain" priority="1000" mode="M1190">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_domain entity of a sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1190"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1190"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1190">
      <xsl:apply-templates select="@*|*" mode="M1190"/>
   </xsl:template>

   <!--PATTERN sidsidtst-->


	<!--RULE -->
<xsl:template match="win-def:sid_sid_test/win-def:object" priority="1001" mode="M1191">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:sid_sid_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a sid_sid_test must reference a sid_sid_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1191"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:sid_sid_test/win-def:state" priority="1000" mode="M1191">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:sid_sid_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a sid_sid_test must reference a sid_sid_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1191"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1191"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1191">
      <xsl:apply-templates select="@*|*" mode="M1191"/>
   </xsl:template>

   <!--PATTERN sidsidobjtrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:sid_sid_object/win-def:trustee_sid" priority="1000" mode="M1192">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a sid_sid_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1192"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1192"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1192">
      <xsl:apply-templates select="@*|*" mode="M1192"/>
   </xsl:template>

   <!--PATTERN sidsidstetrustee_sid-->


	<!--RULE -->
<xsl:template match="win-def:sid_sid_state/win-def:trustee_sid" priority="1000" mode="M1193">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_sid entity of a sid_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1193"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1193"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1193">
      <xsl:apply-templates select="@*|*" mode="M1193"/>
   </xsl:template>

   <!--PATTERN sidsidstetrustee_name-->


	<!--RULE -->
<xsl:template match="win-def:sid_sid_state/win-def:trustee_name" priority="1000" mode="M1194">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_name entity of a sid_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1194"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1194"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1194">
      <xsl:apply-templates select="@*|*" mode="M1194"/>
   </xsl:template>

   <!--PATTERN sidsidstetrustee_domain-->


	<!--RULE -->
<xsl:template match="win-def:sid_sid_state/win-def:trustee_domain" priority="1000"
                 mode="M1195">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the trustee_domain entity of a sid_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1195"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1195"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1195">
      <xsl:apply-templates select="@*|*" mode="M1195"/>
   </xsl:template>

   <!--PATTERN uactst-->


	<!--RULE -->
<xsl:template match="win-def:uac_test/win-def:object" priority="1001" mode="M1196">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:uac_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a uac_test must reference a uac_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1196"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:uac_test/win-def:state" priority="1000" mode="M1196">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:uac_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a uac_test must reference a uac_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1196"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1196"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1196">
      <xsl:apply-templates select="@*|*" mode="M1196"/>
   </xsl:template>

   <!--PATTERN uacsteadminapprovalmode-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:admin_approval_mode" priority="1000"
                 mode="M1197">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the admin_approval_mode entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1197"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1197"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1197">
      <xsl:apply-templates select="@*|*" mode="M1197"/>
   </xsl:template>

   <!--PATTERN uacstebehaviorelevationadmin-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:elevation_prompt_admin" priority="1000"
                 mode="M1198">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the elevation_prompt_admin entity of a uac_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1198"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1198"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1198">
      <xsl:apply-templates select="@*|*" mode="M1198"/>
   </xsl:template>

   <!--PATTERN uacsteelevationpromptstandard-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:elevation_prompt_standard" priority="1000"
                 mode="M1199">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the elevation_prompt_standard entity of a uac_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1199"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1199"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1199">
      <xsl:apply-templates select="@*|*" mode="M1199"/>
   </xsl:template>

   <!--PATTERN uacstedetectinstallations-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:detect_installations" priority="1000"
                 mode="M1200">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the detect_installations entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1200"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1200"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1200">
      <xsl:apply-templates select="@*|*" mode="M1200"/>
   </xsl:template>

   <!--PATTERN uacsteelevatesignedexecutables-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:elevate_signed_executables" priority="1000"
                 mode="M1201">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the elevate_signed_executables entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1201"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1201"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1201">
      <xsl:apply-templates select="@*|*" mode="M1201"/>
   </xsl:template>

   <!--PATTERN uacsteelevateuiaccess-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:elevate_uiaccess" priority="1000" mode="M1202">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the elevate_uiaccess entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1202"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1202"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1202">
      <xsl:apply-templates select="@*|*" mode="M1202"/>
   </xsl:template>

   <!--PATTERN uacsterunadminsaam-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:run_admins_aam" priority="1000" mode="M1203">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the run_admins_aam entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1203"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1203"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1203">
      <xsl:apply-templates select="@*|*" mode="M1203"/>
   </xsl:template>

   <!--PATTERN uacstesecuredesktop-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:secure_desktop" priority="1000" mode="M1204">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the secure_desktop entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1204"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1204"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1204">
      <xsl:apply-templates select="@*|*" mode="M1204"/>
   </xsl:template>

   <!--PATTERN uacstevirtualizewritefailures-->


	<!--RULE -->
<xsl:template match="win-def:uac_state/win-def:virtualize_write_failures" priority="1000"
                 mode="M1205">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the virtualize_write_failures entity of a uac_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1205"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1205"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1205">
      <xsl:apply-templates select="@*|*" mode="M1205"/>
   </xsl:template>

   <!--PATTERN usertst-->


	<!--RULE -->
<xsl:template match="win-def:user_test/win-def:object" priority="1001" mode="M1206">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:user_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a user_test must reference a user_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1206"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:user_test/win-def:state" priority="1000" mode="M1206">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:user_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a user_test must reference a user_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1206"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1206"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1206">
      <xsl:apply-templates select="@*|*" mode="M1206"/>
   </xsl:template>

   <!--PATTERN userobjuser-->


	<!--RULE -->
<xsl:template match="win-def:user_object/win-def:user" priority="1000" mode="M1207">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user entity of a user_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1207"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1207"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1207">
      <xsl:apply-templates select="@*|*" mode="M1207"/>
   </xsl:template>

   <!--PATTERN usersteuser-->


	<!--RULE -->
<xsl:template match="win-def:user_state/win-def:user" priority="1000" mode="M1208">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user entity of a user_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1208"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1208"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1208">
      <xsl:apply-templates select="@*|*" mode="M1208"/>
   </xsl:template>

   <!--PATTERN usersteenabled-->


	<!--RULE -->
<xsl:template match="win-def:user_state/win-def:enabled" priority="1000" mode="M1209">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enabled entity of a user_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1209"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1209"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1209">
      <xsl:apply-templates select="@*|*" mode="M1209"/>
   </xsl:template>

   <!--PATTERN userstegroup-->


	<!--RULE -->
<xsl:template match="win-def:user_state/win-def:group" priority="1000" mode="M1210">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group entity of a user_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1210"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1210"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1210">
      <xsl:apply-templates select="@*|*" mode="M1210"/>
   </xsl:template>

   <!--PATTERN usersid55tst-->


	<!--RULE -->
<xsl:template match="win-def:user_sid55_test/win-def:object" priority="1001" mode="M1211">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:user_sid55_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a user_sid55_test must reference a user_sid55_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1211"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:user_sid55_test/win-def:state" priority="1000" mode="M1211">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:user_sid55_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a user_sid55_test must reference a user_sid55_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1211"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1211"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1211">
      <xsl:apply-templates select="@*|*" mode="M1211"/>
   </xsl:template>

   <!--PATTERN usersid55objuser-->


	<!--RULE -->
<xsl:template match="win-def:user_sid55_object/win-def:user_sid" priority="1000" mode="M1212">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_sid entity of a user_sid55_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1212"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1212"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1212">
      <xsl:apply-templates select="@*|*" mode="M1212"/>
   </xsl:template>

   <!--PATTERN usersid55steuser-->


	<!--RULE -->
<xsl:template match="win-def:user_sid55_state/win-def:user_sid" priority="1000" mode="M1213">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_sid entity of a user_sid55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1213"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1213"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1213">
      <xsl:apply-templates select="@*|*" mode="M1213"/>
   </xsl:template>

   <!--PATTERN usersid55steenabled-->


	<!--RULE -->
<xsl:template match="win-def:user_sid55_state/win-def:enabled" priority="1000" mode="M1214">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enabled entity of a user_sid55_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1214"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1214"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1214">
      <xsl:apply-templates select="@*|*" mode="M1214"/>
   </xsl:template>

   <!--PATTERN usersid55stegroup-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_55state/win-def:group_sid" priority="1000" mode="M1215">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_sid entity of a user_sid55_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1215"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1215"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1215">
      <xsl:apply-templates select="@*|*" mode="M1215"/>
   </xsl:template>

   <!--PATTERN usersidtst_dep-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_test" priority="1000" mode="M1216">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED TEST: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1216"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1216"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1216">
      <xsl:apply-templates select="@*|*" mode="M1216"/>
   </xsl:template>

   <!--PATTERN usersidtst-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_test/win-def:object" priority="1001" mode="M1217">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:user_sid_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a user_sid_test must reference a user_sid_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1217"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:user_sid_test/win-def:state" priority="1000" mode="M1217">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:user_sid_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a user_sid_test must reference a user_sid_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1217"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1217"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1217">
      <xsl:apply-templates select="@*|*" mode="M1217"/>
   </xsl:template>

   <!--PATTERN usersidobj_dep-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_object" priority="1000" mode="M1218">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED OBJECT: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1218"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1218"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1218">
      <xsl:apply-templates select="@*|*" mode="M1218"/>
   </xsl:template>

   <!--PATTERN usersidobjuser-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_object/win-def:user_sid" priority="1000" mode="M1219">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_sid entity of a user_sid_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1219"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1219"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1219">
      <xsl:apply-templates select="@*|*" mode="M1219"/>
   </xsl:template>

   <!--PATTERN usersidste_dep-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_state" priority="1000" mode="M1220">

		<!--REPORT -->
<xsl:if test="true()"> DEPRECATED STATE: <xsl:text/>
         <xsl:value-of select="name()"/>
         <xsl:text/> ID: <xsl:text/>
         <xsl:value-of select="@id"/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1220"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1220"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1220">
      <xsl:apply-templates select="@*|*" mode="M1220"/>
   </xsl:template>

   <!--PATTERN usersidsteuser-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_state/win-def:user_sid" priority="1000" mode="M1221">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the user_sid entity of a user_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1221"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1221"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1221">
      <xsl:apply-templates select="@*|*" mode="M1221"/>
   </xsl:template>

   <!--PATTERN usersidsteenabled-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_state/win-def:enabled" priority="1000" mode="M1222">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the enabled entity of a user_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1222"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1222"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1222">
      <xsl:apply-templates select="@*|*" mode="M1222"/>
   </xsl:template>

   <!--PATTERN usersidstegroup-->


	<!--RULE -->
<xsl:template match="win-def:user_sid_state/win-def:group_sid" priority="1000" mode="M1223">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the group_sid entity of a user_sid_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1223"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1223"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1223">
      <xsl:apply-templates select="@*|*" mode="M1223"/>
   </xsl:template>

   <!--PATTERN volumetst-->


	<!--RULE -->
<xsl:template match="win-def:volume_test/win-def:object" priority="1001" mode="M1224">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:volume_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a volume_test must reference a volume_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1224"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:volume_test/win-def:state" priority="1000" mode="M1224">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:volume_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a volume_test must reference a volume_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1224"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1224"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1224">
      <xsl:apply-templates select="@*|*" mode="M1224"/>
   </xsl:template>

   <!--PATTERN volobjrootpath-->


	<!--RULE -->
<xsl:template match="win-def:volume_object/win-def:rootpath" priority="1000" mode="M1225">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the rootpath entity of a volume_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1225"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1225"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1225">
      <xsl:apply-templates select="@*|*" mode="M1225"/>
   </xsl:template>

   <!--PATTERN volumesterootpath-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:rootpath" priority="1000" mode="M1226">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the rootpath entity of a volume_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1226"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1226"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1226">
      <xsl:apply-templates select="@*|*" mode="M1226"/>
   </xsl:template>

   <!--PATTERN volumestefile_system-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_system" priority="1000" mode="M1227">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_system entity of a volume_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1227"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1227"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1227">
      <xsl:apply-templates select="@*|*" mode="M1227"/>
   </xsl:template>

   <!--PATTERN volumestename-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:name" priority="1000" mode="M1228">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the name entity of a volume_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1228"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1228"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1228">
      <xsl:apply-templates select="@*|*" mode="M1228"/>
   </xsl:template>

   <!--PATTERN volstevolume_max_component_length-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:volume_max_component_length"
                 priority="1000"
                 mode="M1229">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the volume_max_component_length entity of a volume_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1229"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1229"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1229">
      <xsl:apply-templates select="@*|*" mode="M1229"/>
   </xsl:template>

   <!--PATTERN volsteserial_number-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:serial_number" priority="1000" mode="M1230">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='int'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the serial_number entity of a volume_state should be 'int'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1230"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1230"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1230">
      <xsl:apply-templates select="@*|*" mode="M1230"/>
   </xsl:template>

   <!--PATTERN volstefile_case_sensitive_search-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_case_sensitive_search" priority="1000"
                 mode="M1231">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_case_sensitive_search entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1231"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1231"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1231">
      <xsl:apply-templates select="@*|*" mode="M1231"/>
   </xsl:template>

   <!--PATTERN volstefile_case_preserved_names-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_case_preserved_names" priority="1000"
                 mode="M1232">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_case_preserved_names entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1232"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1232"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1232">
      <xsl:apply-templates select="@*|*" mode="M1232"/>
   </xsl:template>

   <!--PATTERN volstefile_unicode_on_disk-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_unicode_on_disk" priority="1000"
                 mode="M1233">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_unicode_on_disk entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1233"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1233"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1233">
      <xsl:apply-templates select="@*|*" mode="M1233"/>
   </xsl:template>

   <!--PATTERN volstefile_persistent_acls-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_persistent_acls" priority="1000"
                 mode="M1234">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_persistent_acls entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1234"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1234"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1234">
      <xsl:apply-templates select="@*|*" mode="M1234"/>
   </xsl:template>

   <!--PATTERN volstefile_file_compression-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_file_compression" priority="1000"
                 mode="M1235">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_file_compression entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1235"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1235"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1235">
      <xsl:apply-templates select="@*|*" mode="M1235"/>
   </xsl:template>

   <!--PATTERN volstefile_volume_quotas-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_volume_quotas" priority="1000"
                 mode="M1236">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_volume_quotas entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1236"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1236"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1236">
      <xsl:apply-templates select="@*|*" mode="M1236"/>
   </xsl:template>

   <!--PATTERN volstefile_supports_sparse_files-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_supports_sparse_files" priority="1000"
                 mode="M1237">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_supports_sparse_files entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1237"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1237"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1237">
      <xsl:apply-templates select="@*|*" mode="M1237"/>
   </xsl:template>

   <!--PATTERN volstefile_supports_reparse_points-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_supports_reparse_points"
                 priority="1000"
                 mode="M1238">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_supports_reparse_points entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1238"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1238"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1238">
      <xsl:apply-templates select="@*|*" mode="M1238"/>
   </xsl:template>

   <!--PATTERN volstefile_supports_remote_storage-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_supports_remote_storage"
                 priority="1000"
                 mode="M1239">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_supports_remote_storage entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1239"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1239"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1239">
      <xsl:apply-templates select="@*|*" mode="M1239"/>
   </xsl:template>

   <!--PATTERN volstefile_volume_is_compressed-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_volume_is_compressed" priority="1000"
                 mode="M1240">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_volume_is_compressed entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1240"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1240"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1240">
      <xsl:apply-templates select="@*|*" mode="M1240"/>
   </xsl:template>

   <!--PATTERN volstefile_supports_object_ids-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_supports_object_ids" priority="1000"
                 mode="M1241">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_supports_object_ids entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1241"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1241"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1241">
      <xsl:apply-templates select="@*|*" mode="M1241"/>
   </xsl:template>

   <!--PATTERN volstefile_supports_encryption-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_supports_encryption" priority="1000"
                 mode="M1242">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_supports_encryption entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1242"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1242"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1242">
      <xsl:apply-templates select="@*|*" mode="M1242"/>
   </xsl:template>

   <!--PATTERN volstefile_named_streams-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_named_streams" priority="1000"
                 mode="M1243">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_named_streams entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1243"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1243"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1243">
      <xsl:apply-templates select="@*|*" mode="M1243"/>
   </xsl:template>

   <!--PATTERN volstefile_read_only_volume-->


	<!--RULE -->
<xsl:template match="win-def:volume_state/win-def:file_read_only_volume" priority="1000"
                 mode="M1244">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@datatype='boolean'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the file_read_only_volume entity of a volume_state should be 'boolean'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1244"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1244"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1244">
      <xsl:apply-templates select="@*|*" mode="M1244"/>
   </xsl:template>

   <!--PATTERN wmitst-->


	<!--RULE -->
<xsl:template match="win-def:wmi_test/win-def:object" priority="1001" mode="M1245">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:wmi_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a wmi_test must reference a wmi_object<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1245"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:wmi_test/win-def:state" priority="1000" mode="M1245">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:wmi_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a wmi_test must reference a wmi_state<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1245"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1245"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1245">
      <xsl:apply-templates select="@*|*" mode="M1245"/>
   </xsl:template>

   <!--PATTERN wmiobjnamespace-->


	<!--RULE -->
<xsl:template match="win-def:wmi_object/win-def:namespace" priority="1000" mode="M1246">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the namespace entity of a wmi_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the namespace entity of a wmi_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1246"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1246"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1246">
      <xsl:apply-templates select="@*|*" mode="M1246"/>
   </xsl:template>

   <!--PATTERN wmiobjwql-->


	<!--RULE -->
<xsl:template match="win-def:wmi_object/win-def:wql" priority="1000" mode="M1247">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the wql entity of a wmi_object should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the wql entity of a wmi_object should be 'equals', note that this overrules the general operation attribute validation (i.e. follow this one)<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1247"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1247"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1247">
      <xsl:apply-templates select="@*|*" mode="M1247"/>
   </xsl:template>

   <!--PATTERN wmistenamespace-->


	<!--RULE -->
<xsl:template match="win-def:wmi_state/win-def:namespace" priority="1000" mode="M1248">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the namespace entity of a wmi_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1248"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1248"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1248">
      <xsl:apply-templates select="@*|*" mode="M1248"/>
   </xsl:template>

   <!--PATTERN wmistewql-->


	<!--RULE -->
<xsl:template match="win-def:wmi_state/win-def:wql" priority="1000" mode="M1249">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the wql entity of a wmi_state should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1249"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1249"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1249">
      <xsl:apply-templates select="@*|*" mode="M1249"/>
   </xsl:template>

   <!--PATTERN wmisteresult-->


	<!--RULE -->
<xsl:template match="win-def:wmi_state/win-def:result" priority="1000" mode="M1250">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="(@datatype='int' and (floor(.) = number(.))) or not(@datatype='int') or not(node())"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - The datatype has been set to 'int' but the value is not an integer.<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1250"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1250"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1250">
      <xsl:apply-templates select="@*|*" mode="M1250"/>
   </xsl:template>

   <!--PATTERN wuaupdatesearchertst-->


	<!--RULE -->
<xsl:template match="win-def:wuaupdatesearcher_test/win-def:object" priority="1001"
                 mode="M1251">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@object_ref=/oval-def:oval_definitions/oval-def:objects/win-def:wuaupdatesearcher_object/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the object child element of a wuaupdatesearcher_test must reference a wuaupdatesearcher_object <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1251"/>
   </xsl:template>

	  <!--RULE -->
<xsl:template match="win-def:wuaupdatesearcher_test/win-def:state" priority="1000"
                 mode="M1251">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="@state_ref=/oval-def:oval_definitions/oval-def:states/win-def:wuaupdatesearcher_state/@id"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - the state child element of a wuaupdatesearcher_test must reference a wuaupdatesearcher_state <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1251"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1251"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1251">
      <xsl:apply-templates select="@*|*" mode="M1251"/>
   </xsl:template>

   <!--PATTERN wuaupdatesearcherobjsearchcriteria-->


	<!--RULE -->
<xsl:template match="win-def:wuaupdatesearcher_object/win-def:search_criteria"
                 priority="1000"
                 mode="M1252">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the search_criteria entity of a wuaupdatesearcher_object should be 'string' <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>

		    <!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@operation) or @operation='equals'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - operation attribute for the search_criteria entity of a wuaupdatesearcher_object should be 'equals' <xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1252"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1252"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1252">
      <xsl:apply-templates select="@*|*" mode="M1252"/>
   </xsl:template>

   <!--PATTERN wuaupdatesearcherstesearchcriteria-->


	<!--RULE -->
<xsl:template match="win-def:wuaupdatesearcher_state/win-def:search_criteria" priority="1000"
                 mode="M1253">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1253"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1253"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1253">
      <xsl:apply-templates select="@*|*" mode="M1253"/>
   </xsl:template>

   <!--PATTERN wuaupdatesearchersteupdateid-->


	<!--RULE -->
<xsl:template match="win-def:wuaupdatesearcher_state/win-def:update_id" priority="1000"
                 mode="M1254">

		<!--ASSERT -->
<xsl:choose>
         <xsl:when test="not(@datatype) or @datatype='string'"/>
         <xsl:otherwise>
                <xsl:text/>
            <xsl:value-of select="../@id"/>
            <xsl:text/> - datatype attribute for the <xsl:text/>
            <xsl:value-of select="name(.)"/>
            <xsl:text/> entity of a <xsl:text/>
            <xsl:value-of select="name(..)"/>
            <xsl:text/> should be 'string'<xsl:value-of select="string('&#xA;')"/>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="@*|*" mode="M1254"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1254"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1254">
      <xsl:apply-templates select="@*|*" mode="M1254"/>
   </xsl:template>

   <!--PATTERN ssr_stype_special_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:states/win-def:sharedresource_state/win-def:shared_type"
                 priority="1000"
                 mode="M1255">

		<!--REPORT -->
<xsl:if test=".='STYPE_SPECIAL'"> DEPRECATED ELEMENT VALUE IN: sharedresource_state ELEMENT VALUE: <xsl:text/>
         <xsl:value-of select="."/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1255"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1255"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1255">
      <xsl:apply-templates select="@*|*" mode="M1255"/>
   </xsl:template>

   <!--PATTERN ssr_stype_temporary_value_dep-->


	<!--RULE -->
<xsl:template match="/oval-def:oval_definitions/oval-def:states/win-def:sharedresource_state/win-def:shared_type"
                 priority="1000"
                 mode="M1256">

		<!--REPORT -->
<xsl:if test=".='STYPE_TEMPORARY'"> DEPRECATED ELEMENT VALUE IN: sharedresource_state ELEMENT VALUE: <xsl:text/>
         <xsl:value-of select="."/>
         <xsl:text/>
            <xsl:value-of select="string('&#xA;')"/>
      </xsl:if>
      <xsl:apply-templates select="@*|*" mode="M1256"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M1256"/>
   <xsl:template match="@*|node()" priority="-2" mode="M1256">
      <xsl:apply-templates select="@*|*" mode="M1256"/>
   </xsl:template>
</xsl:stylesheet>